unit Attributs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type
  TAttributsForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup4: TRadioGroup;
    RadioGroup5: TRadioGroup;
    CheckBox1: TCheckBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ColorDialog1: TColorDialog;
    Shape1: TShape;
    Shape2: TShape;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit4: TEdit;
    RadioGroup3: TRadioGroup;
    GroupBox4: TGroupBox;
    Edit5: TEdit;
    Label8: TLabel;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    RadioGroup7: TRadioGroup;
    RadioGroup8: TRadioGroup;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;

    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure CheckBox11Click(Sender: TObject);
    procedure CheckBox12Click(Sender: TObject);
    procedure CheckBox13Click(Sender: TObject);
    procedure CheckBox14Click(Sender: TObject);
    procedure CheckBox15Click(Sender: TObject);
    procedure CheckBox16Click(Sender: TObject);
  private
    { Dclarations prives }
    TheColor, TheFillColor:longint;
  public
    { Dclarations publiques }
    function Valider: Boolean;
  end;

var
  AttributsForm: TAttributsForm;
  multiselection:boolean;

implementation
uses Unite1{calculs},complex3,graph1_6,saisies;

{$R *.dfm}

procedure TAttributsForm.Button1Click(Sender: TObject);
begin
     if Valider then ModalResult:=mrOk;
end;

procedure TAttributsForm.FormCreate(Sender: TObject);
begin
     digits:=12;
     if not multiselection then
        begin
                GroupBox6.visible:=false;
                Width:= GroupBox6.left;
        end
        else begin
               checkBox6.checked:= false; GroupBox1.enabled:=false;
               checkBox7.checked:= false; RadioGroup1.enabled:=false;
               checkBox8.checked:= false; RadioGroup2.enabled:=false;
               checkBox9.checked:= false; GroupBox3.enabled:=false;
               checkBox10.checked:= false; RadioGroup4.enabled:=false;
               checkBox11.checked:= false; RadioGroup5.enabled:=false;
               checkBox12.checked:= false; GroupBox5.enabled:=false;
               checkBox13.checked:= false; GroupBox4.enabled:=false;
               checkBox14.checked:= false; RadioGroup3.enabled:=false;
               checkBox15.checked:= false; Button3.enabled:=false;
               checkBox16.checked:= false; Button4.enabled:=false;
             end;
     Edit1.text:=Streel(Tmin);
     Edit2.text:=Streel(Tmax);
     Edit3.text:=Streel(NbPoints);
     Edit4.text:=Streel(graph1_6.linewidth);
     Edit5.text:=Streel(Labelangle);
     RadioGroup1.ItemIndex:=DotStyle;
     RadioGroup2.ItemIndex:=1+LineStyle;
     RadioGroup3.ItemIndex:=LabelSize;
     RadioGroup4.ItemIndex:= Arrows;
     CheckBox1.checked:=  (AutoReCalc=1);
     RadioGroup5.ItemIndex:=FillStyle;
     RadioGroup7.ItemIndex:= (LabelStyle And 3); //style horizontal, 2 premiers octets
     RadioGroup8.ItemIndex:= (LabelStyle And 12) div 4; //style vertical, 2 octets suivants
     CheckBox2.checked:=  (LabelStyle And 16=16); //style framed: octet suivant
     CheckBox3.checked:=  (LabelStyle And 32=32); //style stacked: octet suivant
     CheckBox4.checked:=  (LabelStyle And 64=64); //spcial: octet suivant
     CheckBox5.checked:=  ForMinToMax;
     if ForMinToMax then
        begin
                Edit1.enabled:=false; Edit2.enabled:=false;
        end;
     if Linecolor<9 then TheColor:=graph1_6.palette[Linecolor].code else Thecolor:=Linecolor;
     if fillcolor<9 then TheFillColor:=graph1_6.palette[Fillcolor].code else TheFillcolor:=Fillcolor;
     shape1.brush.color:=Thecolor;
     shape2.brush.color:=Thefillcolor;
     digits:=4;
end;

function TAttributsForm.Valider:boolean;
begin
     Valider:=true;
     if
        (checkBox6.checked and not(validReal(edit1,-reel_Max,reel_Max,Tmin) and validReal(edit2,-reel_Max,reel_Max,Tmax)
             and validInteger(edit3,0,2000,NbPoints)))
        or
        (checkBox9.checked and (not validInteger(edit4,1,32767,graph1_6.linewidth)))
        or
        (checkBox13.checked and (not validreal(edit5,-360,360,Labelangle)))
             then
     begin  Valider:=false end
     else begin
     if checkBox7.checked then Dotstyle:=RadioGroup1.ItemIndex;
     if checkBox8.checked then Linestyle:=RadioGroup2.ItemIndex-1;
     if checkBox10.checked then Arrows:=RadioGroup4.ItemIndex;
     AutoReCalc:=byte(checkBox1.checked);
     if checkBox11.checked then FillStyle:=RadioGroup5.ItemIndex;
     if checkBox12.checked then LabelStyle:= RadioGroup7.ItemIndex+4*RadioGroup8.ItemIndex+
                               16*byte(CheckBox2.checked)+32*byte(CheckBox3.checked)+64*byte(CheckBox4.checked);
     if checkBox14.checked then LabelSize:=RadioGroup3.ItemIndex;
     if checkBox15.checked then LineColor:=TheColor;
     if checkBox16.checked then FillColor:=TheFillColor;
     if checkBox6.checked then ForMinToMax:=CheckBox5.checked;
     if not multiselection then SetAttributs;
     end   
end;

procedure TAttributsForm.Button3Click(Sender: TObject);
begin
       Colordialog1.Color:=TheColor;
       if ColorDialog1.Execute
          then begin
                    TheColor:=Colordialog1.Color;
                    Shape1.brush.color:=theColor;
                    Button1.setFocus
                end;
end;

procedure TAttributsForm.Button4Click(Sender: TObject);
begin
       Colordialog1.Color:=TheFillColor;
       if ColorDialog1.Execute
          then begin
                    TheFillColor:=Colordialog1.Color;
                    Shape2.brush.color:=ThefillColor;
                    Button1.setFocus
               end;
end;

procedure TAttributsForm.CheckBox5Click(Sender: TObject);
begin
      if checkbox5.checked
        then
        begin
                Edit1.text:=Streel(Xmin);
                Edit2.text:=Streel(Xmax);
                Edit1.enabled:=false; Edit2.enabled:=false;
        end else
        begin
                Edit1.enabled:=true; Edit2.enabled:=true;
        end;
end;


procedure TAttributsForm.CheckBox6Click(Sender: TObject);
begin
      GroupBox1.enabled:=checkBox6.checked;
      with groupBox1 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox7Click(Sender: TObject);
begin
      RadioGroup1.enabled:=checkBox7.checked;
       with RadioGroup1 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox8Click(Sender: TObject);
begin
      RadioGroup2.enabled:=checkBox8.checked;
      with RadioGroup2 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox9Click(Sender: TObject);
begin
       GroupBox3.enabled:=checkBox9.checked;
       with groupBox3 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox10Click(Sender: TObject);
begin
      RadioGroup4.enabled:=checkBox10.checked;
      with RadioGroup4 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox11Click(Sender: TObject);
begin
     RadioGroup5.enabled:=checkBox11.checked;
     with RadioGroup5 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox12Click(Sender: TObject);
begin
     GroupBox5.enabled:=checkBox12.checked;
     with groupBox5 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox13Click(Sender: TObject);
begin
     GroupBox4.enabled:=checkBox13.checked;
     with groupBox4 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox14Click(Sender: TObject);
begin
      RadioGroup3.enabled:=checkBox14.checked;
      with RadioGroup3 do
        if enabled then font.color:=clblack else font.color:=clgray;
end;

procedure TAttributsForm.CheckBox15Click(Sender: TObject);
begin
      Button3.enabled:=checkBox15.checked;
end;

procedure TAttributsForm.CheckBox16Click(Sender: TObject);
begin
     Button4.enabled:=checkBox16.checked;
end;

Initialization
        multiselection:=false
end.
