unit Macro;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,analyse4;

type
  TMacroForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
    sortieOK:Boolean;
  public
    { Dclarations publiques }
  end;

var
  MacroForm: TMacroForm;
  CurrentMacro:Pmacros;
implementation
uses graph1_6,Unit1;
{$R *.DFM}

procedure TMacroForm.FormCreate(Sender: TObject);
var aux:string;
begin
     if CurrentMacro=nil
        then
            begin
                 edit1.text:='';
                 Memo1.text:='';
            end
        else
            begin
                 edit1.text:=CurrentMacro^.nom;
                 if CurrentMacro^.commande=''
                    then if CurrentMacro^.contenu<>nil
                            then begin
                                 aux:=CurrentMacro^.contenu^.corps^.en_chaine;
                                 Memo1.text:=aux;
                                 end
                            else Memo1.text:=''
                    else Memo1.text:=CurrentMacro^.commande;
            end
end;

procedure TMacroForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var nom:Tnom;
    commande:string;
    f:Pexpression;
begin
     if sortieOk
        then
            begin
                 CanClose:=false;
                 nom:=Edit1.text;
                 commande:=string(Memo1.text);
                 if NomMacroValide(nom) then
           begin
                 new(f,init);
                 if not f^.definir(commande)
                    then begin
                              Messagedlg(ErrorMessage,mtWarning,[mbok],0);
                              dispose(f,detruire);
                              Memo1.selStart:=ErrorPos-1;
                              Memo1.SelLength:=1; Memo1.setfocus
                         end
                    else
                              if CurrentMacro<>nil then
                                 begin
                                       CurrentMacro^.SetCommande(commande);
                                       dispose(CurrentMacro^.contenu,detruire);
                                       CurrentMacro^.nom:=nom;
                                       CurrentMacro^.contenu:=f;
                                       CanClose:=true
                                 end else
                                             begin
                                                  CurrentMacro:=new(PMacros,init(nom,f));
                                                  CurrentMacro^.SetCommande(commande);
                                                  ajouter_macros(CurrentMacro);
                                                  CanClose:=true
                                             end;

           end
           else
               begin
                    Messagedlg('Nom invalide ou dj pris!',mtWarning,[mbok],0);
                    edit1.selectAll;
                    edit1.setfocus
               end

            end
        else CanClose:=true;
end;

procedure TMacroForm.Button1Click(Sender: TObject);
begin
     SortieOk:=true;
end;

procedure TMacroForm.Button2Click(Sender: TObject);
begin
     SortieOk:=false;
end;

procedure TMacroForm.Button3Click(Sender: TObject);
begin
      MainForm.OuvrirlaideClick(Sender);
end;


end.
