unit Marges;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,saisies;

type
  TMargesForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Dclarations prives }
    SortieOk:boolean;

  public
    { Dclarations publiques }
  end;

var
  MargesForm: TMargesForm;

implementation
uses Unite1{calculs},complex3,command5,graph1_6;
{$R *.DFM}

procedure TMargesForm.FormCreate(Sender: TObject);
begin
     digits:=12;
     edit1.text:=Streel(margeG);
     edit2.text:=Streel(margeD);
     edit3.text:=Streel(margeH);
     edit4.text:=Streel(margeB);
     digits:=4;
end;

procedure TMargesForm.Button1Click(Sender: TObject);
begin
     sortieOK:=true;
end;

procedure TMargesForm.Button2Click(Sender: TObject);
begin
     SortieOk:=false;
end;

procedure TMargesForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var x1,x2,x3,x4:real;
begin
     if sortieOk then
     begin
          CanClose:=false;
          if validReal(edit1,0,reel_Max,x1) and
             validReal(edit2,0,reel_Max,x2) and
             validReal(edit3,0,reel_Max,x3) and
             validReal(edit4,0,reel_Max,x4)
             then
                 begin
                      graph1_6.marges(x1,x2,x3,x4);
                      CanClose:=true;
                 end;
     end else CanClose:=true;
end;

end.
