unit Parametree;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,graph2_7;

type
  TParametreeForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
    SortieOk:boolean;
  public
    { Dclarations publiques }
  end;

var
  ParametreeForm: TParametreeForm;
implementation
uses listes2,complex3,analyse4,graph1_6,saisies, Unit1;
{$R *.DFM}

procedure TParametreeForm.Button1Click(Sender: TObject);
begin
     SortieOk:=true;
end;

procedure TParametreeForm.Button2Click(Sender: TObject);
begin
      SortieOK:=false;
end;

procedure TParametreeForm.FormCreate(Sender: TObject);
begin
     Edit1.text:=CurrentName;
     if Pparametree(CurrentGraph)<>nil then
     begin

   Edit2.text:=Pparametree(CurrentGraph)^.LigneCommande;
   checkbox1.checked:=(Pparametree(CurrentGraph)^.saut=1);
   Edit3.text:=Streel(Pparametree(CurrentGraph)^.division);
   Pparametree(CurrentGraph)^.lireAttributs;
     end else
    begin
    Edit2.text:='';
    checkbox1.checked:=False;
    Edit3.text:='5';//division du pas par dfaut
    DefaultSettings
    end;
    case currentCat of
    cat_cartesienne: begin Caption:='Courbe cartsienne'; Label3.Caption:='y=f(x) avec f(x)=';
    Label5.Caption:='La fonction f est une fonction relle de la variable relle x, sur'+
    ' l''intervalle [tMin,tMax] que l''on peut dfinir dans les Attributs';
                      end;
    cat_polaire: begin Caption:='Courbe polaire'; Label3.Caption:='r=f(t) avec f(t)=';
    Label5.Caption:='La fonction f est une fonction relle de la variable relle t, sur'+
    ' l''intervalle [tMin,tMax] que l''on peut dfinir dans les Attributs';
                 end;
    end;

end;

procedure TParametreeForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var division:longint;
    saut:byte;
    f:Pexpression;
    nom:Tnom;
    q:Pelement;
begin
     CanClose:=true;
     if not SortieOk then exit;
     nom:=Edit1.text;
     if NomValide(nom,Pparametree(CurrentGraph)<>nil) then
           begin
                 if not ValidInteger(Edit3,0,255,division)
                    then
                        begin
                             CanClose:=false;
                             exit;
                        end;
                 if CheckBox1.checked then saut:=1 else saut:=0;
                 new(f,init);
                 if not f^.definir(Pchar(Edit2.Text)) then
                         begin
                              Messagedlg(ErrorMessage,mtWarning,[mbok],0);
                              CanClose:=false;
                              Edit2.SelectAll;Edit2.SetFocus;
                         end
                         else
                         begin
                                case cUrrentCat of
                                cat_cartesienne: q:= new(Pcartesienne,init(Nom,edit2.text,division,saut));
                                cat_polaire: q:=new(Ppolaire,init(Nom,edit2.text,division,saut));
                                cat_parametree: q:=new(Pparametree,init(Nom,edit2.text,division,saut));
                                end;
                                 liste_element.inserer(q,CurrentGraph);
                                 liste_element.supprimer(Pcellule(CurrentGraph));
                         end;
                 dispose(f,detruire)
           end
           else
               begin
                    Messagedlg(Edit1.Text+': nom invalide ou dj pris!',mtWarning,[mbok],0);
                    CanClose:=false;
                    Edit2.selStart:=ErrorPos-1;
                    Edit2.SelLength:=1; Edit1.setfocus
               end;
end;

procedure TParametreeForm.Button3Click(Sender: TObject);
begin
      MainForm.GestionAttributs(Edit1.text);
      Button1.SetFocus
end;
end.
