{Copyright (C) 2005 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version 
ultrieure choisie par vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
 Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme;
 si ce n'est pas le cas, crivez  la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 }


Unit surface8;  {surfaces paramtres}
Interface
uses SysUtils,Unite1{calculs},listes2,complex3,analyse4,command5,graph1_6,graph2_7;




type
        PSurface=^TSurface;
        TSurface= object(T_ligne)
                  uMin, uMax, vMin, vMax: real;
                  uNbLg, vNbLg:byte;
                  elimination,degrade:boolean;

                   constructor init(UnNom:string;UneCommande:string);
                   procedure ConstruitArbre(Unarbre:Pcorps);virtual;
                   procedure recalculer;virtual;
                   procedure enregistrer_latex; virtual;
                   
                  end;

         Pproj3D= ^Tproj3D;
         Tproj3D= object(Tcommande)

               function executer(arg:PListe):Paffixe;virtual;
               end;



Implementation
        
type
    TrgtCote= record
                    cote:real;
                    i,j:integer
              end;
    PRgtCote=^TRgtCote;
    Tpont= record
                x,y,z:real;
           end;
     Ppont=^Tpont;
     Ttable=array[1..1] of Ppont;
     Ptable=^Ttable;
     tvisible=array[1..1] of boolean;
     Pvisible=^Tvisible;
     tprojete=array[1..1] of Paffixe;
     Pprojete=^Tprojete;
     tcentre=array[1..1] of Paffixe;
     Pcentre=^Tcentre;
     tcote=array[1..1] of PrgtCote;
     Pcote=^Tcote;
     Teclairage=array[1..1] of real;
     Peclairage=^Teclairage;

var  theta,phi:real;

{=============================}
function projeter(var x,y,z:real):Paffixe;
   begin
     projeter:=new(Paffixe,init(cos(theta)*y-sin(theta)*x,
     -cos(phi)*cos(theta)*x-cos(phi)*sin(theta)*y+sin(phi)*z));
   end;
{=============================}
procedure surface(fX,fY,fZ:Pexpression;var liste:Paffixe;uMin,uMax,vMin,vMax:real;uNbLg,vNbLg:byte;
 elimine,degrader:boolean);

var
   table:ptable;
   visible:Pvisible;
   centres:Pcentre;
   projetes:Pprojete;
   cotes:Pcote;
   eclairage:Peclairage;
   Upas,Vpas,xn,yn,zn,x1,y1,z1:real;
   i,j,indice,nbcotes:integer;
   liste1,liste2:type_liste;
   A1,B1,C1,D1,center:Ppont;
   
       A,B,C,D,M,U,V,res:Paffixe;
       dA,dD,det:real;
       ok,error,Ajump:boolean;
       P:PRgtCote;
   eclair:real;

  
   function convert(A:Ppont):Paffixe;
   var res:type_liste;
   begin
        res.init;
        res.ajouter_fin(new(Paffixe,init(A^.x,A^.y)));
        res.ajouter_fin(new(Paffixe,init(A^.z,0)));
        convert:=Paffixe(res.tete)
   end;


   function det2d(A,B,C,D:Paffixe):real;
   begin
        det2d:=(B^.x-A^.x)*(D^.y-C^.y)-(B^.y-A^.y)*(D^.x-C^.x)
        
   end;

   function det3d(A,B,C:Ppont):real;
   var r,d:real;
       u1,u2,u3,v1,v2,v3:real;
   begin
        u1:=B^.x-A^.x; u2:=B^.y-A^.y; u3:=B^.z-A^.z;
        v1:=C^.x-A^.x; v2:=C^.y-A^.y; v3:=C^.z-A^.z;
        r:=xn*(u2*v3-u3*v2)-yn*(u1*v3-u3*v1)+zn*(u1*v2-u2*v1);
        d:=sqrt(sqr(u1)+sqr(u2)+sqr(u3))*sqrt(sqr(v1)+sqr(v2)+sqr(v3));
        if d<>0 then
                    begin det3D:=sqrt((abs(r/d)));
                    end else det3d:=0;
   end;

     

   function TrouvePivot(i,j:integer):integer;
   var first:real;
       k,res:integer;
   begin
        res:=0;
        first:=cotes^[i]^.cote;
        for k:=i+1 to j do
            if cotes^[k]^.cote<first then res:=k
                                    else
            if cotes^[k]^.cote>first then res:=i;
        TrouvePivot:=res
   end;

   function Partition(i,j: integer; pivot:real):integer;
   var gauche,droite:integer;
       aux:PRgtCote;
   begin
        gauche:=i; droite:=j;
        Repeat
              aux:=cotes^[gauche];
              {cote:=cotes^[gauche]^.cote; k:=cotes^[gauche]^.i; l:=cotes^[gauche]^.j;}
              cotes^[gauche]:=cotes^[droite];
              cotes^[droite]:=aux;
              {cotes^[droite]^.cote:=cote; cotes^[droite]^.i:=k;cotes^[droite]^.j:=l;}
              while cotes^[gauche]^.cote>pivot do inc(gauche);
              while cotes^[droite]^.cote<=pivot do dec(droite);
        until gauche>droite;
        Partition:=gauche
   end;

   procedure TriRapide(i,j:integer);
   var pivot:real;
       k,posPivot:integer;
   begin
        PosPivot:=TrouvePivot(i,j);
        if PosPivot<>0 then
           begin
                pivot:=cotes^[PosPivot]^.cote;
                k:=Partition(i,j,pivot);
                Trirapide(i,k-1); TriRapide(k,j);
           end;
   end;


   procedure eliminer;
   var i,j,k,l:integer;
       ok1,ok2:boolean;
       detdiag:real;
   begin
        for k:=1 to nbCotes do
        begin
        i:=cotes^[k]^.i; j:=cotes^[k]^.j;
        if visible^[(vNbLg+1)*i+j+1] then
        begin
        A:=projetes^[vNbLg*(i-1)+j]; B:=projetes^[vNbLg*(i-1)+j+1];
        C:=projetes^[vNbLg*i+j]; D:=projetes^[vNbLg*i+j+1];
        for l:=k+1 to  nbCotes do
            begin
                i:=cotes^[l]^.i; j:=cotes^[l]^.j;
                if (visible^[(vNbLg+1)*i+j+1])
                    then
                   begin
                        M:=centres^[(vNbLg-1)*(i-1)+j];
                        det:=det2d(M,B,M,C);detdiag:=det2D(M,C,M,A);
                        ok1:=det*detdiag>0;
                        if ok1 then begin detdiag:=det2D(M,A,M,B); ok1:=det*detdiag>0 end;
                         if not ok1 then
                            begin
                                detdiag:=det2D(M,C,M,D);
                                ok2:=det*detdiag>0;
                                if ok2 then begin detdiag:=det2D(M,D,M,B); ok2:=det*detdiag>0 end;
                            end;
                        visible^[(vNbLg+1)*i+j+1]:=not (ok1 or ok2);
                   end;
            end;
        end;
        end;   
   end;

  begin
  xn:=sin(phi)*cos(theta); yn:=sin(phi)*sin(theta); zn:=cos(phi);
  liste1.init;
  
  getmem(table,uNbLg*vNbLg*Sizeof(Ppont));
  getmem(projetes,uNbLg*vNbLg*Sizeof(Paffixe));
  getmem(centres,(uNbLg-1)*(vNbLg-1)*Sizeof(Paffixe));
  getmem(eclairage,(uNbLg-1)*(vNbLg-1)*Sizeof(real));
  getmem(cotes,(uNbLg-1)*(vNbLg-1)*Sizeof(PrgtCote));
  getmem(visible,(uNbLg+1)*(vNbLg+1)*Sizeof(Boolean));


  U:=New(Paffixe,init(0,0));
  V:=New(Paffixe,init(0,0));
  fX^.assigner('u',U); fX^.assigner('v',V);
  fY^.assigner('u',U); fY^.assigner('v',V);
  fZ^.assigner('u',U); fZ^.assigner('v',V);

  U^.x:=uMin; Upas:=(uMax-uMin)/(uNbLg-1); Vpas:=(vMax-vMin)/(vNbLg-1);
  for i:=1 to uNbLg do
      begin
           V^.x:=vMin;
           for j:=1 to vNbLg do
               begin
                    error:=false;
                    indice:=vNbLg*(i-1)+j;
                    res:=fX^.evaluer;
                    if res<>nil then x1:=res^.x else error:=true;
                    Kill(Pcellule(res));

                    res:=fY^.evaluer;
                    if res<>nil then y1:=res^.x else error:=true;
                    Kill(Pcellule(res));

                    res:=fZ^.evaluer;
                    if res<>nil then z1:=res^.x else error:=true;
                    Kill(Pcellule(res));

                    if error
                       then
                           begin
                                table^[indice]:=nil;
                                projetes^[indice]:=nil;
                           end
                       else
                           begin
                                 New(A1);
                                 A1^.x:=x1; A1^.y:=y1; A1^.z:=z1;
                                 table^[indice]:=A1;
                                 projetes^[indice]:= projeter(x1,y1,z1);
                           end;

                    V^.x:=V^.x+Vpas;
               end;
           U^.x:=U^.x+Upas;
      end;

  fX^.desassigner('u'); fX^.desassigner('v');
  fY^.desassigner('u'); fY^.desassigner('v');
  fZ^.desassigner('u'); fZ^.desassigner('v');
  Kill(Pcellule(U)); Kill(Pcellule(V));

  nbcotes:=0;
  for i:=1 to (uNbLg+1)*(vNbLg+1) do visible^[i]:=false;
  for i:=1 to uNbLg-1 do for j:=1 to vNbLg-1 do
      begin
           indice:=(vNbLg-1)*(i-1)+j;
           A1:=table^[vNbLg*(i-1)+j];B1:=table^[vNbLg*(i-1)+j+1];
           C1:=table^[vNbLg*i+j];D1:=table^[vNbLg*i+j+1];
           centres^[indice]:=nil; eclairage^[indice]:=jump^.y;
           if (A1<>nil) and (B1<>nil) and (C1<>nil) and (D1<>nil)
              then
                  begin
                       CalcError:=false;
                       x1:=ajouter(A1^.x,ajouter(B1^.x,ajouter(C1^.x,D1^.x)))/4;
                       z1:=ajouter(A1^.z,ajouter(B1^.z,ajouter(C1^.z,D1^.z)))/4;
                       y1:=ajouter(A1^.y,ajouter(B1^.y,ajouter(C1^.y,D1^.y)))/4;
                       if not CalcError
                          then
                              begin
                                   inc(nbcotes);
                                   visible^[(vNbLg+1)*i+j+1]:=true;
                                   if elimine then centres^[indice]:=projeter(x1,y1,z1)
                                              else if degrader
                                                      then begin
                                                                eclair:=det3D(A1,B1,C1);
                                                                if eclair<>0 then eclairage^[indice]:=eclair
                                                                             else
                                                                              begin
                                                                                   eclair:=det3D(B1,C1,D1);
                                                                                   if eclair<>0 then eclairage^[indice]:=eclair
                                                                                                else
                                                                                                begin
                                                                                                     eclair:=det3D(C1,D1,A1);
                                                                                                     if eclair<>0
                                                                                                then eclairage^[indice]:=eclair
                                                                                                     else
                                                                                                       begin
                                                                                                     eclair:=det3D(A1,B1,D1);
                                                                                              eclairage^[indice]:=eclair
                                                                                                         end
                                                                                                end
                                                                              end
                                                             end;
                                                      
                                   new(P);
                                   P^.cote:= x1*xn+y1*yn+z1*zn;
                                   P^.i:=i; P^.j:=j;
                                   cotes^[nbCotes]:=P
                              end;
                  end;
      end;
   
   if nbCotes>0 then TriRapide(1,nbCotes);
   for i:=nbCotes+1 to (uNbLg-1)*(vNbLg-1) do cotes^[i]:=nil;
   if not elimine
      then
          for indice:=nbCotes downto 1 do
               begin
                    i:=cotes^[indice]^.i; j:=cotes^[indice]^.j;
                    if visible^[(vNbLg+1)*i+j+1]
                       then
                           begin
                                liste1.ajouter_fin(projetes^[vNbLg*(i-1)+j]^.evaluer);

                                liste1.ajouter_fin(projetes^[vNbLg*(i-1)+j+1]^.evaluer);

                                liste1.ajouter_fin(projetes^[vNbLg*i+j+1]^.evaluer);

                                liste1.ajouter_fin(projetes^[vNbLg*i+j]^.evaluer);

                                liste1.ajouter_fin(projetes^[vNbLg*(i-1)+j]^.evaluer);

                                liste1.ajouter_fin(new(Paffixe,init(jump^.x,eclairage^[(vNbLg-1)*(i-1)+j])));

                           end;
               end
      else
          begin
               Eliminer;
               Ajump:=false;
               for i:=1 to uNbLg do
                   begin
                        for j:=1 to vNbLg do
                            begin
                                 indice:=vNbLg*(i-1)+j;
                                 if visible^[(vNbLg+1)*i+j+1] or visible^[(vNbLg+1)*(i-1)+j]
                                    or visible^[(vNbLg+1)*(i-1)+j+1]
                                    or visible^[(vNbLg+1)*i+j]
                                    then
                                        begin
                                             liste1.ajouter_fin(projetes^[indice]^.evaluer);
                                             Ajump:=false;
                                        end
                                    else
                                        if not Ajump
                                           then
                                               begin
                                                    liste1.ajouter_fin(new(Paffixe,init(jump^.x,jump^.y)));
                                                    Ajump:=true;
                                               end
                            end;
                        if not Ajump
                           then
                               begin
                                    liste1.ajouter_fin(new(Paffixe,init(jump^.x,jump^.y)));
                                    Ajump:=true;
                               end
                   end;
  
                for j:=1 to vNbLg do
                    begin
                         for i:=1 to uNbLg do
                             begin
                                  indice:=vNbLg*(i-1)+j;
                                  if visible^[(vNbLg+1)*i+j+1] or visible^[(vNbLg+1)*(i-1)+j]
                                     or visible^[(vNbLg+1)*(i-1)+j+1]
                                     or visible^[(vNbLg+1)*i+j]
                                     then
                                         begin
                                              liste1.ajouter_fin(projetes^[indice]^.evaluer);
                                              Ajump:=false;
                                         end
                                     else
                                         if not Ajump
                                            then
                                                begin
                                                     liste1.ajouter_fin(new(Paffixe,init(jump^.x,jump^.y)));
                                                     Ajump:=true;
                                                end
                             end;
                         if not Ajump
                            then
                                begin
                                     liste1.ajouter_fin(new(Paffixe,init(jump^.x,jump^.y)));
                                     Ajump:=true;
                                end
                    end;
          end;
   for i:=1 to uNbLg-1 do for j:=1 to vNbLg-1
       do
         begin
              Kill(Pcellule(centres^[(vNbLg-1)*(i-1)+j]));
              if cotes^[(vNbLg-1)*(i-1)+j]<>nil then dispose(cotes^[(vNbLg-1)*(i-1)+j]);
         end;
   for i:=1 to uNbLg do for j:=1 to vNbLg
       do
         begin
              Kill(Pcellule(projetes^[(vNbLg)*(i-1)+j]));
              If table^[(vNbLg)*(i-1)+j]<>nil then dispose(table^[(vNbLg)*(i-1)+j]);
         end;

  freemem(table,uNbLg*vNbLg*Sizeof(Ppont));
  freemem(eclairage,(uNbLg-1)*(vNbLg-1)*Sizeof(real));
  freemem(visible,(uNbLg+1)*(vNbLg+1)*Sizeof(Boolean));
  freemem(projetes,uNbLg*vNbLg*Sizeof(Paffixe));
  freemem(centres,(uNbLg-1)*(vNbLg-1)*Sizeof(Paffixe));
  freemem(cotes,(uNbLg-1)*(vNbLg-1)*Sizeof(PrgtCote));

  liste:=Paffixe(liste1.tete);

end;
{==============================}
Constructor TSurface.init;
begin
     elimination:=false;
     degrade:=true;
     T_Ligne.init(UnNom,UneCommande,1,0);
     cat:=cat_surface;
end;
{==============================}
procedure Tsurface.ConstruitArbre;
begin
     if Unarbre<>nil
        then
            begin
             new(arbre,init);
             DefCommande:=false;
             arbre^.VarLoc:=LesVarLoc;
             Unarbre^.ConvertLocale('u');
             Unarbre^.ConvertLocale('v');
             arbre^.corps:=Unarbre;
        end
        else
            begin
                 new(arbre,init);
                 arbre^.varloc^.ajouter_fin(new(Pconstante,init('u',nil,true)));
                 arbre^.varloc^.ajouter_fin(new(Pconstante,init('v',nil,true)));
                 if (not arbre^.definir(LigneCommande))
             or (arbre^.corps^.categorie<>cat_commande)
             or (Pcommande(arbre^.corps^.contenu)^.nom<>'Liste')
             or (arbre^.corps^.arguments=nil)
                then begin dispose(arbre,detruire);arbre:=nil end;
                 DefCommande:=true;
            end;
end;
{=============================}
procedure TSurface.Recalculer;
var fX,fY,fZ:Pexpression;
    f1,f2,f3,f4,f5,f6,f7:Pcorps;
    res,U,V,Lg:Paffixe;
    aux:Pliste;
begin
     if arbre=nil then exit;
     if DefCommande then
        begin
             dispose(arbre,detruire);
             ConstruitArbre(nil);
             if arbre=nil then exit;
        end;
     
    if Ptheta^.affixe=nil
     then
         begin
              theta:=pi/6;
              Ptheta^.affixe:=New(Paffixe,init(theta,0));
         end
     else theta:=Ptheta^.Affixe^.x;
    if Pphi^.affixe=nil
     then
         begin
              phi:=pi/3;
              Pphi^.affixe:=New(Paffixe,init(phi,0));
         end
     else phi:=Pphi^.Affixe^.x;
     f1:=Pcorps(arbre^.corps^.arguments^.tete);
     if f1<>nil then f2:=Pcorps(f1^.suivant) else f2:=nil;
     if f2<>nil then f3:=Pcorps(f2^.suivant) else f3:=nil;
     if (f1=nil) or (f3=nil) or (f2=nil)
        then exit;
     uMin:=-5; uMax:=5;
     vMin:=-5; vMax:=5;
     uNbLg:=25; vNbLg:=25;
     liste_points^.detruire;
     liste_points^.init;

     new(fX,init);
     //fX^.corps:=f1^.dupliquer;
     //aux:=LesVarLoc;
     //LesVarLoc:=fX^.VarLoc;
     //fX^.corps^.brancherLocales;
     fX^.corps:=f1;
     fX^.varloc:=arbre^.VarLoc;

     new(fY,init);
     //fY^.corps:=f2^.dupliquer;
     //LesVarLoc:=fY^.VarLoc;
     //fY^.corps^.brancherLocales;
     fY^.corps:=f2;
     fY^.varloc:=arbre^.VarLoc;

     new(fZ,init);
     //fZ^.corps:=f3^.dupliquer;
     //LesVarLoc:=fZ^.VarLoc;
     //fZ^.corps^.brancherLocales;
     //LesVarLoc:=aux;
     fZ^.corps:=f3;
     fZ^.varloc:=arbre^.VarLoc;

     f4:=Pcorps(f3^.suivant);
     if f4<>nil
        then
            begin
                 U:=f4^.evaluer;
                 if (U<>nil)
                    then
                        begin
                             if (U^.x<U^.y)
                                then
                                    begin
                                         uMin:=U^.x; uMax:=U^.y;
                                    end;
                             Kill(Pcellule(U));
                        end;
                  f5:=Pcorps(f4^.suivant);
                  if f5<>nil
                     then
                         begin
                              V:=f5^.evaluer;
                              if (V<>nil)
                                 then
                                     begin
                                          if (V^.x<V^.y)
                                             then
                                                 begin
                                                      vMin:=V^.x; vMax:=V^.y;
                                                 end;
                                          Kill(Pcellule(V));
                                     end;
                              f6:=Pcorps(f5^.suivant);
                              if f6<>nil
                                 then
                                     begin
                                          Lg:=f6^.evaluer;
                                          if (Lg<>nil)
                                             then
                                                 begin
                                                      uNbLg:=abs(Round(Lg^.x));
                                                      vNbLg:=abs(Round(Lg^.y));
                                                      if uNbLg<2 then uNbLg:=2;
                                                      if vNbLg<2 then vNbLg:=2;
                                                 end;
                                          Kill(Pcellule(Lg));
                                          f7:=Pcorps(f6^.suivant);
                                          if f7<>nil
                                             then
                                                 begin
                                                      Lg:=f7^.evaluer;
                                                       degrade:=(Lg^.x=1);
                                                      Kill(Pcellule(Lg));

                                                end;
                                     end;

                         end;
            end;

     surface(fX,fY,fZ,res,uMin,uMax,vMin,vMax,uNbLg,vNbLg,elimination,degrade);
     dispose(fX); dispose(fY); dispose(fZ);//detruire
     liste_points^.ajouter_fin(res);

     purger;
     clip;
end;

procedure TSurface.enregistrer_latex;
var
   aux:Paffixe;
   oldfill:byte;
begin
     if liste_points^.tete=nil then exit;
     if fill_style=0 then t_ligne.enregistrer_latex
     else begin
     elimination:=true;
     oldfill:=fill_style;
     fermee:=0; fill_style:=0;
     aux:=Paffixe(liste_points^.tete);
     liste_points^.init;
     recalculer;
     T_ligne.enregistrer_latex;
     fermee:=1;
     fill_style:=oldfill;
     elimination:=false;
     liste_points^.detruire;
     liste_points^.ajouter_fin(aux)
     end;
end;
{=====================================}
function Tproj3D.executer(arg: Pliste):Paffixe;
var f:Pcorps;
    P1:Paffixe;
    res:type_liste;
    saut:boolean;
    jumpY:real;
begin
     executer:=nil;
     if arg=nil then exit;
     f:=Pcorps(arg^.tete);
     if f=nil then exit;
     if Ptheta^.affixe=nil
     then
         begin
              theta:=pi/6;
              Ptheta^.affixe:=New(Paffixe,init(theta,0));
         end
     else theta:=Ptheta^.Affixe^.x;
     if Pphi^.affixe=nil
     then
         begin
              phi:=pi/3;
              Pphi^.affixe:=New(Paffixe,init(phi,0));
         end
     else phi:=Pphi^.Affixe^.x;
     res.init;
     P1:=Paffixe(f^.evaluer);
     while P1<>nil do
           begin
                saut:=IsJump(P1);
                if saut then jumpY:=P1^.y else jumpY:=jump^.y;
                if saut or (P1^.suivant=nil) or Isjump(Paffixe(P1^.suivant))
                   then res.ajouter_fin(New(Paffixe,init(jump^.x,jumpY)))
                   else res.ajouter_fin(projeter(P1^.x,P1^.y,Paffixe(P1^.suivant)^.x));
                P1:=Paffixe(P1^.suivant);
                if (P1<>nil) and (not saut) then P1:=Paffixe(P1^.suivant);
           end;
     Kill(Pcellule(P1));
     executer:=Paffixe(res.tete);

end;
{=======================}

{========================}
Begin
     LesConstantes^.ajouter_fin(New(Pconstante,init('theta',New(Paffixe,init(pi/6,0)),false)));
     LesConstantes^.ajouter_fin(New(Pconstante,init('phi',New(Paffixe,init(pi/3,0)),false)));
     LesCommandes^.ajouter_fin(New(PProj3D,init('Proj3D')));
    Ptheta:=constante('theta');
     Pphi:=constante('phi')
end.
