unit AxesGrille;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Graph1_6,Graph2_7, ExtCtrls;

type
  TAxesGrilleForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox3: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    GroupBox4: TGroupBox;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Label7: TLabel;
    Edit7: TEdit;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
     function Valider: Boolean;
  end;

var
  AxesGrilleForm: TAxesGrilleForm;

implementation
uses Unite1,listes2,complex3,analyse4,saisies, Unit1;
{$R *.DFM}

procedure TAxesGrilleForm.Button1Click(Sender: TObject);
begin
     if Valider then ModalResult:=mrOk;
end;


procedure TAxesGrilleForm.Button3Click(Sender: TObject);
begin
     MainForm.GestionAttributs(Edit7.text);
     Button1.SetFocus;
end;

procedure TAxesGrilleForm.FormCreate(Sender: TObject);
var p: Pelement;
begin
     digits:=12;
     Edit7.Text:=CurrentName;
     if CurrentCat=cat_axes
        then p:=Paxes(CurrentGraph)
        else
            begin
                 p:=Pgrille(Currentgraph);
                 GroupBox3.visible:=false;
                 GroupBox4.visible:=false;
                 Button1.Top:=136; Button2.Top:=136;Button3.Top:=136;
                 ClientHeight:=173; Caption:= 'Grille'
            end;

     if p<>nil then
     begin
   p^.lireAttributs;
   Edit1.text:=Streel(Pgrille(p)^.O_x);
   Edit2.text:=Streel(Pgrille(p)^.O_y);
   Edit3.Text:=Streel(Pgrille(p)^.GradX);
   Edit4.text:=Streel(Pgrille(p)^.GradY);
   if CurrentCat=cat_axes then
      begin
           Edit5.text:= Streel(xyticks);
           Edit6.text:= Streel(xylabelsep);
           Radiogroup1.itemIndex:=(xylabelpos And 12) div 4;
           Radiogroup2.itemIndex:=(xylabelpos And 3);
      end
     end else
    begin
     if (Xmin<=0) and (0<=Xmax)
        then Edit1.Text:='0' else Edit1.Text:=Streel((Xmin+Xmax)/2);
     If (Ymin<=0) and (0<=Ymax)
        then Edit2.Text:='0' else Edit2.Text:=Streel((Ymin+Ymax)/2);
     DefaultSettings;
     if CurrentCat=cat_grille then begin
                                   Edit3.Text:='0.25';
                                   Edit4.Text:='0.25';
                                   LineColor:=Rgb(192,192,192);
                                   PColor^.affixe^.x:=LineColor
                            end
                       else begin  Edit3.Text:='1';
                                   Edit4.Text:='1';
                                   Edit5.text:= Streel(xyticks);
                                   Edit6.text:= Streel(xylabelsep);
                                   Radiogroup1.itemIndex:=(xylabelpos and 12) div 4;
                                   Radiogroup2.itemIndex:=(xylabelpos and 3)
                            end;
   end;
   digits:=4;
end;

function TAxesGrilleForm.Valider:boolean;
var    Ox,Oy,Gx,Gy,ticks,labelsep:real;
    Chaine:string;
    nom:Tnom;
begin
     Valider:=true;
     if validreal(Edit1,Xmin,Xmax,Ox) and
        validreal(Edit2,Ymin,Ymax,Oy) and
        validreal(Edit3,0,reel_Max,Gx) and
        validreal(Edit4,0,reel_Max,Gy)
        then
            begin
                 nom:=Edit7.text;
                 chaine:='['+Streel(Ox)+'+i*('+Streel(Oy)+'),'+
                         Streel(Gx)+'+i*('+Streel(Gy)+')]';
                 if CurrentCat=cat_grille
                    then begin
                         liste_element.inserer(new(Pgrille,init(nom,chaine)),CurrentGraph);
                         liste_element.supprimer(Pcellule(CurrentGraph));
                         end
                     else
                     if  validreal(Edit5,0,reel_Max,ticks) and
                         validreal(Edit6,0,reel_Max,labelsep) then
                       begin
                          PxyTicks^.affixe^.x:=ticks;
                          Pxylabelsep^.affixe^.x:=labelsep;
                          PxyLabelpos^.affixe^.x:=Radiogroup2.itemIndex +4*Radiogroup1.ItemIndex;
                          liste_element.inserer(new(Paxes,init(nom,chaine)),CurrentGraph);
                          liste_element.supprimer(Pcellule(CurrentGraph));
                       end
                       else Valider:=false
            end
        else Valider:=false
end;


end.
