unit Fenetre;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFenetreForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Dclarations prives }
    sortieOk:boolean;
  public
    { Dclarations publiques }
  end;

var
FenetreForm: TFenetreForm;

implementation
uses Unite1{calculs},complex3,command5,graph1_6,saisies;
{$R *.DFM}

procedure TFenetreForm.FormCreate(Sender: TObject);
begin
     digits:=12;
     edit1.text:=Streel(Xmin);
     edit2.text:=Streel(Xmax);
     edit3.text:=Streel(Ymin);
     edit4.text:=Streel(Ymax);
     edit5.text:=Streel(Xscale);
     edit6.text:=Streel(Yscale);
     digits:=4;
end;



procedure TFenetreForm.Button1Click(Sender: TObject);
begin
     SortieOk:=true;
end;

procedure TFenetreForm.Button2Click(Sender: TObject);
begin
     SortieOk:=false;
end;

procedure TFenetreForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var x1,x2,y1,y2,xs,ys:real;
begin
     if sortieOk then
     begin
          CanClose:=false;
          if validReal(edit1,-reel_Max,reel_Max,x1) and
             validReal(edit2,-reel_Max,reel_Max,x2) and
             validReal(edit3,-reel_Max,reel_Max,y1) and
             validReal(edit4,-reel_Max,reel_Max,y2) and
             validReal(edit5,0,reel_Max,xs) and
             validReal(edit6,0,reel_Max,ys)
             then
                 if (x1>=x2) or (y1>=y2)
                    then begin
                         Messagedlg('La fentre n''est pas valide',mtWarning,[mbOk],0);
                         exit
                         end
                    else
                 if (xs=0) or (ys=0)
                    then begin
                         Messagedlg('Une des chelles n''est pas valide',mtWarning,[mbOk],0);
                         exit
                         end
                    else
                        begin
                             graph1_6.fenetre(x1,y1,x2,y2,xs,ys);
                             CanClose:=true;
                        end;
     end else CanClose:=true;
end;
end.
