% Fenetre Xmin Xmax Ymin Ymax Xscale Yscale
100#0#8#-5#0#0.800000000000#0.500000000000##
% Marges gauche droite haut bas cadre gestion_couleur
101#0.5#0.5#0.5#0.5#0#1##
% Dclaration des Variables Globales
15#O#0##
15#NbCol#9##
15#NbLig#6##
15#NbTraits#1##
15#largCol#[1,1,1,1,1,1,1,1,1]##
15#hautLig#[1,1,1,1,1,1]##
15#drawGrid#1##
15#decal#1/15##
15#numF#1##
15#numS#1##
15#numB#1##
15#numE#1##
15#numC#1##
15#numD#1##
15#first#1##

% Dclaration des Macros

16#pos#{pos(lig,col): renvoie l'affixe du centre de la case d'indices lig et col}
[$x:= Re(O), y:=i*Im(O),
 for $k from 1 to %2-1 do Inc(x, largCol[k]) od, Inc(x, largCol[%2]/2),
 for $k from 1 to %1-1 do Inc(y,-i*hautLig[k]) od, Inc(y,-i*hautLig[%1]/2),
 x+y]##

16#posNE#{posNE(lig,col): renvoie l'affixe du centre du quart NE de la case d'indices lig et col}
pos(%1,%2)+(largCol[%2]+i*hautLig[%1])/4##

16#posSE#{posSE(lig,col): renvoie l'affixe du centre du quart SE de la case d'indices lig et col}
pos(%1,%2)+(largCol[%2]-i*hautLig[%1])/4##

16#posNO#{posNO(lig,col): renvoie l'affixe du centre du quart NO de la case d'indices lig et col}
pos(%1,%2)-(largCol[%2]-i*hautLig[%1])/4##

16#posSO#{posSO(lig,col): renvoie l'affixe du centre du quart SO de la case d'indices lig et col}
pos(%1,%2)-(largCol[%2]+i*hautLig[%1])/4##

16#posCol#{ posCol(col) renvoie l'affixe du coin suprieur droit de la colonne }
[$x:=O,
 for $k from 1 to %1 do Inc(x, largCol[k]) od,
x]##

16#posLig#{ posLig(lig) renvoie l'affixe du coin infrieur gauche de la ligne}
[$x:=O,
 for $k from 1 to %1 do Inc(x,-i*hautLig[k]) od,
 x]##

16#traitH#{traitH(lig): trait horizontal sous la ligne numero lig}
[if nil(%2)=0 then $col1:=%2 else col1:=1 fi,
 if nil(%3)=0 then $col2:=%3 else col2:=NbCol fi,
 if nil(%4)=0 then $pos:=%4 else pos:=1 fi,
 if nil(%5)=0 then $double:=%5 else double:=0 fi,
 $u:=i*(Im(posLig(%1))+(1-pos)*hautLig[%1])+Re(posCol(col1-1)),
 $v:=i*Im(u)+Re(posCol(col2)),
 if double=0 
 	then Seg(u,v)
 	else $dec:=decal*Xscale/Yscale/2, Seg(u-i*dec,v-i*dec), Seg(u+i*dec,v+i*dec)
 fi
 ]##

16#traitV#{traitV(col): trait vertical aprs la colonne numero col}
[if nil(%2)=0 then $lig1:=%2 else lig1:=1 fi,
 if nil(%3)=0 then $lig2:=%3 else lig2:=NbLig fi,
 if nil(%4)=0 then $pos:=%4 else pos:=1 fi,
 if nil(%5)=0 then $double:=%5 else double:=0 fi,
 $u:=Re(posCol(%1))-(1-pos)*largCol[%1]+i*Im(posLig(lig1-1)),
 $v:=Re(u)+i*Im(posLig(lig2)),
 if double=0 
 	then Seg(u,v)
 	else Seg(u-decal/2,v-decal/2), Seg(u+decal/2,v+decal/2)
 fi
]##

16#Cadre#{Cadre(lig1,col1,lig2,col2) }
[$a:= Re(posCol(%2-1))+i*Im(posLig(%1-1)), $b:= Re(posCol(%4))+i*Im(posLig(%3)),
 Ligne([a, Re(b)+i*Im(a), b, Re(a)+i*Im(b)],1)
 ]##

16#Diag#{Diag(lig1,col1,lig2,col2,type) }
[if %5=1 then
	$a:= Re(posCol(%2-1))+i*Im(posLig(%1-1)), $b:= Re(posCol(%4))+i*Im(posLig(%3))
else a:= Re(posCol(%2-1))+i*Im(posLig(%1)), $b:= Re(posCol(%4))+i*Im(posLig(%3-1))
fi,
Ligne([a, b],0) 
]##


16#largeurCol#
if Input("Entrez le numro de la colonne et sa largeur (sparars d'une virgule), la largeur est de 1 par dfaut.
Pour modifier toutes les colonnes, entrez le numro 0, exemple:
0,1.5", "Modifier la largeur d'une (ou des) colonne(s)")
then
 $x:= Eval([ "[", chaine(), "]" ]), $num:=x[1], $val:=x[2], 
 if num=0 then  largCol:= for $z in largCol do val od, ReCalc()
 elif 0<num And num<=NbCol then replace(largCol,num,val), ReCalc()
 fi
fi##

16#hauteurLig#
if Input("Entrez le numro de la ligne et sa hauteur (sparars d'une virgule), la hauteur est de 1 par dfaut.
Pour modifier toutes les lignes, entrez le numro 0, exemple:
0,1.5", "Modifier la hauteur d'une (ou des) ligne(s)")
then
 $x:= Eval([ "[", chaine(), "]" ]), $num:=x[1], $val:=x[2], 
 if num=0 then  hautLig:= for $z in hautLig do val od, ReCalc()
 elif 0<num And num<=NbLig then replace(hautLig,num,val), ReCalc()
 fi
fi##

%%%%%%%% Cration du Menu %%%%%%%

16#Menu#[
Set($x,0),
Bouton(RefPoint,"Trait Horiz.","GererMenu(1)", "Dessine un trait horizontal sous la ligne voulue"),
Inc(x,1),
Bouton(RefPoint+DeltaB,"Trait Vert.","GererMenu(2)","Dessine un trait vertical  droite de la colonne voulue"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Flche","GererMenu(3)","Dessine une flche d'une case vers une autre"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Double Barre","GererMenu(4)","Dessine une double barre au milieu de la colonne voulue"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Simple Barre","GererMenu(9)","Dessine une barre simple au milieu de la colonne voulue"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Hachures","GererMenu(5)","Hachure une zone rectangulaire du tableau"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Cadre","GererMenu(10)","Dessine un cadre autour d'une ou plusieurs cases du tableau"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"DiagonaleD","GererMenu(11)","Dessine une diagonale descendante dans une ou plusieurs cases du tableau"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"DiagonaleM","GererMenu(12)","Dessine une diagonale montante dans une ou plusieurs cases du tableau"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Grille","GererMenu(6)","Fait apparatre la grille de reprage"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Dimensions","GererMenu(7)","Pour changer le nombre de lignes et/ou de colonnes"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Largeur Colonne","largeurCol()","Pour changer la largeur d'une ou des colonnes"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Hauteur Ligne","hauteurLig()","Pour changer la hauteur d'une ou des lignes"),
Inc(x,1),
Bouton(RefPoint+x*DeltaB,"Terminer","GererMenu(8)", "Pour enlever la grille et retailler la fentre")
]##



16#fleche#{fleche(lig1,col1,lig2,col2): trace une flche de la case (lig1,col1)  la case 
(lig2,col2)}
[Set($a, pos(%1,%2)), Set($b, pos(%3,%4)), Set($long, abs(b-a)), 
 Set($u, (b-a)/long), Set($x1,abs(Re(u)/largCol[%2])),Set($y1,abs(Im(u)/hautLig[%1])),
 Set(norm1,Si(x1>y1,2*x1,y1*2)),
 Set($x2,abs(Re(u)/largCol[%4])),Set($y2,abs(Im(u)/hautLig[%3])),
 Set(norm2,Si(x2>y2,2*x2,y2*2)),
 Set(Arrows, 1), Seg(a+u/norm1, b-u/norm2), Set(Arrows, 0)]##

16#grille#{grille(): dessine la grille de reprage}
if drawGrid then
Fenetre(0-(1-i),Im(posLig(NbLig))*i+Re(posCol(NbCol))),
Set(LineStyle, dotted),
$depart:=O, $arrivee:=posCol(NbCol), Seg(depart,arrivee),
for $k from 1 to NbLig do $saut:=-i*hautLig[k], Inc(depart,saut), Inc(arrivee,saut), Seg(depart,arrivee) od,
$depart:=O, $arrivee:=posLig(NbLig), Seg(depart,arrivee),
for $k from 1 to NbCol do $saut:=largCol[k], Inc(depart,saut), Inc(arrivee,saut), Seg(depart,arrivee) od,
Seq(Label(Re(pos(1,k))+i/2, k),k, 1, NbCol), 
Seq(Label(i*Im(pos(k,1))-1/2, k), k, 1, NbLig)
else Fenetre(0,Im(posLig(NbLig))*i+Re(posCol(NbCol)))
fi
##

16#doubleB#{doubleB(col,lig1,lig2): dessine une double barre dans la colonne col de la ligne
lig1  la ligne lig2 (incluses)}
\traitV(%1,%2,%3,0.5,1)##

16#simpleB#{simpleB(col,lig1,lig2): dessine une barre simple dans la colonne col de la ligne
lig1  la ligne lig2 (incluses)}
\traitV(%1,%2,%3,0.5)##

16#exclusion#{exclusion(lig1,col1,lig2,col2): dessine et hachure une zone rectangulaire dfinie
 par le coin suprieur gauche: (lig1,col1) et le coin infrieur droit: (lig2,col2)}
[Set($x,pos(%1,%2)+i*hautLig[%1]/2+decal/2),
Set($h,Im(x-posLig(%3))), Set($w,Re(posCol(%4)-x)-largCol[%4]/2-decal/2),
Set(FillStyle,bdiag),Set(FillColor,black), 
Ligne([x,x+w,x+w-i*h,x-i*h],1),Set(FillStyle,none)]##

16#Dimension#
if Input("Tapez le nombre de lignes et de colonnes (exemple: 6,9)","Nombre de lignes et de colonnes",[NbLig,",",NbCol])
then
 $x:=1,
 Set($x,Eval(["[",chaine(),"]"])),
 Set($NbLig1,Copy(x,1,1)),
 Set($NbCol1,Copy(x,2,1)),
 if NbCol>NbCol1 then Del(largCol,NbCol1+1,NbCol-NbCol1) 
 	else for $k from NbCol+1 to NbCol1 do Insert(largCol,1) od
 fi, 
 if NbLig>NbLig1 then Del(hautLig,NbLig1+1,NbLig-NbLig1) 
 	else for $k from NbLig+1 to NbLig1 do Insert(hautLig,1) od
 fi,
 NbLig:=NbLig1, NbCol:=NbCol1,
 ReCalc()
fi##


%%%%%%%% Gestion du menu pour chaque item  on indique l'action a excuter %%%%%

16#GererMenu#[Set($item,%1),
if item=1
	then if Input( "Dessine un trait horizontal sous la ligne voulue, de la colonne col1  col2 (de 1  NbCol par dfaut). Position est un nombre entre 0 (haut de la ligne) et 1 (par defaut), double vaut 0 (par dfaut) ou 1. Entrez le numro de la ligne", "traitH( ligne [, col1, col2, position, double] )")
			then Creer(["traitH", NbTraits], ["traitH(",chaine(),")"]), Inc(NbTraits,1), ReDraw()
		 fi	
elif item=2
	then if Input( "Dessine un trait  vertical  droite de la colonne voulue, de la ligne lig1  lig2 (de 1  NbLig par dfaut). Position est un nombre entre 0 (bord gauche) et 1 (par defaut), double vaut 0 (par dfaut) ou 1. Entrez le numro de colonne", "traitV( colonne [, lig1, lig2, position, double] )")
    		then Creer(["traitV", NbTraits], ["traitV(", chaine(),")"]), Inc(NbTraits,1), ReDraw()
    	 fi	
elif item=3 
	then if Input( "Dessine une flche de la case (ligne1,colonne1) vers la case (ligne2,colonne2). Entrez les quatre valeurs numriques: ligne1,colonne1,ligne2,colonne2", "fleche( ligne1, colonne1, ligne2, colonne2)")
    		then Creer(["fleche",numF], ["fleche(", chaine(),")"]), Inc(numF,1), ReDraw()
    	 fi	
elif item=4 
	then if Input( "Dessine une double barre dans la colonne indique, allant d'une ligne  une autre (incluses). Entrez les trois valeurs numriques: colonne,ligne1,ligne2", "doubleB( colonne, ligne1, ligne2).")
            	then Creer(["doubleB", numB], ["doubleB(", chaine(),")"]), Inc(numB,1), ReDraw()
         fi
elif item=5 
	then if Input( "Hachure la zone rectangulaire allant de la case (ligne1, colonne1)  la case (ligne2, colonne2). Entrez les quatre valeurs numriques: ligne1,colonne1,ligne2,colonne2","exclusion( ligne1, colonne1, ligne2 colonne2)")
			then Creer(["exclus", numE], ["exclusion(", chaine(),")"]), Inc(numE,1), ReDraw()
		 fi	
elif item=6
	then if drawGrid=0 then drawGrid:=1,ReCalc() fi
elif item=8
	then if drawGrid=1 then drawGrid:=0,ReCalc() fi
elif item=9
	then if Input( "Dessine une barre simple dans la colonne indique, allant d'une ligne  une autre (incluses). Entrez les trois valeurs numriques: colonne,ligne1,ligne2", "simpleB( colonne, ligne1, ligne2).")
			then Creer(["simpleB", numS], ["simpleB(", chaine(),")"]), Inc(numS,1), ReDraw()
		 fi	
elif item=7
	then Dimension()
elif item=10 
	then if Input( "Entoure la zone rectangulaire allant de la case (ligne1, colonne1)  la case (ligne2, colonne2). Entrez les quatre valeurs numriques: ligne1,colonne1,ligne2,colonne2","Cadre( ligne1, colonne1, ligne2 colonne2)")
			then Creer(["cadre", numC], ["Cadre(", chaine(),")"]), Inc(numC,1), ReDraw()
		 fi		
elif item=11 
	then if Input( "Dessine une diagonale descendante (NO -> SE) dans la zone rectangulaire allant de la case (ligne1, colonne1)  la case (ligne2, colonne2).
	 Entrez les quatre valeurs numriques: ligne1,colonne1,ligne2,colonne2","Diag( ligne1, colonne1, ligne2 colonne2, 1)")
			then Creer(["DiagD", numD], ["Diag(", chaine(),",1)"]), Inc(numD,1), ReDraw()
		 fi			 
elif item=12 
	then if Input( "Dessine une diagonale montante (SO -> NE) dans la zone rectangulaire allant de la case (ligne1, colonne1)  la case (ligne2, colonne2).
	 Entrez les quatre valeurs numriques: ligne1,colonne1,ligne2,colonne2","Diag( ligne1, colonne1, ligne2 colonne2, 2)")
			then Creer(["DiagM", numD], ["Diag(", chaine(),",2)"]), Inc(numD,1), ReDraw()
		 fi
fi]##


%%%%%% Chaque clic gauche provoque l'excution de la macro ClicG %%%%%%%%%

16#ClicG#[$x:=Re(%1), $dep:=Re(O), $k:=0, while dep<x And (k<=NbCol) do Inc(k,1), Inc(dep,largCol[k]) od, 
if k>NbCol then $col:=0 else col:=k fi,
$x:=Im(%1), $dep:=Im(O), $k:=0, while dep>x And (k<=NbLig) do Inc(k,1), Inc(dep,-hautLig[k]) od, 
if k>NbLig then $lig:=0 else lig:=k fi,
if col>0 And lig>0
 then
  if Input(["L",lig,"C",col],"Label:")
  	then Creer(["L",lig,"C",col], ["Label(pos(",lig,",",col,"),""",chaine(),""")"]), ReDraw()
  fi
fi
]##

16#Init#[Menu(), if first then Dimension(), first:=0 fi]##
14#Grille#\grille##
14#traitH0#[Set(Width,thicklines), traitH(1),Set(Width,thinlines)]##
14#traitV0#[Set(Width,thicklines), traitV(1),Set(Width,thinlines)]##

