unit Varglobs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,analyse4;

type
  TVarGlobsForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Dclarations prives }
    sortieOK:boolean;
  public
    { Dclarations publiques }
  end;

var
  VarGlobsForm: TVarGlobsForm;
  CurrentVarGlob:PVarGlob;

implementation
uses listes2,complex3,graph1_6;
{$R *.DFM}

procedure TVarGlobsForm.Button1Click(Sender: TObject);
begin
     SortieOk:=true
end;

procedure TVarGlobsForm.Button2Click(Sender: TObject);
begin
     SortieOk:=false
end;

procedure TVarGlobsForm.FormCreate(Sender: TObject);
begin
     if CurrentVarGlob=nil
        then
            begin
                 edit1.text:='';
                 edit2.text:='';
            end
        else
            begin
                 edit1.text:=CurrentVarGlob^.variable^.nom;
                 if CurrentVarGlob^.commande='' then
                    begin
                    If CurrentVarGlob^.variable^.affixe<>nil
                       then CurrentVarGlob^.commande:=CurrentVarGlob^.variable^.affixe^.en_chaine(12)
                       else CurrentVarGlob^.commande:='1/0'
                    end;
                 edit2.text:=CurrentVarGlob^.commande;
            end
end;

procedure TVarGlobsForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var res:Paffixe;
    f:Pexpression;
    nom:Tnom;
    commande:Pchar;
begin
     if sortieOk then
     begin
     CanClose:=false;
     nom:=Edit1.text;
     commande:=Pchar(edit2.text);
     if NomValide(nom,CurrentVarGlob<>nil) then
           begin
                 new(f,init);
                 if not f^.definir(commande)
                    then begin
                              Messagedlg(ErrorMessage,mtWarning,[mbok],0);
                              Edit2.selStart:=ErrorPos-1;
                              Edit2.SelLength:=1;edit2.setfocus
                         end
                    else
                              if CurrentVarGlob<>nil then
                                 begin
                                        res:=f^.evaluer;
                                        Kill(Pcellule(CurrentVarGlob^.variable^.affixe));
                                        CurrentVarGlob^.variable^.affixe:=res;
                                        CurrentVarGlob^.variable^.nom:=nom;
                                        CurrentVarGlob^.commande:=commande;
                                        CanClose:=true
                                 end else
                                             begin
                              VariablesGlobales^.ajouter_fin(new(PVarGlob,init(nom,commande)));
                              CanClose:=true
                                             end;
                 dispose(f,detruire)
           end
           else
               begin
                    Messagedlg('Nom invalide ou dj pris!',mtWarning,[mbok],0);
                    edit1.selectAll;
                    edit1.setfocus
               end
     end
     else Canclose:=true;
end;

end.
