{Copyright (C) 2005 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version 
ultrieure choisie par vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
 Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme;
 si ce n'est pas le cas, crivez  la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 }

unit command5; { dfinition des oprations, des commandes, des constantes }
INTERFACE
USES windows, Sysutils,Unite1{calculs},Classes,listes2,complex3, analyse4;


function solve(f,df:Pexpression;const v:string;a,b,precision:real;nb:longint):Paffixe;
function definir_reel(Const chaine:String; var x:real):boolean;
function MakeString(f:Pcorps): string;

VAR     
        
        ChangeMac:boolean;       {indique si une macro a t cre/modifie}
        PXmin, PXmax, PYmin, PYmax, PXscale, PYscale: Pconstante; {pointe sur les coins de la fenetre}
        PExportMode: Pconstante; //type d'exportation= tex, pst, teg, eps ou pgf

IMPLEMENTATION


const
         priorite_affectation=-4;
         priorite_or=-2;
         priorite_and=-1;
         priorite_inferieur=0;       {priorits des oprations}
         priorite_superieur=0;
         priorite_egal=0;
         priorite_addition=1;
         priorite_soustraction=2;
         priorite_multiplication=3;
         priorite_division=4;
         priorite_puissance=5;
         priorite_fonction=6;
         priorite_copy=7;


type
         tRec=record Xinf,Yinf,Xsup,Ysup: real end;

         PCmListe= ^TCmListe;
         TCmListe= object(Tcommande)

               function executer(arg:PListe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         PCopy= ^TCopy;
         TCopy= object(Tcommande)

               function executer(arg:PListe):Paffixe;virtual;
               end;

        

         PSolve=^TSolve;
         TSolve= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
                     end;

         PSeq=^TSeq;
         TSeq= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
                     end;

         Pmap= ^Tmap;
         Tmap= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
                     end;

               PSi= ^TSi;
         TSi= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
                     function deriver(arg:Pliste;variable:string):Pcorps;virtual;
                     end;

         PSetVar= ^TSetVar;
         TSetVar= object(Tcommande)

                  function executer(arg:PListe):Paffixe;virtual;
                  end;

         PDel= ^TDel;
         TDel= object(Tcommande)

               function executer(arg:PListe):Paffixe;virtual;
               end;
         PAppend=^Tappend;
         TAppend= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
                end;

         PInc=^TInc;
         TInc= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
              end;

         PEchange=^TEchange;
         TEchange= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
              end;


         PLoop= ^TLoop;
         TLoop= object(Tcommande)

                     function executer(arg:PListe):Paffixe;virtual;
                     end;

         PAssign= ^TAssign;
         TAssign= object(Tcommande)

                     function executer(arg:PListe):Paffixe;virtual;
                     end;

         PNops=^TNops;
         TNops=object(Tcommande)
                   function executer(arg:PListe):Paffixe;virtual;
                     end;


         PDiff= ^TDiff;
         TDiff= object(Tcommande)

                     function executer(arg:PListe):Paffixe;virtual;
                     end;
         PInt= ^TInt;
         TInt= object(Tcommande)

                     function executer(arg:PListe):Paffixe;virtual;
                     function deriver(arg:Pliste;variable:string):Pcorps;virtual;
                     end;

         Pplus=^Tplus;
         Tplus= object(Toperation)

                     function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
                     function deriver(arg:Pliste;const variable:string):Pcorps;virtual;
                     function simplifier(arg:Pliste):Pcorps;virtual;
                     end;

         Pfois=^Tfois;
         Tfois= object(Toperation)

                     function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
                     function deriver(arg:Pliste;const variable:string):Pcorps;virtual;
                     function simplifier(arg:Pliste):Pcorps;virtual;
                     end;

         Pmoins=^Tmoins;
         Tmoins= object(Toperation)
                    
                     function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
                     function deriver(arg:Pliste;const variable:string):Pcorps;virtual;
                     function simplifier(arg:Pliste):Pcorps;virtual;
                     end;

         Pdiv=^Tdiv;
         Tdiv= object(Toperation)
                    
                     function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
                     function deriver(arg:Pliste;const variable:string):Pcorps;virtual;
                     function simplifier(arg:Pliste):Pcorps;virtual;
                     end;

         Pexpo=^Texpo;
         Texpo= object(Toperation)
                    
                     function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
                     function deriver(arg:Pliste;const variable:string):Pcorps;virtual;
                     function simplifier(arg:Pliste):Pcorps;virtual;
                     end;

         PCapD= ^TCapD;
         TCapD= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PCutB= ^TCutB;
         TCutB= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PCutA= ^TCutA;
         TCutA= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PCapL= ^TCapL;
         TCapL= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         POr= ^TOr;
         TOr= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PAnd= ^TAnd;
         TAnd= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PEgal= ^TEgal;
         TEgal= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PSup= ^TSup;
         TSup= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PSupOuE= ^TSupOuE;
         TSupOuE= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PInf= ^TInf;
         TInf= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PInfOuE= ^TInfOuE;
         TInfOuE= object(Toperation)

               function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
               end;

         PInside=^TInside;
         TInside= object(Toperation)
                     
                     function evaluer(arg1,arg2:Paffixe):Paffixe;virtual;
                     end;



         Psqr= ^Tsqr;
         Tsqr= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Popp= ^Topp;
         Topp= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Psin= ^Tsin;
         Tsin= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pcos= ^Tcos;
         Tcos= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Ptan= ^Ttan;
         Ttan= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Parcsin= ^Tarcsin;
         Tarcsin= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Parccos= ^Tarccos;
         Tarccos= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Parctan= ^Tarctan;
         Tarctan= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pargsh= ^Targsh;
         Targsh= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pargch= ^Targch;
         Targch= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pargth= ^Targth;
         Targth= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;



         Pexp= ^Texp;
         Texp= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pln= ^Tln;
         Tln= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Psqrt= ^Tsqrt;
         Tsqrt= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pbar= ^Tbar;
         Tbar= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Psh= ^Tsh;
         Tsh= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pch= ^Tch;
         Tch= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pth= ^Tth;
         Tth= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         Pabs= ^Tabs;
         Tabs= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         PArg= ^TArg;
         TArg= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               end;


         PEnt= ^TEnt;
         TEnt= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               function deriver(arg:Pliste;variable:string):Pcorps;virtual;
               end;

         PRand= ^TRand;
         TRand= object(Tfonction)

               function evaluer(arg:Paffixe):Paffixe;virtual;
               end;

         PRe= ^TRe;
         TRe= object(Tfonction)
                     
                     function evaluer(arg:Paffixe):Paffixe;virtual;
                     function deriver(arg:Pliste;variable:string):Pcorps;virtual;
                     end;

         PIm= ^TIm;
         TIm= object(Tfonction)
                     
                     function evaluer(arg:Paffixe):Paffixe;virtual;
                     function deriver(arg:Pliste;variable:string):Pcorps;virtual;
                     end;

         PRgb= ^TRgb;
         TRgb= object(Tcommande)
                function executer(arg:PListe):Paffixe;virtual;
               end;

         PSort=^Tsort;
         Tsort= object(Tcommande)

               function executer(arg:PListe):Paffixe;virtual;
               end;


{============ TPCmListe qui value une liste de complexes ===================}
function TCmListe.executer(arg:PListe):Paffixe;
var resultat:type_liste;
    op:Pcorps;
begin
     executer:=nil;
     if arg<>nil
        then
            begin
                 resultat.init;
                 op:=Pcorps(arg^.tete);
                 while (op<>nil) do
                       begin
                            resultat.ajouter_fin(PCellule(op^.evaluer));
                            op:=Pcorps(op^.suivant);
                       end;
                 executer:=Paffixe(resultat.tete);
            end;
end;
{=======================}
function TCmListe.deriver(arg:Pliste;variable:string):Pcorps;
var p,aux,f1:Pcorps;
    q:Pcommande;
    error:boolean;
begin
     deriver:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     
     q:=commande('Liste');
     p:=new(Pcorps,init(cat_commande,q));  {p va contenir l'expression drive, c'est une commande Liste}
     error:=false;
     repeat
           aux:=f1^.deriver(variable);
           if aux=nil
              then error:=true
              else p^.ajouter_arg(aux);
                       
           f1:=Pcorps(f1^.suivant);
     until (f1=nil) or  error;
     if error then begin dispose(p,detruire); p:=nil end;
     deriver:=p;
end;

{=============== Commande TSeq =========================================}
function Seq(f1:Pcorps;variable:Pconstante;debut,fin,pas:real):Paffixe;
var r,old:Paffixe;
    i:real;
    l:type_liste;
    {=============}
    function fini:boolean;
    begin
         if pas>0
            then fini:=i>fin
            else fini:=i<fin
    end;
    {=============}
begin
     Seq:=nil;
     if (variable^.predefinie) or (pas=0)
         or ((fin>debut) and (pas<0))
         or ((fin<debut) and (pas>0))
         then exit;
     old:=variable^.affixe;
     variable^.affixe:=new(Paffixe,init(debut,0));
     l.init; i:=debut;
     while not fini do
         begin
              variable^.affixe^.x:=i;
              r:=f1^.evaluer;
              if variable^.affixe<>nil
                 then
                     begin
                          i:=variable^.affixe^.x;
                          l.ajouter_fin(PCellule(r));
                          i:=i+pas
                     end
                 else begin l.detruire; exit end;
         end;
     Kill(Pcellule(variable^.affixe));
     variable^.affixe:=old;
     Seq:=Paffixe(l.tete);
end;
{=============}
function TSeq.executer(arg:PListe):Paffixe;
var f1,f2,f3,f4,f5:Pcorps;
    debut,fin,pas:real;
    T:Paffixe;
    error:boolean;
begin
     executer:=nil;            {f1=expression, f2=compteur, f3=valeur dep, f4= valeur fin, f5=pas}
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     if f3=nil then exit;
     f4:=Pcorps(f3^.suivant);
     if f4=nil then exit;
     f5:=Pcorps(f4^.suivant);
     if f2^.categorie<>cat_constante then exit;
     T:=f3^.evaluer;
     error:=false;
     pas:=1; debut:=0; fin:=0;
     if T<>nil
        then
            begin
                  if T^.y<>0
                     then error:=true
                     else debut:=T^.x;
                  Kill(Pcellule(T))
            end
        else exit;
     T:=f4^.evaluer;
     if T<>nil
        then
            begin
                 if T^.y<>0
                    then error:=true
                    else fin:=T^.x;
                 Kill(Pcellule(T))
            end
        else exit;
     if f5<>nil
        then
            begin
                 T:=f5^.evaluer;
                 if T<>nil
                    then
                        begin
                             if T^.y<>0
                                then error:=true
                                else pas:=T^.x;
                             Kill(Pcellule(T))
                        end
                    else exit;
            end
        else pas:=1;
     if not error
        then
            executer:=Seq(f1,Pconstante(f2^.contenu),debut,fin,pas)
end;

{=============== commande Tmap =================================}
function TMap.executer(arg:Pliste):Paffixe;
var f1,f2,f3:Pcorps;
    T,index,old:Paffixe;
    l:type_liste;
    del:boolean;
    variable:Pconstante;
begin
     executer:=nil;                {f1=expression, f2=variable, f3=liste}
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     if f3=nil then exit;
     if f2^.categorie<>cat_constante  then exit;
     if f3^.categorie=cat_constante
        then
            begin
                 del:=false;       {si f3 est une constante on ne la duplique pas}
                 T:=Pconstante(f3^.contenu)^.affixe;
            end
        else
            begin
                 del:=true;T:=f3^.evaluer;   {f3 est dupliquer}
            end;
     if T=nil then exit;
     index:=T; l.init;
     variable:=Pconstante(f2^.contenu);
     old:=variable^.affixe;
     new(variable^.affixe,init(0,0));
     
     repeat
        variable^.affixe^.x:=index^.x;
        variable^.affixe^.y:=index^.y;
        l.ajouter_fin(PCellule(f1^.evaluer));
        index:=Paffixe(index^.suivant);
        if variable^.affixe=nil then  new(variable^.affixe,init(0,0));
     until (index=nil);
     if del then Kill(Pcellule(T));
     Kill(Pcellule(variable^.affixe));
     variable^.affixe:=old;
     executer:=Paffixe(l.tete)
end;

{=================== commande TSi =========================}
 function TSi.executer(arg:Pliste):Paffixe;
var f1,f2,f3:Pcorps;
    T,r:Paffixe;
    stop:boolean;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     r:=nil;
     stop:=false;
     repeat
           T:=f1^.evaluer;
           if T=nil then exit;
           If (T^.x=1) and (T^.y=0)
              then
                  begin
                       r:=f2^.evaluer;
                       stop:=true
                  end
              else
                  if (T^.x=0) and (T^.y=0)
                     then
                         if (f3<>nil) and (f3^.suivant=nil)
                            then
                                begin
                                     r:=f3^.evaluer;
                                     stop:=true
                                end
                            else
                     else stop:=true;
           Kill(Pcellule(T));
           f1:=f3;
           if f1<>nil
              then f2:=Pcorps(f1^.suivant)
              else f2:=nil;
           if f2<>nil then f3:=Pcorps(f2^.suivant);
     until (f2=nil) or stop;
     executer:=r
end;
{===========================}
function TSi.deriver(arg:Pliste;variable:string):Pcorps;
var p,aux,f1,f2,f3:Pcorps;
    q:Pcommande;
    stop,error:boolean;
begin
     deriver:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     q:=commande('Si');
     p:=new(Pcorps,init(cat_commande,q));  {p va contenir l'expression drive, c'est une commande Si}
     stop:=false;error:=false;
     repeat
           p^.ajouter_arg(f1^.dupliquer);
           aux:=f2^.deriver(variable);
           if aux=nil
              then error:=true
              else
                  begin
                       p^.ajouter_arg(aux);
                       if (f3<>nil) and (f3^.suivant=nil)
                          then
                              begin
                                   aux:=f3^.deriver(variable);
                                   if aux=nil
                                      then error:=true
                                      else p^.ajouter_arg(aux);
                                   stop:=true
                              end;
                  end;
           f1:=f3;
           if f1<>nil
              then f2:=Pcorps(f1^.suivant)
              else f2:=nil;
           if f2<>nil
              then f3:=Pcorps(f2^.suivant);
     until (f2=nil) or stop or error;
     if error then dispose(p,detruire);
     if f3<>nil then 
     deriver:=p;
end;

{=============== commande TSolve =========================================}
function solve(f,df:Pexpression;const v:string;a,b,precision:real;nb:longint):Paffixe;
var r0,r1,r2,r3,r4 :Paffixe;
    liste:type_liste;
    i,k:longint;
    x,fin,deltaX:real;
    error:boolean;
begin
     liste.init;
     x:=a;
     new(r0,init(x,0));
     f^.assigner(v,r0);
     df^.assigner(v,r0);
     deltaX:=(b-a)/nb;
     r1:=nil;r2:=nil;r3:=nil;r4:=nil;
     for k:=1 to nb do
           begin
                r0^.x:=x+deltaX/2;
                fin:=x+deltaX;
                i:=1;
                error:=true;
                while i<=5 do
                    begin
                         r1:=f^.evaluer;
                         if r1<>nil then
                            begin
                                 r2:=df^.evaluer;
                                 if r2<>nil then
                                    begin
                                    r4:=diviserC(r1,r2);
                                    r3:=soustraireC(r0,r4);
                                    error:= (r3=nil);
                                    if (not error) then r0^.x:=r3^.x else i:=5
                                    end else i:=5;
                            end else i:=5;
                         Kill(Pcellule(r1));
                         Kill(Pcellule(r2));
                         Kill(Pcellule(r3));
                         Kill(Pcellule(r4));
                         inc(i)
                    end;
                if not error then
                       if (r0^.x>=x) and (r0^.x<fin) then 
                          begin
                           r1:=f^.evaluer;
                           if (r1<>nil) and (abs(r1^.x)<=precision) then
                           liste.ajouter_fin(new(Paffixe,init(r0^.x,x+deltaX/2)));
                           if r1<>nil then Kill(Pcellule(r1));
                          end;
                 x:=x+deltaX;
           end;
    solve:=Paffixe(liste.tete);
    f^.desassigner(v);df^.desassigner(v);
    Kill(Pcellule(r0));
end;

{commande TSolve }
 function TSolve.executer(arg:Pliste):Paffixe;
var f1,f2,f3,f4,f5:Pcorps;
    r,aux:Paffixe;
    f,df:Pexpression;
    a,b:real;
    n:longint;
    ok:boolean;
    ChaineAux:string;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) or (f2^.categorie<>cat_constante) then exit;
     f3:=Pcorps(f2^.suivant);
     if f3=nil then exit;
     f4:=Pcorps(f3^.suivant);
     if f4=nil then exit;
     f5:=Pcorps(f4^.suivant);
     new(f,init);
     ChaineAux:=f1^.en_chaine;
     ok:=f^.definir(ChaineAux);
     if not ok then begin dispose(f,detruire); exit end;
     df:=f^.deriver(Pconstante(f2^.contenu)^.nom);
      if df=nil then begin dispose(f,detruire); exit end;
     r:=f3^.evaluer;
     if r<>nil then begin a:=r^.x; Kill(Pcellule(r)) end
               else begin dispose(f,detruire); dispose(df,detruire); exit end;
     r:=f4^.evaluer;
     if r<>nil then begin b:=r^.x; Kill(Pcellule(r)) end
               else begin dispose(f,detruire); dispose(df,detruire); exit end;
     if f5<>nil then
        begin
        r:=f5^.evaluer;
        if r<>nil then begin n:=Round(abs(r^.x)); if n=0 then n:=25; Kill(Pcellule(r)) end
                  else begin dispose(f,detruire); dispose(df,detruire); exit end;
        end else n:=25;
     aux:=solve(f,df,Pconstante(f2^.contenu)^.nom,a,b,1.e-5,n);{nil;}
     r:=aux;
     while r<>nil do
           begin
                r^.y:=0;
                r:=Paffixe(r^.suivant);
           end;
     executer:=aux;
     dispose(f,detruire);
     dispose(df,detruire);
end;


{commande TCopy}
function TCopy.executer(arg:Pliste):Paffixe;
var f1,f2,f3:Pcorps;
    T,aux:Paffixe;
    i,depart,nombre:longint;
    l:type_liste;
    del,all: boolean;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     T:=f2^.evaluer;
     if T=nil then exit;
     depart:=Round(T^.x);
     f3:=Pcorps(f2^.suivant);
     if f3=nil then if T^.suivant<>nil then nombre:=Round(Paffixe(T^.suivant)^.x) else nombre:=1
               else begin
                    Kill(Pcellule(T));
                    T:=f3^.evaluer;
                    if T=nil then exit;
                    nombre:=Round(T^.x);
                    end;
     Kill(Pcellule(T));
     if depart=0 then  exit;
     if f1^.categorie=cat_constante then
        begin
             del:=false;
             T:=Pconstante(f1^.contenu)^.affixe
        end else begin del:=true;T:=f1^.evaluer; end;
     if T=nil then exit;
     i:=1;aux:=T;
     while (aux<>nil) and (i<depart) do begin aux:=Paffixe(aux^.suivant); inc(i) end;
     if aux=nil then begin if del then Kill(Pcellule(T)); exit end;
     i:=0;l.init; all:=nombre=0;
     while (aux<>nil) and (all or (i<nombre)) do
           begin l.ajouter_fin(PCellule(new(Paffixe,init(aux^.x,aux^.y))));
                 inc(i);aux:=Paffixe(aux^.suivant)
           end;
     if del then Kill(Pcellule(T));
     executer:=Paffixe(l.tete)
end;




{TLoop }
function TLoop.executer(arg:PListe):Paffixe;
var f1,f2:Pcorps;
    l:type_liste;
    T,r:Paffixe;
    stop:boolean;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) then exit;
     l.init;
     repeat
           T:=f1^.evaluer;
           if T<>nil then l.ajouter_fin(PCellule(T));
           r:=f2^.evaluer;
           stop:=(r=nil) or (r^.x=1);
           if r<>nil then Kill(Pcellule(r));
     until stop;
     executer:=Paffixe(l.tete)
end;


{TAssign}
function TAssign.executer(arg:PListe):Paffixe;
var f1,f2,f3:Pcorps;
   T:Paffixe;
begin
     
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) or(f2^.categorie<>cat_constante) then exit;
     f3:=Pcorps(f2^.suivant);
     if (f3=nil) then exit;
     T:=f3^.evaluer;
     if not f1^.assigner(Pconstante(f2^.contenu)^.nom,T) then Kill(Pcellule(T));
end;

{TNops}
function TNops.executer(arg:PListe):Paffixe;
var f1:Pcorps;
   T,aux:Paffixe;
   nb:word;
   DelT:boolean;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     nb:=0;
     if f1<>nil then
        begin
             if (f1^.categorie=cat_constante) then begin DelT:=false;T:=Pconstante(f1^.contenu)^.affixe end
                                              else begin DelT:=true;T:=f1^.evaluer end;
             aux:=T;
             while aux<>nil do begin inc(nb);aux:=Paffixe(aux^.suivant) end;
             if delT then Kill(Pcellule(T));

        end;
     executer:=new(Paffixe,init(nb,0))
     
end;



{TDiff}
function TDiff.executer(arg:PListe):Paffixe;
var f1,f2,f3,f4,par:Pcorps;
    r:Pexpression;
    aux:Pconstante;
    aux2:Pliste;
    c:Pmacros;
    num:word;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) or (f1^.categorie<>cat_constante) then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     if (f3=nil) or (f3^.categorie<>cat_constante) or (Pconstante(f3^.contenu)^.predefinie) then exit;
     f4:=Pcorps(f3^.suivant);
     new(r,init);
     aux:=Pconstante(LesVarLoc^.tete);
     while aux<>nil do
           begin
                r^.VarLoc^.ajouter_fin(PCellule(new(Pconstante,init(aux^.nom,Nil,true))));
                aux:=Pconstante(aux^.suivant);
           end;
     r^.corps:=f2^.deriver(Pconstante(f3^.contenu)^.nom);
     if r^.corps=nil then begin dispose(r,detruire); exit end;
     num:=0; 
     while f4<>nil do
      if (f4^.categorie=cat_constante) And (not Pconstante(f4^.contenu)^.predefinie)  then
           begin
                inc(num);
                par:=new(Pcorps,init(cat_parametre,new(Pparametre,init(num))));
                r^.corps^.composer(Pconstante(f4^.contenu)^.nom,par);
                dispose(par,detruire);
                f4:=Pcorps(f4^.suivant)
           end;
     r^.simplifier;
     if r^.corps=nil then begin dispose(r,detruire); exit end;
     aux2:=LesVarLoc;
     LesVarLoc:=r^.VarLoc;
     r^.corps^.brancherLocales;
     LesVarLoc:=aux2;
     c:=new(Pmacros,init(Pconstante(f1^.contenu)^.nom,r));
     c^.commande:=r^.corps^.en_chaine;
     ajouter_macros(c);
     ChangeMac:=true;
end;



{TInt}
function integrale(f:Pcorps; variable:string; a,b:real): Paffixe;
var
   compt,deuxN:word;
   h:real;
   T,S0,S1,M0,M1,U0,U1,V0,V1,aux1,aux2,aux3:Paffixe;
   stop:boolean;

          function Median:Paffixe; (*M_2^{n+1}*)
          var k:word;
              res,aux1,aux2:Paffixe;
          begin
               Median:=nil;
               T^.x:=a+h/2;
               res:=f^.evaluer;
               if res=nil then exit;
               for k:=1 to deuxN-1 do
                   begin
                        T^.x:=T^.x+h;
                        aux1:=f^.evaluer;
                        if aux1=nil then
                           begin
                                Kill(Pcellule(res));
                                exit
                           end;
                        aux2:=ajouterC(res,aux1);
                        if res<>nil then Kill(Pcellule(res));
                        if aux1<>nil then Kill(Pcellule(aux1));
                        res:=aux2;
                   end;
               aux1:=new(Paffixe,init(h,0));
               median:=multiplierC(aux1,res);
               if res<>nil then Kill(Pcellule(res));
               if aux1<>nil then Kill(Pcellule(aux1));
          end;
begin
     {integrale:=nil;}
     h:=(b-a);deuxN:=1;compt:=0;
     T:=new(Paffixe,init(a,0));
     f^.assigner(variable,T);
     T^.x:=a; aux1:=f^.evaluer;
     T^.x:=b; aux3:=f^.evaluer;
     T^.x:=(a+b)/2; aux2:=f^.evaluer;
     S0:=nil;
     M0:=nil;
     M1:=median;
     U0:=nil;U1:=nil;V0:=nil;V1:=nil;S1:=nil;
     if (aux1=nil) or (aux3=nil) or (aux2=nil) or (M1=nil) then
        else
        begin
     S1:=new(Paffixe,init(0,0));
     CalcError:=false;
     S1^.x:=multiplier(h/6,ajouter(aux1^.x,ajouter(aux3^.x,multiplier(4,aux2^.x))));
     S1^.y:=multiplier(h/6,ajouter(aux1^.y,ajouter(aux3^.y,multiplier(4,aux2^.y))));
     stop:=CalcError or (S1=nil) or (M1=nil);
     while (not stop) and (compt<=10)
      do begin
          inc(compt);
          if S0<>nil then Kill(Pcellule(S0));
          if M0<>nil then Kill(Pcellule(M0));
          M0:=M1;
          deuxN:=2*deuxN; h:=h/2;
          M1:=median;
          if (M1<>nil) and (M0<>nil) then
             begin
                  S0:=S1;
                  S1:=new(paffixe,init(ajouter(S0^.x/2,ajouter(M1^.x*2/3,-M0^.x/6)),
                  ajouter(S0^.y/2,ajouter(M1^.y*2/3,-M0^.y/6))));
                  If U0<>nil then Kill(Pcellule(U0));
                  U0:=U1;
                  U1:=new(Paffixe,init(ajouter(S1^.x*16/15,-S0^.x/15),
                                       ajouter(S1^.y*16/15,-S0^.y/15)));
                  if U0<>nil then
                     begin
                  If V0<>nil then Kill(Pcellule(V0));
                  V0:=V1;
                  V1:=new(Paffixe,init(ajouter(U1^.x*64/63,-U0^.x/63),
                                       ajouter(U1^.y*64/63,-U0^.y/63)));
                     end;
                  if CalcError then Kill(Pcellule(V1));
                  stop:= CalcError or ((compt>=3) and (V0<>nil) and (V1<>nil)
                  and (sqrt(ajouter(sqr(ajouter(V1^.x,-V0^.x)),sqr(ajouter(V1^.y,-V0^.y))))<1e-5));
             end else stop:=true;

     end;
     end;
     integrale:=V1;
     If S0<>nil then Kill(Pcellule(S0));
     If S1<>nil then Kill(Pcellule(S1));
     If U0<>nil then Kill(Pcellule(U0));
     If U1<>nil then Kill(Pcellule(U1));
     If V0<>nil then Kill(Pcellule(V0));
     If M0<>nil then Kill(Pcellule(M0));
     If M1<>nil then Kill(Pcellule(M1));
     if aux1<>nil then Kill(Pcellule(aux1));
     if aux2<>nil then Kill(Pcellule(aux2));
     if aux3<>nil then Kill(Pcellule(aux3));
     if not f^.assigner(variable,nil) then Kill(Pcellule(T));
end;

function TInt.executer(arg:PListe):Paffixe;
var f1,f2,f3,f4:Pcorps;
    a,b:Paffixe;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) or (f2^.categorie<>cat_constante) then exit;
     f3:=Pcorps(f2^.suivant);
     if (f3=nil) then exit;
     f4:=Pcorps(f3^.suivant);
     if (f4=nil) then exit;
     a:=f3^.evaluer;
     if a=nil then exit;
     b:=f4^.evaluer;
     if b=nil then begin Kill(Pcellule(a)); exit end;
     executer:=integrale(f1,Pconstante(f2^.contenu)^.nom,a^.x,b^.x);
     Kill(Pcellule(a)); Kill(Pcellule(b));

end;

function TInt.deriver(arg:Pliste;variable:string):Pcorps;
var f1,f2,f3,f4,f5,f6:Pcorps;
    aux1,aux2,aux3,aux4:Pcorps;
    op1,op2,res,res2,res3:Pcorps;
begin
     deriver:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) or (f2^.categorie<>cat_constante) then exit;
     f3:=Pcorps(f2^.suivant);
     if (f3=nil) then exit;
     f4:=Pcorps(f3^.suivant);
     if (f4=nil) then exit;
     aux1:=f4^.deriver(variable);
     if aux1=nil then exit;
     aux2:=f1^.dupliquer;
     aux2^.composer(Pconstante(f2^.contenu)^.nom,f4);
     if aux2=nil then begin dispose(aux1,detruire); exit end;
     aux3:=f3^.deriver(variable);
     if aux3=nil then begin dispose(aux1,detruire); dispose(aux2,detruire);exit end;
     aux4:=f1^.dupliquer;
     aux4^.composer(Pconstante(f2^.contenu)^.nom,f3);
     if aux4=nil then begin dispose(aux1,detruire); dispose(aux2,detruire);
                            dispose(aux3,detruire);exit end;
     op1:=new(Pcorps,init(cat_operateur,operation('*')));
     op1^.ajouter_arg(aux1);op1^.ajouter_arg(aux2);
     op2:=new(Pcorps,init(cat_operateur,operation('*')));
     op2^.ajouter_arg(aux3);op2^.ajouter_arg(aux4);
     res:=new(Pcorps,init(cat_operateur,operation('-')));
     res^.ajouter_arg(op1);res^.ajouter_arg(op2);
     if not f1^.DependDe(variable) then deriver:=res
        else
        begin
             f5:=f1^.deriver(variable);
             if f5=nil then begin dispose(res,detruire); exit end;
             f6:=f5^.simplifier;
             if f6=nil then begin dispose(res,detruire); dispose(f5,detruire); exit end;
             dispose(f5,detruire);
             res2:=new(Pcorps,init(cat_commande,commande('Int')));
             res2^.ajouter_arg(f6);
             res2^.ajouter_arg(f2^.dupliquer);
             res2^.ajouter_arg(f3^.dupliquer);
             res2^.ajouter_arg(f4^.dupliquer);
             res3:=new(Pcorps,init(cat_operateur,operation('+')));
             res3^.ajouter_arg(res2);res3^.ajouter_arg(res);
             deriver:=res3
        end;
     
end;

{TRgb}
function TRgb.executer(arg:PListe):Paffixe;
var f1,f2,f3:Pcorps;
    a,b,c:Paffixe;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) then exit;
     f3:=Pcorps(f2^.suivant);
     if (f3=nil) then exit;
     a:=f1^.evaluer;
     if a=nil then exit;
     b:=f2^.evaluer;
     if b=nil then begin Kill(Pcellule(a)); exit end;
     c:=f3^.evaluer;
     if c=nil then begin Kill(Pcellule(a)); Kill(Pcellule(b));exit end;
     executer:=new(Paffixe,init(RGB(round(a^.x*255), round(b^.x*255),round(c^.x*255)),0));
     Kill(Pcellule(a)); Kill(Pcellule(b)); Kill(Pcellule(c));

end;

{=========== oprations  ===============}

{Tplus}
function Tplus.evaluer(arg1,arg2:Paffixe):Paffixe;
var r:Paffixe;
    res:type_liste;
begin
     res.init;
     while (arg1<>nil) or (arg2<>nil) do
           begin
           if arg1=nil then r:=new(Paffixe,init(arg2^.x,arg2^.y))
                       else
           if arg2= nil then r:=new(Paffixe,init(arg1^.x,arg1^.y))
                        else
           r:= ajouterC(arg1,arg2);
           if r<>nil then res.ajouter_fin(r) else {res.ajouter_fin(jump)};
           if arg1<>nil then arg1:=Paffixe(arg1^.suivant);
           if arg2<>nil then arg2:=Paffixe(arg2^.suivant)
           end;
     evaluer:=Paffixe(res.tete);
end;

function Tplus.simplifier(arg:Pliste):Pcorps;
var p,aux1,aux2,aux3,aux4:Pcorps;
    r:Paffixe;
begin
     simplifier:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.simplifier;
     if aux3=nil then exit;
     aux4:=aux2^.simplifier;
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     if (aux3^.categorie=Cat_affixe) and (aux4^.categorie=cat_affixe)
      then begin
               r:=self.evaluer(Paffixe(aux3^.contenu),Paffixe(aux4^.contenu));
               if r<>nil then p:=new(Pcorps,init(cat_affixe,r)) else p:=nil;
               dispose(aux3,detruire); dispose(aux4,detruire);
           end
           else
      if (aux3^.categorie=Cat_affixe) and (Paffixe(aux3^.contenu)^.x=0) and (Paffixe(aux3^.contenu)^.y=0)
       then begin
                 p:=aux4;
                 dispose(aux3,detruire);            
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=0) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=aux3;
                 dispose(aux4,detruire);            
            end else
       begin p:=new(Pcorps,init(cat_operateur,operation(nom)));
             p^.ajouter_arg(aux3);
             p^.ajouter_arg(aux4)
       end;
       simplifier:=p;
end;

function Tplus.deriver(arg:Pliste;const variable:string):Pcorps;
var aux1,aux2,aux3,aux4,p:Pcorps;
    q:Poperation;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.deriver(variable);
     if aux3=nil then exit;
     aux4:=aux2^.deriver(variable);
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     q:=operation('+');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux3);
     p^.ajouter_arg(aux4);
     deriver:=p;
end;


{Tmoins}
function Tmoins.evaluer(arg1,arg2:Paffixe):Paffixe;
var r:Paffixe;
    res:type_liste;
begin
     res.init;
     while (arg1<>nil) or (arg2<>nil) do
           begin
           if arg1=nil then r:=new(Paffixe,init(-arg2^.x,-arg2^.y))
                       else
           if arg2= nil then r:=new(Paffixe,init(arg1^.x,arg1^.y))
                        else
           r:= soustraireC(arg1,arg2);
           if r<>nil then res.ajouter_fin(r) else {res.ajouter_fin(jump)};
           if arg1<>nil then arg1:=Paffixe(arg1^.suivant);
           if arg2<>nil then arg2:=Paffixe(arg2^.suivant)
           end;
     evaluer:=Paffixe(res.tete);
end;

function Tmoins.deriver(arg:Pliste;const variable:string):Pcorps;
var aux1,aux2,aux3,aux4,p:Pcorps;
    q:Poperation;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.deriver(variable);
     if aux3=nil then exit;
     aux4:=aux2^.deriver(variable);
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     q:=operation('-');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux3);
     p^.ajouter_arg(aux4);
     deriver:=p;
end;


function Tmoins.simplifier(arg:Pliste):Pcorps;
var p,aux1,aux2,aux3,aux4:Pcorps;
    r:Paffixe;
begin
     simplifier:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.simplifier;
     if aux3=nil then exit;
     aux4:=aux2^.simplifier;
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     if (aux3^.categorie=Cat_affixe) and (aux4^.categorie=cat_affixe)
      then begin
               r:=self.evaluer(Paffixe(aux3^.contenu),Paffixe(aux4^.contenu));
               if r<>nil then p:=new(Pcorps,init(cat_affixe,r)) else p:=nil;
               dispose(aux3,detruire); dispose(aux4,detruire);
           end
           else
      if (aux3^.categorie=Cat_affixe) and (Paffixe(aux3^.contenu)^.x=0) and (Paffixe(aux3^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_fonction,fonction('opp')));
                 p^.ajouter_arg(aux4);
                 dispose(aux3,detruire);            
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=0) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=aux3;
                 dispose(aux4,detruire);            
            end else
       begin p:=new(Pcorps,init(cat_operateur,operation(nom)));
             p^.ajouter_arg(aux3);
             p^.ajouter_arg(aux4)
       end;
       simplifier:=p;
end;


{Tfois}
function Tfois.evaluer(arg1,arg2:Paffixe):Paffixe;
var r:Paffixe;
    res:type_liste;
begin
     evaluer:=nil;
     res.init;
     if arg1=nil then exit;
     while (arg2<>nil) do
           begin
           r:= multiplierC(arg1,arg2);
           if r<>nil then res.ajouter_fin(r) else {res.ajouter_fin(jump)};
           arg2:=Paffixe(arg2^.suivant)
           end;
     evaluer:=Paffixe(res.tete);
end;

function Tfois.deriver(arg:Pliste;const variable:string):Pcorps;
var aux1,aux2,aux3,aux4,p,p1,p2:Pcorps;
    q,q1:Poperation;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.deriver(variable);
     if aux3=nil then exit;
     aux4:=aux2^.deriver(variable);
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     q1:=operation('*');
     p1:=new(Pcorps,init(cat_operateur,q1));
     p1^.ajouter_arg(aux4);
     p1^.ajouter_arg(aux1^.dupliquer);
     p2:=new(Pcorps,init(cat_operateur,q1));
     p2^.ajouter_arg(aux3);
     p2^.ajouter_arg(aux2^.dupliquer);
     q:=operation('+');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(p1);
     p^.ajouter_arg(p2);
     deriver:=p;
end;

function Tfois.simplifier(arg:Pliste):Pcorps;
var p,aux1,aux2,aux3,aux4:Pcorps;
    r:Paffixe;
begin
     simplifier:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.simplifier;
     if aux3=nil then exit;
     aux4:=aux2^.simplifier;
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     if (aux3^.categorie=Cat_affixe) and (aux4^.categorie=cat_affixe)
      then begin
               r:=self.evaluer(Paffixe(aux3^.contenu),Paffixe(aux4^.contenu));
               if r<>nil then p:=new(Pcorps,init(cat_affixe,r)) else p:=nil;
               dispose(aux3,detruire); dispose(aux4,detruire);
           end
           else
      if (aux3^.categorie=Cat_affixe) and (Paffixe(aux3^.contenu)^.x=0) and (Paffixe(aux3^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_affixe,new(Paffixe,init(0,0))));
                 dispose(aux4,detruire);
                 dispose(aux3,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=0) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_affixe,new(Paffixe,init(0,0))));
                 dispose(aux4,detruire);
                 dispose(aux3,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=1) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=aux3;
                 dispose(aux4,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=-1) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_fonction,fonction('opp')));
                 p^.ajouter_arg(aux3);
                 dispose(aux4,detruire);
            end else
       if (aux3^.categorie=Cat_affixe) and (Paffixe(aux3^.contenu)^.x=1) and (Paffixe(aux3^.contenu)^.y=0)
       then begin
                 p:=aux4;
                 dispose(aux3,detruire);
            end else
       if (aux3^.categorie=Cat_affixe) and (Paffixe(aux3^.contenu)^.x=-1) and (Paffixe(aux3^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_fonction,fonction('opp')));
                 p^.ajouter_arg(aux4);
                 dispose(aux3,detruire);
            end else
       begin p:=new(Pcorps,init(cat_operateur,operation(nom)));
             p^.ajouter_arg(aux3);
             p^.ajouter_arg(aux4)
       end;
       simplifier:=p;
end;



{Tdiv}
function Tdiv.evaluer(arg1,arg2:Paffixe):Paffixe;
var r:Paffixe;
 res:type_liste;
begin
     evaluer:=nil;
     res.init;
     if arg2=nil then exit;
     while (arg1<>nil) do
           begin
           r:= diviserC(arg1,arg2);
           if r<>nil then res.ajouter_fin(r) else {res.ajouter_fin(jump)};
           arg1:=Paffixe(arg1^.suivant)
           end;
     evaluer:=Paffixe(res.tete);
end;


function Tdiv.deriver(arg:Pliste;const variable:string):Pcorps;
var aux1,aux2,aux3,aux4,p,p1,p2,p3,p4:Pcorps;
    q,q1,q2:Poperation;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.deriver(variable);
     if aux3=nil then exit;
     aux4:=aux2^.deriver(variable);
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     q1:=operation('*');
     p1:=new(Pcorps,init(cat_operateur,q1));
     p1^.ajouter_arg(aux4);
     p1^.ajouter_arg(aux1^.dupliquer);
     p2:=new(Pcorps,init(cat_operateur,q1));
     p2^.ajouter_arg(aux3);
     p2^.ajouter_arg(aux2^.dupliquer);
     q:=operation('-');
     p3:=new(Pcorps,init(cat_operateur,q));
     p3^.ajouter_arg(p2);
     p3^.ajouter_arg(p1);
     p4:=new(Pcorps,init(cat_operateur,q1));
     p4^.ajouter_arg(aux2^.dupliquer);
     p4^.ajouter_arg(aux2^.dupliquer);
     q2:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q2));
     p^.ajouter_arg(p3);p^.ajouter_arg(p4);
     deriver:=p;
end;

function Tdiv.simplifier(arg:Pliste):Pcorps;
var p,aux1,aux2,aux3,aux4:Pcorps;
    r:Paffixe;
begin
     simplifier:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.simplifier;
     if aux3=nil then exit;
     aux4:=aux2^.simplifier;
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     if (aux3^.categorie=Cat_affixe) and (aux4^.categorie=cat_affixe)
      then begin
               r:=self.evaluer(Paffixe(aux3^.contenu),Paffixe(aux4^.contenu));
               if r<>nil then p:=new(Pcorps,init(cat_affixe,r)) else p:=nil;
               dispose(aux3,detruire); dispose(aux4,detruire);
           end
           else
      if (aux3^.categorie=Cat_affixe) and (Paffixe(aux3^.contenu)^.x=0) and (Paffixe(aux3^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_affixe,new(Paffixe,init(0,0))));
                 dispose(aux4,detruire);
                 dispose(aux3,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=0) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=nil;
                 dispose(aux4,detruire);
                 dispose(aux3,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=1) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=aux3;
                 dispose(aux4,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=-1) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_fonction,fonction('opp')));
                 p^.ajouter_arg(aux3);
                 dispose(aux4,detruire);
            end else

       begin p:=new(Pcorps,init(cat_operateur,operation(nom)));
             p^.ajouter_arg(aux3);
             p^.ajouter_arg(aux4)
       end;
       simplifier:=p;
end;

 {cap}
 function cap(A,B,C,D: Paffixe):Paffixe;
 var  V1,V2,V3:Paffixe;
     t,de:real;
 begin
      cap:=nil;
      V1:=soustraireC(B,D);
      V2:=soustraireC(C,D);
      V3:=soustraireC(A,B);
      if (v1<>nil) and (v2<>nil) and (v3<>nil)
       then begin
       CalcError:=false;
       de:=det(V2,v3);
       t:=diviser(det(V1,V2),de);
      if (not CalcError) then
      begin
      V2^.init(t,0);
      Kill(Pcellule(v1));
      V1:=multiplierC(V2,V3);
      if v1<>nil then cap:=ajouterC(V1,B);
      end;
            end;
      if v1<>nil then Kill(Pcellule(v1));
      if v2<>nil then Kill(Pcellule(v2));
      if v3<>nil then Kill(Pcellule(v3))
 end;


{TCap}
function TCapD.evaluer(arg1,arg2:Paffixe):Paffixe;
var A,B,C,D:Paffixe;
begin
     evaluer:=nil;
     A:=arg1;C:=Arg2;
     If (A=nil) or (C=nil) then exit;
     D:=Paffixe(C^.suivant);B:=Paffixe(A^.suivant);
     If (B=nil) or (D=nil) then exit;
     evaluer:=cap(A,B,C,D);
end;
{===============}
procedure GetRec(liste:Paffixe;var res:Trec);
var aux:Paffixe;
begin
     res.Xinf:=Reel_Max;res.Yinf:=Reel_Max;
     res.Xsup:=-Reel_Max;res.Ysup:=-Reel_Max;
     aux:=liste;
     while aux<>nil do
          begin
               if not Isjump(aux) then
                  begin
                       if aux^.x<res.Xinf then res.Xinf:=aux^.x;
                       if aux^.y<res.Yinf then res.Yinf:=aux^.y;
                       if aux^.x>res.Xsup then res.Xsup:=aux^.x;
                       if aux^.y>res.Ysup then res.Ysup:=aux^.y;

                  end;
               aux:=Paffixe(aux^.suivant)
          end;
end;
{===============}
function inside(point,liste:Paffixe;rec:Trec):boolean;
var
    A,B,res,L,C,D,auxC,auxD:Paffixe;
    F:Pexpression;
    compt:integer;
    stop,dessus:boolean;
begin
     inside:=false;
     if point=nil then exit;
     with rec do
     begin
     if (point^.x>Xsup) or (point^.x<Xinf) or
        (point^.y>Ysup) or (point^.y<Yinf) then exit;
     if (Liste=nil) or (liste^.suivant=nil) then exit;
     L:=(liste);
     C:=L;
     repeat
           stop:=C^.y<>point^.y;
           if not stop then C:=Paffixe(C^.suivant);
     until stop or (C=nil);
     if C=nil then begin inside:=true; exit end;
     new(A,init(Xinf-1,point^.y));
     new(B,init(point^.x,point^.y));
     compt:=0;
     C:=L;D:=Paffixe(C^.suivant);
     dessus:=(C^.y>B^.y);
     New(F,init);
     F^.definir('[$A,$B] InterL [$C,$D]');
     auxC:=new(Paffixe,init(0,0));
     auxD:=new(Paffixe,init(0,0));
     F^.assigner('A',A);
     F^.assigner('B',B);
     F^.assigner('C',auxC);
     F^.assigner('D',auxD);
     while D<>nil do
       begin
       if (not IsJump(C)) and (not Isjump(D)) then
            begin
                auxC^.x:=C^.x;auxC^.y:=C^.y;
                auxD^.x:=D^.x;auxD^.y:=D^.y;
                res:=F^.evaluer;
                if (res<>nil) then if (res^.x=point^.x) then
                   begin
                        inside:=false;
                        dispose(F,detruire);Kill(Pcellule(res));
                        exit
                   end
                   else begin
                     if (C^.y<D^.y) then
                        begin
                             if ((C^.y<B^.y) and (D^.y>B^.y)) or ((C^.y=B^.y) and (not dessus)) then dec(compt);
                        end
                        else begin
                             if ((C^.y>B^.y) and (D^.y<B^.y)) or ((C^.y=B^.y) and dessus) then inc(compt);
                             end;
                   dessus:=(D^.y>B^.y);
                   end;
                Kill(Pcellule(res));
           end;
        C:=D;D:=Paffixe(D^.suivant)
       end;
     dispose(F,detruire);
     inside:=compt<>0;
     end;
end;

{TInside}
function TInside.evaluer(arg1,arg2:Paffixe):Paffixe;
var A,B:Paffixe;
    rec:Trec;
begin
     evaluer:=nil;
     A:=arg1;B:=arg2;
     if (A=nil) or (B=nil) then begin exit; end;
     GetRec(B,rec);
     evaluer:=new(Paffixe,init(byte(inside(A,B,rec)),0));

end;


function cut(arg1,arg2:Paffixe; before:boolean): Paffixe;
var A,C,u,v,baru,Z: Paffixe;
    trouve:boolean;
    d:real;
    resultat: type_liste;
begin
     cut:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     C:=Paffixe(arg1);
     trouve:=false;
     u:=nil; v:=nil; A:=nil;
     while (not trouve) and (C<>nil) do
           begin
                while IsJump(C) do C:=Paffixe(C^.suivant);
                if C<>nil
                   then
                       begin
                            A:=C;
                            C:=Paffixe(A^.suivant);
                            v:=soustraireC(arg2,A);
                            CalcError:=false;
                            d:=sqrt(ajouter(sqr(soustraire(arg2^.x,A^.x)),sqr(soustraire(arg2^.y,A^.y))));
                            trouve:= (not CalcError) and (d<=0.001);
                            while (not trouve) and (C<>nil) and (Not Isjump(C)) do
                                  begin
                                       Kill(PCellule(u));
                                       u:=v;
                                       v:=soustraireC(arg2,C);
                                       baru:=u; if baru<>nil then baru^.y:=-baru^.y;
                                       Z:=multiplierC(baru,v);
                                       trouve:= (Z<>nil) And (abs(Z^.y)<=0.001) And (Z^.x<=0);
                                       Kill(PCellule(Z));
                                       A:=C; C:=Paffixe(C^.suivant)
                                  end;
                            Kill(Pcellule(v));
                            Kill(Pcellule(u));
                       end;
           end;
     if trouve
        then
            begin
                 resultat.init;
                 if before
                    then
                        begin
                             resultat.ajouter_fin(New(Paffixe,init(arg2^.x,arg2^.y)));
                             resultat.ajouter_fin(A^.evaluer);
                        end
                    else
                        begin
                             Z:=arg1;
                             while Z<>A do
                                   begin
                                        resultat.ajouter_fin(New(Paffixe,init(Z^.x,Z^.y)));
                                        Z:=Paffixe(Z^.suivant)
                                   end;
                             resultat.ajouter_fin(New(Paffixe,init(arg2^.x,arg2^.y)));
                        end;
                 cut:=Paffixe(resultat.tete)
            end
end;


{TCutB}
function TCutB.evaluer(arg1,arg2:Paffixe):Paffixe;
begin
     evaluer:=cut(arg1,arg2,true)
end;

{TCutA}
function TCutA.evaluer(arg1,arg2:Paffixe):Paffixe;
begin
     evaluer:=cut(arg1,arg2,false)
end;
                     



{TCap}
function TCapL.evaluer(arg1,arg2:Paffixe):Paffixe;
var A,B,C,D,res,V1,V2,V3:Paffixe;
    liste:type_liste;
    t,t1,de:real;
    OkAB,OkCD,firstAB,firstCD:boolean;

    

    function chercheSeg(var U,V:Paffixe):boolean;
    var ok:boolean;
    begin
          U:=V;
          ok:=false;
          repeat
          while (U<>nil) and IsJump(U) do U:=Paffixe(U^.suivant);
           If (U=nil) then ok:=true
                      else
                      begin
                   V:=Paffixe(U^.suivant);
                   if V=nil then ok:=true
                            else
                            if IsJump(V) then U:=V else ok:=true;
                      end
          until ok;
          chercheSeg:=(U<>nil) and (V<>nil);

     end;

begin
     B:=arg1;
     liste.init;
     OkAB:=chercheSeg(A,B);
     firstAB:=true;
     while  OkAB do
           begin
                 V3:=soustraireC(A,B);
                 if V3<>nil then
                 begin
                 D:=arg2;
                 OkCD:=chercheSeg(C,D);
                 firstCD:=true;
                 while OkCD do
                       begin
                            V1:=soustraireC(B,D);
                            V2:=soustraireC(C,D);
                            if (v1<>nil) and (v2<>nil)
                            then begin
                                 CalcError:=false;
                                 de:=det(V2,v3);
                                 t:=diviser(det(v1,v2),de);
                                 if not CalcError and (t>=0) and ((firstAB  and (t<=1)) or ((not firstAB) and (t<1))) then
                                 begin
                                 t1:=diviser(det(V1,V3),de);
                                 if (not CalcError) and (t1>=0) and ((firstCD  and (t1<=1)) or ((not firstCD) and (t1<1))) then
                                 begin
                                      V2^.init(t,0);
                                      Kill(Pcellule(v1));
                                      V1:=multiplierC(V2,V3);
                                      if v1<>nil then begin res:=ajouterC(V1,B);
                                      if res<>nil then begin liste.ajouter_fin(res); end;

                                                      end;
                                 end;
                                 end;
                                 end;
                            Kill(Pcellule(v1));
                            Kill(Pcellule(v2));
                            firstCD:=false;
                            OkCD:=chercheSeg(C,D)
                       end;
                 end;
                 Kill(Pcellule(v3));
                 firstAB:=false;
                 OkAB:=chercheSeg(A,B)
           end;
     evaluer:=Paffixe(liste.tete)
end;

  

{Texpo}
function Texpo.evaluer(arg1,arg2:Paffixe):Paffixe;
var resultat:Paffixe;
    r:real;
begin
     evaluer:=nil;
     resultat:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     if (arg2^.y=0) then
             if arg1^.y=0 then begin
                              CalcError:=false;
                              r:=puissance(arg1^.x,arg2^.x);
                              if not CalcError then resultat:=new(Paffixe,init(r,0));
                              end
                         else if Int(arg2^.y)=arg2^.y then
                              resultat:=puissanceC(arg1,Trunc(arg2^.x));
     evaluer:=resultat;

end;

function Texpo.deriver(arg:Pliste;const variable:string):Pcorps;
var aux1,aux2,aux3,p,p1,p2,p3:Pcorps;
    q,q1,q2:Poperation;
    f:Pfonction;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.deriver(variable);
     if aux3=nil then exit;
     if not aux2^.dependDe(variable) then
        begin
        q:=operation('*');
        p3:=new(Pcorps,init(cat_operateur,q));
        p3^.ajouter_arg(aux2^.dupliquer);
        q1:=operation('^');
        p1:=new(Pcorps,init(cat_operateur,q1));
        p1^.ajouter_arg(aux1^.dupliquer);
        q2:=operation('-');
        p2:=new(Pcorps,init(cat_operateur,q2));
        p2^.ajouter_arg(aux2^.dupliquer);
        p2^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0)))));
        p1^.ajouter_arg(p2);
        p3^.ajouter_arg(p1);
        p:=new(Pcorps,init(cat_operateur,q));
        p^.ajouter_arg(p3);
        p^.ajouter_arg(aux3);
        end
     else begin
               f:=fonction('exp');
               p1:=new(Pcorps,init(cat_fonction,f));
               q:=operation('*');
               p2:=new(Pcorps,init(cat_operateur,q));
               p2^.ajouter_arg(aux2^.dupliquer);
               f:=fonction('ln');
               p3:=new(Pcorps,init(cat_fonction,f));
               p3^.ajouter_arg(aux1^.dupliquer);
               p2^.ajouter_arg(p3);
               p1^.ajouter_arg(p2);
               p:=p1^.deriver(variable);
               dispose(p1,detruire)
          end;
     deriver:=p;
end;

function Texpo.simplifier(arg:Pliste):Pcorps;
var p,aux1,aux2,aux3,aux4:Pcorps;
    r:Paffixe;
begin
     simplifier:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     aux2:=Pcorps(aux1^.suivant);
     if aux2=nil then exit;
     aux3:=aux1^.simplifier;
     if aux3=nil then exit;
     aux4:=aux2^.simplifier;
     if aux4=nil then begin dispose(aux3,detruire);exit end;
     if (aux3^.categorie=Cat_affixe) and (aux4^.categorie=cat_affixe)
      then begin
               r:=self.evaluer(Paffixe(aux3^.contenu),Paffixe(aux4^.contenu));
               if r<>nil then p:=new(Pcorps,init(cat_affixe,r)) else p:=nil;
               dispose(aux3,detruire); dispose(aux4,detruire);
           end
           else
      if (aux3^.categorie=Cat_affixe) and (Paffixe(aux3^.contenu)^.x=1) and (Paffixe(aux3^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0))));
                 dispose(aux4,detruire);
                 dispose(aux3,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=0) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0))));
                 dispose(aux4,detruire);
                 dispose(aux3,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=1) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=aux3;
                 dispose(aux4,detruire);
            end else
       if (aux4^.categorie=Cat_affixe) and (Paffixe(aux4^.contenu)^.x=-1) and (Paffixe(aux4^.contenu)^.y=0)
       then begin
                 p:=new(Pcorps,init(cat_operateur,operation('/')));
                 p^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0)))));
                 p^.ajouter_arg(aux3);
                 dispose(aux4,detruire);
            end else
       begin p:=new(Pcorps,init(cat_operateur,operation(nom)));
             p^.ajouter_arg(aux3);
             p^.ajouter_arg(aux4)
       end;
       simplifier:=p;
end;



{Operation OR}
function TOr.evaluer(arg1,arg2:Paffixe):Paffixe;
var resultat:Paffixe;
    r:byte;
begin
     evaluer:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     if (arg2^.y<>0) or (arg1^.y<>0) or ((arg1^.x<>0) and (arg1^.x<>1)) or
     ((arg2^.x<>0) and (arg2^.x<>1)) then exit;
     r:=byte((arg1^.x=1) or (arg2^.x=1));
     resultat:=new(Paffixe,init(r,0));
     evaluer:=resultat;
end;

function TAnd.evaluer(arg1,arg2:Paffixe):Paffixe;
var resultat:Paffixe;
    r:byte;
begin
     evaluer:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     if (arg2^.y<>0) or (arg1^.y<>0) or ((arg1^.x<>0) and (arg1^.x<>1)) or ((arg2^.x<>0) and (arg2^.x<>1)) then exit;
     r:=byte((arg1^.x=1) and (arg2^.x=1));
     resultat:=new(Paffixe,init(r,0));
     evaluer:=resultat;
end;

function TEgal.evaluer(arg1,arg2:Paffixe):Paffixe;
var resultat:Paffixe;
    r:byte;
begin
     evaluer:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     r:=byte((arg1^.x=arg2^.x) and (arg2^.y=arg1^.y));
     resultat:=new(Paffixe,init(r,0));
     evaluer:=resultat;
end;

function TSup.evaluer(arg1,arg2:Paffixe):Paffixe;
var resultat:Paffixe;
    r:byte;
begin
     evaluer:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     if (arg2^.y<>0) or (arg1^.y<>0) then exit;
     r:=byte((arg1^.x > arg2^.x));
     resultat:=new(Paffixe,init(r,0));
     evaluer:=resultat;
end;

function TSupOuE.evaluer(arg1,arg2:Paffixe):Paffixe;
var resultat:Paffixe;
    r:byte;
begin
     evaluer:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     if (arg2^.y<>0) or (arg1^.y<>0) then exit;
     r:=byte((arg1^.x >= arg2^.x));
     resultat:=new(Paffixe,init(r,0));
     evaluer:=resultat;
end;

function TInf.evaluer(arg1,arg2:Paffixe):Paffixe;
var resultat:Paffixe;
    r:byte;
begin
     evaluer:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     if (arg2^.y<>0) or (arg1^.y<>0) then exit;
     r:=byte((arg1^.x < arg2^.x));
     resultat:=new(Paffixe,init(r,0));
     evaluer:=resultat;
end;

function TInfOuE.evaluer(arg1,arg2:Paffixe):Paffixe;
var resultat:Paffixe;
    r:byte;
begin
     evaluer:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     if (arg2^.y<>0) or (arg1^.y<>0) then exit;
     r:=byte((arg1^.x <= arg2^.x));
     resultat:=new(Paffixe,init(r,0));
     evaluer:=resultat;
end;

{================== fonctions =====================}
{Tsqr}
function Tsqr.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=false;
     r:=new(Paffixe,init(ajouter(sqr(arg^.x),-sqr(arg^.y)),
             multiplier(2,multiplier(arg^.x,arg^.y))));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;


function Tsqr.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    aux1,p,p1:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     q:=operation('*');
     p1:=new(Pcorps,init(cat_operateur,q));
     p1^.ajouter_arg(aux1^.dupliquer);
     p1^.ajouter_arg(aux1^.dupliquer);
     p:=p1^.deriver(variable);
     dispose(p1,detruire);
     deriver:=p;
end;


{Topp}
function Topp.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
    res:type_liste;
begin
     evaluer:=nil;
     res.init;
     if arg=nil then exit;
     while (arg<>nil) do
           begin
           r:= new(Paffixe,init(-arg^.x,-arg^.y));
           if r<>nil then res.ajouter_fin(r) else {res.ajouter_fin(jump)};
           arg:=Paffixe(arg^.suivant)
           end;
     evaluer:=Paffixe(res.tete);
end;


function Topp.deriver(arg:Pliste;variable:string):Pcorps;
var q:Pfonction;
    aux1,p,p1:Pcorps;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     p1:=aux1^.deriver(variable);
     if p1=nil then exit;
     q:=fonction('opp');
     p:=new(Pcorps,init(cat_fonction,q));
     p^.ajouter_arg(p1);
     deriver:=p;
end;

{TRand}
function TRand.evaluer(arg:Paffixe):Paffixe;
begin
     evaluer:=nil;
     if arg=nil then
     evaluer:=new(Paffixe,init(Random,0))
     else
     evaluer:=new(Paffixe,init(Random(round(abs(arg^.x))),0));
end;

{TEnt}
function TEnt.evaluer(arg:Paffixe):Paffixe;
var u1,u2:real;
begin
     evaluer:=nil;
     if arg=nil then exit;
     if  arg^.x>=0 then u1:=Int(arg^.x) else u1:=Int(arg^.x)-1;
     if  arg^.y>=0 then u2:=Int(arg^.y) else u2:=Int(arg^.y)-1;
     evaluer:=new(Paffixe,init(u1,u2));

end;

function TEnt.deriver(arg:Pliste;variable:string):Pcorps;
var p:Pcorps;
    q:Pexpression;
begin
     p:=Pcorps(arg^.tete);
     new(q,init);
     q^.definir('Si((x-Ent(x))>0,0)');
     q^.corps^.composer('x',p);
     deriver:=q^.corps;
     q^.corps:=nil;
     dispose(q,detruire);
end;


function Tsin.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if (arg=nil) or (arg^.y<>0) then exit;
     r:=new(Paffixe,init(sin(arg^.x),0));
     evaluer:=r;
end;

function Tsin.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('*');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('cos');
     p1:=new(pCorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     p^.ajouter_arg(p1);
     deriver:=p;
end;

{Tcos}
function Tcos.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if (arg=nil) or (arg^.y<>0) then exit;
     r:=new(Paffixe,init(cos(arg^.x),0));
     evaluer:=r;
end;

function Tcos.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('*');
     p2:=new(Pcorps,init(cat_operateur,q));
     p2^.ajouter_arg(aux2);
     f:=fonction('sin');
     p1:=new(pCorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     p2^.ajouter_arg(p1);
     f:=fonction('opp');
     p:=new(Pcorps,init(cat_fonction,f));
     p^.ajouter_arg(p2);
     deriver:=p;
end;


function Ttan.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if (arg=nil) or (arg^.y<>0) then exit;
     CalcError:=false;
     r:=new(Paffixe,init(tan(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;


function Ttan.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('cos');
     p2:=new(Pcorps,init(cat_fonction,f));
     p2^.ajouter_arg(aux1^.dupliquer);
     f:=fonction('sqr');
     p1:=new(pCorps,init(cat_fonction,f));
     p1^.ajouter_arg(p2);
     p^.ajouter_arg(p1);
     deriver:=p;
end;


function Tarcsin.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if (arg=nil) or (arg^.y<>0) then exit;
     CalcError:=false;
     r:=new(Paffixe,init(arcsin(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Tarcsin.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2,p3:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('sqr');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     q:=operation('-');
     p2:=new(pCorps,init(cat_operateur,q));
     p2^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0)))));
     p2^.ajouter_arg(p1);
     f:=fonction('sqrt');
     p3:=new(Pcorps,init(cat_fonction,f));
     p3^.ajouter_arg(p2);
     p^.ajouter_arg(p3);
     deriver:=p;
end;


function Tarccos.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if (arg=nil) or (arg^.y<>0) then exit;
     CalcError:=false;
     r:=new(Paffixe,init(arccos(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Tarccos.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2,p3,p4:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('sqr');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     q:=operation('-');
     p2:=new(pCorps,init(cat_operateur,q));
     p2^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0)))));
     p2^.ajouter_arg(p1);
     f:=fonction('sqrt');
     p3:=new(Pcorps,init(cat_fonction,f));
     p3^.ajouter_arg(p2);
     p^.ajouter_arg(p3);
     f:=fonction('opp');
     p4:=new(Pcorps,init(cat_fonction,f));
     p4^.ajouter_arg(p);
     deriver:=p4;
end;


function Tarctan.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=new(Paffixe,init(arctan(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Tarctan.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('sqr');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     q:=operation('+');
     p2:=new(pCorps,init(cat_operateur,q));
     p2^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0)))));
     p2^.ajouter_arg(p1);
     p^.ajouter_arg(p2);
     deriver:=p;
end;


function Tsh.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=new(Paffixe,init(sh(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Tsh.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('*');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('ch');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     p^.ajouter_arg(p1);
     deriver:=p;
end;


function Tch.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=new(Paffixe,init(ch(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Tch.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('*');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('sh');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     p^.ajouter_arg(p1);
     deriver:=p;
end;


function Tth.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=new(Paffixe,init(th(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Tth.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('ch');
     p2:=new(Pcorps,init(cat_fonction,f));
     p2^.ajouter_arg(aux1^.dupliquer);
     f:=fonction('sqr');
     p1:=new(pCorps,init(cat_fonction,f));
     p1^.ajouter_arg(p2);
     p^.ajouter_arg(p1);
     deriver:=p;
end;


function Targsh.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=new(Paffixe,init(argsh(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;
function Targsh.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2,p3:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('sqr');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     q:=operation('+');
     p2:=new(pCorps,init(cat_operateur,q));
     p2^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0)))));
     p2^.ajouter_arg(p1);
     f:=fonction('sqrt');
     p3:=new(Pcorps,init(cat_fonction,f));
     p3^.ajouter_arg(p2);
     p^.ajouter_arg(p3);
     deriver:=p;
end;


function Targch.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=new(Paffixe,init(argch(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Targch.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2,p3:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('sqr');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     q:=operation('-');
     p2:=new(pCorps,init(cat_operateur,q));
     p2^.ajouter_arg(p1);
     p2^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0)))));
     f:=fonction('sqrt');
     p3:=new(Pcorps,init(cat_fonction,f));
     p3^.ajouter_arg(p2);
     p^.ajouter_arg(p3);
     deriver:=p;
end;


function Targth.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=new(Paffixe,init(argth(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Targth.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('sqr');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     q:=operation('-');
     p2:=new(pCorps,init(cat_operateur,q));
     p2^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(1,0)))));
     p2^.ajouter_arg(p1);
     p^.ajouter_arg(p2);
     deriver:=p;
end;


function Texp.evaluer(arg:Paffixe):Paffixe;
var res:Paffixe;
    r:real;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=false;
     r:=exp(arg^.x);
     if not CalcError then
             res:=new(Paffixe,init(multiplier(r,cos(arg^.y)),multiplier(r,sin(arg^.y))))
             else  res:=nil;
           
     evaluer:=res;
end;


function Texp.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1:Pcorps; 
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('*');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('exp');
     p1:=new(pCorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     p^.ajouter_arg(p1);
     deriver:=p;
end;


function Tln.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=new(Paffixe,init(ln(arg^.x),0));
     if CalcError then Kill(Pcellule(r));
     evaluer:=r;
end;

function Tln.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    aux1,aux2,p:Pcorps;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     p^.ajouter_arg(aux1^.dupliquer);
     deriver:=p;
end;


function Tbar.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     r:=new(Paffixe,init(arg^.x,-arg^.y));
     evaluer:=r;
end;

function Tbar.deriver(arg:Pliste;variable:string):Pcorps;
var q:Pfonction;
    aux1,aux2,p:Pcorps;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=fonction('bar');
     p:=new(Pcorps,init(cat_fonction,q));
     p^.ajouter_arg(aux2);
     deriver:=p;
end;

{TRe}
function TRe.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     r:=new(Paffixe,init(arg^.x,0));
     evaluer:=r;
end;


function TRe.deriver(arg:Pliste;variable:string):Pcorps;
var q:Pfonction;
    aux1,aux2,p:Pcorps;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=fonction('Re');
     p:=new(Pcorps,init(cat_fonction,q));
     p^.ajouter_arg(aux2);
     deriver:=p;
end;

{TIm}
function TIm.evaluer(arg:Paffixe):Paffixe;
var r:Paffixe;
begin
     evaluer:=nil;
     if arg=nil then exit;
     r:=new(Paffixe,init(arg^.y,0));
     evaluer:=r;
end;


function TIm.deriver(arg:Pliste;variable:string):Pcorps;
var q:Pfonction;
    aux1,aux2,p:Pcorps;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=fonction('Im');
     p:=new(Pcorps,init(cat_fonction,q));
     p^.ajouter_arg(aux2);
     deriver:=p;
end;



function Tsqrt.evaluer(arg:Paffixe):Paffixe;
var res:Paffixe;
    r:real;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=arg^.y<>0;
     r:=sqrt(arg^.x);
     if not CalcError then res:=new(Paffixe,init(r,0)) else res:=nil;
     evaluer:=res;
end;

function Tsqrt.deriver(arg:Pliste;variable:string):Pcorps;
var q:Poperation;
    f:Pfonction;
    aux1,aux2,p,p1,p2:Pcorps;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     q:=operation('/');
     p:=new(Pcorps,init(cat_operateur,q));
     p^.ajouter_arg(aux2);
     f:=fonction('sqrt');
     p1:=new(Pcorps,init(cat_fonction,f));
     p1^.ajouter_arg(aux1^.dupliquer);
     q:=operation('*');
     p2:=new(Pcorps,init(cat_operateur,q));
     p2^.ajouter_arg(new(Pcorps,init(cat_affixe,new(Paffixe,init(2,0)))));
     p2^.ajouter_arg(p1);
     p^.ajouter_arg(p2);
     deriver:=p;
end;



function Tabs.evaluer(arg:Paffixe):Paffixe;
var res:Paffixe;
    r:real;
begin
     evaluer:=nil;
     if arg=nil then exit;
     CalcError:=false;
     if (arg^.y=0) then r:=abs(arg^.x)
                   else r:=sqrt(ajouter(sqr(arg^.x),sqr(arg^.y)));
     if not CalcError then res:=new(Paffixe,init(r,0))
                   else res:=nil;
     evaluer:=res;
end;


function Tabs.deriver(arg:Pliste;variable:string):Pcorps;
var aux1,aux2:Pcorps;
    f:Pexpression;
begin
     deriver:=nil;
     if arg=nil then exit;
     aux1:=Pcorps(arg^.tete);
     if aux1=nil then exit;
     aux2:=aux1^.deriver(variable);
     if aux2=nil then exit;
     new(f,init);
     f^.definir('($up*bar($u)+u*bar(up))/(2*abs(u))');
     f^.corps^.composer('up',aux2);
     f^.corps^.composer('u',aux1);
     dispose(aux2,detruire);
     deriver:=f^.corps^.dupliquer;
     dispose(f,detruire);
end;


function TArg.evaluer(arg:Paffixe):Paffixe;
var res:Paffixe;
    r:real;
begin
     evaluer:=nil;
     if arg=nil then exit;
     if (arg^.x=0) and (arg^.y=0) then exit;
     CalcError:=false;
     if (arg^.x=0) then if arg^.y>0 then r:=pi/2 else r:=-pi/2
                          else
     if arg^.x>0 then r:=arctan(diviser(arg^.y,arg^.x))
                        else
     if arg^.y>=0 then r:=ajouter(pi,arctan(diviser(arg^.y,arg^.x)))
                         else r:=ajouter(-pi,arctan(diviser(arg^.y,arg^.x)));
     if not CalcError then res:=new(Paffixe,init(r,0)) else res:=nil;
     evaluer:=res;
end;

procedure restoreVarG(nom:string;valeur:Paffixe);
var aux:PVarGlob;
begin
     aux:=PVarGlob(VariablesGlobales^.tete);
     while aux<>nil do
           begin
                if nom=aux^.variable^.nom
                   then begin
                        aux^.commande:='';
                        ChangeVarG:=true;
                        end;
                aux:=PVarGlob(aux^.suivant);
           end;
end;

{Commande TSetVar}

function TSetVar.executer(arg:PListe):Paffixe;
var f1,f2:Pcorps;
    T:Paffixe;
    c:Pconstante;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) or (f1^.categorie<>cat_constante) then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     c:=Pconstante(f1^.contenu);
     if (c^.predefinie) then exit;
     T:=f2^.evaluer;
     if c^.affixe<>nil then Kill(Pcellule(c^.affixe));
     c^.affixe:=T;
     if not c^.locale then restoreVarG(c^.nom,T);
end;

{Commande TInc}

function TInc.executer(arg:PListe):Paffixe;
var f1,f2:Pcorps;
    T,res,aux,aux1:Paffixe;
    c:Pconstante;
    r:type_liste;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) or (f1^.categorie<>cat_constante) then exit;
     c:=Pconstante(f1^.contenu);
     if (c^.predefinie) then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     T:=f2^.evaluer;
     if T=Nil then exit;
     r.init;
     aux:=T;
     aux1:=c^.affixe;
     while (aux1<>nil) or (aux<>nil) do
           begin
           if aux1=nil then res:=new(Paffixe,init(aux^.x,aux^.y))
                       else
           if aux=nil then res:=new(Paffixe,init(aux1^.x,aux1^.y))
                      else res:=ajouterC(aux1,aux);
           if res<>nil then r.ajouter_fin(res) else;
           if aux<>nil then  aux:=Paffixe(aux^.suivant);
           if aux1<> nil then aux1:=Paffixe(aux1^.suivant);
           end;
     Kill(Pcellule(c^.affixe));
     c^.affixe:=Paffixe(r.tete);
     Kill(Pcellule(T));
     if not c^.locale then restoreVarG(c^.nom,c^.affixe);
end;

{Commande TEchange}

function TEchange.executer(arg:PListe):Paffixe;
var f1,f2:Pcorps;
    T:Paffixe;
    c1,c2:Pconstante;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) or (f1^.categorie<>cat_constante) then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) or (f2^.categorie<>cat_constante) then exit;
     c1:=Pconstante(f1^.contenu);
     c2:=Pconstante(f2^.contenu);
     if (c1^.predefinie) or (c2^.predefinie) then exit;
     T:=c1^.affixe;
     c1^.affixe:=c2^.affixe;
     c2^.affixe:=T;
     if not c1^.locale then restoreVarG(c1^.nom,c1^.affixe);
     if not c2^.locale then restoreVarG(c2^.nom,c2^.affixe);
end;

{fonction TAppend}

function TAppend.executer(arg:Pliste):Paffixe;
var f1,f2,f3:Pcorps;
    T,aux1:Paffixe;
    l:type_liste;
    mode,compt:word;
    c:Pconstante;
    
    aux,fin:Paffixe;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) or (f1^.categorie<>cat_constante) or (Pconstante(f1^.contenu)^.predefinie) then  exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     T:=f2^.evaluer;
     if T=nil then exit;
     c:=Pconstante(f1^.contenu);
     f3:=Pcorps(f2^.suivant);
     mode:=0;
     if f3<>nil then begin
                     aux1:=f3^.evaluer;
                     if aux1<>nil then mode:= Round(aux1^.x);
                     Kill(Pcellule(aux1));
                     end;
     
     l.init;
     if mode=0 then begin if c^.affixe<>nil then l.ajouter_fin(c^.affixe);l.ajouter_fin(T)
                    end else
     if mode=1 then begin
        l.ajouter_fin(T);
        if c^.affixe<>nil then l.ajouter_fin(c^.affixe);
                    end else
                    begin
     compt:=1;if c^.affixe<>nil then l.ajouter_fin(c^.affixe);
     aux:=c^.affixe;
     while (aux<>nil) and (compt<mode) do begin aux:=Paffixe(aux^.suivant); inc(compt) end;
     if (aux=nil) then l.ajouter_fin(T)
        else
        begin
             T^.precedent:=aux^.precedent;
             aux^.precedent^.suivant:=T;
             fin:=T;
             while fin^.suivant<>nil do fin:=Paffixe(fin^.suivant);
             fin^.suivant:=aux;
             aux^.precedent:=fin;
        end
                    end;
     c^.affixe:=Paffixe(l.tete);
     if not c^.locale then restoreVarG(c^.nom,c^.affixe);
end;


{commande TDel}
function TDel.executer(arg:Pliste):Paffixe;
var f1,f2,f3:Pcorps;
    T,aux:Paffixe;
    i,depart,nombre:longint;
    l:type_liste;
    all:boolean;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if (f1=nil) or (f1^.categorie<>cat_constante) or (Pconstante(f1^.contenu)^.predefinie) then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     if f3=nil then exit;
     T:=f2^.evaluer;
     if T=nil then exit;
     depart:=Round(T^.x); Kill(Pcellule(T));
     T:=f3^.evaluer;
     if T=nil then exit;
     nombre:=Round(T^.x); Kill(Pcellule(T));
     All:=(nombre=0);
     T:=Pconstante(f1^.contenu)^.affixe;
     if T=nil then exit;
     i:=1;aux:=T;
     while (aux<>nil) and (i<depart) do begin aux:=Paffixe(aux^.suivant); inc(i) end;
     if aux=nil then begin exit end;
     i:=0;l.init;l.ajouter_fin(T);
     while (aux<>nil) and (All or (i<nombre)) do
           begin l.supprimer(PCellule(aux));
                 inc(i);
           end;
     Pconstante(f1^.contenu)^.affixe:=Paffixe(l.tete);
     if not Pconstante(f1^.contenu)^.locale then
     restoreVarG(Pconstante(f1^.contenu)^.nom,Paffixe(l.tete));
end;

{Tsort}
function TSort.executer(arg: Pliste):Paffixe;
var f:Pcorps;
    P1:Paffixe;
    res:type_liste;
    list:Tlist;

    function Comparer(Item1, Item2: Pointer): Integer;
    var x:real;
    begin
         x:= Paffixe(Item1).x - Paffixe(Item2).x;
         if x<0 then result:=-1 else if x>0 then result:=1 else
                begin
                        x:= Paffixe(Item1).y - Paffixe(Item2).y;
                        if x<0 then result:=-1 else if x>0 then result:=1 else result:=0;
                end
    end;

    procedure ajouter;
    var i:integer;
    begin
        list.Sort(@comparer);
        for i:=0 to list.count-1 do
         res.ajouter_fin(New(Paffixe,init(Paffixe(list.Items[i])^.x, Paffixe(list.Items[i])^.y)));
        list.Clear;
    end;

begin
     executer:=nil;
     if arg=nil then exit;
     f:=Pcorps(arg^.tete);
     if (f=nil) or (f^.categorie<>cat_constante) or
        (Pconstante(f^.contenu)^.predefinie) then  exit;
     res.init;
     P1:=Pconstante(f^.contenu)^.affixe;
     list:=Tlist.create;
     while P1<>nil do
           begin
                if IsJump(P1) then
                       if list.count>0 then  begin
                                                ajouter;
                                                res.ajouter_fin(New(Paffixe,init(jump^.x,jump^.y)));
                                               end
                                       else
                    else list.add(P1);
                P1:=Paffixe(P1^.suivant)
           end;
      if list.count>0 then  ajouter;
      list.Free;
      Kill(Pcellule(P1));
      Pconstante(f^.contenu)^.affixe:=Paffixe(res.tete);
      if not Pconstante(f^.contenu)^.locale then
     restoreVarG(Pconstante(f^.contenu)^.nom,Paffixe(res.tete));
end;

 {============== Definir reel ==============}
 function definir_reel(Const chaine:String; var x:real):boolean;
 var f:Pexpression;
     r:Paffixe;
 begin
      definir_reel:=false;
      new(f,init);
      if f^.Definir(chaine)
         then
             begin
                  r:=f^.evaluer;
                  if r<>nil
                     then
                         begin
                              x:=r^.x;
                              definir_reel:=true; Kill(Pcellule(r))
                         end;
             end;
      dispose(f,detruire)
end;
{========== MakeString =============}
function MakeString(f:Pcorps): string;
var aux,chaine2:string;
    T:Paffixe;
    ok:boolean;
    f2,f3:Pcorps;
    c:Pmacros;
    d:PvarGlob;
begin
     MakeString:='';
     f2:=f;
     if f2=nil then exit;
     chaine2:='';
     if (f2^.categorie=cat_commande) and (PCommande(f2^.contenu)^.nom='Liste')
                                     then
                                         begin f2:=Pcorps(f2^.arguments^.tete); ok:=true
                                         end
                                     else ok:=false;
     while f2<>nil do
           begin
                if (f2^.categorie=cat_commande) and (PCommande(f2^.contenu)^.nom='String')
                   then
                       begin
                            f3:=Pcorps(f2^.arguments^.tete);
                            if f3=nil then aux:=''
                            else
                            if f3^.categorie=cat_constante
                                then aux:=Pconstante(f3^.contenu)^.nom
                                {else
                            if f3^.categorie=cat_macro
                                then aux:=Pmacros(f3^.contenu)^.nom}
                                else aux:=f3^.en_chaine;
                       end
                   else
                if (f2^.categorie=cat_commande) and (PCommande(f2^.contenu)^.nom='Str')
                   then
                       begin
                            f3:=Pcorps(f2^.arguments^.tete);
                            if f3=nil then aux:=''
                            else
                            if f3^.categorie=cat_constante
                                then aux:=Pconstante(f3^.contenu)^.nom
                                else
                            if f3^.categorie=cat_macro
                                then aux:=Pmacros(f3^.contenu)^.nom
                                else aux:=MakeString(f3);
                            if aux<>'' then
                                begin
                                c:=macros(aux);
                                if c<>nil
                                        then aux:=c^.commande
                                        else
                                        begin
                                                d:=varglob(aux);
                                                if d<>nil
                                                        then aux:=d^.commande;
                                        end;
                                end;
                       end
                   else
                if f2^.categorie=cat_string
                   then aux:=analyse4.Pstring(f2^.contenu)^.chaine
                   else
                if (f2^.categorie=cat_macro) and (Pmacros(f2^.contenu)^.nom='chaine')
                    then begin
                              c:=macros('chaine');
                              aux:='';
                              if c<>nil then
                                 begin
                                      f3:=c^.contenu^.corps;
                                      if (f3^.categorie=cat_string )
                                         then aux:=analyse4.Pstring(f3^.contenu)^.chaine
                                         else aux:=''
                                 end;
                         end
                    else
                         begin
                             T:=f2^.evaluer;
                             if T<>nil then begin aux:=T^.en_chaine(12);Kill(Pcellule(T)); end
                                       else aux:='';
                        end;
                chaine2:=chaine2+aux;
                if ok then f2:=Pcorps(f2^.suivant) else f2:=nil
           end;
     MakeString:=chaine2;
end;

Initialization

     LesOperations^.ajouter_fin(PCellule(new(Pplus,init('+',priorite_addition))));
     LesOperations^.ajouter_fin(PCellule(new(Pfois,init('*',priorite_multiplication))));
     LesOperations^.ajouter_fin(PCellule(new(Pdiv,init('/',priorite_division))));
     LesOperations^.ajouter_fin(PCellule(new(Pmoins,init('-',priorite_soustraction))));
     LesOperations^.ajouter_fin(PCellule(new(Pexpo,init('^',priorite_puissance))));
     LesOperations^.ajouter_fin(PCellule(new(PCapD,init('Inter',priorite_fonction))));
     LesOperations^.ajouter_fin(PCellule(new(PCapL,init('InterL',priorite_fonction))));
     LesOperations^.ajouter_fin(PCellule(new(PCutB,init('CutB',priorite_or))));
     LesOperations^.ajouter_fin(PCellule(new(PCutA,init('CutA',priorite_or))));
     LesOperations^.ajouter_fin(PCellule(new(PInside,init('Inside',priorite_egal))));
     LesOperations^.ajouter_fin(PCellule(new(POr,init('Or',priorite_or))));
     LesOperations^.ajouter_fin(PCellule(new(PAnd,init('And',priorite_and))));
     LesOperations^.ajouter_fin(PCellule(new(PEgal,init('Egal',priorite_egal))));
     LesOperations^.ajouter_fin(PCellule(new(PSup,init('Sup',priorite_superieur))));
     LesOperations^.ajouter_fin(PCellule(new(PSupOuE,init('SupOuE',priorite_superieur))));
     LesOperations^.ajouter_fin(PCellule(new(PInf,init('Inf',priorite_inferieur))));
     LesOperations^.ajouter_fin(PCellule(new(PInfOuE,init('InfOuE',priorite_inferieur))));
     LesOperations^.ajouter_fin(PCellule(new(POperation,init('Recoit',priorite_affectation))));
     LesOperations^.ajouter_fin(PCellule(new(POperation,init('Extract',priorite_copy))));


     LesFonctions^.ajouter_fin(PCellule(new(Psqr,init('sqr'))));
     LesFonctions^.ajouter_fin(PCellule(new(Popp,init('opp'))));
     LesFonctions^.ajouter_fin(PCellule(new(Psin,init('sin'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pcos,init('cos'))));
     LesFonctions^.ajouter_fin(PCellule(new(Ptan,init('tan'))));
     LesFonctions^.ajouter_fin(PCellule(new(Parcsin,init('arcsin'))));
     LesFonctions^.ajouter_fin(PCellule(new(Parccos,init('arccos'))));
     LesFonctions^.ajouter_fin(PCellule(new(Parctan,init('arctan'))));
     LesFonctions^.ajouter_fin(PCellule(new(Psh,init('sh'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pch,init('ch'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pth,init('th'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pargsh,init('argsh'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pargch,init('argch'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pargth,init('argth'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pexp,init('exp'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pln,init('ln'))));
     LesFonctions^.ajouter_fin(PCellule(new(Psqrt,init('sqrt'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pbar,init('bar'))));
     LesFonctions^.ajouter_fin(PCellule(new(Pabs,init('abs'))));
     LesFonctions^.ajouter_fin(PCellule(new(PArg,init('Arg'))));
     LesFonctions^.ajouter_fin(PCellule(new(PEnt,init('Ent'))));
     LesFonctions^.ajouter_fin(PCellule(new(PRe,init('Re'))));
     LesFonctions^.ajouter_fin(PCellule(new(PIm,init('Im'))));
     LesFonctions^.ajouter_fin(PCellule(new(PRand,init('Rand'))));

    
     Constpredefinie:=true;
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('i',new(Paffixe,init(0,1)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('e',new(Paffixe,init(exp(1),0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('pi',new(Paffixe,init(pi,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('black',new(Paffixe,init(0,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('white',new(Paffixe,init(1,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('red',new(Paffixe,init(2,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('green',new(Paffixe,init(3,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('blue',new(Paffixe,init(4,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('yellow',new(Paffixe,init(5,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('cyan',new(Paffixe,init(6,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('magenta',new(Paffixe,init(7,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('gray',new(Paffixe,init(8,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('noline',new(Paffixe,init(-1,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('solid',new(Paffixe,init(0,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('dashed',new(Paffixe,init(1,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('dotted',new(Paffixe,init(2,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('thinlines',new(Paffixe,init(2,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('thicklines',new(Paffixe,init(8,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('Thicklines',new(Paffixe,init(14,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('cross',new(Paffixe,init(2,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('dot',new(Paffixe,init(0,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('bigdot',new(Paffixe,init(1,0)),false))));

     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('centered',new(Paffixe,init(0,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('left',new(Paffixe,init(1,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('right',new(Paffixe,init(2,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('framed',new(Paffixe,init(16,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('stacked',new(Paffixe,init(32,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('special',new(Paffixe,init(64,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('top',new(Paffixe,init(4,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('bottom',new(Paffixe,init(8,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('jump',new(Paffixe,init(reel_Max-1,0)),false))));

     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('none',new(Paffixe,init(0,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('full',new(Paffixe,init(1,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('bdiag',new(Paffixe,init(2,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('hvcross',new(Paffixe,init(3,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('diagcross',new(Paffixe,init(4,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('fdiag',new(Paffixe,init(5,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('horizontal',new(Paffixe,init(6,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('vertical',new(Paffixe,init(7,0)),false))));

     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('tiny',new(Paffixe,init(0,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('scriptsize',new(Paffixe,init(1,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('footnotesize',new(Paffixe,init(2,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('small',new(Paffixe,init(3,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('normalsize',new(Paffixe,init(4,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('large',new(Paffixe,init(5,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('Large',new(Paffixe,init(6,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('LARGE',new(Paffixe,init(7,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('huge',new(Paffixe,init(8,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('Huge',new(Paffixe,init(9,0)),false))));

     PXmin:=new(Pconstante,init('Xmin',new(Paffixe,init(-5,0)),false));
     LesConstantes^.ajouter_fin(PCellule(PXmin));

     PYmin:=new(Pconstante,init('Ymin',new(Paffixe,init(-5,0)),false));
     LesConstantes^.ajouter_fin(PCellule(PYmin));

     PXmax:=new(Pconstante,init('Xmax',new(Paffixe,init(5,0)),false));
     LesConstantes^.ajouter_fin(PCellule(PXmax));

     PYmax:=new(Pconstante,init('Ymax',new(Paffixe,init(5,0)),false));
     LesConstantes^.ajouter_fin(PCellule(PYmax));

     PXscale:=new(Pconstante,init('Xscale',new(Paffixe,init(1,0)),false));
     LesConstantes^.ajouter_fin(PCellule(PXscale));

     PYscale:=new(Pconstante,init('Yscale',new(Paffixe,init(1,0)),false));
     LesConstantes^.ajouter_fin(PCellule(PYscale));

     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('margeG',new(Paffixe,init(0.5,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('margeD',new(Paffixe,init(0.5,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('margeH',new(Paffixe,init(0.5,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('margeB',new(Paffixe,init(0.5,0)),false))));
     PExportMode:=new(Pconstante,init('ExportMode',new(Paffixe,init(0,0)),false));
     LesConstantes^.ajouter_fin(PCellule(PExportMode));

     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('teg',new(Paffixe,init(3,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('tex',new(Paffixe,init(1,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('pst',new(Paffixe,init(2,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('pgf',new(Paffixe,init(5,0)),false))));
     LesConstantes^.ajouter_fin(PCellule(new(Pconstante,init('eps',new(Paffixe,init(4,0)),false))));

     Constpredefinie:=false;


     LesCommandes^.ajouter_fin(PCellule(new(PSeq,init('Seq'))));
     LesCommandes^.ajouter_fin(PCellule(new(PMap,init('Map'))));
     LesCommandes^.ajouter_fin(PCellule(new(PCmListe,init('Liste'))));
     LesCommandes^.ajouter_fin(PCellule(new(PSi,init('Si'))));
     LesCommandes^.ajouter_fin(PCellule(new(PCopy,init('Copy'))));
     LesCommandes^.ajouter_fin(PCellule(new(PLoop,init('Loop'))));
     LesCommandes^.ajouter_fin(PCellule(new(PAssign,init('Assign'))));
     LesCommandes^.ajouter_fin(PCellule(new(PNops,init('nops'))));
     LesCommandes^.ajouter_fin(PCellule(new(PNops,init('Nops'))));
     LesCommandes^.ajouter_fin(PCellule(new(PDiff,init('Diff'))));
     LesCommandes^.ajouter_fin(PCellule(new(PInt,init('Int'))));
     LesCommandes^.ajouter_fin(PCellule(new(PSolve,init('Solve'))));
     LesCommandes^.ajouter_fin(new(PSetVar,init('Set')));
     LesCommandes^.ajouter_fin(new(PDel,init('Del')));
     LesCommandes^.ajouter_fin(new(PEchange,init('Echange')));
     LesCommandes^.ajouter_fin(new(PInc,init('Inc')));
     LesCommandes^.ajouter_fin(new(PAppend,init('Append')));
     LesCommandes^.ajouter_fin(new(PAppend,init('Insert')));
     LesCommandes^.ajouter_fin(new(PRgb,init('Rgb')));
     LesCommandes^.ajouter_fin(New(PSort,init('Sort')));

     jump:=constante('jump')^.affixe;
     Randomize
END.
