{Copyright (C) 2005 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version 
ultrieure choisie par vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
 Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme;
 si ce n'est pas le cas, crivez  la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 }


Unit command9; {dfinition de commandes graphiques}
INTERFACE
uses SysUtils,listes2,complex3,analyse4,command5,graph1_6,graph2_7,surface8;
const
      fileChanged:boolean=false;
      ChangeGraph:boolean=false; {indique si un nouvel lment graphique a t cr}
      
IMPLEMENTATION

type  PStr= ^TStr;
      TStr= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      PName= ^TName;
      TName= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      
      PPolyg= ^TPolyg;
      TPolyg= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      PCourbe= ^TCourbe;
      TCourbe= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

     

      PDroite2= ^TDroite2;
      TDroite2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      PAxes2= ^TAxes;
      TAxes= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      PGrille2= ^TGrille;
      TGrille= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;
     
      PCircle= ^TCircle;
      TCircle= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      

      PNuage= ^TNuage;
      TNuage= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;


      PTangent= ^TTangent;
      TTangent= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

          
      PArc2= ^TArc2;
      TArc2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

     
      PEquaDif2= ^TEquaDif2;
      TEquaDif2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      PImplicit2= ^TImplicit2;
      TImplicit2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      Pbezier2= ^Tbezier2;
      Tbezier2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;
      
      Putilisateur2=^Tutilisateur2;
      Tutilisateur2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      Plabel2= ^Tlabel2;
      Tlabel2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      Pspline2= ^Tspline2;
      Tspline2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

      Psurface2= ^Tsurface2;
      Tsurface2= object(Tcommande)

           function executer(arg:PListe):Paffixe;virtual;
           end;

       
       Pwind=^Twind;
       Twind= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
              end;


       PEval=^TEval;
       TEval= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
              end;


       PGet=^TGet;
       TGet= object(Tcommande)

                     function executer(arg:PListe):Paffixe;virtual;
              end;


var MakeListe: Pcorps; {arbre contenant la fonction Liste}

function NomStandard: string;
begin
        if ContexteUtilisateur then result:=''
          else
                begin
                        PcomptGraph^.affixe^.x:=PcomptGraph^.affixe^.x+1;
                        Result:='objet'+Streel(PcomptGraph^.affixe^.x);
                end;
end;

function TPolyg.executer(arg:PListe):Paffixe;
var f1,f2,f3:PCorps;
    closed:byte;
    Unrayon:real;
    aux1,aux2:Paffixe;
    res:Pligne;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     Unrayon:=0;closed:=0;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=PCorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     aux1:=f2^.evaluer;
     if aux1<>nil then begin closed:=round(aux1^.x);Kill(Pcellule(aux1)) end;
     if f3<>nil then begin aux2:=f3^.evaluer end
                else begin aux2:=nil;end;
     if aux2<>nil then begin Unrayon:=aux2^.x;Kill(Pcellule(aux2)) end;
     //aux:=f1^.en_chaine;
     res:=new(PLigne,init('','',closed,Unrayon));
     res^.ConstruitArbre(f1);
     res^.Recalculer;
     liste_enfant.ajouter_fin(res)
end;


{Commande TCourbe}

function TCourbe.executer(arg:PListe):Paffixe;
var f1,f2,f3:PCorps;
    T:Paffixe;
    diviser,saut:byte;
    //chaine:string;
    res:Pparametree;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2<>nil then f3:=Pcorps(f2^.suivant);
     diviser:=5; saut:=0;
     if f2<>nil then
        begin
             T:=f2^.evaluer;
             if T<>nil then begin diviser:=Round(T^.x) mod 256; Kill(Pcellule(T)) end;
             if f3<>nil then
                begin
                     T:=f3^.evaluer;
                     if T<>nil then begin saut:=Round(T^.x) mod 2; Kill(Pcellule(T)) end;
                end;
        end;
     res:=new(Pparametree,init('','',diviser,saut));
     res^.ConstruitArbre(f1);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;



{Commande TDroite2}

function TDroite2.executer(arg:PListe):Paffixe;
var p,f1,f2,f3:PCorps;
    //chaine:string;
    res:Pdroite;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     p:=MakeListe;
     p^.arguments:=arg;
     //chaine:='['+f1^.en_chaine+','+f2^.en_chaine;
     //if f3<>nil then chaine:=chaine+','+f3^.en_chaine+']' else chaine:=chaine+']';
     res:= new(Pdroite,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;

{Commande TAxes}

function TAxes.executer(arg:PListe):Paffixe;
var p,f1,f2:PCorps;
    //chaine:string;
    res:PAxes;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     //chaine:='['+f1^.en_chaine+','+f2^.en_chaine+']';
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PAxes,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;

{Commande TGrille}

function TGrille.executer(arg:PListe):Paffixe;
var p,f1,f2:PCorps;
    //chaine:string;
    res:PGrille;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PGrille,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
     //chaine:='['+f1^.en_chaine+','+f2^.en_chaine+']';
end;



{Commande TCircle}
function TCircle.executer(arg:PListe):Paffixe;
var p,f1,f2:PCorps;
    //chaine:string;
    res:Pcercle;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PCercle,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;


{Commande TNuage}

function TNuage.executer(arg:PListe):Paffixe;
var p,f1:PCorps;
    //chaine:string;
    res:Pdot;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(Pdot,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;



{Commande TTangent}

function TTangent.executer(arg:PListe):Paffixe;
var f1,f2,f3,f4:PCorps;
    T,aux,aux1,res:Paffixe;
    l:type_liste;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=PCorps(f1^.suivant);
     if (f2=nil) or (f2^.categorie<>cat_constante) or (Pconstante(f2^.contenu)^.predefinie) then exit;
     f3:=PCorps(f2^.suivant);
     if f3=nil then exit;
     aux:=f3^.evaluer;
     if (aux=nil) then exit;
     f4:=f1^.deriver(Pconstante(f2^.contenu)^.nom);
     if f4=nil then begin Kill(Pcellule(aux)); exit end;
     T:=new(Paffixe,init(0,0));
     f4^.assigner(Pconstante(f2^.contenu)^.nom,T);
     aux1:=Paffixe(aux);
     l.init;
     while aux1<>nil do
           begin
                T^.x:=aux1^.x;T^.y:=aux1^.y;
                res:=f4^.evaluer;
                if res<>nil then l.ajouter_fin(res);
                aux1:=Paffixe(aux1^.suivant)
           end;
     executer:=Paffixe(l.tete);
     Kill(Pcellule(aux));
     f4^.desassigner(Pconstante(f2^.contenu)^.nom);
     Kill(Pcellule(T));
     dispose(f4,detruire);
end;


{Commande TArc2}
function TArc2.executer(arg:PListe):Paffixe;
var p,f1,f2,f3,f4,f5:PCorps;
    a:Paffixe;
    sens:integer;
    //chaine:string;
    res:PArc;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     if f3=nil then exit;
     f4:=Pcorps(f3^.suivant);
     if f4=nil then exit;
     f5:=Pcorps(f4^.suivant);
     if f5=nil then sens:=1 else
        begin a:=f5^.evaluer;
              if (a=nil) or (a^.y<>0) then exit else sens:=round(a^.x);Kill(Pcellule(a));
              arg^.supprimer(Pcellule(f5));
        end;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PArc,init('','',sens));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;



{Commande TEquaDif2}

function TEquaDif2.executer(arg:PListe):Paffixe;
var p,f1:PCorps;
    i,mode:byte;
    //chaine:string;
    aux:Paffixe;
    res:PEquaDif;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     i:=1;
     while f1^.suivant<>nil do begin inc(i); f1:=Pcorps(f1^.suivant) end;
     if i=4 then aux:=Pcorps(f1)^.evaluer else aux:=nil;
     if aux=nil then mode:=0
                else
                        begin mode:=Round(aux^.x) mod 3;
                              Kill(Pcellule(aux));
                              arg^.supprimer(Pcellule(f1))
                        end;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PEquaDif,init('','',mode));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;

{Commande TImplicit2}

function TImplicit2.executer(arg:PListe):Paffixe;
var p,f1:PCorps;
    //chaine:string;
    res:PImplicit;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PImplicit,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;



{Commande Tbezier2}

function Tbezier2.executer(arg:PListe):Paffixe;
var p,f1:PCorps;
    //chaine:string;
    res:PBezier;
begin

     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PBezier,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;

{Commande Tspline2}

function Tspline2.executer(arg:PListe):Paffixe;
var p,f1:PCorps;
    //chaine:string;
    res:PSpline;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PSpline,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);

end;

{Commande Tsurface2}

function Tsurface2.executer(arg:PListe):Paffixe;
var p,f1:PCorps;
    //chaine:string;
    res:PSurface;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     p:=MakeListe;
     p^.arguments:=arg;
     res:= new(PSurface,init('',''));
     res^.ConstruitArbre(p);res^.Recalculer;
     liste_enfant.ajouter_fin(res);
end;

{Commande TStr}

function TStr.executer(arg:PListe):Paffixe;
begin
     executer:=nil;
end;

{Commande TName}

function TName.executer(arg:PListe):Paffixe;
begin
     executer:=nil;
end;


{Commande Tutilisateur2}

function Tutilisateur2.executer(arg:Pliste):Paffixe;
var f1,f2,f3:PCorps;
    aux,chaine2:string; //string
    chaine1:Tnom;
    aux1:Pelement;
    ok:boolean;
    code:integer;
    res:Paffixe;
begin
     executer:=nil;code:=-1;
     If Not FoncSpeciales then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if (f1=nil) then exit;
     f2:=Pcorps(f1^.suivant);
     if f2=nil
        then
            begin //nom standard
                  chaine1:=NomStandard;
                  f2:=f1 //corps de la commande
            end
        else
        begin
              chaine1:=MakeString(f1);  //f1 contient le nom
              f3:=Pcorps(f2^.suivant);
              if f3<>nil then
                begin
                        res:=f3^.evaluer;
                        if res<>nil then
                                begin
                                        code:=round(res^.x);
                                        Kill(Pcellule(res))
                                end;
                end
        end;
     if not NomValide(chaine1,true) then exit;
     aux1:=Pelement(liste_element.tete);
     while (aux1<>nil) and (aux1^.nom<>chaine1) do aux1:=Pelement(aux1^.suivant);
     ok:=(aux1<>nil); //dj existant?? si oui l'ancien sera cras
     if ok or VariableValide(chaine1,false) then   //une variable ne doit pas porter le mme nom
        begin
     aux:=MakeString(f2);
     chaine2:=FormatString(aux,80);
     FoncSpeciales:=false;
     liste_element.inserer(new(Putilisateur,init(chaine1,chaine2,code)),aux1);
     if ok then liste_element.supprimer(Pcellule(aux1))
           else ChangeGraph:=true;
     FoncSpeciales:=true;
     fileChanged:=true;
       end;
end;

{Commande Tlabel2 }
function Tlabel2.executer(arg:PListe):Paffixe;
var f1,f2:PCorps;
    chaine2:string;
    res:Plabel;
begin
     executer:=nil;
     If Not ContexteUtilisateur then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) then exit;
     while (f2<>nil) do
     begin
     chaine2:=MakeString(f2);
     if chaine2<>'' then
        begin
             res:=new(Plabel,init('','',chaine2));
             res^.ConstruitArbre(f1);res^.Recalculer;
             liste_enfant.ajouter_fin(res)
        end;
     f2:=Pcorps(f1^.suivant);
     f1:=Pcorps(f2^.suivant);
     if f1<>nil then f2:=Pcorps(f1^.suivant) else f2:=nil;
     end;
end;

{Commande Tget }
function TGet.executer(arg:PListe):Paffixe;
var f1:PCorps;
    chaine:string;
    //aux:string;
    aux2:Putilisateur;
    index,index2:Pelement;
    res,Laux:type_liste;
    oldNomVide:boolean;
    name:Tnom;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     res.init;
     if f1^.categorie=cat_constante then
        begin
             name:=Pconstante(f1^.contenu)^.nom;
             index:=Pelement(liste_element.tete);
             while index<>nil do
                   begin
                        if index^.nom=name then
                                  if index^.liste_points^.tete<>nil
                                     then
                                     res.ajouter_fin(Paffixe(index^.liste_points^.tete)^.evaluer)
                                     else
                                  if index^.cat=cat_utilisateur then
                                     begin
                                          index2:=Pelement(Putilisateur(index)^.enfants.tete);
                                          while index2<>nil do
                                                begin
                                                if Paffixe(index2^.liste_points^.tete)<>nil
                                                   then res.ajouter_fin(Paffixe(index2^.liste_points^.tete)^.evaluer);
                                                index2:=Pelement(index2^.suivant);
                                                if (index2<>nil) and (Paffixe(index2^.liste_points^.tete)<>nil)
                                                   then res.ajouter_fin(new(Paffixe,init(jump^.x,jump^.y)))
                                                end;
                                     end;
                        index:=Pelement(index^.suivant);
                   end
        end else
        begin
     oldNomVide:=ContexteUtilisateur;
     ContexteUtilisateur:=true;
     Laux.init;
     laux.tete:=liste_enfant.tete;
     Laux.queue:=liste_enfant.queue;
     liste_enfant.init;
     chaine:=f1^.en_chaine;
     aux2:=new(Putilisateur,init('',chaine,-1));
     index:=Pelement(aux2^.enfants.tete);
     while index<>nil do
           begin
                res.ajouter_fin(Paffixe(index^.liste_points^.tete));
                index^.liste_points^.init;
                index:=Pelement(index^.suivant);
                if index<>nil then res.ajouter_fin(new(Paffixe,init(jump^.x,jump^.y)))
           end;
     dispose(aux2,detruire);
     ContexteUtilisateur:=OldNomVide;
     liste_enfant.tete:=Laux.tete;
     liste_enfant.queue:=Laux.queue;
        end;
     if res.tete<>nil then executer:=Paffixe(res.tete);

 end;

{commande TWind}

function TWind.executer(arg:PListe):Paffixe;
var f1,f2,f3:PCorps;
    T:Paffixe;
    x1,x2,y1,y2,ex,ey:real;
begin
     executer:=nil;
     {if Not FoncSpeciales then exit;}
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     f2:=Pcorps(f1^.suivant);
     if (f2=nil) then exit;
     f3:=Pcorps(f2^.suivant);
     T:=f1^.evaluer;
     if T<>nil then begin x1:=T^.x;y2:=T^.y;Kill(Pcellule(T)) end else exit;
     T:=f2^.evaluer;
     if T<>nil then begin x2:=T^.x;y1:=T^.y;Kill(Pcellule(T)) end else exit;
     ex:=Xscale;ey:=Yscale;
     if f3<>nil then
        begin
             T:=f3^.evaluer;
             if T<>nil then begin ex:=T^.x;ey:=T^.y;Kill(Pcellule(T)) end else exit;
        end;
     if (x1<x2) and (y1<y2) and (ex>0) and (ey>0)
        then fenetre(x1,y1,x2,y2,ex,ey);
end;

{commande TEval}

function TEval.executer(arg:PListe):Paffixe;
var f1:PCorps;
    T:Paffixe;
    f:Pexpression;
    aux:string;
begin
     executer:=nil;
     //If Not FoncSpeciales then exit;
     if arg=nil then exit;
     f1:=PCorps(arg^.tete);
     if f1=nil then exit;
     aux:=MakeString(f1);
     if aux='' then exit;
     new(f,init);
     T:=nil;
     if f^.definir(aux) then  begin T:=f^.evaluer;end;
     dispose(f,detruire);
     executer:=T
end;



 {======================}
Initialization
     LesCommandes^.ajouter_fin(new(PPolyg,init('Ligne')));
     LesCommandes^.ajouter_fin(new(PCourbe,init('Courbe')));
     LesCommandes^.ajouter_fin(new(PDroite2,init('Droite')));
     LesCommandes^.ajouter_fin(new(PCircle,init('Cercle')));
     LesCommandes^.ajouter_fin(new(PNuage,init('Point')));
     LesCommandes^.ajouter_fin(new(PTangent,init('Der')));
     LesCommandes^.ajouter_fin(new(PArc2,init('Arc')));
     LesCommandes^.ajouter_fin(new(PEquaDif2,init('EquaDif')));
     LesCommandes^.ajouter_fin(new(PImplicit2,init('Implicit')));
     LesCommandes^.ajouter_fin(new(PBezier2,init('Bezier')));
     LesCommandes^.ajouter_fin(new(PSpline2,init('Spline')));
     LesCommandes^.ajouter_fin(new(PSurface2,init('Surface')));
     LesCommandes^.ajouter_fin(new(PStr,init('Str')));
     LesCommandes^.ajouter_fin(new(PName,init('String')));
    
     LesCommandes^.ajouter_fin(new(Putilisateur2,init('Creer')));
     LesCommandes^.ajouter_fin(new(Putilisateur2,init('NewGraph')));
     LesCommandes^.ajouter_fin(new(PLabel2,init('Label')));
     
     LesCommandes^.ajouter_fin(new(PWind,init('Fenetre')));
     LesCommandes^.ajouter_fin(new(PEval,init('Eval')));
     
     LesCommandes^.ajouter_fin(new(PGet,init('Get')));
     LesCommandes^.ajouter_fin(new(PAxes2,init('Axes')));
     LesCommandes^.ajouter_fin(new(PGrille2,init('Grille')));

     MakeListe:=new(Pcorps, init(cat_commande, commande('Liste')));
end.
