{Copyright (C) 2005 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version 
ultrieure choisie par vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
 Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme;
 si ce n'est pas le cas, crivez  la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 }


unit graph1_6; {Dfinition des lments graphiques premire partie }
INTERFACE
Uses Windows, Graphics,SysUtils,Unite1{calculs}, listes2 {listes},
     complex3{complexes},analyse4{analyseur}, command5 {commandes};

const car_special='#'; {separateur dans les fichiers exports}
      //ComptGraph:longint=0; //compteur d'lments graphiques pour les noms par dfaut
      ChangeFen:boolean=false; {indique si la fenetre a t modifie}
      ExportJpeg:boolean=false;
      ExportPrn:boolean=false;
      Apercu:boolean=false;
      PenMode1= pmNotXor;

      latex=1;
      pgf=5;
      eps=4;
      pstricks=2;
      teg=3;
      pdf=6;
      jpeg=7;

      TexDashStyle:string='\dashline{0.15}';
      TexDotStyle:string='\dottedline[\circle*{.01}]{0.1}';

      cat_element=0;   {categories d'lments graphiques}
      cat_axes=1;
      cat_grille=2;
      cat_parametree=3;
      cat_dot=4;
      cat_surface=5;
      cat_droite=6;
      cat_cercle=7;
      cat_label=8;
      cat_Equadif=9;
      cat_implicit=10;
      cat_arc=11;
      cat_polygone=12;
      cat_VarPredef=13;
      cat_utilisateur=14;
      cat_const=15;
      cat_mac=16;
      cat_macGraph2D=102;
      cat_macGraph3D=103;
      cat_bezier=17;
      cat_command=18;
      cat_spline=19;
      cat_input=20;
      cat_cartesienne=21;
      cat_polaire=22;
      cat_fenetre=100;
      cat_marges=101;


      colonnes=100;
      max_points:word=100;

      FoncSpeciales:boolean=false;

      {noms des lments graphiques:}
      type_element:array[0..22] of string=
      ('',' (Axes)',' (Grille)',' (Courbe param.)',' (Point(s))',' (Surface)',' (Droite)',
      ' (Cercle)',' (Label)', ' (Equa Diff)',' (Courbe impli.)',' (Arc)',
      ' (Ligne Polyg.)',' (Var predef) ',
       ' (Utilisateur)', '(Constante)',' (Macro)', ' (Bzier)',' (Commande)',' (Spline)',
       '',' (Courbe carts.)', ' (Courbe polai.)');

       ContexteUtilisateur:boolean=false;  {true dans element Utilisateur, false en dehors}
       UsePsfrag: boolean=false;
       LabelPsfrag:longint=1; {compteur de labels pour PSfrag}

       pica= 28.34646; {1cm = 28.34646 pica}


type
         PEpsCoord=^TEpsCoord;
         TEpsCoord= object(Tcommande)
                     
                     function executer(arg:PListe):Paffixe;virtual;
                     end;

         PSaveAttr=^TSaveAttr;
         TSaveAttr= object(Tcommande)

                     function executer(arg:PListe):Paffixe;virtual;
                     end;

         PGetAttr=^TGetAttr;
         TGetAttr= object(Tcommande)

                     function executer(arg:PListe):Paffixe;virtual;
                     end;

         PRestoreAttr=^TRestoreAttr;
         TRestoreAttr= object(Tcommande)

                     function executer(arg:PListe):Paffixe;virtual;
                     end;

            t_element=object(TNoeud)   {cat 0}       {ancetre des lments graphiques}
                    id: integer;              {code identification pour la souris}
                    cat,ReCalcAuto:shortint; {attributs communs}
                    trait,couleur:longint;
                    pen_mode:TpenMode;
                    LigneCommande:string;     {chaque lment est dfini  partir d'une commande}
                    arbre:Pexpression;          {certains sont dfinis  partir d'un arbre}
                    DefCommande:boolean;      {indique si la dfinition vient d une commande ou un arbre}
                    donnees:Paffixe;          {valuation de l'arbre}
                    liste_points:Pliste;     {liste des affixes des points constituant l'lment graphique}


                    constructor init(const UnNom, UneCommande:string);
                    procedure ConstruitArbre(Unarbre:Pcorps);virtual;
                    procedure recalculer;virtual;
                    procedure purger;virtual;
                    procedure clip;virtual;
                    procedure lireAttributs;virtual;
                    procedure fixeAttributs;virtual;
                    function PenWidth:integer;virtual;
                    procedure dessiner(feuille:TCanvas); virtual;
                    procedure parametres_scr(feuille:TCanvas;var coul:longint);virtual;
                    procedure enregistrer_latex; virtual;
                    function parametres_pst:string;virtual;
                    procedure enregistrer_pst;virtual;
                    function parametres_teg:string;virtual;
                    procedure enregistrer_teg;virtual;
                    procedure enregistrer_eps;virtual;
                    procedure enregistrer_pgf;virtual;
                    destructor detruire;virtual;
                    end;
      Pelement=^t_element;

      t_dot=object(t_element)   {cat 4}
                  point_style:byte;

                  constructor init(const UnNom, UneCommande:string);
                  procedure lireAttributs;virtual;
                  procedure fixeAttributs;virtual;
                  procedure recalculer;virtual;
                  procedure dessiner(feuille: Tcanvas); virtual;
                  procedure parametres_scr(feuille:TCanvas;var coul:longint);virtual;
                  function parametres_pst:string;virtual;
                  procedure enregistrer_latex; virtual;
                  procedure enregistrer_pst;virtual;
                  procedure enregistrer_eps;virtual;
                  procedure enregistrer_pgf;virtual;
                  function parametres_teg:string;virtual;
                  end;
      Pdot=^t_dot;

       t_label=object(t_element)  {cat 8}
             Texte: string;
             style_label:byte;
//alignement horizontal h= 0(centr), 1 (left)  2(right)
//alignement vertical v= 0(centr), 1 (top) ou  2(bottom), le code est alors h+4*v, en ajoutant: 16 pour framed,
//, 32 pour stacked et 64 pour special (label non affich et export tel quel)
             size_label:byte;
             angle_label:real;

             ligne_style:shortint;
             fill_style:byte;
             fill_color:longint;
             constructor init(const UnNom, UneCommande,UnTexte:string);
             procedure lireAttributs;virtual;
             procedure fixeAttributs;virtual;
             procedure recalculer;virtual;
             procedure dessiner(feuille: Tcanvas); virtual;
             procedure parametres_scr(feuille:TCanvas;var coul:longint);virtual;
             function parametres_pst:string;virtual;
             procedure enregistrer_latex; virtual;
             procedure enregistrer_pst; virtual;
             procedure enregistrer_eps;virtual;
             procedure enregistrer_pgf;virtual;
             function parametres_teg:string;virtual;
             procedure enregistrer_teg;virtual;
             destructor detruire;virtual;
             end;
     Plabel=^t_label;

     PLigne=^T_Ligne;
     t_ligne= object(t_element)
              ligne_style:shortint;
              fill_style,fleche:byte;
              fill_color:longint;
              nb_points:word;
              fermee: byte;
              rayon:real;
              clippee:boolean;
              ptsFleches:Pliste;

              constructor init(const UnNom, UneCommande:string;Closed:byte;Unrayon:real);
              procedure recalculer;virtual;
              procedure lireAttributs;virtual;
              procedure fixeAttributs;virtual;
              procedure calcul_fleches;virtual;
              procedure clip;virtual;
              procedure dessiner(feuille: Tcanvas);  virtual;
              procedure parametres_scr(feuille:TCanvas;var coul:longint);virtual;
              procedure dessiner_fleches(feuille: Tcanvas);
              procedure fillLatex(style:byte; mode:byte);virtual;
              function parametres_pst:string;virtual;
              procedure parametres_eps;virtual;
              procedure parametres_pgf;virtual;
              procedure enregistrer_latex; virtual;
              procedure fleches_latex(mode:byte);virtual;
              procedure enregistrer_pst; virtual;
              procedure enregistrer_eps; virtual;
              procedure enregistrer_pgf; virtual;
              function parametres_teg:string;virtual;
              procedure enregistrer_teg;virtual;
              destructor detruire;virtual;
              end;



procedure initialiser;
procedure fenetre(Xinf,Yinf,Xsup,Ysup,Xechelle,Yechelle:real);
procedure marges(gauche,droite,haut,bas:real);

procedure ajouter_element(p:Pelement);

procedure unite_graphique(res: integer; echelle:real);
procedure dessiner_elements(feuille: Tcanvas);
procedure draw_elements(feuille: Tcanvas);
procedure recalculer_elements(tous: boolean);

procedure enregistrer_elements(format: byte;bordure:boolean);

procedure vider_liste;
function nomValide(nom:Tnom;modif:boolean):boolean;
function VariableValide(nom:Tnom;modif:boolean):boolean;
function NomMacroValide(nom:Tnom):boolean;

procedure GetAttributs;
procedure SetAttributs;
procedure DefaultSettings;

function FormatString(const chaine:string;long:word):string;

Function Xreel(x:integer):Real;
Function Yreel(y:integer):Real;
Function Xentier(x:real): Integer;
Function Yentier(y:real): Integer;
Function XTex(x:Real):Real;
Function YTex(y:Real):Real;
Function XEps(x:Real):Real;
Function YEps(y:Real):Real;


function StrColor(coul:longint; mode:byte):string;



var inclure_commentaires,gestion_couleur,cadre:boolean;

    Xmin,Xmax,Ymin,Ymax,Xscale,Yscale,margeH,margeB,margeG,margeD,AspectRatio:real;

    MaxX,MaxY,GmargeH,GmargeB,GmargeG,GmargeD:word;
    CurrentRes:word; //rsolution du contexte en cours
    CurrentScale: real;  //echelle dans le contexte en cours
    OffsetX, OffsetY: integer; //centrer le dessin pour l'impression directe

    liste_element,liste_enfant:type_liste;

    f, psfrag:textFile;    //fichiers pour les enregistrements

    LabelStyle,DotStyle,Linestyle,LineWidth,linecolor,Arrows,FillStyle,FillColor,AutoReCalc:longint;
    NbPoints,LabelSize,xyLabelPos, PenMode:longint;
    tmin, tmax, LabelAngle, xyticks, xylabelsep:real;
    ForMinToMax:boolean;

     PLabelStyle,PDotStyle,PLinestyle,Pwidth,Pcolor,PArrows,PFillStyle,
     PFillColor,PNbPoints,Ptmin,Ptmax,PAutoReCalc, Ptheta, Pphi, PLabelSize, PLabelAngle,
     Pxyticks, Pxylabelsep, PxyLabelPos, PPenMode, PForMinToMax, Pcomptgraph: Pconstante;

     palette:array[0..8] of record nom :string[10];
                                   code:longint;
                            end;
     couleur_courante,Texte_courant,epaisseur_courante,style_courant, courant_point_style,fill_courant,
     fillcolor_courant,hatchcolor_courant,LabelSize_courant:longint;

     //epaisseur:array[0..2] of string[20];
     Unstyle:array[-1..2] of string[20];
     UnPointstyle:array[0..2] of string[30];
     stylefill:array[0..8] of string[50];
     TailleLabel:array[0..9] of string[15];

     OxEps, OyEps, CpicaX, CpicaY: real;

     Yafond:boolean; //gestion du fond ventuel
     Fondname:TFileName;
     fondOrigX,fondOrigY,FondLarge,fondHaut:real;

 IMPLEMENTATION
 uses Classes;
 type
  Attr = Array[1..19] of real;
  PAttr=^Attr;
var ListAttr:TList;

{=======================}
function TEpsCoord.executer(arg:PListe):Paffixe;
var T:Paffixe;
    f1:Pcorps;
    x,y:real;
begin
     executer:=nil;
     if (arg=nil) or (arg^.tete=nil) then exit;
     f1:=Pcorps(arg^.tete);
     T:=f1^.evaluer;
     if T=nil then exit;
     CalcError:=false;
     x:=multiplier(CpicaX,soustraire(T^.x,OxEps));
     y:=multiplier(CpicaY,soustraire(T^.y,OyEps));
     kill(Pcellule(T));
     if CalcError then  exit;
     executer:=New(Paffixe,init(x,y))
end;

{=======================}
function StrColor(coul:longint; mode:byte):string;
var chaine:string;
    red,green,blue:real;
begin
     red:=GetRvalue(coul)/255; green:= GetGvalue(coul)/255; blue:=GetBvalue(coul)/255;
     case mode of
     latex: if coul>8 then
          chaine:= '[rgb]{'+Streel(red)+','+Streel(green)+','+Streel(blue)+'}'
          else chaine:='{'+palette[coul].nom+'}';
     pstricks:  if coul>8 then
          chaine:= '[rgb]{'+Streel(red)+','+Streel(green)+','+Streel(blue)+'}'
          else chaine:=palette[coul].nom;
     eps: if coul>8 then
          chaine:= Streel(red)+' '+Streel(green)+' '+Streel(blue)+' rgb '
          else chaine:=palette[coul].nom+' ';
     pgf: if coul>8 then
          chaine:= '{rgb,1:red,'+Streel(red)+';green,'+Streel(green)+';blue,'+Streel(blue)+'}'
          else chaine:='{'+palette[coul].nom+'}';
     end;

     StrColor:=chaine;
end;
{========================}
function FormatString(Const chaine:string;long:word):string;
begin
       FormatString:=WrapText(chaine,#13#10, [' ', ',', ')', ']'],long);
end;
{========================}
procedure saveAttr;
var Attr:PAttr;
    i:Integer;
begin
        New(Attr);i:=1; GetAttributs;
        attr^[i]:=LineStyle; Inc(i);
        attr^[i]:=Linewidth; Inc(i);
        attr^[i]:=linecolor; Inc(i);
        attr^[i]:=nbpoints; Inc(i);
        attr^[i]:=dotstyle; Inc(i);
        attr^[i]:=labelstyle; Inc(i);
        attr^[i]:=tmin; Inc(i);
        attr^[i]:=tmax; Inc(i);
        attr^[i]:=arrows; Inc(i);
        attr^[i]:=fillstyle; Inc(i);
        attr^[i]:=fillcolor; Inc(i);
        attr^[i]:=AutoReCalc; Inc(i);
        attr^[i]:=labelsize; Inc(i);
        attr^[i]:=labelangle; Inc(i);
        attr^[i]:=xylabelsep; Inc(i);
        attr^[i]:=xyticks; Inc(i);
        attr^[i]:=xylabelpos; Inc(i);
        attr^[i]:=Penmode; Inc(i);
        attr^[i]:=byte(ForMinToMax);
        ListAttr.Insert(0,Attr);
end;
{=======================}
procedure restoreAttr;
var Attr:PAttr;
    i:Integer;
begin
         if ListAttr.count<1 then exit;
         Attr:= ListAttr.Items[0]; i:=1;
         LineStyle:=Round(Attr^[i]); Inc(i);
         Linewidth:=Round(Attr^[i]); Inc(i);
         linecolor:=Round(Attr^[i]); Inc(i);
         nbpoints:=Round(Attr^[i]); Inc(i);
         dotstyle:=Round(Attr^[i]); Inc(i);
         labelstyle:=Round(Attr^[i]); Inc(i);
         tmin:=Attr^[i]; Inc(i);
         tmax:=Attr^[i]; Inc(i);
         arrows:=Round(Attr^[i]); Inc(i);
         fillstyle:=Round(Attr^[i]); Inc(i);
         fillcolor:=Round(Attr^[i]); Inc(i);
         AutoReCalc:=Round(Attr^[i]); Inc(i);
         labelsize:=Round(Attr^[i]); Inc(i);
         labelangle:=Attr^[i]; Inc(i);
         xylabelsep:=Attr^[i]; Inc(i);
         xyticks:=Attr^[i]; Inc(i);
         xylabelpos:=Round(Attr^[i]); Inc(i);
         PenMode:=Round(Attr^[i]); Inc(i);
         ForMinToMax:=Round(Attr^[i])=1;
         SetAttributs;
         ListAttr.delete(0);
end;
{=======================}
function TSaveAttr.executer(arg:PListe):Paffixe;
begin
      executer:=nil;
      saveAttr;
end;
{=======================}
function TRestoreAttr.executer(arg:PListe):Paffixe;
begin
      executer:=nil;
      restoreAttr;
end;
{=======================}
function TGetAttr.executer(arg:PListe):Paffixe;
var f1:Pcorps;
    aux:Pelement;
    Anom:string;
begin
     executer:=nil;
     if arg=nil then exit;
     f1:=Pcorps(arg^.tete);
     if f1=nil then exit;
     if f1^.categorie=cat_constante then Anom:=Pconstante(f1^.contenu)^.nom
                                    else Anom:=MakeString(f1);
     aux:=Pelement(liste_element.tete);
     while (aux<>nil) and (aux^.nom<>Anom) do aux:=Pelement(aux^.suivant);
     if aux<>nil then aux^.lireAttributs;
end;
{=======================}
procedure SetAttributs;
begin
     if PLineStyle^.affixe<>nil then PLineStyle^.affixe^.x:=LineStyle
               else PLineStyle^.affixe:=new(Paffixe,init(LineStyle,0));
     if Pwidth^.affixe<>nil then Pwidth^.affixe^.x:=Linewidth
               else Pwidth^.affixe:=new(Paffixe,init(Linewidth,2));
     if Pcolor^.affixe<>nil then Pcolor^.affixe^.x:=linecolor
               else Pcolor^.affixe:=new(Paffixe,init(linecolor,0));
     if PNbPoints^.affixe<>nil then PNbPoints^.affixe^.x:=NbPoints
               else PNbPoints^.affixe:=new(Paffixe,init(NbPoints,0));
     if Pdotstyle^.affixe<>nil then Pdotstyle^.affixe^.x:=DotStyle
               else Pdotstyle^.affixe:=new(Paffixe,init(DotStyle,0));
     if Plabelstyle^.affixe<>nil then Plabelstyle^.affixe^.x:=LabelStyle
               else Plabelstyle^.affixe:=new(Paffixe,init(LabelStyle,0));
     if Ptmin^.affixe<>nil then Ptmin^.affixe^.x:=tmin
               else Ptmin^.affixe:=new(Paffixe,init(tmin,0));
     if Ptmax^.affixe<>nil then Ptmax^.affixe^.x:=tmax
               else Ptmax^.affixe:=new(Paffixe,init(tmax,0));
     if Parrows^.affixe<>nil then Parrows^.affixe^.x:=arrows
               else Parrows^.affixe:=new(Paffixe,init(arrows,0));
     if Pfillstyle^.affixe<>nil then Pfillstyle^.affixe^.x:=FillStyle
               else Pfillstyle^.affixe:=new(Paffixe,init(FillStyle,0));
     if Pfillcolor^.affixe<>nil then Pfillcolor^.affixe^.x:=FillColor
               else Pfillcolor^.affixe:=new(Paffixe,init(FillColor,0));
     if PAutoReCalc^.affixe<>nil then PAutoReCalc^.affixe^.x:=AutoReCalc
               else PAutoReCalc^.affixe:=new(Paffixe,init(AutoReCalc,0));
     if PLabelSize^.affixe<>nil then PLabelSize^.affixe^.x:=LabelSize
               else PLabelSize^.affixe:=new(Paffixe,init(LabelSize,0));
     if PLabelAngle^.affixe<>nil then PLabelAngle^.affixe^.x:=LabelAngle
               else PLabelAngle^.affixe:=new(Paffixe,init(LabelAngle,0));
     if Pxylabelsep^.affixe<>nil then Pxylabelsep^.affixe^.x:=xylabelsep
               else Pxylabelsep^.affixe:=new(Paffixe,init(xylabelsep,0));
     if Pxyticks^.affixe<>nil then Pxyticks^.affixe^.x:=xyticks
               else Pxyticks^.affixe:=new(Paffixe,init(xyticks,0));
     if Pxylabelpos^.affixe<>nil then Pxylabelpos^.affixe^.x:=xylabelpos
               else Pxylabelpos^.affixe:=new(Paffixe,init(xylabelpos,0));
     if PPenMode^.affixe<>nil then PPenMode^.affixe^.x:=PenMode
               else PPenMode^.affixe:=new(Paffixe,init(PenMode,0));
     if PForMinToMax^.affixe<>nil then PForMinToMax^.affixe^.x:=byte(ForMinToMax)
               else PForMinToMax^.affixe:=new(Paffixe,init(byte(ForMinToMax),0));
end;
{========================}
procedure GetAttributs;
begin
     if Plinestyle^.affixe<>nil then Linestyle:=(round(Plinestyle^.affixe^.x+1) mod 4)-1 else LineStyle:=0;
     if Pwidth^.affixe<>nil then
     Linewidth:=round(abs(Pwidth^.affixe^.x)) {mod 3} else LineWidth:=2;
     if Pcolor^.affixe<>nil then
     linecolor:=round(Pcolor^.affixe^.x) else linecolor:=0;
     if PNbpoints^.affixe<>nil then
     NbPoints:=round(PNbpoints^.affixe^.x) else NbPoints:=50;
     if Pdotstyle^.affixe<>nil then
     Dotstyle:=round(Pdotstyle^.affixe^.x) mod 3 else DotStyle:=0;
     if Plabelstyle^.affixe<>nil then
     Labelstyle:=round(Plabelstyle^.affixe^.x) else LabelStyle:=0;
     if Ptmin^.affixe<>nil then
     tmin:=Ptmin^.affixe^.x else tMin:=Xmin;
     if Ptmax^.affixe<>nil then
     tmax:=Ptmax^.affixe^.x else tMax:=Xmax;
     if Parrows^.affixe<>nil then
     Arrows:=round(Parrows^.affixe^.x) mod 3 else Arrows:=0;
     if Pfillstyle^.affixe<>nil then
     Fillstyle:=round(Pfillstyle^.affixe^.x) mod 8 else FillStyle:=0;
     if Pfillcolor^.affixe<>nil then
     FillColor:=round(Pfillcolor^.affixe^.x)  else FillColor:=1;
     if PAutoReCalc^.affixe<>nil then
     AutoReCalc:=round(PAutoReCalc^.affixe^.x) mod 2 else AutoReCalc:=1;
     if PLabelSize^.affixe<>nil then
     LabelSize:=round(PLabelSize^.affixe^.x) mod 10 else LabelSize:=3;
     if PLabelAngle^.affixe<>nil then
     LabelAngle:=round(PLabelAngle^.affixe^.x) else LabelAngle:=0;
     if Pxyticks^.affixe<>nil then
     xyticks:=Pxyticks^.affixe^.x else xyticks:=0.1;
     if Pxylabelsep^.affixe<>nil then
     xylabelsep:=Pxylabelsep^.affixe^.x else xylabelsep:=0.105;
     if Pxylabelpos^.affixe<>nil then
     xylabelpos:=round(Pxylabelpos^.affixe^.x) else xylabelsep:=9;//left+bottom
     if PPenMode^.affixe<>nil then
     PenMode:=round(PPenMode^.affixe^.x) mod 2 else PenMode:=0; //normal
     if PForMinToMax^.affixe<>nil then
     ForMinToMax:= (round(PForMinToMax^.affixe^.x) mod 2=1) else ForMinToMax:=false;
end;
{============================}
function VariableValide(Nom:Tnom;modif:boolean):boolean;
var ok:boolean;
    i,k:longint;
begin
      i:=1;k:=length(Nom);
      ok:=Nom[i] in ['a'..'z','A'..'Z'];
      while (i<=k) and (Nom[i] in Set_nom) do inc(i);
      ok:=ok and (i>k) and ((constante(nom)=nil) or modif);
      VariableValide:=ok
end;
{=======================}
function NomMacroValide(Nom:Tnom):boolean;
var ok:boolean;
    i,k:longint;
    p:Pmacros;
begin
      i:=1; k:=length(Nom);
      ok:=Nom[i] in ['a'..'z','A'..'Z'];
      while (i<=k) and (Nom[i] in Set_nom) do inc(i);
      ok:=ok and (i>k);
      if ok then p:=macros(nom) else p:=nil;
      ok:=ok and ((p=nil) or (p^.statut=0)) and (fonction(nom)=nil) and (commande(nom)=nil);
      NomMacroValide:=ok
end;
{=======================}
function NomValide(Nom:Tnom;modif:boolean):boolean;
var ok:boolean;
    aux:Pelement;
begin
      ok:=VariableValide(Nom,modif);
      aux:=Pelement(liste_element.tete);
      {if aux<>nil
         then ok:=ok and ((Trouver(nom, @Liste_element)=nil) or modif);}
      while (aux<>nil) and ok do
       begin
            ok:=ok and ((aux^.nom<>nom) or modif);
            aux:=Pelement(aux^.suivant);
       end;
       nomValide:=ok
end;
{========================}
procedure DefaultSettings;
begin
     Arrows:=0;LabelStyle:=0;DotStyle:=0;LineStyle:=0;
     Linewidth:=2;
     linecolor:=0;
     tmin:=Xmin;
     tmax:=Xmax;NbPoints:=50;
     FillStyle:=0;
     FillColor:=1;
     AutoReCalc:=1;
     LabelSize:=3;
     LabelAngle:=0;
     xyticks:=0.2;
     xylabelsep:=0.1;
     xylabelpos:=9; //left(=1)+bottom(=8)
     PenMode:=0; //mode normal
     ForMinToMax:=false;
     Setattributs;
end;
{=======================}
procedure initialiser;
begin
     fenetre(-5,-5,5,5,1,1);
     marges(0.5,0.5,0.5,0.5);
     gestion_couleur:=true;
     inclure_commentaires:=true;
     liste_element.init;
     liste_enfant.init;
     palette[0].nom:='black';
     palette[0].code:=$0;
     palette[1].nom:='white';
     palette[1].code:=$00FFFFFF;
     palette[2].nom:='red';
     palette[2].code:=$000000FF;
     palette[3].nom:='green';
     palette[3].code:=$0000FF00;
     palette[4].nom:='blue';
     palette[4].code:=$00FF0000;
     palette[5].nom:='yellow';
     palette[5].code:=$0000FFFF;
     palette[6].nom:='cyan';
     palette[6].code:=$00FFFF00;
     palette[7].nom:='magenta';
     palette[7].code:=$00FF00FF;
     palette[8].nom:='gray';
     palette[8].code:=$00808080;
     //epaisseur[0]:='\thinlines';
     //epaisseur[1]:='\thicklines';
     //epaisseur[2]:='\Thicklines';
     Unstyle[-1]:='none';
     Unstyle[0]:='solid';
     Unstyle[1]:='dashed';
     Unstyle[2]:='dotted';
     UnPointstyle[0]:='*,dotsize=1.5pt 0';
     UnPointstyle[1]:='*,dotsize=3pt 0';
     UnPointstyle[2]:='x,dotsize=6pt 0,dotangle=45';
     stylefill[0]:='none';
     stylefill[1]:='solid';
     stylefill[2]:='hlines,hatchwidth=0.2pt,hatchangle=45';
     stylefill[3]:='crosshatch,hatchwidth=0.2pt,hatchangle=0';
     stylefill[4]:='crosshatch,hatchwidth=0.2pt,hatchangle=45';
     stylefill[5]:='vlines,hatchwidth=0.2pt,hatchangle=45';
     stylefill[6]:='hlines,hatchwidth=0.2pt,hatchangle=0';
     stylefill[7]:='vlines,hatchwidth=0.2pt,hatchangle=0';
     TailleLabel[0]:='\tiny'; TailleLabel[1]:='\scriptsize';
     TailleLabel[2]:='\footnotesize'; TailleLabel[3]:='\small';
     TailleLabel[4]:='\normalsize'; TailleLabel[5]:='\large';
     TailleLabel[6]:='\Large'; TailleLabel[7]:='\LARGE';
     TailleLabel[8]:='\huge'; TailleLabel[9]:='\Huge';
     cadre:=true;
     OffsetX:=0; OffsetY:=0
end;
{======================}
procedure unite_graphique(res: integer; echelle:real);
begin
     CurrentRes:=res;
     CurrentScale:=echelle;
     AspectRatio:=echelle*CurrentRes/2.54;
     maxX:=round(AspectRatio*(Xmax-Xmin)*Xscale);
     maxY:=round(AspectRatio*(Ymax-Ymin)*Yscale);
     GmargeH:=round(AspectRatio*margeH);
     GmargeB:=round(AspectRatio*margeB);
     GmargeG:=round(AspectRatio*margeG);
     GmargeD:=round(AspectRatio*margeD);
end;
{=======================}
procedure fenetre(Xinf,Yinf,Xsup,Ysup,Xechelle,Yechelle:real);
begin
     Xmin:=Xinf;
     Ymin:=Yinf;
     Xmax:=Xsup;
     Ymax:=Ysup;
     Xscale:=Xechelle; Yscale:=Yechelle;
     PXmin^.affixe^.x:=Xmin;
     PXmax^.affixe^.x:=Xmax;
     PYmin^.affixe^.x:=Ymin;
     PYmax^.affixe^.x:=Ymax;
     PXscale^.affixe^.x:=Xscale;
     PYscale^.affixe^.x:=Yscale;
     maxX:=round(AspectRatio*(Xmax-Xmin)*Xscale);
     maxY:=round(AspectRatio*(Ymax-Ymin)*Yscale);
     CpicaX:=pica*Xscale;
     CpicaY:=pica*Yscale;
     OxEps:= Xmin-margeG/Xscale;
     OyEps:= Ymin-margeB/Yscale;
     ChangeFen:=true;
end;
{=======================}
procedure marges(gauche,droite,haut,bas:real);
begin
     margeH:=haut;margeB:=bas;margeG:=gauche;margeD:=droite;
     GmargeH:=round(AspectRatio*margeH);
     GmargeB:=round(AspectRatio*margeB);
     GmargeG:=round(AspectRatio*margeG);
     GmargeD:=round(AspectRatio*margeD);
     constante('margeG')^.affixe^.x:=margeG;
     constante('margeD')^.affixe^.x:=margeD;
     constante('margeH')^.affixe^.x:=margeH;
     constante('margeB')^.affixe^.x:=margeB;
     CpicaX:=pica*Xscale;
     CpicaY:=pica*Yscale;
     OxEps:= Xmin-margeG/Xscale;
     OyEps:= Ymin-margeB/Yscale;
     ChangeFen:=true;
end;
{=======================}
procedure ajouter_element(p:Pelement);
begin
     liste_element.ajouter_fin(p);
end;
{=======================}
procedure recalculer_elements(tous:boolean);
var aux:PCellule;
begin
     aux:=liste_element.tete;
     if tous then
     while aux<>nil do begin Pelement(aux)^.recalculer; aux:=aux^.suivant end
     else
     while aux<>nil do begin if Pelement(aux)^.ReCalcAuto=1 then Pelement(aux)^.recalculer; aux:=aux^.suivant end;
 end;
{======================}
procedure draw_elements(feuille: Tcanvas);
var aux:PCellule;
begin
     aux:=liste_element.tete;
     while aux<>nil do begin
     Pelement(aux)^.dessiner(feuille); aux:=aux^.suivant end;
 end;
 {======================}
procedure dessiner_elements(feuille: Tcanvas);
begin
     draw_elements(feuille);
     feuille.brush.style:=bsClear;
     feuille.pen.style:=psSolid;
     feuille.pen.mode:=pmCopy;
     feuille.pen.width:=1;
     if (not (exportJpeg or exportPrn)) or cadre
      then
        begin
     feuille.pen.color:=clblack;
     feuille.rectangle(OffsetX,OffsetY,maxX+GmargeG+GmargeD+OffsetX,maxY+GmargeH+GmargeB+OffsetY);
        end;
     if not (exportJpeg or exportPrn)
        then
         begin
     feuille.pen.style:=psDot;
     feuille.pen.width:=1;
     feuille.pen.color:=clLtGray;
     feuille.rectangle(GmargeG,GmargeH,maxX+GmargeG,maxY+GmargeH);
        end;

end;
 {======================}
procedure enregistrer_elements(format:byte;bordure:boolean);
var aux:PCellule;
    aux2:string;
    a,b:longint;
    E:Pexpression;
    res:Paffixe;
    mac:Pmacros;
    old:boolean;

    function accesfond: string;
    var aux1:string;
    begin
        if Apercu then
                begin
                  aux1:=changeFileExt(FondName,'');
                  aux1:=StringReplace(aux1,'\','/',[rfReplaceAll]);
                end else aux1:=changeFileExt(ExtractFileName(FondName),'');
        result:=aux1
    end;
begin
     epaisseur_courante:=-1;
     style_courant:=0;
     courant_point_style:=4;
     fill_courant:=0;
     fillcolor_courant:=1;
     hatchcolor_courant:=1;
     couleur_courante:=0;
     Texte_courant:=0;
     PExportMode^.affixe^.x:=format;
     //Execution de Bsave
     old:= FoncSpeciales;
     FoncSpeciales:=true;
     New(E,init);
     E^.definir('Bsave()');
     res:=E^.evaluer;
     Kill(Pcellule(res));
     dispose(E,detruire);
     FoncSpeciales:=old;
     rewrite(f);
      case format of
      LaTeX:begin
             if liste_element.tete=nil then exit;
             writeln(f,'\unitlength 1cm');
             writeln(f,'\begin{picture}(',streel((Xmax-Xmin)*Xscale+margeG+margeD),',',
             streel((Ymax-Ymin)*Yscale+margeH+margeB),')(',streel(-margeG),',',
             streel(-margeB),')%');
             if bordure then
                begin
             writeln(f,'% Bordure');
             writeln(f,'\path('+streel(-margeG)+','+streel(-margeB)+')('+
             streel(-margeG)+','+streel(Ytex(Ymax)+margeH)+')('+
             streel(XTex(Xmax)+margeD)+','+streel(Ytex(Ymax)+margeH)+')('+
             streel(Xtex(Xmax)+margeD)+','+streel(-margeB)+')('+
             streel(-margeG)+','+streel(-margeB)+')');
               end;
             if Yafond then
                begin
                  writeln(f, '% fond');
                  writeln(f, '\put('+streel(Xtex(fondOrigX))+','+streel(Ytex(fondOrigY-fondHaut))+'){'+
                  '\includegraphics[width='+streel(FondLarge*Xscale)+'cm]{'+AccesFond+'}}%');
                end;
             aux:=liste_element.tete;
             while aux<>nil do begin Pelement(aux)^.enregistrer_latex;aux:=aux^.suivant end;
             write(f,'\end{picture}%');
        end;
   pstricks: begin
             if liste_element.tete=nil then exit;
             writeln(f,'\psset{xunit=1cm, yunit=1cm}');
             writeln(f,'\begin{pspicture}(',streel(-margeG),',',
             streel(-margeB),')(',streel(Xtex(Xmax)+margeD),',',
             streel(Ytex(Ymax)+margeH),')%');
             if bordure then
                begin
             writeln(f,'% Bordure');
             writeln(f,'\pspolygon('+streel(-margeG)+','+streel(-margeB)+')('+
             streel(-margeG)+','+streel(Ytex(Ymax)+margeH)+')('+
             streel(Xtex(Xmax)+margeD)+','+streel(Ytex(Ymax)+margeH)+')('+
             streel(Xtex(Xmax)+margeD)+','+streel(-margeB)+')');
               end;

             if Yafond then
                begin
                  writeln(f, '% fond');
                  writeln(f, '\put('+streel(Xtex(fondOrigX))+','+streel(Ytex(fondOrigY-fondHaut))+'){'+
                  '\includegraphics[width='+streel(FondLarge*Xscale)+'cm]{'+AccesFond+'}}%');
                end;
             writeln(f,'\pstVerb{1 setlinejoin}%');
             aux:=liste_element.tete;
             while aux<>nil do begin Pelement(aux)^.enregistrer_pst;aux:=aux^.suivant end;
             write(f,'\end{pspicture}%');
        end;

     teg: begin
             DefaultSettings;
         writeln(f,'% Fenetre Xmin Xmax Ymin Ymax Xscale Yscale');
              writeln(f,cat_fenetre,car_special,
              streel(Xmin)+car_special+streel(Xmax)+car_special+streel(Ymin)+car_special+streel(Ymax)+car_special,
              Xscale:0:12,car_special,Yscale:0:12,car_special+car_special);
         writeln(f,'% Marges gauche droite haut bas cadre gestion_couleur comptgraph');
              writeln(f,cat_marges,car_special,
              streel(margeG)+car_special+streel(margeD)+car_special+streel(margeH)+car_special+streel(margeB)+
              car_special,byte(cadre),car_special,byte(gestion_couleur),car_special,Streel(PcomptGraph^.affixe^.x),car_special+car_special);
         if Yafond then
                begin
                     writeln(f,'% Image de fond');
                     writeln(f,'18'+car_special+car_special,'[$coin1:=Xmin+i*Ymax, $coin2:=Xmax+i*Ymin,',
                     'Fenetre('+streel(FondOrigX)+'+i*('+streel(FondOrigY)+'),'+streel(FondOrigX+FondLarge)+'+i*('+streel(FondOrigY-FondHaut)+
                     ')), LoadImage("'+FondName+'"), Fenetre(coin1,coin2)]',car_special+car_special);
                end;
         writeln(f,'% Affectation des Variables theta et phi');
         if Ptheta^.affixe=nil then Ptheta^.affixe:=New(Paffixe,init(pi/6,0));
         if Pphi^.affixe=nil then Pphi^.affixe:=New(Paffixe,init(pi/3,0));
         writeln(f,cat_command,car_special,car_special,'[Set(theta,',streel(Ptheta^.affixe^.x),'),Set(phi,',
                       streel(Pphi^.affixe^.x),')]',car_special,car_special);
         mac:=macros('TegWrite');
              if (mac<>nil)
                 then
                     if mac^.contenu^.corps<>nil
                        then
                            begin
                                 aux2:=mac^.contenu^.corps^.en_chaine;
                                 aux2:=FormatString(aux2,80);
                                 writeln(f,'18'+car_special+car_special,aux2,car_special+car_special);
                            end;
         aux:=VariablesGlobales^.tete;
         if (aux<>nil) then
            begin writeln(f,'% Dclaration des Variables Globales');
                  while (aux<>nil) do
                   begin
                        if PVarGlob(aux)^.statut=0
                           then
                           begin
                             if PVarGlob(aux)^.commande='' then
                                begin
                                     If PVarGlob(aux)^.variable^.affixe<>nil
                                        then PVarGlob(aux)^.commande:=PVarGlob(aux)^.variable^.affixe^.en_chaine(12)
                                        else PVarGlob(aux)^.commande:='1/0'
                                end;
                             writeln(f,cat_const,car_special,PVarGlob(aux)^.variable^.nom,car_special,
                             FormatString(PVarGlob(aux)^.commande,80),car_special+car_special);
                          end;
                        aux:=PVarGlob(aux^.suivant);
                   end;
            end;
         aux:=LesMacros^.tete;
         if (aux<>nil) then
            begin
                 writeln(f,'% Dclaration des Macros');
                 while aux<>nil do
                       begin
                       if PMacros(aux)^.statut=0 then
                          begin
                               write(f,cat_mac,car_special,PMacros(aux)^.nom,car_special);
                               writeln(f,PMacros(aux)^.commande,car_special+car_special);
                          end;
                          aux:=PMacros(aux^.suivant) ;
                       end;

            end;

              aux:=liste_element.tete;
              if (aux<>nil) then writeln(f,'% Dclaration des Elments graphiques');
             while aux<>nil do begin Pelement(aux)^.enregistrer_teg;writeln(f,car_special);aux:=aux^.suivant;end;
         end;
       eps: begin {format eps}
            if liste_element.tete=nil then exit;
            a:=round(XEps(Xmax+margeD/Xscale));
            b:=round(YEps(Ymax+margeH/Yscale));
            writeln(f, '%!PS-Adobe-3.0 EPSF-3.0');
            writeln(f, '%%Creator: TeXgraph');
            writeln(f, '%%BoundingBox: 0 0 ',a,' ',b);
            writeln(f, '%%Page: 1 1');
            if not UsePsfrag then
          begin
            writeln(f, '/encoding_vector [');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f,'/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f,'/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f,'/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f,'/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f,'/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f,'/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f,'/.notdef      	/.notdef      	/.notdef      	/.notdef');

            writeln(f, '/space        	/exclam       	/quotedbl     	/numbersign');
            writeln(f, '/dollar       	/percent      	/ampersand    	/quoteright');
            writeln(f, '/parenleft    	/parenright   	/asterisk     	/plus');
            writeln(f, '/comma        	/minus        	/period       	/slash');
            writeln(f, '/zero         	/one          	/two          	/three');
            writeln(f, '/four         	/five         	/six          	/seven');
            writeln(f, '/eight        	/nine         	/colon        	/semicolon');
            writeln(f, '/less         	/equal        	/greater      	/question');

            writeln(f, '/at           	/A            	/B            	/C');
            writeln(f, '/D            	/E            	/F            	/G');
            writeln(f, '/H            	/I            	/J            	/K');
            writeln(f, '/L            	/M            	/N            	/O');
            writeln(f, '/P            	/Q            	/R            	/S');
            writeln(f, '/T            	/U            	/V            	/W');
            writeln(f, '/X            	/Y            	/Z            	/bracketleft');
            writeln(f, '/backslash    	/bracketright 	/asciicircum  	/underscore');

            writeln(f, '/quoteleft    	/a            	/b            	/c');
            writeln(f, '/d            	/e            	/f            	/g');
            writeln(f, '/h            	/i            	/j            	/k');
            writeln(f, '/l            	/m            	/n            	/o');
            writeln(f, '/p            	/q            	/r            	/s');
            writeln(f, '/t            	/u            	/v            	/w');
            writeln(f, '/x            	/y            	/z            	/braceleft');
            writeln(f, '/bar          	/braceright   	/tilde        	/.notdef');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f, '/.notdef      	/.notdef      	/.notdef      	/.notdef');
            writeln(f, '/space        	/exclamdown   	/cent         	/sterling');
            writeln(f, '/currency     	/yen          	/brokenbar    	/section');
            writeln(f, '/dieresis     	/copyright    	/ordfeminine  	/guillemotleft');
            writeln(f, '/logicalnot   	/hyphen       	/registered   	/macron');
            writeln(f, '/degree       	/plusminus    	/twosuperior  	/threesuperior');
            writeln(f, '/acute        	/mu           	/paragraph    	/bullet');
            writeln(f, '/cedilla      	/dotlessi     	/ordmasculine 	/guillemotright');
            writeln(f, '/onequarter   	/onehalf      	/threequarters	/questiondown');
            writeln(f, '/Agrave       	/Aacute       	/Acircumflex  	/Atilde');
            writeln(f, '/Adieresis    	/Aring        	/AE           	/Ccedilla');
            writeln(f, '/Egrave       	/Eacute       	/Ecircumflex  	/Edieresis');
            writeln(f, '/Igrave       	/Iacute       	/Icircumflex  	/Idieresis');
            writeln(f, '/Eth          	/Ntilde       	/Ograve       	/Oacute');
            writeln(f, '/Ocircumflex  	/Otilde       	/Odieresis    	/multiply');
            writeln(f, '/Oslash       	/Ugrave       	/Uacute       	/Ucircumflex');
            writeln(f, '/Udieresis    	/Yacute       	/Thorn        	/germandbls');
            writeln(f, '/agrave       	/aacute       	/acircumflex  	/atilde');
            writeln(f, '/adieresis    	/aring        	/ae           	/ccedilla');
            writeln(f, '/egrave       	/eacute       	/ecircumflex  	/edieresis');
            writeln(f, '/igrave       	/iacute       	/icircumflex  	/idieresis');
            writeln(f, '/eth          	/ntilde       	/ograve       	/oacute');
            writeln(f, '/ocircumflex  	/otilde       	/odieresis    	/divide');
            writeln(f, '/oslash       	/ugrave       	/uacute       	/ucircumflex');
            writeln(f, '/udieresis    	/yacute       	/thorn        	/ydieresis');
            writeln(f, '] def');
            writeln(f, '/MF {');
            writeln(f, '/newfontname exch def');
            writeln(f, '  /fontname exch def');
            writeln(f, '  /fontdict fontname findfont def');
            writeln(f, '  /newfont fontdict maxlength dict def');
            writeln(f, 'fontdict {');
            writeln(f, '    exch');
            writeln(f, '    dup /FID eq {');
            writeln(f, '      pop pop');
            writeln(f, '    } {');
            writeln(f, '      exch newfont 3 1 roll put');
            writeln(f, '    } ifelse');
            writeln(f, '  } forall');
            writeln(f, '  newfont /FontName newfontname put');
            writeln(f, '  encoding_vector length 256 eq {');
            writeln(f, '    newfont /Encoding encoding_vector put');
            writeln(f, '  } if');
            writeln(f, '  newfontname newfont definefont pop');
            writeln(f, '} def');
            writeln(f, '/Times-Roman /myfont MF');
            writeln(f, '/myfont findfont 10 scalefont setfont');
          end
            else writeln(f, '/Helvetica findfont 10 scalefont setfont');
            writeln(f, '/gsave');
            writeln(f, '34 dict begin');
            writeln(f, '/bd{bind def} bind def /ld{load def}bd /gs/gsave ld /gr/grestore ld');
            writeln(f, '/fact{0.333}bd');
            writeln(f, '/h{-10 fact mul}def');
            writeln(f, '/m/moveto ld /rm/rmoveto ld /l/lineto ld /rl/rlineto ld');
            writeln(f, '/s/stroke ld /rgb/setrgbcolor ld /black{0 0 0 rgb} bd /white{1 1 1 rgb }bd');
            writeln(f, '/red{1 0 0 rgb} bd /green{0 1 0 rgb} bd /blue{0 0 1 rgb} bd /yellow{1 1 0 rgb}bd');
            writeln(f, '/cyan{0 1 1 rgb}bd /magenta{1 0 1 rgb}bd /gray{0.31 0.31 0.31 rgb}bd /thinlines{0.2 setlinewidth}bd');
    writeln(f, '/thicklines{0.8 setlinewidth}bd /Thicklines{1.4 setlinewidth}bd /SolidLine{[] 0 setdash}bd');
            writeln(f, '/DotLine{[0 2] 0 setdash}bd /DashLine{[2.5 2] 0 setdash}bd');
            if not UsePsfrag then
               begin
            write(f, '/CenterH{dup stringwidth pop 2 div 0 exch sub}bd');
            writeln(f, '/Right{dup stringwidth pop 0 exch sub}bd');
            write(f,'/Left{0}bd');
            write(f,'/CenterV{h rm show s}bd');
            write(f,'/Top{h 2 mul rm show s}bd');
            write(f,'/Bottom{0 rm show s}bd');
               end else
               begin
            write(f, '/CenterH{show}bd');write(f,'/Left{show}bd');write(f, '/Right{show}bd');write(f,'/Top{s}bd');
            write(f,'/CenterV{s}bd');writeln(f,'/Bottom{s}bd')
               end;
            writeln(f, '/dot{0.75 0 360 arc fill s}bd /Bdot{1.5 0 360 arc fill s}bd');
            writeln(f, '/cross{m 3 neg 0 rm 6 0 rl 3 neg 3 neg rm 0 6 rl s}bd');
            writeln(f, '/CM {matrix currentmatrix}bd');

            if bordure then
               begin
                    writeln(f, '%Bordure');
                    writeln(f, 'thinlines 0.4 0.4 m 0.4 ',b,' 0.4 sub l ',a,
                               ' 0.4 sub ',b,' 0.4 sub l ',a,' 0.4 sub 0.4 l closepath s');
               end;
            writeln(f,'1 setlinejoin 1 setlinecap');
            aux:=liste_element.tete;
            LabelPsfrag:=1; {compteur de labels}
            if UsePsfrag then rewrite(psfrag);
            while aux<>nil do begin Pelement(aux)^.enregistrer_eps;aux:=aux^.suivant end;
            writeln(f);
            writeln(f,'end');
            writeln(f,'%EOF');
            writeln(f,'%%Trailer');
            LabelPsfrag:=1;{compteur de labels}
            end;
   pgf: begin {format pgf}
            if liste_element.tete=nil then exit;
            writeln(f,'\begin{pgfpicture}{'+streel(-margeG)+'cm}{'+streel(-margeB)+'cm}'+
            '{',streel(Xtex(Xmax)+margeD)+'cm}{',streel(Ytex(Ymax)+margeH),'cm}%');
            if bordure then
               begin
                    writeln(f, '% Bordure');
                    write(f, '\pgfmoveto{\pgfxy('+streel(-margeG)+','+streel(-margeB)+')}');
                    write(f, '\pgflineto{\pgfxy('+streel(Xtex(Xmax)+margeD)+','+ streel(-margeB)+')}');
                    write(f, '\pgflineto{\pgfxy('+streel(Xtex(Xmax)+margeD)+','+ streel(Ytex(Ymax)+margeH)+')}');
                    write(f, '\pgflineto{\pgfxy('+ streel(-margeG)+','+ streel(Ytex(Ymax)+margeH)+')}');
                    writeln(f, '\pgfclosestroke');

               end;
            if Yafond then
                begin
                  writeln(f, '% fond');
                  writeln(f, '\pgfputat{\pgfxy('+streel(Xtex(fondOrigX))+','+streel(Ytex(fondOrigY-fondHaut))+')}{'+
                  '\includegraphics[width='+streel(FondLarge*Xscale)+'cm]{'+AccesFond+'}}%');
                end;
            writeln(f,'\pgfsetroundjoin \pgfsetroundcap%');
            aux:=liste_element.tete;
            while aux<>nil do begin Pelement(aux)^.enregistrer_pgf;aux:=aux^.suivant end;
            write(f,'\end{pgfpicture}%');
       end;
      end;
      closeFile(f);
      //Execution de Esave
      FoncSpeciales:=true;
      New(E,init);
      E^.definir('Esave()');
      res:=E^.evaluer;
      Kill(Pcellule(res));
      dispose(E,detruire);
      FoncSpeciales:=old;
 end;
 {======================}
 procedure vider_liste;
 begin
        liste_element.detruire;
        PcomptGraph^.affixe^.x:=0;
 end;
 {======================}
Function Xreel(x:integer):Real;
begin Xreel:= Xmin+(x-GmargeG)*(Xmax-Xmin)/maxX
end;
{==================}
Function Yreel(y:integer):Real;
begin Yreel:=Ymax+(y-GmargeH)*(Ymin-Ymax)/maxY
end;
{==================}
Function Xentier(x:real): Integer;
begin
      Xentier:=round((x-Xmin)*maxX/(Xmax-Xmin))+GmargeG+OffsetX
end;
{==================}
Function Yentier(y:real): Integer;
begin
      Yentier:=round((y-Ymax)*maxY/(Ymin-Ymax))+GmargeH+OffsetY
end;
{==================}
Function XTeX(x:Real):Real;
begin Result:= (x-Xmin)*Xscale
end;
{==================}
Function YTeX(y:Real):Real;
begin Result:= (y-Ymin)*Yscale
end;
{==================}
Function XEps(x:Real):Real;
begin Result:= CpicaX*(x-OxEps)
end;
{==================}
Function YEps(y:Real):Real;
begin Result:=CpicaY*(y-OyEps)
end;
{==========================================Type t_element ==================}
constructor t_element.init(const UnNom, UneCommande:string);
begin
 TNoeud.init(UnNom);
 id:=-1;
 fixeAttributs;
 liste_points:=new(Pliste,init);
 LigneCommande:=UneCommande;
 arbre:=nil;
 donnees:=nil;
 ConstruitArbre(nil);
 Recalculer
end;
{======================}
procedure t_element.ConstruitArbre(Unarbre:Pcorps);
begin
     if Unarbre<>nil
        then
            begin
             new(arbre,init);
             DefCommande:=false;
             arbre^.VarLoc:=LesVarLoc;
             arbre^.corps:=Unarbre;
        end
        else
            begin
                 new(arbre,init);
                 if not arbre^.definir(LigneCommande)
                    then begin dispose(arbre,detruire); arbre:=nil end;
                 DefCommande:=true;
            end;
end;
{======================}
procedure t_element.fixeAttributs;
begin
      GetAttributs;
      couleur:=linecolor;
      trait:=Linewidth;
      if trait=0 then trait:=1;
      ReCalcAuto:=AutoReCalc;
      if PenMode=1 then pen_mode:=PenMode1 else pen_mode:=pmCopy;
end;
{========================}
procedure t_element.lireAttributs;
begin
     linecolor:=couleur;
     linewidth:=trait;
     AutoReCalc:=ReCalcAuto;
     //PenMode:=byte(pen_mode);
     Setattributs;
end;
{========================}
function t_element.PenWidth:integer;
begin
        Result:=Round(trait*CurrentScale*CurrentRes/722.7)
end;
{========================}
procedure t_element.recalculer;
var aux:Paffixe;
begin
     if arbre=nil then exit;
     if DefCommande then
        begin
             dispose(arbre,detruire);
             ConstruitArbre(nil);
             if arbre=nil then exit;
        end;
     liste_points^.detruire;
     liste_points^.init;
     aux:=arbre.evaluer;
     if aux<>nil then
          liste_points^.ajouter_fin(aux);
end;
{=======================}
procedure t_element.purger;
var aux,aux1:Paffixe;
    A,B,X,Y,epsilon:real;
begin
         epsilon:=0.00172805;
         aux:=Paffixe(Liste_points^.tete);
         if aux=nil then exit;
         while (aux<>nil) and Isjump(aux) do liste_points^.supprimer(Pcellule(aux));
         if aux=nil then exit;
         A:=aux^.x*Xscale;
         B:=aux^.y*Yscale;
         while aux<>nil do
             begin
             aux1:=Paffixe(aux^.suivant);
             if (aux1<>nil) and (not Isjump(aux1))
                then begin
                     X:=aux1^.x*Xscale;
                     Y:=aux1^.y*Yscale;
                     if (abs(A-X)<=epsilon) and  (abs(B-Y)<=epsilon) then
                        liste_points^.supprimer(Pcellule(aux))
                        else begin A:=X;B:=Y;aux:=aux1;end;
                     end
                else begin
                     if aux1<>nil then aux1:=Paffixe(aux1^.suivant);
                     while (aux1<>nil) and (IsJump(aux1)) do liste_points^.supprimer(Pcellule(aux1));
                     aux:=aux1;
                     if aux<>nil then begin A:=aux^.x*Xscale;B:=aux^.y*Yscale; end
                     end
             end;
end;
{===========================}
procedure T_element.clip;
var aux:Paffixe;
begin
     aux:=Paffixe(Liste_points^.tete);
     if aux=nil then exit;
     while aux<>nil do
     if (aux^.y>=Ymin) and (aux^.y<=Ymax)
               and (aux^.x>=Xmin) and (aux^.x<=Xmax)
     then  aux:=Paffixe(aux^.suivant)
     else Liste_points^.supprimer(Pcellule(aux));
     purger;
end;
{=======================}
procedure t_element.parametres_scr(feuille:TCanvas;var coul:longint);
begin
     if gestion_couleur or (not ExportPrn)
        then
            if couleur<9 then coul:=palette[couleur].code
                         else coul:=couleur
        else coul:=$0;
     feuille.pen.color:=coul;
     feuille.Pen.mode:=pen_mode;
     feuille.pen.style:=psSolid;
     feuille.Pen.width:=PenWidth; //(trait div 6)+1;
end;
{=======================}
procedure t_element.dessiner(feuille: Tcanvas);
begin
end;
{=======================}
procedure t_element.enregistrer_latex;
var ok:boolean;
begin
     ok:=false;
     if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
     if gestion_couleur and (couleur<>couleur_courante)  and (cat<>cat_utilisateur)
     then begin
                 write(f,'\color',StrColor(couleur,latex));ok:=true;
                 couleur_courante:=couleur
           end;
     if (trait<>epaisseur_courante) and (cat<>cat_label) and (cat<>cat_utilisateur)
      then begin
           case trait of
           2: write(f,'\thinlines ');
           8: write(f,'\thicklines ');
           14: write(f,'\Thicklines ');
           else write(f, '\allinethickness{'+streel(0.1*trait)+'pt}%');
           end;
           epaisseur_courante:=trait;ok:=true;
           end;
      if ok then writeln(f);
end;
{=======================}
function t_element.parametres_pst:string;
var chaine:string;
begin
     chaine:='';
     if gestion_couleur and (couleur<>couleur_courante) then
        begin
             chaine:='linecolor='+StrColor(couleur,pstricks);
             couleur_courante:=couleur
           end;
      if (trait<>epaisseur_courante) and (cat<>cat_dot) then
      begin
        if chaine<>'' then chaine:=chaine+',';
        chaine:=chaine+'linewidth='+streel(0.1*trait)+'pt';
        epaisseur_courante:=trait
      end;
     parametres_pst:=chaine;

end;
{========================}
procedure t_element.enregistrer_pst;
var chaine:string;
begin
     if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
     chaine:=parametres_pst;
     if chaine<>'' then writeln(f,'\psset{'+chaine+'}');
end;
{=======================}
function t_element.parametres_teg:string;
var chaine:string;
begin
     chaine:='';
     if trait<>Linewidth then
         begin LineWidth:=trait; chaine:=chaine+',Set(Width,'+Streel(trait)+')';end;
     if couleur<>linecolor then
         begin linecolor:=couleur; chaine:=chaine+',Set(Color,'+Streel(couleur)+')';end;
     if ReCalcAuto<>AutoReCalc then
         begin AutoReCalc:=ReCalcAuto; chaine:=chaine+',Set(AutoReCalc,'+Streel(ReCalcAuto)+')';end;
      parametres_teg:=chaine
end;
{========================}
procedure t_element.enregistrer_teg;
var chaine:string;
begin
     writeln(f, '% ',nom,type_element[cat]);
     chaine:=parametres_teg;
     if chaine<>'' then
         begin
              delete(chaine,1,1);
              chaine:='['+chaine+']';
              writeln(f,cat_command,car_special,car_special,chaine,car_special,car_special);
         end;
     if cat=cat_utilisateur
        then  write(f,cat,car_special,nom,car_special, LigneCommande ,car_special)
        else  write(f,cat,car_special,nom,car_special, FormatString(LigneCommande,80),car_special);
end;
{=======================}
procedure t_element.enregistrer_eps;
begin
     if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
     if gestion_couleur and (couleur<>couleur_courante) and (cat<>cat_utilisateur)
     then
        begin
             write(f, StrColor(couleur,eps));
             couleur_courante:=couleur
           end;
      if (trait<>epaisseur_courante) and (cat<>cat_utilisateur)
      then
      begin
       case trait of
       2:  write(f, 'thinlines ');
       8: write(f, 'thicklines ');
       14: write(f, 'Thicklines ')
       else write(f, streel(0.1*trait)+' setlinewidth ');
       end;
        epaisseur_courante:=trait
      end;
end;
{=======================}
procedure t_element.enregistrer_pgf;
var ok:boolean;
begin
     ok:=false;
     if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
     if gestion_couleur  and (couleur<>couleur_courante) and (cat<>cat_utilisateur)
     then
        begin
              write(f,'\pgfsetstrokecolor'+StrColor(couleur,pgf)); ok:=true;
              couleur_courante:=couleur
        end;
      if (trait<>epaisseur_courante) and (cat<>cat_label) and (cat<>cat_utilisateur)
      then
         begin
              write(f, '\pgfsetlinewidth{'+streel(0.1*trait)+'pt} ');ok:=true;
              epaisseur_courante:=trait
         end;
      if ok then writeln(f);
end;
{=======================}
destructor t_element.detruire;
begin
     if liste_points<>nil then dispose(liste_points,detruire);
     if arbre<>nil then
        if DefCommande then dispose(arbre,detruire) else dispose(arbre);
     Kill(Pcellule(donnees));
     TNoeud.detruire;
end;
{===============================t_dot====================================}
constructor t_dot.init(const UnNom, UneCommande:string);
begin
     cat:=cat_dot;
     t_element.init(UnNom,UneCommande);
end;
{======================}
procedure t_dot.recalculer;
begin
     t_element.recalculer;
     clip;
end;
{======================}
procedure t_dot.fixeAttributs;
begin
      t_element.fixeAttributs;
      point_style:=dotstyle;
end;
{========================}
procedure t_dot.lireAttributs;
begin
     dotstyle:=point_style;
     t_element.lireAttributs;
end;
{========================}
procedure t_dot.parametres_scr(feuille:TCanvas;var coul:longint);
begin
     t_element.parametres_scr(feuille,coul);
     feuille.brush.style:= bsSolid;
     feuille.brush.color:= coul;
end;
{========================}
procedure t_dot.dessiner(feuille: Tcanvas);
var hauteur,largeur:integer;
    coul:longint;
    x1,y1:real;
    aux:Paffixe;
begin
     if liste_points^.tete=nil then exit;
     aux:=Paffixe(liste_points^.tete);
     parametres_scr(feuille,coul);   
     hauteur:=5;//0.1/Yscale;
     largeur:=5;//0.1/Xscale;
     while aux<>nil do
           if not IsJump(aux) then begin
     x1:=aux^.X; y1:=aux^.Y;
     with feuille do
     case point_style of
     2: begin MoveTo(Xentier(x1),Yentier(y1));
              LineTo(Xentier(x1)-largeur,Yentier(y1));
              MoveTo(Xentier(x1),Yentier(y1));
              LineTo(Xentier(x1)+largeur,Yentier(y1));
              MoveTo(Xentier(x1),Yentier(y1)-hauteur);
              LineTo(Xentier(x1),Yentier(y1)+hauteur);
        end;
     0: (*Setpixel(DragDc,Xentier(x1),Yentier(y1),coul);*)
        ellipse(Xentier(x1)-2,Yentier(y1)-2,Xentier(x1)+2,Yentier(y1)+2);
     1: ellipse(Xentier(x1)-3,Yentier(y1)-3,Xentier(x1)+3,Yentier(y1)+3);
     end;

     aux:=Paffixe(aux^.suivant);
           end;

end;
{=======================}
procedure t_dot.enregistrer_latex;
var hauteur:real;
    x1,y1:real;
    aux:Paffixe;
begin
     if liste_points^.tete=nil then exit;
     aux:=Paffixe(liste_points^.tete);
     t_element.enregistrer_latex;
     hauteur:=0.1;
     while aux<>nil do
           begin
     x1:=aux^.X; y1:=aux^.Y;
     case point_style of
     2: writeln(f,'\put('+streel(Xtex(x1)-hauteur)+','+streel(Ytex(y1))+'){\line(1,0){'+streel(2*hauteur)+'}}'+
                '\put('+streel(Xtex(x1))+','+streel(Ytex(y1)-hauteur)+'){\line(0,1){'+streel(2*hauteur)+'}}');


       
     1: writeln(f,'\put('+streel(Xtex(x1))+','+streel(Ytex(y1))+'){\makebox(0,0){\large$\bullet$}}');
     0: writeln(f,'\put('+streel(Xtex(x1))+','+streel(Ytex(y1))+'){\makebox(0,0){\tiny$\bullet$}}');
     end;
      aux:=Paffixe(aux^.suivant)
           end;                          
end;
{=======================}
function t_dot.parametres_pst;
var chaine:string;
begin
     chaine:=t_element.parametres_pst;
     if (point_style<>courant_point_style) then
        begin
             if chaine<>'' then chaine:=chaine+',';
             chaine:=chaine+'dotstyle='+UnPointStyle[point_style];
             courant_point_style:=point_style;
        end;
     parametres_pst:=chaine;
end;
{=======================}
procedure t_dot.enregistrer_pst;
var aux:Paffixe;
    x1,y1:real;
    nb_colonnes,points:word;
    chaine:string;
begin
     if liste_points^.tete=nil then exit;
     aux:=Paffixe(liste_points^.tete);
     t_element.enregistrer_pst;
     write(f,'\psdots');nb_colonnes:=8;points:=0;
     while aux<>nil do
           begin
     x1:=aux^.X; y1:=aux^.Y;
     if points>=Max_points then begin if nb_colonnes>0 then writeln(f);
                                      write(f,'\psdots');points:=0;nb_colonnes:=8
                                end;
     chaine:='('+streel(Xtex(x1))+','+streel(Ytex(y1))+')';
     write(f,chaine);
     inc(nb_colonnes,length(chaine));inc(points);
     if nb_colonnes>=colonnes then begin writeln(f);nb_colonnes:=0 end;
     aux:=Paffixe(aux^.suivant)
           end;
     if nb_colonnes>0 then writeln(f);
end;
{===================}
procedure t_dot.enregistrer_eps;
var aux:Paffixe;
    x1,y1:real;
    nb_colonnes,points:word;
    chaine,commande:string;
begin
     if liste_points^.tete=nil then exit;
     aux:=Paffixe(liste_points^.tete);
     t_element.enregistrer_eps;
     case point_style of
     0: commande:=' dot ';
     1: commande:=' Bdot ';
     2: commande:=' cross ';
     end;
     if style_courant<>0
        then
            begin
                 writeln(f, 'SolidLine ');
                 style_courant:=0;
            end;
     nb_colonnes:=0;points:=0;
     while aux<>nil do
           begin
     x1:=XEps(aux^.X); y1:=YEps(aux^.Y);
     if points>=Max_points then begin if nb_colonnes>0 then writeln(f);
                                      points:=0;nb_colonnes:=0
                                end;
     chaine:=streel(x1)+' '+streel(y1)+commande;
     write(f,chaine);
     inc(nb_colonnes,length(chaine));inc(points);
     if nb_colonnes>=colonnes then begin writeln(f);nb_colonnes:=0 end;
     aux:=Paffixe(aux^.suivant)
           end;
     if nb_colonnes>0 then writeln(f);

end;
{===================}
procedure t_dot.enregistrer_pgf;
var hauteur:real;
    x1,y1:real;
    aux:Paffixe;
begin
     if liste_points^.tete=nil then exit;
     aux:=Paffixe(liste_points^.tete);
     t_element.enregistrer_pgf;
     if (point_style in [0,1]) and (fillcolor_courant<>couleur) then
        begin
             fillcolor_courant:=couleur;
             write(f,'\pgfsetfillcolor'+StrColor(couleur,pgf));
        end;
     hauteur:=0.1;
     if style_courant<>0
        then
            begin
                 writeln(f, '\pgfsetdash{}{0pt}');
                 style_courant:=0;
            end;
     while aux<>nil do
           begin
     x1:=Xtex(aux^.X); y1:=Ytex(aux^.Y);
     case point_style of
     2: begin
             writeln(f,'\pgfmoveto{\pgfxy('+streel(x1-hauteur)+','+streel(y1)+')}\pgflineto{\pgfxy('+
                           streel(x1+hauteur)+','+streel(y1)+')}\pgfstroke');
             writeln(f, '\pgfmoveto{\pgfxy('+
                           streel(x1)+','+streel(y1-hauteur)+')}\pgflineto{\pgfxy('+
                           streel(x1)+','+streel(y1+hauteur)+')}\pgfstroke ');
      end;
     1: writeln(f,'\pgfcircle[fillstroke]{\pgfxy('+streel(x1)+','+streel(y1)+')}{.05cm}');
     0: writeln(f,'\pgfcircle[fillstroke]{\pgfxy('+streel(x1)+','+streel(y1)+')}{.025cm}');
     end;
      aux:=Paffixe(aux^.suivant)
           end;
end;
{=======================}
function t_dot.parametres_teg:string;
var chaine:string;
begin
     chaine:=t_element.parametres_teg;
     if point_style<>DotStyle then
         begin DotStyle:=point_style; chaine:=chaine+',Set(DotStyle,'+Streel(point_style)+')';end;
     parametres_teg:=chaine
end;
{==============================t_label===========================}
constructor t_label.init(const UnNom,UneCommande,UnTexte:string);
begin
     Texte:=UnTexte;
     t_element.init(UnNom,UneCommande);
     cat:=cat_label;
end;
{=======================}
procedure t_label.recalculer;
begin
     t_element.recalculer;
     clip;
end;
{========================}
procedure t_label.fixeAttributs;
begin
      t_element.fixeAttributs;
      style_label:=labelstyle;
      size_label:=LabelSize;
      angle_label:=LabelAngle;

      ligne_style:=lineStyle;
      Fill_style:=fillstyle;
      fill_color:=fillcolor;
end;
{========================}
procedure t_label.lireAttributs;
begin
     labelstyle:=style_label;
     LabelSize:=size_label;
     LabelAngle:=angle_label;

     LineStyle:=ligne_style;
     FillStyle:=fill_style;
     fillColor:=fill_color;

     t_element.lireAttributs
end;
{========================}
procedure t_label.parametres_scr(feuille:Tcanvas;var coul:longint);
var fillcoul:longint;
begin
     t_element.parametres_scr(feuille,coul);
     with feuille do
     begin
     case ligne_style of
    -1:  pen.style:=psClear;
     0:  pen.style:=psSolid;
     1:  pen.style:=psDash;
     2:  pen.style:=psDot;
     end;
     pen.width:=1;
     font.Color:=coul;
     font.size:=size_label*2+4;
     if gestion_couleur or (not ExportPrn)
        then
     if fill_color<9 then fillcoul:=palette[fill_color].code
                     else fillcoul:=fill_color
        else fillcoul:=clwhite;
     Brush.Color:=fillcoul;
     if not((style_label And 16)=16) then Brush.style:=bsclear  //not framed
     else
     case fill_style of
             0: Brush.style:=bsClear;
             1: Brush.Style:=bsSolid;
             2: Brush.style:=bsBdiagonal;
             3: Brush.style:=bsCross;
             4: Brush.style:=bsDiagcross;
             5: Brush.style:=bsFdiagonal;
             6: Brush.style:=bsHorizontal;
             7: Brush.style:=bsVertical;
     end;
     end;
end;
{========================}
procedure t_label.dessiner(feuille: Tcanvas);
var
    coul,hauteur,largeur,u,v,ureel,vreel,uref,vref:longint;
    theta,ctheta,stheta:real;
    framed:byte;
    lf: LOGFONT; // structure de fonte Windows native
    Points:Array of Tpoint;

    procedure rotate(xs,ys:integer);  //M'=C+exp(i*theta)(M-C)  o C(xrel,yreel) est le point d'affichage voulu
    var x,y:integer;
    begin
         x:=xs-ureel; y:=ys-vreel;
         v:=round(vreel+ctheta*y-stheta*x);
         u:=round(ureel+ctheta*x+stheta*y);
    end;

begin
     if liste_points^.tete=nil then exit;
     if (style_label and 64=64) then exit;//style spcial, pas d'affichage
     ureel:=Xentier(Paffixe(liste_points^.tete)^.X);
     vreel:=Yentier(Paffixe(liste_points^.tete)^.Y);
     parametres_scr(feuille,coul);
     if angle_label<>0 then
        begin
             FillChar(lf,SizeOf(lf), Byte(0));
             lf.lfHeight := -feuille.font.Size*feuille.font.PixelsPerInch div 72 ;
             lf.lfEscapement := round(10*angle_label); // Nombre de degrs de rotation
             lf.lfOrientation := round(10 * angle_label);
             lf.lfCharSet := DEFAULT_CHARSET;
             StrCopy(lf.lfFaceName, 'verdana');
             feuille.Font.Handle := CreateFontIndirect(lf);
             theta:=angle_label*pi/180;
             ctheta:=cos(theta); stheta:=sin(theta);
        end;
     with feuille do
             begin
                  largeur:=TextWidth(Texte) div 2;
                  hauteur:=TextHeight(Texte) div 2;
                  framed:= byte((style_label And 16)=16);
                  Case (style_label) And 3 of  {horizontal}
                       1: {left}  uref:=ureel+framed*5;
                       0: {centr} uref:=ureel-largeur;
                       2: {right}  uref:=ureel-2*largeur-framed*5;
                       else uref:=ureel-largeur;
                  end;
                  Case (style_label) And  12 of   {vertical}
                       4: {top}   vref:=vreel+framed*5;
                       0: {centr} vref:=vreel-hauteur;
                       8: {bottom} vref:=vreel-2*hauteur-framed*5;
                       else vref:=vreel-hauteur;
                  end;
             {if pen_mode=pmCopy then}
             if (framed=1) {or (pen_mode=PenMode1)} then
             if angle_label<>0 then
                begin
                     SetLength(Points,4);
                     rotate(uref-5,vref-5); Points[0].x:=u; Points[0].y:=v;
                     rotate(uref+2*largeur+5,vref-5); Points[1].x:=u; Points[1].y:=v;
                     rotate(uref+2*largeur+5,vref+2*hauteur+5); Points[2].x:=u; Points[2].y:=v;
                     rotate(uref-5,vref+2*hauteur+5); Points[3].x:=u; Points[3].y:=v;
                     polygon(Points);
                end
                else rectangle(uref-5,vref-5,uref+2*largeur+5,vref+2*hauteur+5);
             if angle_label<>0 then rotate(uref,vref) else begin u:=uref;v:=vref end;
             Textout(u,v,Texte);
             end;
end;
{=======================}
procedure t_label.enregistrer_latex;
var name,style:string;
    x1,y1:real;
    horizontal:boolean;
begin
     if liste_points^.tete=nil then exit;
     if (style_label And 64)=64
        then begin  //style spcial
                  writeln(f,Texte);
                  exit
             end;
     //point d'affichage
     x1:=Xtex(Paffixe(liste_points^.tete)^.X);
     y1:=Ytex(Paffixe(liste_points^.tete)^.Y);

     horizontal:=true;
     case (style_label And 3) of
          1: style:='l';
          2: style:='r';
          else begin style:=''; horizontal:=false; end;
     end;
     case (style_label And  12) of
          4: if horizontal then style:=style+',t' else style:='t';
          8: if horizontal then style:=style+',b' else style:='b';
     end;
     if style<>'' then style:='['+style+']';
     //texte  afficher
     name:=Texte;
     if (style_label and 32)=32 then name:='\shortstack{'+name+'}'; //style stacked
     if ((style_label and 16)=16) And (ligne_style>-1)
       then name:='\framebox{'+name+'}'; //style framed
     name:=tailleLabel[size_label]+' '+name;
     //enregistrement
     t_element.enregistrer_latex;
     write(f,'\put('+ streel(x1)+','+streel(y1)+'){');
     if angle_label=0 then writeln(f,'\makebox(0,0)'+style+'{'+name+'}}')
                      else writeln(f, '\begin{rotate}{'+streel(angle_label)+'}\makebox(0,0)'+style+'{'+name+'}\end{rotate}}');
end;
{=======================}
function t_label.parametres_pst;
var chaine:string;
    ok:boolean;
    oldfill:longint;
begin
     chaine:=t_element.parametres_pst;
     ok:=chaine<>'';
     if gestion_couleur and (couleur<>Texte_courant) then
        begin
             writeln(f, '\color'+StrColor(couleur,latex));
             Texte_courant:=couleur;
        end;
     if (style_label And 16)=16 then //style framed
     begin
     if not gestion_couleur
        then
            begin
                 oldFill:=fill_color;
                 if fill_style=1 then fill_color:=1 else fill_color:=0;
            end;
     if (ligne_style<>style_courant) then
        begin if ok then chaine:=chaine+',';
              chaine:=chaine+'linestyle='+UnStyle[ligne_style];
              ok:=true;
              style_courant:=ligne_style
           end;
        if (fill_style<>fill_courant) then
        begin if ok then chaine:=chaine+',';
              chaine:=chaine+'fillstyle='+StyleFill[fill_style];
              ok:=true;
              fill_courant:=fill_style
           end;
        if (fill_style<>0)  then
        begin
             if (fill_style=1) and (fill_color<>fillcolor_courant)
                then
                begin
             if ok then chaine:=chaine+',';
                         chaine:=chaine+'fillcolor='+StrColor(fill_color,pstricks);
             fillcolor_courant:=fill_color;
                end else
             if (fill_style<>1) and (fill_color<>hatchcolor_courant)
                then
                begin
              if ok then chaine:=chaine+',';
                         chaine:=chaine+'hatchcolor='+StrColor(fill_color,pstricks);
              hatchcolor_courant:=fill_color
                end;

           end;
         if not gestion_couleur  then fill_color:=oldFill

        end;
        parametres_pst:=chaine;
end;
{=======================}
procedure t_label.enregistrer_pst;
var style,name:string;
    x1,y1:real;
begin
     if liste_points^.tete=nil then exit;
     if (style_label And 64)=64
        then begin  //style spcial
                  writeln(f,Texte);
                  exit
             end;
     //point d'affichage
     x1:=Xtex(Paffixe(liste_points^.tete)^.X);
     y1:=Ytex(Paffixe(liste_points^.tete)^.Y);
     //type d'affichage
     case (style_label And 3) of
          1: style:='l';
          2: style:='r';
          else style:='';
     end;
     case (style_label And  12) of
          4: style:=style+'t';
          8: style:=style+'b';
     end;
     if style<>'' then style:='['+style+']';
     if angle_label=0 then style:=style+'(' else style:=style+'{'+streel(angle_label)+'}(';
     //texte  afficher
     name:=Texte;
     if (style_label and 32)=32 then name:='\shortstack{'+name+'}'; //style stacked
     if (style_label and 16)=16 then name:='\psframebox{'+name+'}'; //style framed
     name:=tailleLabel[size_label]+' '+name;
     //enregistrement
     t_element.enregistrer_pst;
     writeln(f,'\rput'+style+streel(x1)+','+streel(y1)+'){'+name+'}');
end;
{=================}
procedure t_label.enregistrer_pgf;
var anchor,style,name:string;
    x1,y1:real;
    rotate:boolean;
begin
     if liste_points^.tete=nil then exit;
     t_element.enregistrer_pgf;
     if (style_label And 64)=64
        then begin  //style spcial
                  writeln(f,Texte);
                  exit
             end;
     //point d'affichage
     x1:=Xtex(Paffixe(liste_points^.tete)^.X);
     y1:=Ytex(Paffixe(liste_points^.tete)^.Y);
     //type d'affichage
     rotate:=(angle_label<>0);

     case (style_label And  12) of
          4:  anchor:='north';
          8:  anchor:='south';
           else anchor:='';
     end;
     case (style_label And 3) of
          1: anchor:=anchor+' west';
          2: anchor:=anchor+' east';
     end;
     if anchor='' then anchor:='center';
     if anchor[1]=' ' then system.delete(anchor,1,1);
     //style
     if ((style_label and 16)=16)//framed
        then
                begin
                        if fill_style=1 then  //remplissage
                                begin
                                     if gestion_couleur  and (fill_color<>fillcolor_courant)  then
                                        begin
                                                writeln(f,'\pgfsetfillcolor'+StrColor(fill_color,pgf));
                                                fillcolor_courant:=fill_color
                                        end;
                                     if ligne_style>-1 then style:='\pgfusepath{fill,stroke}'
                                                       else style:='\pgfusepath{fill}';
                                end
                        else //pas de remplisage
                             if (ligne_style>-1) then style:='\pgfusepath{stroke}' else style:='\pgfusepath{}';
                end
                else style:='\pgfusepath{}';

      //texte  afficher
     name:=Texte;
     name:=tailleLabel[size_label]+' '+name;
     if gestion_couleur  and (couleur<>fillcolor_courant)  then
            name:='\color'+StrColor(couleur,pgf)+name;
     if (style_label and 32)=32 then name:='\shortstack{'+name+'}'; //style stacked
     
     //enregistrement
     if rotate then writeln(f,'{\pgftransformrotate{'+Streel(angle_label)+'}');
     write(f,'\pgfputat{\pgfxy('+ streel(x1)+','+streel(y1)+ ')}{\pgfnode{rectangle}{'+anchor+'}{'
     +name+'}{}{'+style+'}}');
     if rotate then writeln(f,'}') else writeln(f);
end;
{=======================}
procedure t_label.enregistrer_eps;
var    x1,y1:real;
       name,epsname,style:string;
       rot,horizontal:boolean;
begin
     if liste_points^.tete=nil then exit;
     if (style_label And 64)=64
        then begin  //style spcial
                  writeln(f,Texte);
                  exit
             end;
     // point d'affichage
     x1:=XEps(Paffixe(liste_points^.tete)^.X);
     y1:=YEps(Paffixe(liste_points^.tete)^.Y);
     epsname:=Texte;
     // dbut de l'enregistrement des paramtres dans le fichier Eps
     if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
     //si on utilise Psfrag, il y a une sortie semblable  la sortie LaTeX dans le fichier Psfrag
     if UsePsfrag then
     begin
          //style d'affichage
          horizontal:=true;
          case (style_label And 3) of
               1: style:='l';
               2: style:='r';
               else begin style:=''; horizontal:=false; end;
          end;
          case (style_label And  12) of
               4: if horizontal then style:=style+',t' else style:='t';
               8: if horizontal then style:=style+',b' else style:='b';
          end;
          if style<>'' then style:='['+style+']';
          // texte  afficher rellement (name) et texte dans le fichier Eps (epsname)
          name:=Texte; epsname:='L'+IntToStr(LabelPsfrag); //codes L1, L2 ...etc dans le fichier Eps
          if (style_label and 32)=32 then name:='\shortstack{'+name+'}'; //style stacked
          if ((style_label and 16)=16) and (ligne_style>-1)
             then name:='\framebox{'+name+'}'; //style framed
          name:=tailleLabel[size_label]+' '+name;
          if gestion_couleur and (couleur<>0) // on suppose que la couleur initiale dans le document est le noir
             then name:='\color'+StrColor(couleur,latex)+' '+name ;  //on indique  Psfrag la couleur du label
          // enregistrement  dans Psfrag
          writeln(psfrag,'\psfrag{'+epsname+'}{\makebox(0,0)'+style+'{'+name+'}}');
          //incrmenter le compteur de labels
          Inc(LabelPsfrag,1);
     end
     else //pas de sortie Psfrag, les labels sont  enregistrer dans le fichier Eps
     begin
          if gestion_couleur and (couleur<>couleur_courante)
             then  begin
                        write(f, StrColor(couleur,eps));
                        couleur_courante:=couleur
                   end;
        if (size_label<> LabelSize_courant)
        then
            begin
                 writeln(f, '/myfont findfont '+ streel(size_Label*2+4)+' scalefont setfont /h{-'+streel(size_Label*2+4)+' fact mul}def');
                 LabelSize_courant:= size_label;
            end;
     end;
     //Suite de l'enregistrement dans le fichier Eps
     epsname:='('+epsname+')';
     write(f, streel(x1)+' '+streel(y1)+' m '); // enregistrement du point courant
     rot:=(angle_label<>0); //rotation?
     if rot then write(f,streel(angle_label)+' rotate ');  // rotation s'il y a
     case (style_label And 3) of
          2  : write(f, epsname+' Right ');
          1  : write(f,epsname+' Left ');
          else write(f,epsname+' CenterH ');
     end;
     case (style_label And 12) of
     4: write(f,'Top ');
     8: write(f, 'Bottom ');
     else write(f,'CenterV ')
     end;
     if rot then writeln(f,streel(-angle_Label)+' rotate ') else writeln(f);
end;
{=================}
function t_label.parametres_teg:string;
var chaine:string;
begin
     chaine:=t_element.parametres_teg;
     if style_label<>LabelStyle then
         begin LabelStyle:=style_label; chaine:=chaine+',Set(LabelStyle,'+Streel(style_label)+')';end;
     if size_label<>LabelSize then
         begin LabelSize:=size_label; chaine:=chaine+',Set(LabelSize,'+Streel(size_label)+')';end;
     if angle_label<>LabelAngle then
         begin LabelAngle:=angle_label; chaine:=chaine+',Set(LabelAngle,'+Streel(angle_label)+')';end;
     if ligne_style<>LineStyle then
         begin LineStyle:=ligne_style; chaine:=chaine+',Set(LineStyle,'+Streel(ligne_style)+')';end;
      if FillStyle<>fill_style then
         begin FillStyle:=fill_style; chaine:=chaine+',Set(FillStyle,'+Streel(fill_style)+')';end;
      if FillColor<>fill_color then
         begin FillColor:=fill_color; chaine:=chaine+',Set(FillColor,'+Streel(fill_color)+')';end;
     parametres_teg:=chaine
end;
{========================}
procedure T_Label.enregistrer_teg;
begin
     t_element.enregistrer_teg;
     write(f,Texte,car_special);
end;
{========================}
destructor T_Label.detruire;
begin
      T_Element.detruire
end;
{=========T_ligne==============}
constructor T_ligne.init(const UnNom, UneCommande:string;Closed:byte;Unrayon:real);
begin
     fermee:=closed;
     rayon:=Unrayon;
     PtsFleches:=new(Pliste,init);
     t_element.init(UnNom,UneCommande);
     cat:=cat_polygone;
end;
{============}
procedure t_ligne.fixeAttributs;
begin
      T_element.fixeAttributs;
      ligne_style:=lineStyle;
      fleche:=Arrows;
      nb_points:=NbPoints;
      Fill_style:=fillstyle;
      fill_color:=fillcolor;
end;
{========================}
procedure t_ligne.lireAttributs;
begin
     LineStyle:=ligne_style;
     Arrows:=fleche;
     NbPoints:=nb_points;
     FillStyle:=fill_style;
     fillColor:=fill_color;
     t_element.lireAttributs
end;
{========================}
procedure T_ligne.recalculer;
var liste,UneListe,T,debut,fin:Paffixe;
    res:type_liste;
    FXY:Pexpression;
    chaine:string;
    coul:real;
begin
     if arbre=nil then exit;
     if DefCommande then
        begin
             dispose(arbre,detruire);
             ConstruitArbre(nil);
             if arbre=nil then exit;
        end;
     liste_points^.detruire;
     liste_points^.init;
     liste:=arbre^.evaluer;
     if liste=nil then exit;
     debut:=liste;
     while debut<>nil do
   begin
        res.init;
        fin:=Paffixe(debut);
        while (fin<>nil) and (not IsJump(fin)) do fin:=Paffixe(fin^.suivant);
        if fin<>nil then coul:=fin^.y else coul:=jump^.y;
        if fin<>nil then if fin^.precedent<>nil then fin^.precedent^.suivant:=nil else liste:=nil;
        res.ajouter_fin(liste);
        liste:=fin;
        while (fin<>nil) and (IsJump(fin)) do
              begin
                   liste:=Paffixe(fin^.suivant);
                   dispose(fin,detruire);
                   fin:=liste;
              end;
        debut:=fin;
        UneListe:=Paffixe(res.tete);
     if UneListe<>nil then
     begin  {***}
     if (rayon=0) then
        begin
             liste_points^.ajouter_fin(UneListe);
             if fermee=1 then Liste_points^.ajouter_fin(new(Paffixe,init(UneListe^.x,UneListe^.y)));
        end else
        begin {**}
     chaine:=
     'Si((Nops($L)>1) And ($r>0),[Set($b,Copy(L,1,1)), Set($c,Copy(L,2,1)), Si(closed=1,Append(L,[b,c]),b),'+
     'Seq( [Set($a,b),Set(b,c), Set(c,Copy(L,$k+1,1)), Si((a=jump) Or (c=jump),b,b=jump,jump,['+
     'Set($alpha,Arg((c-b)/(a-b))/2),Set($sinalpha,abs(sin(alpha))),Si((Nops([sinalpha])=1) And (sinalpha<1) And (sinalpha>0),['+
     'Set($u,(c-b)/abs(c-b)),Set($v,(a-b)/abs(a-b)),Set($O,b+(u+v)/abs(u+v)*r/sinalpha),Set($O1,b+v*r*cos(alpha)/sinalpha),'+
     'Set($O2,b+u*r*cos(alpha)/sinalpha),'+
     'Set($tf,Arg((O2-O)/(O1-O))),'+
     'Set($n,Ent(abs(tf*NbPoints/(2*pi)))),Set($pas,tf/n),Set($t,0),Seq([O+(O1-O)*exp(i*t),Inc(t,pas)],$k1,0,n)'+
     '],b)])],k,2,Nops(L)-1),Si(closed=0,c)],L)';
    
     new(FXY,init);
     FXY^.varloc^.ajouter_fin(new(Pconstante,init('L',UneListe,true)));
     FXY^.varloc^.ajouter_fin(new(Pconstante,init('r',new(Paffixe,init(rayon,0)),true)));
     FXY^.varloc^.ajouter_fin(new(Pconstante,init('closed',new(Paffixe,init(fermee,0)),true)));
     if FXY^.definir(chaine) then
        begin {*}
             T:=FXY^.evaluer;
             if T<>nil then  begin
                             liste_points^.ajouter_fin(T);
                             if fermee=1 then liste_points^.ajouter_fin(new(Paffixe,init(T^.x,T^.y)));
                             end;
        dispose(FXY,detruire);
        end;{*}
     end; {**}
     end;{***}
     if debut<>nil then liste_points^.ajouter_fin(new(Paffixe,init(jump^.x,coul)));
   end;
     purger;
     clip;
     if fleche>0 then calcul_fleches;
   Kill(Pcellule(liste));
end;
{============}
procedure t_ligne.calcul_fleches;
var xu,yu,xn,yn,xI,yI,n,x1,y1,x2,y2,x3,y3,x4,y4,large,long:real;
    aux,debut,fin:Paffixe;
    i:byte;
    compt:word;
begin
     if PtsFleches^.tete<>nil then PtsFleches^.detruire;
     if (liste_points^.tete=nil) or  (liste_points^.tete^.suivant=nil) then exit;
     large:=0.5/7.5;
     long:=sqrt(0.75)/7.5;
     debut:=Paffixe(liste_points^.tete);
     while debut<>nil do
      begin
       fin:=debut;compt:=1;
       while (Paffixe(fin^.suivant)<>nil) and (Not IsJump(Paffixe(fin^.suivant))) do
             begin inc(compt); fin:=Paffixe(fin^.suivant); end;
       if compt>1 then
       for i:=1 to fleche do
       begin
          if i=1 then
             begin
                  aux:=Paffixe(fin);
                  x2:=aux^.X;y2:=aux^.Y;aux:=Paffixe(aux^.precedent);
                  x1:=aux^.X; y1:=aux^.Y;
             end else begin
                 aux:=Paffixe(debut);
                 x2:=aux^.X;y2:=aux^.Y;aux:=Paffixe(aux^.suivant);
                 x1:=aux^.X;y1:=aux^.Y;
                      end;
     n:=sqrt(sqr(Xscale*(x2-x1))+sqr(Yscale*(y2-y1)));
     if n=0 then exit;
     xu:=(x2-x1)/n;yu:=(y2-y1)/n;
     xn:=-yu*Yscale/Xscale;yn:=xu*Xscale/Yscale;
     xI:=x2-long*xu;yI:=y2-long*yu;
     x3:=xI+large*xn;y3:=yI+large*yn;
     x4:=xI-large*xn;y4:=yI-large*yn;
     PtsFleches^.ajouter_fin(Pcellule(new(Paffixe,init(x3,y3))));
     PtsFleches^.ajouter_fin(Pcellule(new(Paffixe,init(x2,y2))));
     PtsFleches^.ajouter_fin(Pcellule(new(Paffixe,init(x4,y4))));
     PtsFleches^.ajouter_fin(Pcellule(new(Paffixe,init(x1,y1))));
       end ;
       debut:=Paffixe(fin^.suivant);
       if IsJump(debut) then debut:=Paffixe(debut^.suivant);
     end;
end;
{=======================}
function IsIn(point:Paffixe;i:integer):boolean;
    begin
         case i of
         1: IsIn:= (point^.x>=Xmin);
         2: IsIn:=(point^.y>=Ymin);
         4: IsIn:=(point^.y<=Ymax);
         3: IsIn:=(point^.x<=Xmax);
         else IsIn:=false;
         end;

    end;
{==============}
function intersec(A,B:Paffixe;i:integer):Paffixe;
var res:Paffixe;
begin
         case i of
         1: begin new(res,init(Xmin,0));
                  CalcError:=false;
                  res^.y:=
                  ajouter(B^.y,multiplier(soustraire(A^.y,B^.y),diviser(soustraire(Xmin,B^.x),soustraire(A^.x,B^.x))));
            end;
         3: begin new(res,init(Xmax,0));
                  CalcError:=false;
                  res^.y:=
                  ajouter(B^.y,multiplier(soustraire(A^.y,B^.y),diviser(soustraire(Xmax,B^.x),soustraire(A^.x,B^.x))));
            end;
         2: begin new(res,init(0,Ymin));
                  CalcError:=false;
                  res^.x:=
                  ajouter(B^.x,multiplier(soustraire(A^.x,B^.x),diviser(soustraire(Ymin,B^.y),soustraire(A^.y,B^.y))));
            end;
         4: begin new(res,init(0,Ymax));
                  CalcError:=false;
                  res^.x:=
                  ajouter(B^.x,multiplier(soustraire(A^.x,B^.x),diviser(soustraire(Ymax,B^.y),soustraire(A^.y,B^.y))));
            end;
         end;
         if CalcError then Kill(Pcellule(res));
         intersec:=res;

    end;
{================}
procedure T_ligne.clip;
var liste,aux,aux1:Paffixe;
    compt:integer;
    coul:real;

    procedure clipConnexe(var De:Paffixe);
    var aux,T,lastOut,lastIn:Paffixe;
        listeAux:type_liste;
        i:integer;

    begin
         listeAux.init;
         listeAux.ajouter_fin(De);
         for i:=1 to 4 do
         begin
              lastOut:=nil;
              lastIn:=Nil;
              aux:=Paffixe(ListeAux.tete);
              while aux<>nil do
                    begin
                         if IsIn(aux,i)
                            then begin
                                 if lastOut<>nil then
                                          begin
                                          T:=intersec(lastOut,aux,i);
                                          if T<>nil then listeAux.inserer(T,Pcellule(aux));
                                          listeAux.supprimer(Pcellule(lastOut));
                                          clippee:=true;
                                          lastOut:=nil;
                                          end;
                                 lastIn:=aux;
                                 end
                            else begin
                                 if lastIn=nil
                                    then begin clippee:=true;listeAux.supprimer(Pcellule(lastOut)) end
                                    else begin
                                          T:=intersec(lastIn,aux,i);
                                          lastIn:=nil;
                                          if T<>nil then listeAux.inserer(T,Pcellule(aux));
                                          clippee:=true;
                                         end;
                                 lastOut:=aux;
                                 end;
                            aux:=Paffixe(aux^.suivant)
                    end;
              if lastOut<>nil then begin clippee:=true;listeAux.supprimer(Pcellule(lastOut)); end;
              if (fermee=1) and (listeAux.tete<>nil) then
            listeAux.ajouter_fin(new(Paffixe,init(Paffixe(listeAux.tete)^.x,Paffixe(listeAux.tete)^.y)));
         end;

         if listeAux.tete=nil then exit;

         liste_points^.ajouter_fin(Paffixe(listeAux.tete));
    end;

begin
     clippee:=false;
     liste:=Paffixe(liste_points^.tete);
     if liste=nil then exit;
     liste_points^.init;
     aux:=liste;
     while aux<>nil do
          begin
               compt:=1;
               aux1:=Paffixe(aux^.suivant);
               while (aux1<>nil) and (not IsJump(aux1)) do begin inc(compt);aux1:=Paffixe(aux1^.suivant) end;
               if aux1<>nil then coul:=aux1^.y else coul:=jump^.y;
               if compt>1 then begin
                               if aux1<>nil then aux1^.precedent^.suivant:=nil;
                               ClipConnexe(aux);
                               end else dispose(aux,detruire);
               while (aux1<>nil) and (IsJump(aux1)) do begin liste:=Paffixe(aux1^.suivant);
                                                             dispose(aux1,detruire);
                                                             aux1:=liste;
                                                       end;
               aux:=aux1;
               if (aux<>nil) and (not IsJump(Paffixe(liste_points^.queue)))
                  then liste_points^.ajouter_fin(new(Paffixe,init(jump^.x,coul)))

          end;
     purger
end;
{==========================}
procedure t_ligne.parametres_scr(feuille:Tcanvas;var coul:longint);
begin
     t_element.parametres_scr(feuille,coul);
     with feuille do
     begin
     case ligne_style of
    -1:  pen.style:=psClear;
     0:  pen.style:=psSolid;
     1:  pen.style:=psDash;
     2:  pen.style:=psDot;
     end;
     end;
end;
{============}
procedure T_ligne.dessiner(feuille: Tcanvas);
type Ppoints=array[0..1] of Tpoint;
var aux,aux1:Paffixe;
    coul,fillcoul:longint;
    Points:^Ppoints;
    i,compt:word;
    mypen:boolean;
    oldpen, ThePen: Hpen;
    TheBrush:tagLogBrush;
begin
     aux:= Paffixe(liste_points^.tete);
     if aux=nil then exit;
     parametres_scr(feuille,coul);
     if (ligne_style=-1) and (fill_style=0) then exit;
     with feuille do
     begin
         if gestion_couleur or (not ExportPrn)
        then
     if fill_color<9 then fillcoul:=palette[fill_color].code
                     else fillcoul:=fill_color
        else fillcoul:=clwhite;
     Brush.Color:=fillcoul;
     case fill_style of
             0: Brush.style:=bsClear;
             1: Brush.Style:=bsSolid;
             2: Brush.style:=bsBdiagonal;
             3: Brush.style:=bsCross;
             4: Brush.style:=bsDiagcross;
             5: Brush.style:=bsFdiagonal;
             6: Brush.style:=bsHorizontal;
             7: Brush.style:=bsVertical;
     end;

    myPen:=(ligne_style<>0) and (pen.width<>1) and (pen_mode=pmCopy);
    if mypen then
     begin
        TheBrush.lbStyle:=bs_Solid;
        TheBrush.lbcolor:=coul;
        case ligne_style of
               -1:  ThePen:=ExtCreatePen(ps_geometric or ps_Null, Pen.Width, TheBrush,0,nil);
                0:  ThePen:=ExtCreatePen(ps_geometric or ps_solid or PS_ENDCAP_SQUARE or PS_JOIN_ROUND, Pen.Width, TheBrush,0,nil);
                1:  ThePen:=ExtCreatePen(ps_geometric or PS_dash or PS_ENDCAP_SQUARE, Pen.Width, TheBrush,0,nil);
                2:  ThePen:=ExtCreatePen(ps_geometric or ps_dot or PS_ENDCAP_ROUND, Pen.Width, TheBrush,0,nil);
        end;
        oldpen:=SelectObject(feuille.Handle,ThePen);
     end;
     end;
     SetPolyFillMode(feuille.Handle,Winding);
     while aux<>nil do
          begin
               compt:=1;
               aux1:=Paffixe(aux^.suivant);
               while (aux1<>nil) and (not IsJump(aux1)) do begin inc(compt);aux1:=Paffixe(aux1^.suivant) end;
               if (fill_Style=1) and (aux1<>nil) and (aux1^.y<>jump^.y) then
                  begin
                       feuille.Brush.Color:=Rgb(Round(aux1^.y*GetRvalue(fillcoul)),round(aux1^.y*GetGvalue(fillcoul)),
                                            Round(aux1^.y*GetBvalue(fillcoul)));
                  end;

               while (aux1<>nil) and (IsJump(aux1)) do begin aux1:=Paffixe(aux1^.suivant) end;
               getmem(Points,compt*SizeOf(Tpoint));

               for i:=0 to compt-1 do
                   begin Points^[i].x:=Xentier(aux^.x);
                         Points^[i].y:=Yentier(aux^.y);
                         aux:=Paffixe(aux^.suivant)
                   end;
               if myPen then
               if fill_style=0 then polyLine(feuille.Handle,Points^,compt)
                               else polygon(feuille.Handle,Points^,compt)
                        else
                if fill_style=0 then feuille.polyLine(Slice(Points^,compt))
                                else feuille.polygon(Slice(Points^,compt));
               aux:=aux1;
               freemem(Points,compt*SizeOf(Tpoint));
          end;

     if fleche>0 then dessiner_fleches(feuille);
     if myPen then
        begin
                selectobject(feuille.Handle,oldpen);
                deleteobject(Thepen)
        end;
end;
{============}
procedure t_ligne.dessiner_fleches(feuille:TCanvas);
var x2,y2,x3,y3,x4,y4:real;
    aux:Paffixe;
begin
     if (fleche>0) and (PtsFleches^.tete<>nil)
     then  with feuille do
     begin
              aux:=Paffixe(PtsFleches^.tete);
              while aux<>nil do
                    begin
              x3:=aux^.x;y3:=aux^.y;aux:=Paffixe(aux^.suivant);if aux=nil then exit;
              x2:=aux^.x;y2:=aux^.y;aux:=Paffixe(aux^.suivant);if aux=nil then exit;
              x4:=aux^.x;y4:=aux^.y;aux:=Paffixe(aux^.suivant);if aux=nil then exit;
              aux:=Paffixe(aux^.suivant);
              MoveTo(Xentier(x3),Yentier(y3));
              LineTo(Xentier(x2),Yentier(y2));
              LineTo(Xentier(x4),Yentier(y4));
                    end
      end;
end;
{=============}
procedure T_ligne.fillLatex(style:byte; mode:byte);
var aux,aux1,Ak,Bk:Paffixe;
    compt,NbP:word;
    Xu,Yu,Xv,Yv,delta:real;
    LesPoints,LesReels:type_liste;
    j:integer;ok:boolean;

    function test(M:Paffixe):real;
    var V1,V2:Paffixe;
    begin
         V1:=soustraireC(M,Ak);
         V2:=New(Paffixe,init(Xu,Yu));
         CalcError:=false;
         test:=ajouter(multiplier(V1^.x*Xscale,V2^.x*Xscale),multiplier(V1^.y*Yscale,V2^.y*Yscale));
         Kill(Pcellule(V1));Kill(Pcellule(V2))
    end;

    function intersec(A,B:Paffixe):real;
    var V1,V2,V3:Paffixe;
    begin
         V1:=soustraireC(Bk,B);
         V2:=soustraireC(Bk,Ak);
         V3:=soustraireC(B,A);
         CalcError:=false;
         intersec:=diviser(det(V1,V3),det(V2,V3));
         Kill(Pcellule(V1));Kill(Pcellule(V2));Kill(Pcellule(V3));
    end;

    procedure ranger(x:real);
    var aux:Paffixe;
    begin
         aux:=Paffixe(LesReels.tete);
         while (aux<>nil) and (aux^.x<=x) do aux:=Paffixe(aux^.suivant);
         if aux=nil then LesReels.ajouter_fin(new(Paffixe,init(x,0)))
                    else LesReels.inserer(new(Paffixe,init(x,0)),aux)
    end;

    procedure fillConnexe(debut,fin:Paffixe);
    var A,B:Paffixe;
        k:word;
        positif:boolean;
        LeTest,Xa,Ya:real;
    begin
         LesPoints.init;
         LesReels.init;
         case style of
         2: begin Ak^.x:=Xmin;Ak^.y:=Ymax end;
         5: begin Ak^.x:=Xmin;Ak^.y:=Ymin end;
         6: begin Ak^.x:=Xmin;Ak^.y:=Ymax end;
         7: begin Ak^.x:=Xmin;Ak^.y:=Ymax end;
         end;
         for k:=1 to NbP do
             begin
                  Ak^.x:=Ak^.x+Xu;Ak^.y:=Ak^.y+Yu;
                  Bk^.x:=Ak^.x+Xv;Bk^.y:=Ak^.y+Yv;
                  A:=debut;
                  positif:= test(A)>0; B:=Paffixe(A^.suivant);
                  compt:=0;
                  while B<>fin do
                        begin
                             LeTest:=test(B);
                             if ((LeTest<0) and positif) or ((LeTest>0) and (not positif)) then
                                begin
                                     positif:=not positif;
                                     ranger(intersec(A,B));
                                     inc(compt);
                                end;
                             A:=B;
                             B:=Paffixe(B^.suivant);
                        end;
                  if fermee=0 then
                     begin
                          B:=debut;
                          LeTest:=test(B);
                             if ((LeTest<0) and positif) or ((LeTest>0) and (not positif)) then
                                begin
                                     ranger(intersec(A,B));
                                     inc(compt);
                                end;
                     end;
                  if not odd(compt) then
                     begin
                  A:=Paffixe(LesReels.tete);
                  while A<>nil do
                  begin
                       Xa:=-A^.x*Xv+Bk^.x;Ya:=-A^.x*Yv+Bk^.y;
                       LesPoints.ajouter_fin(new(Paffixe,init(Xa,Ya)));
                       A:=Paffixe(A^.suivant);
                  end;
                     end;
                 LesReels.detruire;
             end;
         A:=Paffixe(LesPoints.tete);
         if A=nil then exit;
         B:=Paffixe(A^.suivant);
         j:=0;
         while B<>nil do
               begin
                    inc(j);
                    case mode of
                    eps: write(f,Streel(Xeps(A^.X)),' ',Streel(Yeps(A^.Y)),' m ',
                                      Streel(Xeps(B^.X)),' ',Streel(Yeps(B^.Y)),' l s ');
                    LaTex: write(f,'\path('+Streel(Xtex(A^.X)),',',Streel(Ytex(A^.Y)),')(',
                                      Streel(Xtex(B^.X)),',',Streel(Ytex(B^.Y)),')');
                    pgf: write(f,'\pgfxyline('+Streel(Xtex(A^.X)),',',Streel(Ytex(A^.Y)),')(',
                                     Streel(Xtex(B^.X)),',',Streel(Ytex(B^.Y)),')');
                    end;
                    if j=3 then begin writeln(f); j:=0 end;
                    A:=Paffixe(B^.suivant);
                    if A<>nil then B:=Paffixe(A^.suivant) else B:=nil;

               end;

         LesPoints.detruire;
         if j>0 then writeln(f);
    end;
begin
     aux:=Paffixe(liste_points^.tete);
     if aux=nil then exit;
     delta:=0.15;
     New(Ak,init(0,0));
     New(Bk,init(0,0));
     case style of
     2 {bdiag}: begin
             Xu:=delta/(sqrt(2)*Xscale);Yu:=-delta/(sqrt(2)*Yscale);
             Xv:=Xu;Yv:=-Yu;
             NbP:=round(1+abs((Xmax-Xmin)*Xscale+(Ymax-Ymin)*Yscale)/sqrt(2)/delta);
                end;
     5 {fdiag}: begin
             Xu:=delta/(sqrt(2)*Xscale);Yu:=delta/(sqrt(2)*Yscale);
             Xv:=Xu;Yv:=-Yu;
             NbP:=round(1+abs((Xmax-Xmin)*Xscale+(Ymax-Ymin)*Yscale)/sqrt(2)/delta);
                end;
     6 {horizontal}: begin
             Xu:=0;Yu:=-delta/(Yscale);
             Xv:=-Yu;Yv:=0;
             NbP:=round(1+abs((Ymax-Ymin)*Yscale)/delta);
                end;
     7 {vertical}: begin
             Xu:=delta/Xscale;Yu:=0;
             Xv:=0;Yv:=Xu;
             NbP:=round(1+abs((Xmax-Xmin)*Xscale)/delta);
                end;
     else exit;
     end;
     ok:=false;
         if epaisseur_courante<>2 //2=thinlines
            then
                begin
                     case mode of
                     eps: write(f, ' thinlines ');
                     Latex:write(f, '\thinlines ');
                     pgf: write(f, '\pgfsetlinewidth{0.2pt}');
                     end;
                     epaisseur_courante:=2;ok:=true;
                end;
         if gestion_couleur and (fill_color<>couleur_courante)
            then
                begin
                     case mode of
                     eps:write(f, StrColor(fill_color,eps));
                     LaTeX: write(f, '\color',StrColor(fill_color,latex));
                     pgf:  write(f,'\pgfsetstrokecolor'+StrColor(fill_color,pgf));
                     end;
                     couleur_courante:=fill_color;ok:=true;
                end;
     if ok then writeln(f);
     while aux<>nil do
          begin
               compt:=1;
               aux1:=Paffixe(aux^.suivant);
               while (aux1<>nil) and (not IsJump(aux1)) do begin inc(compt);aux1:=Paffixe(aux1^.suivant) end;
               if compt>2 then FillConnexe(aux,aux1);
               while (aux1<>nil) and (IsJump(aux1)) do aux1:=Paffixe(aux1^.suivant);
               aux:=aux1;
          end;
     Kill(Pcellule(Ak));Kill(Pcellule(Bk));
end;
{======================================}
procedure T_ligne.enregistrer_latex;
var aux1:Paffixe;
    commande,chaine:string;
    points,nb_col,col_dep:word;
    ok,old:boolean;
begin
     if liste_points^.tete=nil then exit;
     aux1:=Paffixe(liste_points^.tete);
     if aux1=nil then exit;
     if fill_style=0
        then t_element.enregistrer_latex
        else
            begin
                 if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
                 case fill_style of
                      2: fillLatex(2,LaTex);
                      3: begin fillLatex(6,LaTex);fillLatex(7,LaTex); end;
                      4: begin fillLatex(2,LaTex);fillLatex(5,LaTex); end;
                      5: FillLatex(5,LaTex);
                      6: fillLatex(6,LaTex);
                      7: fillLatex(7,LaTex);
                 end;
                 old:=inclure_commentaires;
                 inclure_commentaires:=false;
                 t_element.enregistrer_latex;
                 inclure_commentaires:=old;
            end;
     if ligne_style=-1 then exit;
     fleches_latex(LaTeX);
     nb_col:=0;
             case ligne_style of
              0: begin commande:='\path'; col_dep:=5 end;
              1: begin commande:=TeXdashStyle;col_dep:=14 end;
              2: begin commande:=TexDotStyle;col_dep:=19 end;
              end;

          points:=0;
          while aux1<>nil do
          begin
               if not IsJump(aux1) then
                begin
                ok:=false;
                if (points=0) and (aux1^.suivant<>nil) and (not IsJump(Paffixe(aux1^.suivant)))
                    then begin  write(f,commande); nb_col:=col_dep;ok:=true end;
                if (points<>0) or ok then
                  begin
                  chaine:=streel(Xtex(aux1^.x))+','+streel(Ytex(aux1^.y));
                  inc(nb_col,length(chaine)+2);
                  write(f,'(',chaine,')');inc(points);
                  if (aux1^.suivant=nil) then {writeln(f)}
                   else
                       if (not IsJump(Paffixe(aux1^.suivant))) and (points>=max_points)
                          then begin
                          writeln(f);
                          write(f,commande+'('+chaine+')');nb_col:=col_dep+length(chaine)+2;
                          points:=1;
                          end
                          else if (nb_col>colonnes) and (not IsJump(Paffixe(aux1^.suivant)))
                                  then begin writeln(f);nb_col:=0 end;
                   end;
                end else begin if points>0 then writeln(f);points:=0 end;

               aux1:=Paffixe(aux1^.suivant);
          end;
          if nb_col<>0 then writeln(f);
end;
{============}
procedure T_ligne.parametres_pgf;
var old:boolean;
begin
     if fill_style=0
        then t_element.enregistrer_pgf
        else
            begin
                 if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
                 case fill_style of
                      2: fillLatex(2,pgf);
                      3: begin fillLatex(6,pgf);fillLatex(7,pgf); end;
                      4: begin fillLatex(2,pgf);fillLatex(5,pgf); end;
                      5: FillLatex(5,pgf);
                      6: fillLatex(6,pgf);
                      7: fillLatex(7,pgf);
                 end;
                 old:=inclure_commentaires;
                 inclure_commentaires:=false;
                 t_element.enregistrer_pgf;
                 inclure_commentaires:=old;
            end;
     //if ligne_style<>-1 then fleches_LaTeX(pgf);
     if ligne_style<>style_Courant then
        begin
             case ligne_style of
              0: writeln(f, '\pgfsetdash{}{0pt}');
              1: writeln(f, '\pgfsetdash{{5pt}{3pt}}{0pt}');
              2: writeln(f, '\pgfsetdash{{0pt}{3pt}}{0pt}');
              end;
              if ligne_style<>-1 then Style_Courant:=ligne_style
        end;
end;
{=============}
procedure T_ligne.enregistrer_pgf;
var aux1:Paffixe;
    points:integer;
    ligneVide:boolean;   //indique si la ligne comporte au plus 2 points
    fillColor,fillColor1:longint;

    procedure compt;
    begin
         if points> 4 then
            begin
                 points:=0;
                 writeln(f)
            end else inc(points,1)
    end;

    procedure trace;
    begin
          LigneVide:=true;
          while (aux1<>nil) and IsJump(aux1) do aux1:=Paffixe(aux1^.suivant);
           If aux1<>nil then
              If (aux1^.suivant<>nil) and (not Isjump(Paffixe(aux1^.suivant)))
              then
                   if (aux1^.suivant^.suivant=nil) or (Isjump(Paffixe(aux1^.suivant^.suivant)))
                      then
                          begin  {il n'y a que 2 points}
                               write(f,'\pgfxyline(',streel(Xtex(aux1^.x))+','+streel(Ytex(aux1^.y))+')(',
                               streel(Xtex(Paffixe(aux1^.suivant)^.x))+','+streel(Ytex(Paffixe(aux1^.suivant)^.y))+')');
                               aux1:=Paffixe(aux1^.suivant^.suivant);
                               compt
                          end
                      else
                   begin
                        write(f, '\pgfmoveto{\pgfxy(',streel(Xtex(aux1^.x))+','+streel(Ytex(aux1^.y))+')}');
                        compt; LigneVide:=false;
                        aux1:=Paffixe(aux1^.suivant);
                        while (aux1<>nil) and (not IsJump(aux1)) do
                         begin
                              if (fermee=1) and (aux1^.suivant=nil)
                                 then write(f,'\pgfclosepath')
                                 else write(f, '\pgflineto{\pgfxy('+streel(Xtex(aux1^.x))+','+streel(Ytex(aux1^.y))+')}');
                              compt;
                              aux1:=Paffixe(aux1^.suivant);
                        end;
                       if gestion_couleur and (fill_style=1) and (aux1<>nil) and (aux1^.y<>jump^.y) then
                       fillColor:=Rgb(Round(aux1^.y*GetRvalue(fillColor1)),round(aux1^.y*GetGvalue(fillColor1)),
                                              Round(aux1^.y*GetBvalue(fillColor1)));
                   end
              else aux1:=Paffixe(aux1^.suivant);
    end;

begin
     if liste_points^.tete=nil then exit;
     aux1:=Paffixe(liste_points^.tete);
     if aux1=nil then exit;
     parametres_pgf;

     if fill_color<9 then fillColor1:=palette[fill_color].code else fillColor1:=fill_color;
     if gestion_couleur then fillColor:=fillColor1
                       else  fillColor:=Rgb(255,255,255);
     if (ligne_style=-1) and (fill_style<>1) then exit;
     points:=0;
     Repeat
                   trace;
                   if not Lignevide
                   then
                   if fill_style=1
                              then begin
                                        if fillcolor<>fillcolor_courant
                                           then
                                           begin
                                                fillcolor_courant:=fillcolor;
                                                write(f,'\pgfsetfillcolor'+StrColor(fillcolor,pgf));
                                           end;
                                        if ligne_style=-1 then writeln(f,'\pgffill') else writeln(f, '\pgffillstroke');
                                     end
                              else writeln(f,'\pgfstroke')
     until aux1=nil;
     if LigneVide and (points>0) then writeln(f);
     if ligne_style<>-1 then fleches_latex(pgf);
end;
{============}
procedure T_ligne.parametres_eps;
var old:boolean;
begin
     if fill_style=0
        then t_element.enregistrer_eps
        else
            begin
                 if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
                 case fill_style of
                      2: fillLatex(2,eps);
                      3: begin fillLatex(6,eps);fillLatex(7,eps); end;
                      4: begin fillLatex(2,eps);fillLatex(5,eps); end;
                      5: FillLatex(5,eps);
                      6: fillLatex(6,eps);
                      7: fillLatex(7,eps);
                 end;
                 old:=inclure_commentaires;
                 inclure_commentaires:=false;
                 t_element.enregistrer_eps;
                 inclure_commentaires:=old;
            end;
     //if ligne_style<>-1 then fleches_latex(eps);
     if ligne_style<>style_Courant then
        begin
             case ligne_style of
              0: writeln(f, ' SolidLine ');
              1: writeln(f, ' DashLine ');
              2: writeln(f, ' DotLine ');
              end;
              if ligne_style<>-1 then Style_Courant:=ligne_style
        end;
end;
{=============}
procedure T_ligne.enregistrer_eps;
var aux1,aux2:Paffixe;
    points:integer;
    ligneVide:boolean;    {indique si la ligne contient au plus 1 point}
    fillColor,fillColor1:longint;

    procedure compt;
    begin
         if points> 5 then
            begin
                 points:=0;
                 writeln(f)
            end else inc(points,1)
    end;

    procedure trace;
    begin
          aux2:=aux1;
          ligneVide:=true;
          while (aux1<>nil) and IsJump(aux1) do aux1:=Paffixe(aux1^.suivant);
           If aux1<>nil then
              If (aux1^.suivant<>nil) and (not Isjump(Paffixe(aux1^.suivant)))
              then
              begin
                   write(f, streel(XEps(aux1^.x))+' '+streel(YEps(aux1^.y))+' m ');
                   compt;
                   ligneVide:=false;
                   aux1:=Paffixe(aux1^.suivant);
                   while (aux1<>nil) and (not IsJump(aux1)) do
                         begin
                              if (fermee=1) and (aux1^.suivant=nil)
                                 then write(f, 'closepath ')
                                 else write(f, streel(XEps(aux1^.x))+' '+streel(YEps(aux1^.y))+' l ');
                              compt;
                              aux1:=Paffixe(aux1^.suivant);
                         end;
                   if gestion_couleur and (fill_style=1) and (aux1<>nil) and (aux1^.y<>jump^.y) then
                      fillColor:=Rgb(Round(aux1^.y*GetRvalue(fillColor1)),round(aux1^.y*GetGvalue(fillColor1)),
                                              Round(aux1^.y*GetBvalue(fillColor1)));

              end
              else aux1:=Paffixe(aux1^.suivant);
    end;

begin
     if liste_points^.tete=nil then exit;
     aux1:=Paffixe(liste_points^.tete);
     if aux1=nil then exit;
     parametres_eps;
     points:=0;
     if fill_color<9 then fillColor1:=palette[fill_color].code else fillColor1:=fill_color;
     fillColor:=fillColor1;
     if gestion_couleur then fillColor:=fillColor1
                       else  fillColor:=Rgb(255,255,255);
     if (ligne_style=-1) and (fill_style<>1) then exit;
     Repeat
                   trace;
                   if not Lignevide
                   then
                   if (ligne_style<>-1)
                      then
                           if fill_style=1
                              then write(f,'gs ',StrColor(fillColor,eps), 'fill gr s ')
                              else write(f, 's ')

                      else if fill_style=1
                              then write(f, StrColor(fillColor,eps),'fill s ',StrColor(couleur_courante,eps));
     until aux1=nil;
     if (not Lignevide) and (points>0) then writeln(f);
     if ligne_style<>-1 then fleches_latex(eps);
 end;
{============}
procedure t_ligne.fleches_latex(mode:byte);
var x1,y1,x2,y2,x3,y3,x4,y4:real;
    aux:Paffixe;
    ok:boolean;
begin
     if (fleche>0) and (PtsFleches^.tete<>nil)
     then
     begin    ok:=false;
              aux:=Paffixe(PtsFleches^.tete);
              if aux<>nil then
              case mode of
              eps:  if style_courant<>0 then begin write(f,' SolidLine '); style_courant:=0 end;

              pgf:  begin
                         if style_courant<>0
                           then
                               begin
                                    write(f, '\pgfsetdash{}{0pt}');
                                    style_courant:=0; ok:=true;
                               end;
                         if fillcolor_courant<>couleur
                            then
                                begin
                                     write(f,'\pgfsetfillcolor'+StrColor(couleur,pgf));
                                     fillcolor_courant:=couleur;ok:=true;
                                end;
                    end;
              end;
              if ok then writeln(f);
              while aux<>nil do
                    begin
              x3:=aux^.x;y3:=aux^.y;aux:=Paffixe(aux^.suivant);if aux=nil then exit;
              x2:=aux^.x;y2:=aux^.y;aux:=Paffixe(aux^.suivant);if aux=nil then exit;
              x4:=aux^.x;y4:=aux^.y;aux:=Paffixe(aux^.suivant);if aux=nil then exit;
              x1:=(x3+x4)/4+x2/2;y1:=(y3+y4)/4+y2/2;aux:=Paffixe(aux^.suivant);
              case mode of
              eps:  begin
                              writeln(f,streel(Xeps(x3))+' '+streel(Yeps(y3))+' m '+
                                     streel(Xeps(x2))+' '+streel(Yeps(y2))+' l '+
                                     streel(Xeps(x4))+' '+streel(Yeps(y4))+' l '+
                                     streel(Xeps(x1))+' '+streel(Yeps(y1))+' l closepath gs fill gr s')
                    end;
              LaTeX:writeln(f,'\path('+streel(Xtex(x3))+','+streel(Ytex(y3))+')('+streel(Xtex(x2))+','+
              streel(Ytex(y2))+')('+ streel(Xtex(x4))+','+streel(Ytex(y4))+')');
              pgf: begin
                        writeln(f,'\pgfmoveto{\pgfxy('+streel(Xtex(x3))+','+streel(Ytex(y3))+')}\pgflineto{\pgfxy('+streel(Xtex(x2))+','
              +streel(Ytex(y2))+')}\pgflineto{\pgfxy('+ streel(Xtex(x4))+','+streel(Ytex(y4))+')}\pgflineto{\pgfxy('+
              streel(Xtex(x1))+','+streel(Ytex(y1))+')}\pgfclosepath\pgffillstroke');
                  end;
              end;
                  end;
      end;
end;
{=======================}
function t_ligne.parametres_pst;
var ok:boolean;
    chaine:string;
    oldFill:integer;
begin
     chaine:=t_element.parametres_pst;
     ok:=chaine<>'';
     if not gestion_couleur
        then
            begin
                 oldFill:=fill_color;
                 if fill_style=1 then fill_color:=1 else fill_color:=0;
            end;
     if (ligne_style<>style_courant) then
        begin if ok then chaine:=chaine+',';
              chaine:=chaine+'linestyle='+UnStyle[ligne_style];
              ok:=true;
              style_courant:=ligne_style
           end;
        if (fill_style<>fill_courant) then
        begin if ok then chaine:=chaine+',';
              chaine:=chaine+'fillstyle='+StyleFill[fill_style];
              ok:=true;
              fill_courant:=fill_style
           end;
        if (fill_style<>0)  then
        begin
             if (fill_style=1) and (fill_color<>fillcolor_courant)
                then
                begin
             if ok then chaine:=chaine+',';
                         chaine:=chaine+'fillcolor='+StrColor(fill_color,pstricks);
             fillcolor_courant:=fill_color;
                end else
             if (fill_style<>1) and (fill_color<>hatchcolor_courant)
                then
                begin
              if ok then chaine:=chaine+',';
                         chaine:=chaine+'hatchcolor='+StrColor(fill_color,pstricks);
              hatchcolor_courant:=fill_color
                end;

           end;
     parametres_pst:=chaine;
     if not gestion_couleur  then fill_color:=oldFill
end;
{============}
procedure T_ligne.enregistrer_pst;
var aux1,aux2:Paffixe;
    commande,chaine:string;
    points,nb_col,col_dep,oldMaxPoints,oldfleche:word;
    ok:boolean;
    fillColor,fillColor1:longint;
begin
     if liste_points^.tete=nil then exit;
     t_element.enregistrer_pst;
     aux1:=Paffixe(liste_points^.tete);
     if ligne_style=-1 then begin oldfleche:=fleche; fleche:=0 end;
     if aux1=nil then exit;
     if fill_color<9 then fillColor1:=palette[fill_color].code else fillColor1:=fill_color;
     if (fill_style<>0) or (fleche<>0) or (fermee=1) then begin oldMaxPoints:=max_points; max_points:=1000 end;
     if (fermee=0) or (fleche<>0) then begin commande:='\psline';col_dep:=7 end
                 else begin commande:='\pspolygon';col_dep:=10 end;
     if fleche=1 then begin inc(col_dep,5); commande:=commande+'{->}' end
                 else
     if fleche=2 then begin inc(col_dep,6); commande:=commande+'{<->}';end;
     points:=0;nb_col:=0;
          while aux1<>nil do
          begin
               aux2:=aux1;
               while (aux2<>nil) and (not Isjump(aux2)) do aux2:=Paffixe(aux2^.suivant);
               if (fill_style=1) and (aux2<>nil) and (aux2^.y<>jump^.y) then
                          begin
                               fillColor:=Rgb(Round(aux2^.y*GetRvalue(fillColor1)),round(aux2^.y*GetGvalue(fillColor1)),
                                              Round(aux2^.y*GetBvalue(fillColor1)));
                               if fillColor<>fillColor_courant
                                  then
                                      begin
                                           writeln(f,'\psset{fillcolor='+StrColor(fillColor,pstricks)+'}');
                                           fillColor_courant:=fillColor
                                      end;
                          end;
               if not IsJump(aux1) then
                begin
                     ok:=false;
                     if (points=0) and (aux1^.suivant<>nil) and (not IsJump(Paffixe(aux1^.suivant)))
                        then begin  write(f,commande); nb_col:=col_dep;ok:=true end;
                     if (points<>0) or ok then
                        begin
                             chaine:=streel(Xtex(aux1^.x))+','+streel(Ytex(aux1^.y));
                             inc(nb_col,length(chaine)+2);
                             if  ((aux1^.suivant=nil) or IsJump(Paffixe(aux1^.suivant)))
                                 and (fermee=1) and (fleche=0) and (points>2)
                                 then //on n'exporte pas le dernier point avec pspolygon
                                 else begin write(f,'(',chaine,')');inc(points); end;
                             if (aux1^.suivant=nil) then {writeln(f)}
                                else
                                    if (not IsJump(Paffixe(aux1^.suivant))) and (points>=max_points)
                                       then begin
                                                 writeln(f);
                                                 write(f,commande+'('+chaine+')');nb_col:=col_dep+length(chaine)+2;
                                                 points:=1;
                                            end
                                       else
                                           if (nb_col>colonnes) and (not IsJump(Paffixe(aux1^.suivant)))
                                           then begin writeln(f);nb_col:=0 end;
                        end;
                end
                else
                    begin
                         if points>0 then writeln(f);points:=0;
                    end;

               aux1:=Paffixe(aux1^.suivant);
          end;
          if nb_col<>0 then writeln(f);
          if (fill_style<>0) or (fleche<>0) then max_points:=oldMaxPoints;
          if ligne_style=-1 then fleche:=oldfleche;
end;
{==================}
function t_ligne.parametres_teg:string;
var chaine:string;
begin
     chaine:=t_element.parametres_teg;
     if fleche<>Arrows then
        begin Arrows:=fleche; chaine:=chaine+',Set(Arrows,'+Streel(fleche)+')';end;
      if ligne_style<>LineStyle then
         begin LineStyle:=ligne_style; chaine:=chaine+',Set(LineStyle,'+Streel(ligne_style)+')';end;
      if NbPoints<>nb_points then
         begin NbPoints:=nb_points; chaine:=chaine+',Set(NbPoints,'+Streel(nb_points)+')';end;
      if FillStyle<>fill_style then
         begin FillStyle:=fill_style; chaine:=chaine+',Set(FillStyle,'+Streel(fill_style)+')';end;
      if FillColor<>fill_color then
         begin FillColor:=fill_color; chaine:=chaine+',Set(FillColor,'+Streel(fill_color)+')';end;
      parametres_teg:=chaine
end;
{==================}
procedure T_Ligne.enregistrer_teg;
begin
     t_element.enregistrer_teg;
     if cat<>cat_cercle then write(f,fermee,car_special,Streel(rayon),car_special);
end;
{=============}
destructor t_ligne.detruire;
begin
     if PtsFleches<>nil then dispose(PtsFleches,detruire);
     t_element.detruire;
end;

var i:integer;
Initialization;
     LesCommandes^.ajouter_fin(new(PEpsCoord,init('EpsCoord')));
     LesCommandes^.ajouter_fin(new(PSaveAttr,init('SaveAttr')));
     LesCommandes^.ajouter_fin(new(Prestoreattr,init('RestoreAttr')));
     LesCommandes^.ajouter_fin(new(PGetAttr,init('GetAttr')));

     PLineStyle:=new(Pconstante,init('LineStyle',new(Paffixe,init(0,0)),false));
     PWidth:=(new(Pconstante,init('Width',new(Paffixe,init(2,0)),false)));
     PColor:=(new(Pconstante,init('Color',new(Paffixe,init(0,0)),false)));
     PtMin:=(new(Pconstante,init('tMin',new(Paffixe,init(-5,0)),false)));
     PtMax:=(new(Pconstante,init('tMax',new(Paffixe,init(5,0)),false)));
     PNbPoints:=(new(Pconstante,init('NbPoints',new(Paffixe,init(50,0)),false)));
     PDotStyle:=(new(Pconstante,init('DotStyle',new(Paffixe,init(0,0)),false)));
     PLabelstyle:=(new(Pconstante,init('LabelStyle',new(Paffixe,init(0,0)),false)));
     PArrows:=(new(Pconstante,init('Arrows',new(Paffixe,init(0,0)),false)));
     PFillStyle:=(new(Pconstante,init('FillStyle',new(Paffixe,init(0,0)),false)));
     PFillColor:=(new(Pconstante,init('FillColor',new(Paffixe,init(1,0)),false)));
     PAutorecalc:=(new(Pconstante,init('AutoReCalc',new(Paffixe,init(1,0)),false)));
     PLabelSize:=(new(Pconstante,init('LabelSize',new(Paffixe,init(3,0)),false)));
     PLabelAngle:=(new(Pconstante,init('LabelAngle',new(Paffixe,init(0,0)),false)));
     Pxylabelsep:=(new(Pconstante,init('xylabelsep',new(Paffixe,init(0.105,0)),false)));
     Pxyticks:=(new(Pconstante,init('xyticks',new(Paffixe,init(0.1,0)),false)));
     PxylabelPos:=(new(Pconstante,init('xylabelpos',new(Paffixe,init(9,0)),false)));//left+bottom
     PPenMode:=(new(Pconstante,init('PenMode',new(Paffixe,init(0,0)),false)));//left+bottom
     PForMinToMax:=(new(Pconstante,init('ForMinToMax',new(Paffixe,init(0,0)),false)));
     PComptGraph:=(new(Pconstante,init('ComptGraph',new(Paffixe,init(0,0)),false)));

     LesConstantes^.ajouter_fin(PLabelStyle);
     LesConstantes^.ajouter_fin(PDotStyle);
     LesConstantes^.ajouter_fin(PLinestyle);
     LesConstantes^.ajouter_fin(Pwidth);
     LesConstantes^.ajouter_fin(Pcolor);
     LesConstantes^.ajouter_fin(PArrows);
     LesConstantes^.ajouter_fin(PFillStyle);
     LesConstantes^.ajouter_fin(PFillColor);
     LesConstantes^.ajouter_fin(PNbPoints);
     LesConstantes^.ajouter_fin(Ptmin);
     LesConstantes^.ajouter_fin(Ptmax);
     LesConstantes^.ajouter_fin(PAutoReCalc);
     LesConstantes^.ajouter_fin(PLabelSize);
     LesConstantes^.ajouter_fin(PLabelAngle);
     LesConstantes^.ajouter_fin(Pxylabelsep);
     LesConstantes^.ajouter_fin(Pxyticks);
     LesConstantes^.ajouter_fin(Pxylabelpos);
     LesConstantes^.ajouter_fin(PPenMode);
     LesConstantes^.ajouter_fin(PForMinToMax);
     LesConstantes^.ajouter_fin(PComptGraph);
     Initialiser;
     DefaultSettings;
     ListAttr:=TList.Create

Finalization

     for i:=0 to ListAttr.Count-1 do
         Dispose(ListAttr.items[i]);
     ListAttr.free
End.