{Copyright (C) 2005-2006 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version 
ultrieure choisie par vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
 Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme;
 si ce n'est pas le cas, crivez  la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 }


unit graph2_7; {Dfinition des lments graphiques partie 2 }
INTERFACE
Uses Sysutils,Graphics,Unite1{calculs},listes2,complex3,analyse4,command5,graph1_6,dialogs;

type
     t_axes=object(t_ligne)  {cat 1}
                    O_x,O_y,gradX,gradY,Xmin,Xmax,Ymin,Ymax:real;
                    NbTraitsXg, NbTraitsXd,NbTraitsYh, NbTraitsYb:longint;
                    ticks, labelsep:real;
                    size_label,xlabelpos,ylabelpos:byte;

                    constructor init(const Anom,UneCommande:string);
                    procedure lireAttributs;virtual;
                    procedure fixeAttributs;virtual;
                    procedure recalculer;virtual;
                    procedure dessiner(feuille: Tcanvas); virtual;
                    procedure parametres_scr(feuille:TCanvas;var coul:longint);virtual;
                    procedure enregistrer(format:byte);
                    procedure enregistrer_latex; virtual;
                    procedure enregistrer_pst;  virtual;
                    procedure enregistrer_eps; virtual;
                    procedure enregistrer_pgf; virtual;
                    function parametres_teg:string;virtual;
                    end;
     Paxes=^t_axes;

     t_grille=object(t_axes)   {cat 2}
                    constructor init(const Anom,UneCommande:string);
                    procedure dessiner(feuille: Tcanvas);  virtual;
                    procedure enregistrer_latex; virtual;
                    procedure enregistrer_pst; virtual;
                    procedure enregistrer_eps; virtual;
                    procedure enregistrer_pgf; virtual;
                    function parametres_teg:string;virtual;
                    end;
     Pgrille=^t_grille;

      t_droite=object(t_ligne)    {cat 6}

              constructor init(const UnNom, UneCommande:string);
              procedure recalculer;virtual;
              end;
     Pdroite=^t_droite;


     t_cercle=object(t_ligne)     {cat 7}

              Xcentre,Ycentre:real;

              constructor init(const UnNom, UneCommande:string);
              procedure recalculer;virtual;
              procedure enregistrer_latex; virtual;
              procedure enregistrer_pst;virtual;
              procedure enregistrer_eps; virtual;
              procedure enregistrer_pgf; virtual;
              end;
     Pcercle=^t_cercle;

     t_Arc=object(t_ligne)     {cat 7}
              angleA,angleB:real;
              Sens:integer;

              constructor init(const UnNom, UneCommande:string;LeSens:integer);
              procedure recalculer;virtual;
              procedure enregistrer_latex; virtual;
              procedure enregistrer_pst;virtual;
              procedure enregistrer_teg;virtual;
              procedure enregistrer_eps; virtual;
              procedure enregistrer_pgf; virtual;
              end;
     PArc=^t_Arc;

    t_parametree=object(t_Ligne)      {cat 3}
                    minT,maxT:real;
                    division:byte; saut:byte;
                    ParcourtFenetre:boolean;

                    constructor init(const UnNom, UneCommande:string;diviser,discont:byte);
                    procedure ConstruitArbre(Unarbre:Pcorps);virtual;
                    procedure recalculer;virtual;
                    procedure lireAttributs;virtual;
                    procedure fixeAttributs;virtual;
                    procedure clip;virtual;
                    function parametres_teg:string;virtual;
                    procedure enregistrer_teg;virtual;
                    
                    end;
     Pparametree=^t_parametree;

     t_cartesienne=object(t_parametree)


                    constructor init(const UnNom, UneCommande:string;diviser,discont:byte);
                    procedure ConstruitArbre(Unarbre:Pcorps);virtual;
                    //procedure enregistrer_teg;virtual;

                    end;
     Pcartesienne=^t_cartesienne;

     t_polaire=object(t_parametree)


                    constructor init(const UnNom, UneCommande:string;diviser,discont:byte);
                    procedure ConstruitArbre(Unarbre:Pcorps);virtual;
                    //procedure enregistrer_teg;virtual;

                    end;
     Ppolaire=^t_polaire;

     Pbezier=^t_bezier;
     t_bezier= object(t_parametree)

              control3: boolean;

              constructor init(const UnNom, UneCommande:string);
              procedure recalculer;virtual;
              //procedure enregistrer_latex; virtual;
              procedure enregistrer_pst; virtual;
              procedure enregistrer_eps; virtual;
              procedure enregistrer_pgf; virtual;
              function parametres_teg:string;virtual;
              end;

     T_Spline= object(t_parametree)

               constructor init(const UnNom, UneCommande:string);
               procedure recalculer;virtual;
               function parametres_teg:string;virtual;
               end;
     PSpline=^T_Spline;

     t_equadif=object(t_parametree)      {cat 3}
                    mode:byte; {0= (x,y), 1=(t,x), 2=(t,y) }

                    constructor init(const UnNom, UneCommande:string;Unmode:byte);
                    procedure ConstruitArbre(Unarbre:Pcorps);virtual;
                    procedure recalculer;virtual;
                    procedure enregistrer_teg;virtual;
                    end;
     PEquaDif=^t_EquaDif;

     t_implicit=object(t_ligne)      {cat 3}
                    //ligne_style:byte;
                    GridX,GRidY:word;

                    constructor init(const UnNom, UneCommande:string);
                    procedure ConstruitArbre(Unarbre:Pcorps);virtual;
                    //procedure lireAttributs;virtual;
                    //procedure fixeAttributs;virtual;
                    procedure recalculer;virtual;
                    procedure dessiner(feuille: Tcanvas);virtual;
                    function parametres_pst:string;virtual;
                    procedure enregistrer_latex; virtual;
                    procedure enregistrer_pst;virtual;
                    procedure enregistrer_eps; virtual;
                    procedure enregistrer_pgf; virtual;
                    function parametres_teg:string;virtual;
                    end;
     Pimplicit=^t_implicit;

     t_utilisateur= object(t_parametree)
                    enfants:type_liste;
                    style_label,point_style,size_label:byte;
                    angle_label:real;

                    constructor init(const UnNom, UneCommande:string;Acode:integer);
                    procedure ConstruitArbre(Unarbre:Pcorps);virtual;
                    procedure lireAttributs;virtual;
                    procedure fixeAttributs;virtual;
                    procedure recalculer;virtual;
                    procedure dessiner(feuille: Tcanvas); virtual;
                    procedure enregistrer_latex; virtual;
                    function parametres_pst:string;virtual;
                    procedure enregistrer_pst;virtual;
                    procedure enregistrer_eps; virtual;
                    procedure enregistrer_pgf; virtual;
                    function parametres_teg:string;virtual;
                    procedure enregistrer_teg; virtual;
                    destructor detruire;virtual;
                    end;
     Putilisateur=^T_utilisateur;


 IMPLEMENTATION
uses math;
{==========================================Type t_axes ==================}
constructor t_axes.init(const Anom,UneCommande:string);
begin
     t_ligne.init(Anom,UneCommande,0,0);
     cat:=cat_axes;
end;
{=======================}
procedure t_axes.fixeAttributs;
begin
      t_ligne.fixeAttributs;
      size_label:=LabelSize;
      ticks:=xyticks;
      labelsep:=xylabelsep;
      ylabelpos:=xyLabelPos and 3;
      xlabelpos:=(xylabelpos and 12) div 4;
end;
{========================}
procedure t_axes.lireAttributs;
begin
     LabelSize:=size_label;
     xyticks:=ticks;
     xylabelsep:=labelsep;
     xyLabelpos:=ylabelpos+4*xlabelpos;
     t_ligne.lireAttributs
end;
{========================}
procedure t_axes.recalculer;
var aux:Paffixe;
    F:Pexpression;
    denom:longint;
begin
     t_element.recalculer;
     aux:=Paffixe(liste_points^.tete);
     if aux=nil then exit;
     Xmin:=PXmin^.affixe^.x; Xmax:=PXmax^.affixe^.x; Ymin:=PYmin^.affixe^.x; Ymax:=PYmax^.affixe^.x;
     O_x:=aux^.x;O_y:=aux^.y;
     aux:= paffixe(aux^.suivant);
     if aux<>nil then
        begin
             gradX:=aux^.x;gradY:=aux^.y;
             if gradX<0 then gradX:=-gradX;
             if gradY<0 then gradY:=-gradY;
        end else exit;
        if gradX=0 then
                   begin
                        if (O_x<Xmin) then O_x:=Xmin;
                        if (O_x>Xmax) then O_x:=Xmax;
                   end
                   else
                       if (O_x<Xmin) or (Xmax<O_x) then
                          begin
                          O_x:=O_x+Floor((Xmax+Xmin-2*O_x)/GradX/2)*gradX;
                          if (O_x<Xmin) then O_x:=Xmin;
                          if (O_x>Xmax) then O_x:=Xmax;
                          end;
        if gradY=0 then
                   begin
                        if (O_y<Ymin) then O_y:=Ymin;
                        if (O_y>Ymax) then O_y:=Ymax;
                   end
                   else
                       if (O_y<Ymin) or (Ymax<O_y) then
                          begin
                          O_y:=O_y+Floor((Ymax+Ymin-2*O_y)/GradY/2)*gradY;
                          if (O_y<Ymin) then O_y:=Ymin;if (O_y>Ymax) then O_y:=Ymax;
                          end;
     liste_points^.detruire;
     new(F,init);
     F^.definir('[Xmin+i*('+Streel(O_y)+'),Xmax+i*('+Streel(O_y)+'),jump,'+Streel(O_x)+'+i*Ymin,'+Streel(O_x)+'+i*Ymax]');
     liste_points^.ajouter_fin(F^.evaluer);
     dispose(F,detruire);
     if fleche>0 then calcul_fleches;
     denom:= round(gradX*Xscale*10000);
     if denom=0 then begin NbTraitsXg:=0; NbTraitsXd:=0 end
                else
                begin
     NbTraitsXd:= 1+ round((Xmax-O_x)*Xscale*10000) div denom;
     NbTraitsXg:= round((O_x-Xmin)*Xscale*10000) div denom;
                 end;
     denom:= round(gradY*Yscale*10000);
     if denom=0 then begin NbTraitsYh:=0; NbTraitsYb:=0 end
                else
                begin
     NbTraitsYh:= 1+ round((Ymax-O_y)*Yscale*10000) div denom;
     NbTraitsYb:= round((O_y-Ymin)*Yscale*10000) div denom;
                end;
     ticks:=min(min(ticks,2*Yscale*(O_y-Ymin)+margeB),2*Yscale*(Ymax-O_y)+margeH);
     ticks:=min(min(ticks,2*Xscale*(O_x-Xmin)+margeG),2*Xscale*(Xmax-O_x)+margeD);

     //isLabelx:= (labelsep+ticks/2)<=(O_y-Ymin)*Yscale+margeB;
     //isLabely:= (ticks/2+labelsep)<=(O_x-Xmin)*Xscale+margeG;
end;
{=======================}
procedure t_axes.parametres_scr(feuille:TCanvas;var coul:longint);
begin
        t_ligne.parametres_scr(feuille,coul);
        feuille.font.Color:=coul;
        feuille.font.size:=size_label*2+4;
end;
{======================}
procedure t_axes.dessiner(feuille: Tcanvas);
var x,hauteur,xboite,yboite: real;
    chaine:string[80];
    compt,posX,posY,depart,arrivee:longint;
begin
     if ligne_style=-1 then exit;
     t_ligne.dessiner(feuille);

     hauteur:=ticks/(2*Yscale);
     if xlabelpos=2 //bottom
        then yboite:=-labelsep/Yscale-hauteur
        else yboite:=labelsep/Yscale+hauteur; //top

     if gradX>0 then
     begin
     x:=O_x;

     depart:=Yentier(O_y-hauteur);arrivee:=Yentier(O_y+hauteur);
     posY:=Yentier(O_y+yboite);
     if xlabelpos=1 then dec(posY,feuille.textheight('123'));
     for compt:=1 to nbtraitsXd do
           begin
                posX:=Xentier(x);
                chaine:=streel(x);
                feuille.MoveTo(posX,depart);
                feuille.Lineto(posX,arrivee);
                if xlabelpos>0 then
                feuille.TextOut(posX-(feuille.textWidth(chaine) div 2),
                        posY, chaine);
                x:=x+gradX;
           end;

     x:=O_x-gradX;
     for compt:=1 to nbtraitsXg do
           begin
                posX:=Xentier(x);
                chaine:=streel(x);
                feuille.MoveTo(posX,depart);
                feuille.Lineto(posX,arrivee);
                if xlabelpos>0 then
                feuille.TextOut(posX-(feuille.textWidth(chaine) div 2),
                        posY, chaine);
                x:=x-gradX;
           end;
     end;
     if gradY>0 then
     begin
     x:=O_y;
     hauteur:=ticks/(2*Xscale);
     if ylabelpos=1 //left
        then  xboite:=-(labelsep/Xscale+hauteur)
        else xboite:=labelsep/Xscale+hauteur; //right
     depart:=Xentier(O_x-hauteur);arrivee:=Xentier(O_x+hauteur);

     posX:=Xentier(O_x+xboite);
     for compt:=1 to nbtraitsYh do
           begin
                posY:=Yentier(x);
                chaine:=streel(x);
                feuille.MoveTo(depart,posY);
                feuille.Lineto(arrivee,posY);
                if yLabelpos=1 then
                   feuille.TextOut(posX-feuille.textWidth(chaine),posY-(feuille.textHeight(chaine) div 2),chaine)
                   else
                if ylabelpos=2 then
                   feuille.TextOut(posX,posY-(feuille.textHeight(chaine) div 2),chaine);
                x:=x+gradY;
     end;
     x:=O_y-gradY;
     for compt:=1 to nbtraitsYb do
           begin
                posY:=Yentier(x);
                chaine:=streel(x);
                feuille.MoveTo(depart,posY);
                feuille.Lineto(arrivee,posY);
                if yLabelpos=1 then
                   feuille.TextOut(posX-feuille.textWidth(chaine),posY-(feuille.textHeight(chaine) div 2),chaine)
                   else
                if ylabelpos=2 then
                   feuille.TextOut(posX,posY-(feuille.textHeight(chaine) div 2),chaine);
                x:=x-gradY;
           end;
     end;
end;
{=======================}
procedure t_axes.enregistrer;
var x,hauteur,xboite,yboite,aux,aux1,aux2: real;
    compt,i:longint;
    mode:string[10];
begin
     hauteur:=ticks/2;
     if xlabelpos=2 //bottom
        then yboite:=-labelsep-hauteur
        else yboite:=labelsep+hauteur; //top

     if gradX>0 then
     begin
     x:=O_x; aux:= Ytex(O_y)+yboite; aux1:= Ytex(O_y)-hauteur; aux2:= Ytex(O_y)+hauteur;
     if NbTraitsXd>0 then  //graduations
      case format of
      LaTeX: writeln(f,'\multiput('+
                 streel(Xtex(O_x))+','+streel(aux1)+')'+
        '('+streel(gradX*Xscale)+',0){'+streel(NbTraitsXd)+'}{\line(0,1){'+
                    streel(2*hauteur)+'}}');
      PsTricks: writeln(f,'\multips('+
                 streel(Xtex(O_x))+','+streel(aux1)+')'+
        '('+streel(gradX*Xscale)+',0){'+streel(NbTraitsXd)+'}{\qline(0,0)(0,'+streel(2*hauteur)+')}');
       Pgf: for i:=1 to NbTraitsXd do
            begin
                 write(f, '\pgfxyline('+streel(Xtex(O_x+(i-1)*gradX))+','+ streel(aux1)+')('+
                          streel(Xtex(O_x+(i-1)*gradX))+','+ streel(aux2)+')');
                 if (i mod 4=0) or (i=NbTraitsXd) then writeln(f);
                 x:=x+gradX
            end;
       end;
     x:=O_x;
     if xlabelpos>0 then  //labels
     case format of
     PsTricks: begin
               if xlabelpos=2 then mode:='t' else mode:='b';
               for compt:=1 to NbTraitsXd do
                    begin
                         writeln(f,'\rput['+mode+']('+streel(Xtex(x))+','+streel(aux)+'){'+TailleLabel[size_label]+' $'+streel(x)+'$}');
                         x:=x+gradX
                    end;
               end;
     LaTeX:  begin
               if xlabelpos=2 then mode:='t' else mode:='b';
               for compt:=1 to NbTraitsXd do
                    begin
                         writeln(f,'\put('+streel(Xtex(x))+','+streel(aux)+'){\makebox(0,0)['+mode+']{'+TailleLabel[size_label]+' $'+streel(x)+'$}}');
                         x:=x+gradX
                    end;
              end;
     pgf: begin
            if xlabelpos=2 then mode:='top' else mode:='bottom';
            for i:=1 to NbTraitsXd do
            begin
                 writeln(f,'\pgfputat{\pgfxy('+streel(Xtex(x))+','+streel(aux)+')}{\pgftext['+mode+']{'+TailleLabel[size_label]+' $'+streel(x)+'$}}');
                 x:=x+gradX
            end;
          end;
      end;

      x:=O_x-gradX;
      if NbTraitsXg>0 then  //graduations
      case format of
      LaTeX: writeln(f,'\multiput('+
                 streel(Xtex(x))+','+streel(aux1)+')'+
        '('+streel(-gradX*Xscale)+',0){'+streel(NbTraitsXg)+'}{\line(0,1){'+
                    streel(2*hauteur)+'}}');
      PsTricks: writeln(f,'\multips('+
                 streel(Xtex(O_x-gradX))+','+streel(aux1)+')'+
        '('+streel(-gradX*Xscale)+',0){'+streel(NbTraitsXg)+'}{\qline(0,0)(0,'+streel(2*hauteur)+')}');
      Pgf: for i:=1 to NbTraitsXg do
            begin
                 write(f, '\pgfxyline('+streel(Xtex(O_x-i*gradX))+','+ streel(aux1)+')('+
                          streel(Xtex(O_x-i*gradX))+','+ streel(aux2)+')');
                 if (i mod 4=0) or (i=NbTraitsXg) then writeln(f);
                 x:=x-gradX
            end;
      end;

      x:=O_x-gradX;
      if xLabelpos>0 then //labels
      case format of
      PsTricks: begin
                    if xlabelpos=2 then mode:='t' else mode:='b';
                    for compt:=1 to NbTraitsXg do
                    begin
                         writeln(f,'\rput['+mode+']('+streel(Xtex(x))+','+streel(aux)+'){'+TailleLabel[size_label]+' $'+streel(x)+'$}');
                         x:=x-gradX
                    end;
                 end;
       LaTeX: begin
               if xlabelpos=2 then mode:='t' else mode:='b';
               for compt:=1 to NbTraitsXg do
                    begin
                         writeln(f,'\put('+streel(Xtex(x))+','+streel(aux)+'){\makebox(0,0)['+mode+']{'+TailleLabel[size_label]+' $'+streel(x)+'$}}');
                         x:=x-gradX
                    end;
               end;
       Pgf: begin
               if xlabelpos=2 then mode:='top' else mode:='bottom';
               for i:=1 to NbTraitsXg do
                 begin
                 writeln(f,'\pgfputat{\pgfxy('+streel(Xtex(x))+','+streel(aux)+')}{\pgftext['+mode+']{'+TailleLabel[size_label]+' $'+streel(x)+'$}}');
                 x:=x-gradX
                 end;
            end;
       end;
     end;

     if gradY>0 then
     begin
          x:=O_y; hauteur:=ticks/2;
          xboite:=labelsep+hauteur;
          if ylabelpos=1 //left
             then  xboite:=-(labelsep+hauteur)
             else xboite:=labelsep+hauteur; //right
          aux:= Xtex(O_x)+xboite;aux1:=Xtex(O_x)-hauteur; aux2:= Xtex(O_x)+hauteur;
          if NbTraitsYh>0 then  //graduations
          case format of
          LaTeX: writeln(f,'\multiput('+
                 streel(aux1)+','+streel(Ytex(O_y))+')'+
                 '(0,'+streel(gradY*Yscale)+'){'+streel(NbTraitsYh)+'}{\line(1,0){'+
                    streel(2*hauteur)+'}}');
          PsTricks: writeln(f,'\multips('+streel(aux1)+','+streel(Ytex(O_y))+')'+
                    '(0,'+streel(gradY*Yscale)+'){'+streel(NbTraitsYh)+'}{\qline(0,0)('+streel(2*hauteur)+',0)}');
          Pgf: for i:=1 to NbTraitsYh do
            begin
                 write(f, '\pgfxyline('+streel(aux1)+','+ streel(Ytex(O_y+(i-1)*gradY))+')('+
                          streel(aux2)+','+ streel(Ytex(O_y+(i-1)*gradY))+')');
                 if (i mod 4=0) or (i=NbTraitsYh) then writeln(f);
                x:=x+gradY
            end;
          end;
          x:=O_y;
          if yLabelpos>0 then //labels
          case format of
          PsTricks: begin
                    if ylabelpos=1 then mode:='r' else mode:='l';
                    for compt:=1 to NbTraitsYh do
                         begin
                              writeln(f,'\rput['+mode+']('+streel(aux)+','+streel(Ytex(x))+'){'+TailleLabel[size_label]+' $'+streel(x)+'$}');
                              x:=x+gradY
                         end;
                    end;
          LaTeX: begin
                 if ylabelpos=1 then mode:='r' else mode:='l';
                 for compt:=1 to NbTraitsYh do
                         begin
                              writeln(f,'\put('+streel(aux)+','+streel(Ytex(x))+'){\makebox(0,0)['+mode+']{'+TailleLabel[size_label]+' $'+streel(x)+'$}}');
                              x:=x+gradY
                         end;
                 end;
          Pgf: begin
               if ylabelpos=1 then mode:='right' else mode:='left';
               for i:=1 to NbTraitsYh do
                   begin
                   writeln(f,'\pgfputat{\pgfxy('+streel(aux)+','+streel(Ytex(x))+')}{\pgftext['+mode+']{'+TailleLabel[size_label]+' $'+streel(x)+'$}}');
                   x:=x+gradY
                   end;
               end;
          end;
          x:=O_y-gradY;
          if NbTraitsYb>0 then  //graduations
          case format of
          LaTeX: writeln(f,'\multiput('+
                 streel(aux1)+','+streel(Ytex(x))+')'+
                 '(0,'+streel(-gradY*Yscale)+'){'+streel(NbTraitsYb)+'}{\line(1,0){'+
                    streel(2*hauteur)+'}}');
          PsTricks:  writeln(f,'\multips('+ streel(aux1)+','+streel(Ytex(x))+')'+
                     '(0,'+streel(-gradY*Yscale)+'){'+streel(NbTraitsYb)+'}{\qline(0,0)('+streel(2*hauteur)+',0)}');
          Pgf: for i:=1 to NbTraitsYb do
            begin
                 write(f, '\pgfxyline('+streel(aux1)+','+ streel(Ytex(x))+')('+streel(aux2)+','+ streel(Ytex(O_y-i*gradY))+')');
                 if (i mod 4=0) or (i=NbTraitsYb) then writeln(f);
                x:=x-gradY
            end;
          end;
          x:=O_y-gradY;
          if yLabelpos>0 then //labels
          case format of
          PsTricks: begin
                    if ylabelpos=1 then mode:='r' else mode:='l';
                    for compt:=1 to NbTraitsYb do
                         begin
                              writeln(f,'\rput['+mode+']('+streel(aux)+','+streel(Ytex(x))+'){'+TailleLabel[size_label]+' $'+streel(x)+'$}');
                              x:=x-gradY
                         end;
                    end;
          LaTeX: begin
                    if ylabelpos=1 then mode:='r' else mode:='l';
                    for compt:=1 to NbTraitsYb do
                         begin
                              writeln(f,'\put('+streel(aux)+','+streel(Ytex(x))+'){\makebox(0,0)['+mode+']{'+TailleLabel[size_label]+' $'+streel(x)+'$}}');
                              x:=x-gradY
                         end;
                    end;
          Pgf: begin
                    if ylabelpos=1 then mode:='right' else mode:='left';
                    for i:=1 to NbTraitsYb do
                        begin
                        writeln(f,'\pgfputat{\pgfxy('+streel(aux)+','+streel(Ytex(x))+')}{\pgftext['+mode+']{'+TailleLabel[size_label]+' $'+streel(x)+'$}}');
                        x:=x-gradY
                        end;
                    end;
          end;
     end;
end;
{=================}
procedure t_axes.enregistrer_latex;
begin
     if ligne_style=-1 then exit;
     t_ligne.enregistrer_latex;
     enregistrer(LaTeX);
end;
{=======================}
procedure t_axes.enregistrer_pst;
begin
     if ligne_style=-1 then exit;
     t_ligne.enregistrer_pst;
     if gestion_couleur and (couleur<>Texte_courant) then
        begin
             writeln(f, '\color'+StrColor(couleur,latex));
             Texte_courant:=couleur;
        end;
     enregistrer(PsTricks)
end;
{==================}
procedure t_axes.enregistrer_pgf;
begin
     if ligne_style=-1 then exit;
      T_ligne.enregistrer_pgf;
      if ((gradX>0) or (gradY>0)) and (fillcolor_courant<>couleur)
        then
            begin
              fillcolor_courant:=couleur;
              writeln(f,'\pgfsetfillcolor'+StrColor(couleur,pgf));
            end;
      enregistrer(Pgf);
      if ligne_style<>-1 then fleches_latex(pgf);
end;
{==================}
procedure t_axes.enregistrer_eps;
var x,hauteur,xboite,yboite: real;
    compt:longint;
    chaine,truechaine,StrCouleur,modeXps,modeYps:string;
    modeX,modeY:char;

   procedure LabPsfrag(style:char);
   begin
        truechaine:=chaine; chaine:='L'+IntToStr(LabelPsfrag);
        writeln(psfrag,'\psfrag{'+chaine+'}{\makebox(0,0)['+style+']{'+TailleLabel[size_label]+' '+StrCouleur+'$'+truechaine+'$}}');
        Inc(LabelPsfrag,1);
   end;

begin
     if ligne_style=-1 then exit;
      if gestion_couleur and (couleur<>0) then StrCouleur:='\color'+StrColor(couleur,latex)+' '
                                          else StrCouleur:='';
     T_ligne.enregistrer_eps;
     if (not UsePsfrag) and ((gradX>0) or (gradY>0)) then
        if (size_label<> LabelSize_courant)
        then
            begin
                 writeln(f, '/myfont findfont '+ streel(size_Label*2+4)+' scalefont setfont /h{-'+streel(size_Label*2+4)+' fact mul}def');
                 LabelSize_courant:= size_label;
            end;
     hauteur:=ticks/2;
     //yboite:=-(labelsep+hauteur)/Yscale;
     //xboite:=(labelsep+hauteur)/Xscale;
     if xlabelpos=2 //bottom
        then begin yboite:=-(labelsep+hauteur)/Yscale; modeX:='t';modeXps:=' Top ' end
        else begin yboite:=(labelsep+hauteur)/Yscale; modeX:='b'; modeXps:=' Bottom ' end; //top
     if ylabelpos=1 //left
        then begin xboite:=(labelsep+hauteur)/Xscale; modeY:='r'; modeYps:=' Right ' end
        else begin xboite:=-(labelsep+hauteur)/Xscale; modeY:='l'; modeYps:=' Left ' end; //right

     if gradX>0 then
     begin
      if NbTraitsXd>0 then   //graduations
      writeln(f,streel(XEps(O_x))+' '+streel(YEps(O_y-hauteur/Yscale))+' m '+
                streel(NbTraitsXd)+' {0 '+ streel(2*hauteur*pica)+ ' rl '+streel(gradX*Xscale*pica)+
                ' '+streel(2*hauteur*pica)+' neg rm} repeat s');


     if NbTraitsXg>0 then //graduations
      writeln(f,streel(XEps(O_x-gradX))+' '+streel(YEps(O_y-hauteur/Yscale))+' m '+
                streel(NbTraitsXg)+' {0 '+streel(2*hauteur*pica)+ ' rl '+streel(gradX*Xscale*pica)+
                ' neg '+streel(2*hauteur*pica)+' neg rm} repeat s');

     if xLabelpos>0 then //labels
     begin
     x:=O_x;
     for compt:=1 to NbTraitsXd do
           begin
                chaine:=streel(x);
                if UsePsfrag then LabPsfrag(modeX);
                writeln(f, streel(XEps(x))+' '+streel(YEps(O_y+yboite))+' m ('+
                chaine+') CenterH'+modeXps);
                x:=x+gradX
           end;
     x:=O_x-gradX;
     for compt:=1 to NbTraitsXg do
           begin
                chaine:=streel(x);
                if UsePsfrag then LabPsfrag(modeX);
                writeln(f, streel(XEps(x))+' '+streel(YEps(O_y+yboite))+' m ('+
                chaine+') CenterH'+modeXps);
                x:=x-gradX
           end;

     end;
     end;

     if gradY>0 then
     begin
     if NbTraitsYh>0 then  //graduations
      writeln(f,streel(XEps(O_x-hauteur/Xscale))+' '+streel(YEps(O_y))+' m '+
                streel(NbTraitsYh)+' {'+streel(2*hauteur*pica)+ ' 0 rl '+streel(2*hauteur*pica)+
                ' neg '+streel(gradY*Yscale*pica)+' rm} repeat s');

     if NbTraitsYb>0 then
      writeln(f,streel(XEps(O_x-hauteur/Xscale))+' '+streel(YEps(O_y-gradY))+' m '+
                streel(NbTraitsYb)+' {'+streel(2*hauteur*pica)+ ' 0 rl '+streel(2*hauteur*pica)+
                ' neg '+streel(gradY*Yscale*pica)+' neg rm} repeat s');
     if yLabelpos>0 then  //labels
     begin
     x:=O_y;
     for compt:=1 to NbTraitsYh do
           begin
                chaine:=streel(x);
                if UsePsfrag then LabPsfrag(modeY);
                writeln(f, streel(XEps(O_x-xboite))+' '+streel(YEps(x))+' m ('+
                chaine+')'+modeYps+'CenterV');
                x:=x+gradY
           end;
     x:=O_y-gradY;
     for compt:=1 to NbTraitsYb do
           begin
                chaine:=streel(x);
                if UsePsfrag then LabPsfrag(modeY);
                writeln(f, streel(XEps(O_x-xboite))+' '+streel(YEps(x))+' m ('+
                chaine+')'+modeYps+'CenterV');
                x:=x-gradY
           end;

     end;
     end;
     if ligne_style<>-1 then fleches_latex(eps);
end;
{=================}
function t_axes.parametres_teg:string;
var chaine:string;
begin
     chaine:=t_element.parametres_teg;
     if fleche<>Arrows then
        begin Arrows:=fleche; chaine:=chaine+',Set(Arrows,'+Streel(fleche)+')';end;
      if ligne_style<>LineStyle then
         begin LineStyle:=ligne_style; chaine:=chaine+',Set(LineStyle,'+Streel(ligne_style)+')';end;
      if fill_style<>FillStyle then
         begin FillStyle:=fill_style; chaine:=chaine+',Set(FillStyle,'+Streel(fill_style)+')';end;
      if xyticks<>ticks then
         begin xyticks:=ticks; chaine:=chaine+',Set(xyticks,'+Streel(ticks)+')';end;
      if xylabelsep<>labelsep then
         begin xylabelsep:=labelsep; chaine:=chaine+',Set(xylabelsep,'+Streel(labelsep)+')';end;
      if size_label<>LabelSize then
         begin LabelSize:=size_label; chaine:=chaine+',Set(LabelSize,'+Streel(size_label)+')';end;
      if ylabelpos+4*xlabelpos<>xyLabelpos then
         begin xyLabelpos:=ylabelpos+4*xlabelpos; chaine:=chaine+',Set(xylabelpos,'+Streel(xylabelpos)+')';end;
      parametres_teg:=chaine;
end;
{==========================================Type t_grille ==================}
constructor t_grille.init(const Anom,UneCommande:string);
begin
     t_ligne.init(Anom,UneCommande,0,0);
     cat:=cat_grille;
end;
{=======================}
procedure t_grille.dessiner(feuille: Tcanvas);
var x: real;
    compt,coul,depart,arrivee:longint;
begin
     if ligne_style=-1 then exit;
     t_ligne.parametres_scr(feuille,coul);
     with feuille do
   begin
     if gradX>0 then
     begin
     depart:=Yentier(Ymin);arrivee:=Yentier(Ymax);
     x:=O_x;
     for compt:=1 to NbTraitsXd do
           begin
                MoveTo(Xentier(x),depart);
                Lineto(Xentier(x),arrivee);
                x:=x+gradX;
           end;
     x:=O_x-gradX;
     for compt:=1 to NbTraitsXg do
           begin
                MoveTo(Xentier(x),depart);
                Lineto(Xentier(x),arrivee);
                x:=x-gradX
           end;
     end;
     if gradY>0 then
     begin
     depart:=Xentier(Xmin);arrivee:=Xentier(Xmax);
     x:=O_y;
     for compt:=1 to NbTraitsYh  do
           begin
                MoveTo(depart,Yentier(x));
                Lineto(arrivee,Yentier(x));
                x:=x+gradY
     end;
     x:=O_y-gradY;
     for compt:=1 to NbTraitsYb do
           begin
                MoveTo(depart,Yentier(x));
                Lineto(arrivee,Yentier(x));
                x:=x-gradY
           end;
     end;
   end;
end;
{=======================}
procedure t_grille.enregistrer_latex;

          function trace(a,b,long:real): string;
          begin
               case ligne_style of
                    0:  trace:='\line('+Streel(a)+','+Streel(b)+'){'+streel(long)+'}';(* continu*)
                    1:  trace:=TeXDashStyle+'(0,0)('+Streel(a*long)+','+Streel(b*long)+')';(* tirets*)
                    2:  trace:=TexDotStyle+'(0,0)('+Streel(a*long)+','+Streel(b*long)+')';(* pointills*)
                    end;
          end;

begin
     if ligne_style=-1 then exit;
     if (gradX=0) or (gradY=0) then exit;
     t_element.enregistrer_latex;

     if NbTraitsXd>0 then
     writeln(f,'\multiput('+
                 streel(Xtex(O_x))+',0)'+
        '('+streel(gradX*Xscale)+',0){'+streel(NbTraitsXd)+
        '}{'+trace(0,1,(Ymax-Ymin)*Yscale)+'}');

     if NbTraitsXg>0 then
     writeln(f,'\multiput('+
                 streel(Xtex(O_x-gradX))+',0)'+
        '('+streel(-gradX*Xscale)+',0){'+streel(NbTraitsXg)+
        '}{'+trace(0,1,(Ymax-Ymin)*Yscale)+'}');

     if NbTraitsYh>0 then
     writeln(f,'\multiput(0,'+
                 streel(Ytex(O_y))+')'+
        '(0,'+streel(gradY*Yscale)+'){'+streel(NbTraitsYh)+
        '}{'+trace(1,0,(Xmax-Xmin)*Xscale)+'}');

     if NbTraitsYb>0 then
     writeln(f,'\multiput(0,'+
                 streel(Ytex(O_y-gradY))+')'+
        '(0,'+streel(-gradY*Yscale)+'){'+streel(NbTraitsYb)+
        '}{'+trace(1,0,(Xmax-Xmin)*Xscale)+'}');
end;
{=======================}
procedure t_grille.enregistrer_pgf;
var i,j: integer;
   aux2:real;
    procedure affiche(s:string);
    begin
         write(f,s); inc(j);
         if j=4 then begin writeln(f);j:=0 end;
    end;
begin
     if ligne_style=-1 then exit;
     if (gradX=0) or (gradY=0) then exit;
     t_element.enregistrer_pgf;
     if ligne_style<>style_courant then
        begin
             case ligne_style of
             0: writeln(f, '\pgfsetdash{}{0pt}');
             1: writeln(f, '\pgfsetdash{{5pt}{3pt}}{0pt} ');
             2: writeln(f, '\pgfsetdash{{0pt}{3pt}}{0pt}');
             end;
             if ligne_style<>-1 then Style_Courant:=ligne_style
        end;
     j:=0; aux2:=Ytex(Ymax);
     for i:=1 to NbTraitsXd
         do affiche('\pgfxyline('+
                 streel(Xtex(O_x+(i-1)*gradX))+',0)('+
        streel(Xtex(O_x+(i-1)*gradX))+','+ streel(aux2)+')');

     for i:=1 to NbTraitsXg
         do affiche('\pgfxyline('+
                 streel(Xtex(O_x-i*gradX))+',0)('+
        streel(Xtex(O_x-i*gradX))+','+ streel(aux2)+')');
      aux2:=Xtex(Xmax);
     for i:=1 to NbTraitsYh
         do affiche('\pgfxyline(0,'+
                 streel(Ytex(O_y+(i-1)*gradY))+')('+
        streel(aux2)+','+ streel(Ytex(O_y+(i-1)*gradY))+')');

     for i:=1 to NbTraitsYb
         do affiche('\pgfxyline(0,'+
                streel(Ytex(O_y-i*gradY))+')('+
        streel(aux2)+','+ streel(Ytex(O_y-i*gradY))+')');
end;
{=======================}
procedure t_grille.enregistrer_eps;
var delta:real;
begin
     if ligne_style=-1 then exit;
     if (gradX=0) or (gradY=0) then exit;
     t_element.enregistrer_eps;
     if ligne_style<>style_courant then
        begin
             case ligne_style of
                  0: write(f, ' SolidLine ');
                  1: write(f, ' DashLine ');
                  2: write(f, ' DotLine ');
             end;
             if ligne_style<>-1 then Style_Courant:=ligne_style
        end;
     if NbTraitsXd>0 then
        begin
             delta:=(Ymax-Ymin)*Yscale*pica;
             writeln(f,streel(XEps(O_x))+' '+streel(YEps(Ymin))+' m '+
                       streel(NbTraitsXd)+' {0 '+ streel(delta)+ ' rl '+streel(gradX*Xscale*pica)+
                       ' '+streel(delta)+' neg rm} repeat s');
        end;


     if NbTraitsXg>0 then
        begin
             delta:= (Ymax-Ymin)*Yscale*pica;
             writeln(f,streel(XEps(O_x-gradX))+' '+streel(YEps(Ymin))+' m '+
                       streel(NbTraitsXg)+' {0 '+ streel(delta)+ ' rl '+streel(gradX*Xscale*pica)+
                       ' neg '+streel(delta)+' neg rm} repeat s');
        end;


     if NbTraitsYh>0 then
        begin
             delta:= (Xmax-Xmin)*Xscale*pica;
             writeln(f,streel(XEps(Xmin))+' '+streel(YEps(O_y))+' m '+
                       streel(NbTraitsYh)+' {'+streel(delta)+ ' 0 rl '+streel(delta)+
                       ' neg '+streel(gradY*Yscale*pica)+' rm} repeat s');
        end;


     if NbTraitsYb>0 then
        begin
             delta:= (Xmax-Xmin)*Xscale*pica;
             writeln(f,streel(XEps(Xmin))+' '+streel(YEps(O_y-gradY))+' m '+
                       streel(NbTraitsYb)+' {'+streel(delta)+ ' 0 rl '+streel(delta)+
                       ' neg '+streel(gradY*Yscale*pica)+' neg rm} repeat s');
        end;

end;

{=======================}
procedure t_grille.enregistrer_pst;
begin
     if ligne_style=-1 then exit;
     if (gradX=0) or (gradY=0) then exit;
     t_element.enregistrer_pst;

     if NbTraitsXd>0 then
     writeln(f,'\multips('+streel(Xtex(O_x))+',0)'+
        '('+streel(gradX*Xscale)+',0){'+streel(NbTraitsXd)+
        '}{\qline(0,0)(0,'+ streel((Ymax-Ymin)*Yscale)+')}');

     if NbTraitsXg>0 then
     writeln(f,'\multips('+streel(Xtex(O_x-gradX))+',0)'+
        '('+streel(-gradX*Xscale)+',0){'+streel(NbTraitsXg)+
        '}{\qline(0,0)(0,'+ streel((Ymax-Ymin)*Yscale)+')}');

     if NbTraitsYh>0 then
     writeln(f,'\multips(0,'+streel(Ytex(O_y))+')'+
        '(0,'+streel(gradY*Yscale)+'){'+streel(NbTraitsYh)+
        '}{\qline(0,0)('+ streel((Xmax-Xmin)*Xscale)+',0)}');


     if NbTraitsYb>0 then
     writeln(f,'\multips(0,'+streel(Ytex(O_y-gradY))+')'+
        '(0,'+streel(-gradY*Yscale)+'){'+streel(NbTraitsYb)+
        '}{\qline(0,0)('+ streel((Xmax-Xmin)*Xscale)+',0)}');
end;
{===================}
function t_grille.parametres_teg:string;
var chaine:string;
begin
     chaine:=t_element.parametres_teg;
     if ligne_style<>LineStyle then
         begin LineStyle:=ligne_style; chaine:=chaine+',Set(LineStyle,'+Streel(ligne_style)+')';end;
      parametres_teg:=chaine;
end;

{==========================================Type t_courbe ==================}
constructor t_parametree.init(const UnNom, UneCommande:string;diviser,discont:byte);
begin
     division:=diviser; saut:=discont;
     t_Ligne.init(UnNom,UneCommande,0,0);
     cat:=cat_parametree;
end;
{=========================}
procedure t_parametree.ConstruitArbre;
begin
     if Unarbre<>nil
        then
            begin
             new(arbre,init);
             DefCommande:=false;
             arbre^.VarLoc:=LesVarLoc;
             Unarbre^.ConvertLocale('t');
             arbre^.corps:=Unarbre;
        end
        else
            begin
                 new(arbre,init);
                 arbre^.varloc^.ajouter_fin(new(Pconstante,init('t',nil,true)));
                 if not arbre^.definir(LigneCommande)
                    then begin dispose(arbre,detruire); arbre:=nil end;
                 DefCommande:=true;
            end;
end;
{========================}
procedure t_parametree.fixeAttributs;
begin
      t_ligne.fixeAttributs;
      ParcourtFenetre:=ForMinToMax;
      if ParcourtFenetre then
        begin
          MinT:=Xmin;
          MaxT:=Xmax;
        end
      else
        begin
          MinT:=tMin;
          MaxT:=tMax;
        end;
end;
{========================}
procedure t_parametree.lireAttributs;
begin
     tMin:=MinT;
     tMax:=maxT;
     ForMinToMax:=ParcourtFenetre;
     t_ligne.lireAttributs;
end;
{========================}
function IsOut(point:Paffixe):boolean;
begin
     IsOut:= (point^.x<=Xmin) or (point^.y<=Ymin)
             or (point^.y>=Ymax) or (point^.x>=Xmax);
end;
{=======================}
procedure t_parametree.clip;
var liste,aux,aux1:Paffixe;
    compt:integer;
    F:Pexpression;
    A,B,A1,A2,A3,A4:Paffixe;

    procedure clipConnexe(var De:Paffixe);
    var aux1,res,T:Paffixe;
        listeAux:type_liste;
        lastOut:Boolean;

    begin
         listeAux.init;
         listeAux.ajouter_fin(De);
         aux:=Paffixe(ListeAux.tete);
         lastOut:=IsOut(aux);
         while aux<>nil do
                    begin
                         if IsOut(aux)
                            then
                              begin
                                   clippee:=true;
                                   if lastOut
                                    then
                                    begin
                                 aux1:=Paffixe(aux^.suivant);
                                 while (aux1<>nil) and (IsOut(aux1)) do
                                       begin
                                            listeAux.supprimer(Pcellule(aux));
                                            aux1:=Paffixe(aux1^.suivant);
                                       end;
                                 if aux1<>nil then begin
                                            T:=new(Paffixe,init(jump^.x,jump^.y));
                                            listeAux.inserer(T,aux);
                                                   A^.x:=aux^.x;A^.y:=aux^.y;
                                                   B^.x:=aux1^.x;B^.y:=aux1^.y;
                                                   res:=F^.evaluer;
                                                   if res<>nil then listeAux.inserer(res,aux1);
                                                   listeAux.supprimer(Pcellule(aux));
                                                   end
                                              else begin
                                                   aux1:=aux;
                                                   aux:=Paffixe(aux1^.precedent);
                                                   listeAux.supprimer(Pcellule(aux1))
                                                   end;
                                 lastOut:=false;
                                    end else begin
                                                  lastOut:=true;
                                                  A^.x:=Paffixe(aux^.precedent)^.x;A^.y:=Paffixe(aux^.precedent)^.y;
                                                  B^.x:=aux^.x;B^.y:=aux^.y;
                                                  res:=F^.evaluer;
                                                  if res<>nil then listeAux.inserer(res,aux);
                                                  aux:=res
                                             end
                                  end
                            else lastOut:=false;

                         if aux<>nil then aux:=Paffixe(aux^.suivant)
                    end;
         liste_points^.ajouter_fin(Paffixe(listeAux.tete));
    end;

begin
     {T_ligne.clip;exit;}
     clippee:=false;
     liste:=Paffixe(liste_points^.tete);
     if liste=nil then exit;
     liste_points^.init;
     new(F,init);
     new(A1,init(Xmin,Ymin));
     new(A2,init(Xmax,Ymin));
     new(A3,init(Xmax,Ymax));
     new(A4,init(Xmin,Ymax));
     new(A,init(0,0));
     new(B,init(0,0));
     F^.varloc^.ajouter_fin(new(Pconstante,init('A1',A1,true)));
     F^.varloc^.ajouter_fin(new(Pconstante,init('A2',A2,true)));
     F^.varloc^.ajouter_fin(new(Pconstante,init('A3',A3,true)));
     F^.varloc^.ajouter_fin(new(Pconstante,init('A4',A4,true)));
     F^.varloc^.ajouter_fin(new(Pconstante,init('A',A,true)));
     F^.varloc^.ajouter_fin(new(Pconstante,init('B',B,true)));
     F^.definir('Copy([A,B] InterL [A1,A2,A3,A4,A1],1,1)');
     aux:=liste;
     while aux<>nil do
          begin
               compt:=1;
               aux1:=Paffixe(aux^.suivant);
               while (aux1<>nil) and (not IsJump(aux1)) do begin inc(compt);aux1:=Paffixe(aux1^.suivant) end;
               if compt>1 then begin
                               if aux1<>nil then aux1^.precedent^.suivant:=nil;
                               ClipConnexe(aux);
                               end else dispose(aux,detruire);
               while (aux1<>nil) and (IsJump(aux1)) do begin liste:=Paffixe(aux1^.suivant);
                                                             dispose(aux1,detruire);
                                                             aux1:=liste;
                                                       end;
               aux:=aux1;
               if (aux<>nil) and (not IsJump(Paffixe(liste_points^.queue)))
                  then liste_points^.ajouter_fin(new(Paffixe,init(jump^.x,jump^.y)))
          end;
     dispose(F,detruire);
     if fermee=1 then
        begin
             liste:=Paffixe(liste_points^.tete);
             if liste=nil then exit;
             aux:=liste;
             while aux<>nil do
                   begin
               while (aux<>nil) and IsJump(aux) do aux:=Paffixe(aux^.suivant);
               if aux<>nil
                  then
                      begin
                           aux1:=Paffixe(aux^.suivant);
                           while (aux1<>nil) and (not IsJump(aux1)) do aux1:=Paffixe(aux1^.suivant);
                           liste_points^.inserer(new(Paffixe,init(aux^.x,aux^.y)),aux1);
                           while (aux1<>nil) and (IsJump(aux1)) do aux1:=Paffixe(aux1^.suivant);
                           aux:=aux1;
                      end;
                   end;
        end;
     purger;
end;
{=======================}
procedure t_parametree.recalculer;
var h,t1:real;
    i:integer;
    T,r,old:Paffixe;
    LastJump:boolean;

    function d(a1,a2:Paffixe):real;
    begin
         d:=abs(a2^.x-a1^.x)+abs(a2^.y-a1^.y);
    end;

procedure midle(t1,t2:real;f1,f2:Paffixe;n:integer);
    var tm,ancien:real;
        fm:Paffixe;
    begin
         if n>division then if saut=1 then liste_points^.ajouter_fin(New(Paffixe,init(jump^.X, jump^.Y))) else
          else begin
         ancien:=T^.x;tm:=(t1+t2)/2;
         T^.x:=tm;
         fm:=arbre^.evaluer;
         if (fm<>nil)
          then begin
                    if (f1=nil) or (d(f1,fm)>h) then midle(t1,tm,f1,fm,n+1);
                    liste_points^.ajouter_fin(fm);
                    if (f2=nil) or (d(f2,fm)>h) then midle(tm,t2,fm,f2,n+1);
               end else begin
                             if f1<>nil
                                then midle(t1,tm,f1,fm,n+1)
                                else liste_points^.ajouter_fin(New(Paffixe,init(jump^.X, jump^.Y)));
                             if f2<>nil
                                then midle(tm,t2,fm,f2,n+1)
                                else liste_points^.ajouter_fin(New(Paffixe,init(jump^.X, jump^.Y)));
                        end;
                           {     else if saut=1 then liste_points^.ajouter_fin(New(Paffixe,init(jump^.X, jump^.Y)));}
         T^.x:=ancien
               end;
    end;

begin
     if arbre=nil then exit;
     if DefCommande then
        begin
             dispose(arbre,detruire);
             ConstruitArbre(nil);
             if arbre=nil then exit;
        end;
     if ParcourtFenetre then
        begin
          MinT:=Xmin;
          MaxT:=Xmax;
        end;
     liste_points^.detruire;
     T:=new(Paffixe,init(MinT,0));
     arbre^.assigner('t',T);
     h:=(MaxT-MinT)/(nb_points-1);
     LastJump:=true;old:=nil;
     if division>0 then
     for i:=1 to nb_points do
           begin
            r:=arbre^.evaluer;
            if (r<>nil) then begin
                                  if ((old<>nil)  and (d(old,r)>h)) or
                                     ((old=nil) and (T^.x>Mint))  then midle(t1,T^.x,old,r,1);
                                  liste_points^.ajouter_fin(r);
                                  LastJump:=false;
                             end
                        else if (old<>nil)
                             then midle(t1,T^.x,old,r,1)
                             else
                             if not LastJump then
                             begin
                             liste_points^.ajouter_fin(new(Paffixe,init(jump^.X,jump^.Y)));
                             LastJump:=true;
                             end;
            t1:=T^.x;old:=r;
            {IsIn1:=IsIn2;}
            T^.x:=T^.x+h;
            end
       else
       for i:=1 to nb_points do
           begin
            r:=arbre^.evaluer;
            if (r<>nil) then begin
                                  liste_points^.ajouter_fin(r);
                                  LastJump:=false;
                             end
                        else if not LastJump then
                             begin
                             liste_points^.ajouter_fin(new(Paffixe,init(jump^.X,jump^.Y)));
                             LastJump:=true;
                             end;
            T^.x:=T^.x+h;
            end;
     clip;
     if fleche>0 then calcul_fleches;
     arbre^.desassigner('t'); Kill(Pcellule(T));
end;
{======================}
function t_parametree.parametres_teg:string;
var chaine:string;
begin
     chaine:=t_ligne.parametres_teg;
     if ParcourtFenetre<>ForMinToMax then
         begin ForMinToMax:=ParcourtFenetre;
                chaine:=chaine+',Set(ForMinToMax,'+Streel(byte(ParcourtFenetre))+')'
         end;
     if minT<>tmin then
         begin tmin:=minT; chaine:=chaine+',Set(tMin,'+Streel(minT)+')'end;
      if maxT<>tmax then
         begin tmax:=maxT; chaine:=chaine+',Set(tMax,'+Streel(maxT)+')'end;
      parametres_teg:=chaine
end;
{====================}
procedure t_parametree.enregistrer_teg;
begin t_element.enregistrer_teg;
      if division<>0 then
         begin
              write(f,division,car_special);
              if saut<>0 then write(f,saut,car_special);
         end;
end;
{=================================t_droite============================}
constructor t_droite.init(const UnNom, UneCommande:string);
begin
     t_ligne.init(UnNom,UneCommande,0,0);
     cat:=cat_droite;
     fleche:=0;
end;
{=======================}
function ClipDroite(a,b,c1,MinX,MaxX,MinY,MaxY:real):Paffixe;
var positif:boolean;
    LesPoints:type_liste;
    i:integer;
    C:array[1..5] of Record x,y:real end;
    LeTest,t,Xa,Ya:real;

begin
     LesPoints.init;
     C[1].x:=MinX;C[1].y:=MinY;
     C[2].x:=MaxX;C[2].y:=MinY;
     C[3].x:=MaxX;C[3].y:=MaxY;
     C[4].x:=MinX;C[4].y:=MaxY;
     C[5].x:=MinX;C[5].y:=MinY;
     CalcError:=false;
     positif:=soustraire(ajouter(multiplier(a,C[1].x),multiplier(b,C[1].y)),c1)>0;
     for i:=2 to 5 do
         begin
              CalcError:=false;
              LeTest:=soustraire(ajouter(multiplier(a,C[i].x),multiplier(b,C[i].y)),c1);
              if ((LeTest<=0) and positif) or ((LeTest>0) and (not positif)) then
                                begin
                                     positif:=not positif;
                                     t:= diviser(c1-a*C[i].x-b*C[i].y,
                                         a*(C[i-1].x-C[i].x)+b*(C[i-1].y-C[i].y));
                                     Xa:=t*(C[i-1].x-C[i].x)+C[i].x;
                                     Ya:=t*(C[i-1].y-C[i].y)+C[i].y;
                                     LesPoints.ajouter_fin(new(Paffixe,init(Xa,Ya)));
                                end;
         end;

         if (LesPoints.tete=nil) or (LesPoints.tete^.suivant=nil) or
         ((Paffixe(LesPoints.tete)^.x=Paffixe(LesPoints.tete^.suivant)^.x) and
          (Paffixe(LesPoints.tete)^.y=Paffixe(LesPoints.tete^.suivant)^.y))
          then LesPoints.detruire;
          ClipDroite:=Paffixe(LesPoints.tete);
end;
{============}
procedure t_droite.recalculer;
var  t1,t2,t3:Paffixe;
     res:Paffixe;
     a,b,c:real;
begin
     t_element.recalculer;
     if (liste_points^.tete=nil) then begin exit end;
     t1:=Paffixe(liste_points^.tete);
     t2:=Paffixe(t1^.suivant);
     if (t2=nil) then begin liste_points^.detruire; exit;end;
     t3:=Paffixe(t2^.suivant);
     if t3<>nil then begin {equation}
                     a:=t1^.x;b:=t2^.x;c:=t3^.x;
                     end
                else
     begin
         CalcError:=false;
         b:=ajouter(t2^.x,-t1^.x);
         a:=-ajouter(t2^.y,-t1^.y);
         c:=ajouter(multiplier(b,t1^.y),multiplier(a,t1^.x));
     end;
    liste_points^.init;
    if not CalcError then
       begin
       {res:=segm(a,b,c,Xmin,Xmax,Ymin,Ymax);}
       res:=Clipdroite(a,b,c,Xmin,Xmax,Ymin,Ymax);
       if res<>nil then begin liste_points^.ajouter_fin(res)end;
       end;
       Kill(Pcellule(t1));
end;
{============================t_cercle=================================}
constructor t_cercle.init;
begin
     t_ligne.init(UnNom,UneCommande,1,0);
     cat:=cat_cercle;
     fleche:=0;
end;
{=====================}
procedure T_cercle.recalculer;
var t1,t2,t3,T:Paffixe;
    f:Pexpression;
    error:boolean;
begin
     t_element.recalculer;
     t1:=Paffixe(liste_points^.tete);
     if (t1=nil) or (t1^.suivant=nil) then begin liste_points^.detruire; exit;end;
     t2:=Paffixe(t1^.suivant);
     if t2<>nil then t3:=Paffixe(t2^.suivant);
     error:=false;
     if t3<>nil then
        begin
             new(f,init);
             f^.varLoc^.ajouter_fin(new(Pconstante,init('a',new(Paffixe,init(t1^.x,t1^.y)),true)));
             f^.varLoc^.ajouter_fin(new(Pconstante,init('b',new(Paffixe,init(t2^.x,t2^.y)),true)));
             f^.varLoc^.ajouter_fin(new(Pconstante,init('c',new(Paffixe,init(t3^.x,t3^.y)),true)));
             f^.definir('[Set($O,[(b+c)/2,(b+c)/2+i*(b-c)] Inter [(a+b)/2,(a+b)/2+i*(b-a)]),O,abs(a-O)]');
             T:=f^.evaluer;
             if T<>nil then begin Xcentre:=T^.x;Ycentre:=T^.y; rayon:=Paffixe(T^.suivant)^.X;Kill(Pcellule(T)) end
                       else error:=true;
             dispose(f,detruire);
        end else begin Xcentre:=t1^.x; Ycentre:=t1^.y; rayon:=t2^.x end;
     liste_points^.detruire;
     if error then exit;
     new(f,init);
     f^.varLoc^.ajouter_fin(new(Pconstante,init('a',new(Paffixe,init(Xcentre,Ycentre)),true)));
     f^.varLoc^.ajouter_fin(new(Pconstante,init('r',new(Paffixe,init(rayon,0)),true)));
     f^.varLoc^.ajouter_fin(new(Pconstante,init('nbpoints',new(Paffixe,init(nb_points,0)),true)));
     if f^.definir('[if r>1 then nbpoints:=Ent((nbpoints-1)*r)+2 fi, Set($pas, 2*pi/(nbpoints-1)),$t:=0,for $k from 1 to nbpoints do a+r*exp(i*t),Inc(t,pas) od]')
      then  T:=f^.evaluer else T:=nil;

    if T<>nil then begin
                          liste_points^.ajouter_fin(T);
                          clip;
                    end;
     dispose(f,detruire);
end;
{=======================}
procedure t_cercle.enregistrer_latex;
var old:boolean;
begin
     if liste_points^.tete=nil then exit;
     if clippee or (Xscale<>Yscale) or
     (ligne_style<>0) then
                      T_Ligne.enregistrer_Latex
                      else
     begin
            if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
            case fill_style of
                      2: fillLatex(2,LaTex);
                      3: begin fillLatex(6,LaTex);fillLatex(7,LaTex); end;
                      4: begin fillLatex(2,LaTex);fillLatex(5,LaTex); end;
                      5: FillLatex(5,LaTex);
                      6: fillLatex(6,LaTex);
                      7: fillLatex(7,LaTex);
            end;
            old:=inclure_commentaires;
            inclure_commentaires:=false;
            t_element.enregistrer_latex;
            inclure_commentaires:=old;
            if fill_style=1
               then
                   begin
                        if fill_Color<>couleur_courante then write(f,'\color'+StrColor(fill_Color,latex));
                        writeln(f,'\put('+streel(Xtex(Xcentre))+','+streel(Ytex(Ycentre))+
                           '){\circle*{'+streel(2*Rayon*Xscale)+'}}');
                        write(f,'\color'+StrColor(couleur_courante,latex));
                   end;
            writeln(f,'\put('+streel(Xtex(Xcentre))+','+streel(Ytex(Ycentre))+
                           '){\circle{'+streel(2*Rayon*Xscale)+'}}');
     end;
end;
{=======================}
procedure t_cercle.enregistrer_pst;
begin
     if liste_points^.tete=nil then exit;
     if clippee then T_ligne.enregistrer_pst
                else begin
                     t_element.enregistrer_pst;
                     writeln(f,'\psellipse('+streel(Xtex(Xcentre))+','+streel(Ytex(Ycentre))+')('+streel(rayon*Xscale)+
                     ','+streel(rayon*Yscale)+')');
                     end;
end;
{=======================}
procedure t_cercle.enregistrer_pgf;
var arg:string;
    fillColor:integer;

    procedure trace;
    begin
         writeln(f,'\pgfellipse['+arg+']{\pgfxy('+Streel(Xtex(Xcentre))+','+Streel(Ytex(Ycentre))+')}{'+
                     '\pgfxy('+streel(rayon*Xscale)+',0)}{\pgfxy(0,'+ streel(rayon*Yscale)+')}');
    end;

begin
     if liste_points^.tete=nil then exit;
     if clippee then T_ligne.enregistrer_pgf
                else
     begin
          t_ligne.parametres_pgf;
          if gestion_couleur then fillColor:=fill_Color
                             else fillColor:=1;
          if (ligne_style=-1) and (fill_style<>1) then exit;
          if fill_style=1   {remplissage}
             then
                 begin
                      if fillcolor<>fillcolor_courant
                         then begin fillcolor_courant:=fillcolor;
                                    write(f,'\pgfsetfillcolor'+StrColor(fillcolor,pgf));
                               end;
                      if ligne_style=-1 then arg:='fill' else arg:='fillstroke';
                      trace;
                 end
             else {pas de remplissage}
                   begin
                        arg:='stroke';
                        trace
                   end;
     end;
end;
{=======================}
procedure T_Cercle.enregistrer_eps;
var FillColor:integer;

    procedure trace;
    begin
         writeln(f,'0 360 '+streel((CpicaX*(rayon)))+' '+streel((CpicaY*(rayon)))+' '+
                 '0.5 currentlinewidth mul dup 4 -1 roll sub neg 3 1 roll sub '+Streel((XEps(Xcentre)))+' '
                 +streel((YEps(Ycentre))));
         write(f,' /mtrx CM def translate scale 0 0 1 5 3 roll arc mtrx setmatrix closepath ')
    end;

begin
     if liste_points^.tete=nil then exit;
     if clippee then T_ligne.enregistrer_eps
     else
     begin
          t_ligne.parametres_eps;
          if gestion_couleur then fillColor:=fill_Color
                             else fillColor:=1;
          if (ligne_style=-1) and (fill_style<>1) then exit;
          trace;
          if (ligne_style<>-1)
             then
                 if fill_style=1
                    then writeln(f,'gs ',StrColor(fillColor,eps), 'fill gr s ')
                    else writeln(f, 's ')

             else if fill_style=1
                     then writeln(f, StrColor(fillColor,eps),'fill s ',StrColor(couleur_courante,eps));

     end;
end;
{===================TArc==========================}
constructor T_Arc.init(const UnNom, UneCommande:string;LeSens:integer);
begin
     if LeSens>0 then sens:=1 else Sens:=-1;
     T_Ligne.init(UnNom,UneCommande,0,0);
     cat:=cat_Arc;
end;
{==============}
procedure T_arc.recalculer;
var
    f:Pexpression;
    chaine:string;
    T,a,b,c,r:Paffixe;
begin
     t_element.recalculer;
     if liste_points^.tete=nil then exit;
     Kill(Pcellule(donnees));
     donnees:=Paffixe(liste_points.tete);
     liste_points^.init;
     T:=Paffixe(donnees);
     if (T<>Nil) and (T^.suivant<>nil) and (T^.suivant^.suivant<>nil)
        and (T^.suivant^.suivant^.suivant<>nil) then
           begin
                b:=T;
                a:=Paffixe(T^.suivant);
                c:=Paffixe(a^.suivant);
                r:=Paffixe(c^.suivant);
                if ((a^.x=b^.x) and (a^.y=b^.y)) or
                                 ((a^.x=c^.x) and (a^.y=c^.y))  or (r^.y<>0) or (r^.x<0)
                                  then exit;
           end else begin Kill(Pcellule(donnees)); exit end;
     new(f,init);
     f^.varLoc^.ajouter_fin(new(Pconstante,init('a',new(Paffixe,init(a^.x,a^.y)),true)));
     f^.varLoc^.ajouter_fin(new(Pconstante,init('b',new(Paffixe,init(b^.x,b^.y)),true)));
     f^.varLoc^.ajouter_fin(new(Pconstante,init('c',new(Paffixe,init(c^.x,c^.y)),true)));
     if f^.definir('[Arg(b-a),Arg(c-a)]') then T:=f^.evaluer else T:=nil;
     if (T<>nil) and (T^.suivant<>nil) then
      begin
      angleA:=T^.x;angleB:=Paffixe(T^.suivant)^.x;
      if angleA<0 then angleA:=2*pi+angleA;
      if angleB<0 then angleB:=2*pi+angleB;
      angleA:=angleA*180/pi;angleB:=angleB*180/pi;
      Kill(Pcellule(T))
      end else begin liste_points^.detruire; dispose(f,detruire); exit end;
     dispose(f,detruire);
     new(f,init);
     f^.varLoc^.ajouter_fin(new(Pconstante,init('a',new(Paffixe,init(a^.x,a^.y)),true)));
     f^.varLoc^.ajouter_fin(new(Pconstante,init('b',new(Paffixe,init(b^.x,b^.y)),true)));
     f^.varLoc^.ajouter_fin(new(Pconstante,init('c',new(Paffixe,init(c^.x,c^.y)),true)));
     f^.varLoc^.ajouter_fin(new(Pconstante,init('r',new(Paffixe,init(r^.x,0)),true)));
     f^.varLoc^.ajouter_fin(new(Pconstante,init('nbpoints',new(Paffixe,init(nb_points,0)),true)));

     chaine:='[Set($l,r*(b-a)/abs(b-a)),Set($tf,Arg((c-a)/(b-a))),';
     if sens=1 then chaine:=chaine+'Si(tf<0,Inc(tf,2*pi)),'
               else chaine:=chaine+'Si(tf>0,Inc(tf,-2*pi)),';
     //chaine:=chaine+'Set($n,Ent(abs(tf*nbpoints)/(2*pi))),Set($pas,tf/n),Set($t,0),Seq([a+l*exp(i*t),Inc(t,pas)],$k,0,n)]';
     chaine:=chaine+'Set($n,2+Ent(abs(tf*nbpoints)/(2*pi))),'+
     'if r>1 then n:=Ent((n-1)*r)+2 fi, Set($pas,tf/n),Set($t,0),for $k from 0 to n do a+l*exp(i*t), Inc(t,pas) od]';
     if f^.definir(chaine) then  T:=f^.evaluer else T:=nil;
     if T<>nil then begin
                          liste_points^.ajouter_fin(T);
                          clip;
                          if fleche>0 then calcul_fleches
                    end;
     dispose(f,detruire);
end;
{===============}
procedure T_Arc.enregistrer_latex;
var
    aux:Paffixe;
    angledep,anglefin,x1,y1,R:real;
    old:boolean;
begin
    if (arbre=nil) or (donnees=nil) then exit;
    if clippee or (Xscale<>Yscale) or
    (ligne_style<>0) then T_ligne.enregistrer_latex
       else
       begin
            if inclure_commentaires then writeln(f,'%',nom,' ',type_element[cat]);
            case fill_style of
                      2: fillLatex(2,LaTex);
                      3: begin fillLatex(6,LaTex);fillLatex(7,LaTex); end;
                      4: begin fillLatex(2,LaTex);fillLatex(5,LaTex); end;
                      5: FillLatex(5,LaTex);
                      6: fillLatex(6,LaTex);
                      7: fillLatex(7,LaTex);
            end;
            old:=inclure_commentaires;
            inclure_commentaires:=false;
            t_element.enregistrer_latex;
            inclure_commentaires:=old;
            fleches_Latex(LaTeX);
            aux:=Paffixe(donnees);
            aux:=Paffixe(aux^.suivant);
            x1:=aux^.X;y1:=aux^.Y;
            aux:=Paffixe(aux^.suivant);aux:=Paffixe(aux^.suivant);
            R:=aux^.X;
            if sens=1 then begin angledep:=-angleB;anglefin:=-angleA;end
                      else begin angledep:=-angleA;anglefin:=-angleB;end;
            writeln(f,'\put('+streel(Xtex(x1))+','+streel(Ytex(y1))+'){\arc{'+streel(2*R*Xscale)+'}{'+
                streel(angleDep*pi/180)+'}{'+streel(angleFin*pi/180)+'}}');
       end;
end;
{==============}
procedure T_Arc.enregistrer_pst;
var    x1,y1,R:real;
       aux:Paffixe;
begin
     if (arbre=nil) or (donnees=nil) then exit;
     if clippee or (Xscale<>Yscale) then T_ligne.enregistrer_pst
        else
        begin
     aux:=Paffixe(donnees);
     aux:=Paffixe(aux^.suivant);
     x1:=Xtex(aux^.X);y1:=Ytex(aux^.Y);
     aux:=Paffixe(aux^.suivant);aux:=Paffixe(aux^.suivant);
     R:=aux^.X;
     t_element.enregistrer_pst;
     if sens=1 then write(f,'\psarc') else write(f,'\psarcn');
     if fleche=1 then write(f,'{->}') else if fleche=2 then write(f,'{<->}');
     writeln(f,'('+streel(x1)+','+streel(y1)+'){'+streel(R*Xscale)+'}{'+
                streel(angleA)+'}{'+streel(angleB)+'}');
        end
end;
{================================}
procedure T_arc.enregistrer_eps;
var    x1,y1,R:real;
       aux:Paffixe;
       FillColor:integer;

    procedure trace;
    begin
         writeln(f,Streel(angleA),' ',Streel(angleB),' '+streel((CpicaX*(R)))+' '+streel((CpicaY*(R)))+' '+
                 '0.5 currentlinewidth mul dup 4 -1 roll sub neg 3 1 roll sub '+Streel((XEps(X1)))+' '
                 +streel((YEps(Y1))));
         write(f,' /mtrx CM def translate scale 0 0 1 5 3 roll ');
         if sens=1 then write(f,'arc ') else write(f,'arcn ');
         write(f,'mtrx setmatrix ')
    end;

begin
     if (arbre=nil) or (donnees=nil) then exit;
     if clippee then T_ligne.enregistrer_eps
     else
     begin
          aux:=Paffixe(donnees);
          aux:=Paffixe(aux^.suivant);
          x1:=aux^.X;y1:=aux^.Y;
          aux:=Paffixe(aux^.suivant);aux:=Paffixe(aux^.suivant);
          R:=aux^.X;
          t_ligne.parametres_eps;
          if gestion_couleur then fillColor:=fill_Color
                             else fillColor:=1;
          if (ligne_style=-1) and (fill_style<>1) then exit;
          trace;
          if (ligne_style<>-1)
             then
                 if fill_style=1
                    then writeln(f,'gs ',StrColor(fillColor,eps), 'fill gr s ')
                    else writeln(f, 's ')

             else if fill_style=1
                     then writeln(f, StrColor(fillColor,eps),'fill s ',StrColor(couleur_courante,eps));
             if ligne_style<>-1 then fleches_latex(eps);
     end;
end;
{=======================}
procedure t_Arc.enregistrer_pgf;
var fillColor:integer;
    x1,y1,R:real;
    aux:Paffixe;
    deb,fin:real;

    procedure trace;
    begin
         writeln(f,'\pgfmoveto{\pgfxy('+Streel(Xtex(X1+R*cos(deb*pi/180)))+','+Streel(Ytex(Y1+R*sin(deb*pi/180)))+
         ')}\pgfarc{'+streel(deb)+'}{'+ streel(fin)+'}{'+streel(R*Xscale)+'cm/'+streel(R*Yscale)+'cm}');
    end;

begin
     if (arbre=nil) or (donnees=nil) then exit;
     if clippee then T_ligne.enregistrer_pgf
                else
     begin
          t_ligne.parametres_pgf;
          if gestion_couleur then fillColor:=fill_Color
                             else fillColor:=1;
          if (ligne_style=-1) and (fill_style<>1) then exit;
          aux:=Paffixe(donnees);
          aux:=Paffixe(aux^.suivant);
          x1:=aux^.X;y1:=aux^.Y;
          aux:=Paffixe(aux^.suivant);
          aux:=Paffixe(aux^.suivant);
          R:=aux^.X;
          deb:=angleA; fin:=angleB;
          if sens=1 then
             if angleA>angleB then deb:=deb-360 else
             else if angleA<angleB then fin:=fin-360;
          trace;
          if fill_style=1   {remplissage}
             then
                 begin
                      if fillcolor<>fillcolor_courant
                         then begin fillcolor_courant:=fillcolor;
                                    write(f,'\pgfsetfillcolor'+StrColor(fillcolor,pgf));
                               end;
                      if ligne_style=-1 then writeln(f,'\pgffill') else writeln(f,'\pgffillstroke');

                 end
             else writeln(f,'\pgfstroke');
             if ligne_style<>-1 then fleches_latex(pgf);
     end;
end;
{==============================}
procedure T_Arc.enregistrer_teg;
begin
     t_element.enregistrer_teg;
     write(f,sens,car_special);
end;
{===============================T_Equadif ======================================}
constructor T_EquaDif.init(const UnNom, UneCommande:string;Unmode:byte);
begin
     mode:=Unmode mod 3;
     t_parametree.init(UnNom,UneCommande,0,0);
     cat:=cat_EquaDif;
end;
{=======================}
procedure T_Equadif.ConstruitArbre;
var p:Pcorps;
    aux:Pliste;
begin
     if Unarbre<>nil
        then
            begin
             new(arbre,init);
             DefCommande:=false;
             UnArbre^.ConvertLocale('t');
             arbre^.VarLoc:=LesVarLoc;
             arbre^.corps:=Unarbre;
        end
        else
            begin
                 new(arbre,init);
                 arbre^.varloc^.ajouter_fin(new(Pconstante,init('t',nil,true)));
                 arbre^.varloc^.ajouter_fin(new(Pconstante,init('z',nil,true)));
                 if not arbre^.definir(LigneCommande)
                    then begin dispose(arbre,detruire); arbre:=nil end;
                 DefCommande:=true;
            end;
     if arbre<>nil then
        begin
             aux:=LesVarLoc; LesVarLoc:=arbre^.VarLoc;
             p:=DefCorps('Re($z)'); arbre^.corps^.composer('x',p); dispose(p,detruire);
             p:=DefCorps('Im($z)'); arbre^.corps^.composer('y',p); dispose(p,detruire);
             arbre^.VarLoc:=LesVarLoc; LesVarLoc:=aux;
        end;
end;
{=======================}
procedure T_EquaDif.recalculer;
var h,t0,Zx,Zy:real;
    j,k,N:integer;
    aux:Paffixe;
    T,Z,y0,k1,k2,k3,k4,Zaux:Paffixe;
    f1,f2,f3:Pcorps;
begin
     if arbre=nil then exit;
     if DefCommande then
        begin
             dispose(arbre,detruire);
             ConstruitArbre(nil);
             if arbre=nil then exit;
        end;
     if ParcourtFenetre then
        begin
          MinT:=Xmin;
          MaxT:=Xmax;
        end;
     liste_points^.detruire;
     f1:=Pcorps(arbre^.corps);
     if (f1=nil) or (f1^.categorie<>cat_commande) or  (Pcommande(f1^.contenu)^.nom<>'Liste') then exit;
     {dtermination de f1,f2,f3,t0,y0}
     f1:=Pcorps(f1^.arguments^.tete);
     f2:=Pcorps(f1^.suivant);
     if f2=nil then exit;
     f3:=Pcorps(f2^.suivant);
     if f3=nil then exit;
     T:=f2^.evaluer;
     if T=nil then exit;
     t0:=T^.x; Kill(Pcellule(T));
     //if (t0<MinT) or (t0>MaxT) then exit;
     y0:=f3^.evaluer;
     if y0=nil then exit;

     {on assigne f1(t,z)}
     T:=new(Paffixe,init(t0,0));
     Z:=new(Paffixe,init(y0^.x,y0^.y));
     arbre^.assigner('t',T);
     arbre^.assigner('z',Z);
     Zaux:=nil;k1:=nil;k2:=nil;k3:=nil;k4:=nil;
     {calcul des points}
     if mode=0 then new(aux,init(y0^.x,y0^.y))
               else
     if mode=1 then new(aux,init(t0,y0^.x))
               else new(aux,init(t0,y0^.y));
     liste_points^.ajouter_fin(aux);   
     for j:=1 to 2 do
     begin
     T^.x:=t0;
     Z^.x:=y0^.x;Z^.y:=y0^.y;
     CalcError:=false;
     if j=1 then begin
                N:=Trunc((nbpoints-1)*(maxT-t0)/(maxT-minT)); //nb points aprs t0
                if N>0 then h:=(MaxT-t0)/N else h:=0
                end
            else begin
                N:=nbpoints-N-1; //nb points avant t0
                if N>0 then h:=(MinT-t0)/N else h:=0
                end;
     k:=0;
     while (k<N)  and (not CalcError) do
           begin
            k1:=f1^.evaluer;
            if k1=nil then CalcError:=true
               else
               begin
            T^.x:=T^.x+h/2;
            Zaux:=Z^.evaluer;
            Z^.x:= ajouter(Z^.x,multiplier(h/2,k1^.x));
            Z^.y:= ajouter(Z^.y,multiplier(h/2,k1^.y));
            k2:=f1^.evaluer;
            if k2=nil then CalcError:=true
               else
               begin
            Z^.x:= ajouter(Zaux^.x,multiplier(h/2,k2^.x));
            Z^.y:= ajouter(Zaux^.y,multiplier(h/2,k2^.y));
            k3:=f1^.evaluer;
            if k3=nil then CalcError:=true
               else
               begin
            T^.x:=T^.x+h/2;
            Z^.x:= ajouter(Zaux^.x,multiplier(h,k3^.x));
            Z^.y:= ajouter(Zaux^.y,multiplier(h,k3^.y));
            k4:=f1^.evaluer;
            if k4=nil then CalcError:=true
               else
               begin
            Z^.x:= ajouter(Zaux^.x,
                  multiplier(h/6,
                  ajouter(k1^.x,ajouter(multiplier(2,k2^.x),
                  ajouter(multiplier(2,k3^.x),k4^.x)))));
            Z^.y:=ajouter(Zaux^.y,
                  multiplier(h/6,
                  ajouter(k1^.y,ajouter(multiplier(2,k2^.y),
                  ajouter(multiplier(2,k3^.y),k4^.y)))));
            if not CalcError
               then
            begin
            if mode=1 then begin Zy:=Z^.x;Zx:=T^.x end
                      else
            if mode=2 then begin Zx:=T^.x;Zy:=Z^.y end
                      else begin Zx:=Z^.x;Zy:=Z^.y end;
            if j=1 then liste_points^.ajouter_fin(new(Paffixe,init(Zx,Zy)))
                   else liste_points^.inserer(new(Paffixe,init(Zx,Zy)),liste_points^.tete);
               end
               end;{k4}
               end;{k3}
               end;{k2}
               end;{k1}
            Kill(Pcellule(Zaux));Kill(Pcellule(k1));Kill(Pcellule(k2));Kill(Pcellule(k3));
            Kill(Pcellule(k4));
            Inc(k,1)
            end;
     end;
     Kill(Pcellule(y0));
     clip;
     if fleche>0 then calcul_fleches;
     arbre^.desassigner('t'); Kill(Pcellule(T));
     arbre^.desassigner('z'); Kill(Pcellule(Z));
end;
{===============}
procedure T_EquaDif.enregistrer_teg;
begin
     t_element.enregistrer_teg;
     write(f,mode,car_special);
end;
{======================================================================}
constructor T_implicit.init(const UnNom, UneCommande:string);
begin
     cat:=cat_implicit;
     t_element.init(UnNom,UneCommande);
end;
{=========================================}
procedure T_implicit.ConstruitArbre;
var p:Pexpression;
    f1,f2,f3:Pcorps;
    aux1:Pliste;
    T:Paffixe;
begin
     if Unarbre<>nil
        then
            begin
             new(arbre,init);
             DefCommande:=false;
             Unarbre^.ConvertLocale('x');
             Unarbre^.ConvertLocale('y');
             arbre^.VarLoc:=LesVarLoc;
             arbre^.corps:=Unarbre;
        end
        else
            begin
                 new(arbre,init);
                 arbre^.varloc^.ajouter_fin(new(Pconstante,init('x',nil,true)));
                 arbre^.varloc^.ajouter_fin(new(Pconstante,init('y',nil,true)));
                 if not arbre^.definir(LigneCommande)
                    then begin dispose(arbre,detruire); arbre:=nil end;
                 DefCommande:=true;
            end;
     if arbre<>nil then
        begin
             GridX:=50;GridY:=50;
             if (arbre^.corps^.categorie=cat_commande) and
                (Pcommande(arbre^.corps^.contenu)^.nom<>'Liste')
                then
                begin
                     if (arbre^.corps^.arguments=nil) then exit;
                     f1:=Pcorps(arbre^.corps^.arguments^.tete);
                     f2:=Pcorps(f1^.suivant);
                     if f2<> nil then
                        begin
                             CalcError:=false;
                             T:=f2^.evaluer;
                             if CalcError or (T=nil) or (T^.x<0)  then else GridX:=Round(T^.x);
                             Kill(Pcellule(T));
                             f3:=Pcorps(f2^.suivant);
                             if f3<>nil then
                                    begin
                                    CalcError:=false;
                                    T:=f3^.evaluer;
                                    if CalcError or (T=nil) or (T^.x<0)  then else GridY:=Round(T^.x);
                                    Kill(Pcellule(T));
                                    end;
                        end;
                     new(p,init);
                     p^.corps:=f1^.dupliquer;
                     aux1:=LesVarLoc;
                     LesVarLoc:=p^.VarLoc;
                     p^.corps^.brancherLocales;
                     LesVarLoc:=aux1;
                     if DefCommande then dispose(arbre,detruire) else dispose(arbre);
                     arbre:=p;
                end;
        end;
end;
{===========================}
procedure T_implicit.recalculer;
var Y,X,T,aux,r1,r2,S:Paffixe;
    epsilonX,epsilonY,precision,N,Nx,Ny,dx,dy:real;
    DYF,DXF:Pexpression;
begin
     if arbre=nil then exit;
     if DefCommande then
        begin
             dispose(arbre,detruire);
             ConstruitArbre(nil);
             if arbre=nil then exit;
        end;
     liste_points^.detruire;
     DyF:=arbre^.deriver('y');
     DxF:=arbre^.deriver('x');
     if DxF=nil then exit;
     if DYF=nil then begin dispose(DxF,detruire); exit; end;

     liste_points^.detruire;
     epsilonY:=(Ymax-Ymin)/GridY/2; dy:=epsilonY;
     epsilonX:=(Xmax-Xmin)/GridX/2; dx:=epsilonX;
     Y:=new(Paffixe,init(Ymin+epsilonY,0));
     X:=new(Paffixe,init(0,0));
     arbre^.assigner('y',Y);
     DxF^.assigner('y',Y);
     DyF^.assigner('y',Y);
     DyF^.assigner('x',X);
     precision:=1e-4;
     T:=nil;r1:=nil;r2:=nil;
     Repeat
           T:=solve(arbre,DxF,'x',Xmin,Xmax,precision,GridX);
           DxF^.assigner('x',X);
           if T<>nil then
           begin
           aux:=T;
           while aux<>nil do
                 begin
                      X^.x:=aux^.x;
                      r1:=DxF^.evaluer;
                      r2:=DyF^.evaluer;
                      if (r1<>nil) and (r2<>nil) then
                         begin
                         CalcError:=false;
                         Nx:=r1^.x;Ny:=r2^.x;
                         Kill(Pcellule(r1));Kill(Pcellule(r2));
                         N:=ajouter(multiplier(Nx,aux^.x),multiplier(Ny,Y^.x));
                         if (not CalcError)
                            then
                            S:=ClipDroite(Nx,Ny,N,Max(aux^.x-dX,Xmin),Min(aux^.x+dX,Xmax),
                            Max(Y^.x-dY,Ymin),Min(Y^.x+dY,Ymax))
                                       else  S:=nil;
                         if (S<>nil) then liste_points^.ajouter_fin(S);
                         end;
                      aux:=Paffixe(aux^.suivant);
                 end;
           Kill(Pcellule(T));
           end;
           Y^.x:=Y^.x+2*epsilonY;
     until Y^.x>Ymax;

     {deuxime passage}
     X^.x:=Xmin+epsilonX;
     arbre^.assigner('x',X);
     Repeat
           T:=solve(arbre,DyF,'y',Ymin,Ymax,precision,GridY);
           DyF^.assigner('y',Y);
           if T<>nil then
           begin
           aux:=T;
           while aux<>nil do
                 begin
                      Y^.x:=aux^.x;
                      r1:=DxF^.evaluer;
                      r2:=DyF^.evaluer;
                      if (r1<>nil) and (r2<>nil) then
                         begin
                         CalcError:=false;
                         Nx:=r1^.x;Ny:=r2^.x;
                         Kill(Pcellule(r1));Kill(Pcellule(r2));
                         N:=ajouter(multiplier(Nx,X^.x),multiplier(Ny,aux^.x));
                         if (not CalcError)
                            then
                            S:=ClipDroite(Nx,Ny,N,Max(X^.x-dX,Xmin),Min(X^.x+dX,Xmax),
                            Max(aux^.x-dY,Ymin),Min(aux^.x+dY,Ymax))
                                       else S:=nil;
                         if (S<>nil) then liste_points^.ajouter_fin(S);
                         end;
                      aux:=Paffixe(aux^.suivant);
                 end;
           Kill(Pcellule(T));
           end;
           X^.x:=X^.x+2*epsilonX;
     until X^.x>Xmax;
     arbre^.desassigner('y');
     DxF^.desassigner('y');
     DyF^.desassigner('y');
     DxF^.desassigner('x');
     DyF^.desassigner('x');
     arbre^.desassigner('x');
     Kill(Pcellule(Y));Kill(Pcellule(X));
     dispose(DxF,detruire);
     dispose(DyF,detruire);
end;{========================================}
procedure t_implicit.dessiner(feuille: Tcanvas);
var
    coul:longint;
    x1,y1,x2,y2:real;
    aux:Paffixe;
begin
     if liste_points^.tete=nil then exit;
     aux:=Paffixe(liste_points^.tete);
     parametres_scr(feuille,coul);
     with feuille do
 begin
     while aux<>nil do
           begin
     x1:=aux^.X; y1:=aux^.Y;
     MoveTo(Xentier(x1),Yentier(y1));
     aux:=Paffixe(aux^.suivant);
     if aux<>nil then
        begin
             x2:=aux^.X; y2:=aux^.Y;
             LineTo(Xentier(x2),Yentier(y2));
             aux:=Paffixe(aux^.suivant);
        end;
           end;
 end
end;
{=======================}
procedure t_implicit.enregistrer_latex;
var    x1,y1,x2,y2:real;
       aux:Paffixe;
       commande:string;
begin
     if liste_points^.tete=nil then exit;
     t_element.enregistrer_latex;
     case ligne_style of
     0: commande:='\path(';
     1: commande:=TexDashStyle+'(';
     2: commande:=TexDotStyle+'(';
     end;
     aux:=Paffixe(liste_points^.tete);
     while aux<>nil do
           begin
     x1:=aux^.X;y1:=aux^.Y;
     aux:=Paffixe(aux^.suivant);
     x2:=aux^.X;y2:=aux^.Y;
     writeln(f,commande+streel(Xtex(x1))+','+streel(Ytex(y1))+')('+
                streel(Xtex(x2))+','+streel(Ytex(y2))+')');
     aux:=Paffixe(aux^.suivant)
     end;
end;
{=======================}
function t_implicit.parametres_pst;
var chaine:string;
    ok:boolean;
begin
     chaine:=t_element.parametres_pst;
     ok:=chaine<>'';
     if (ligne_style<>style_courant) then
        begin if ok then chaine:=chaine+',';
              chaine:=chaine+'linestyle='+UnStyle[ligne_style];
              style_courant:=ligne_style
           end;
      parametres_pst:=chaine
end;
{========================}
procedure t_implicit.enregistrer_pst;
var    x1,y1,x2,y2:real;
       aux:Paffixe;
begin
     if liste_points^.tete=nil then exit;
     t_element.enregistrer_pst;
     aux:=Paffixe(liste_points^.tete);
     while aux<>nil do
           begin
     x1:=Xtex(aux^.X);y1:=Ytex(aux^.Y);
     aux:=Paffixe(aux^.suivant);
     x2:=Xtex(aux^.X); y2:=Ytex(aux^.Y);
     writeln(f,'\qline('+streel(x1)+','+streel(y1)+')('+
                streel(x2)+','+streel(y2)+')');
     aux:=Paffixe(aux^.suivant);
          end;
end;
{================}
procedure t_implicit.enregistrer_eps;
var    x1,y1,x2,y2:real;
       aux:Paffixe;
begin
     if liste_points^.tete=nil then exit;
     t_element.enregistrer_eps;
     if ligne_style<>style_Courant then
        begin
             case ligne_style of
              0: write(f, ' SolidLine ');
              1: write(f, ' DashLine ');
              2: write(f, ' DotLine ');
              end;
              Style_Courant:=ligne_style
        end;
     aux:=Paffixe(liste_points^.tete);
     while aux<>nil do
           begin
     x1:=aux^.X;y1:=aux^.Y;
     aux:=Paffixe(aux^.suivant);
     x2:=aux^.X;y2:=aux^.Y;
     writeln(f,streel(XEps(x1))+' '+streel(YEps(y1))+' m '+
                streel(XEps(x2))+' '+streel(YEps(y2))+' l s');
     aux:=Paffixe(aux^.suivant);
          end;
end;
{================}
procedure t_implicit.enregistrer_pgf;
var    x1,y1,x2,y2:real;
       aux:Paffixe;
begin
     if liste_points^.tete=nil then exit;
     t_element.enregistrer_pgf;
     if ligne_style<>style_Courant then
        begin
             case ligne_style of
              0: writeln(f, '\pgfsetdash{}{0pt}');
              1: writeln(f, '\pgfsetdash{{5pt}{3pt}}{0pt} ');
              2: writeln(f, '\pgfsetdash{{0pt}{3pt}}{0pt}');
              end;
              Style_Courant:=ligne_style
        end;
     aux:=Paffixe(liste_points^.tete);
     while aux<>nil do
           begin
     x1:=Xtex(aux^.X);y1:=Ytex(aux^.Y);
     aux:=Paffixe(aux^.suivant);
     x2:=Xtex(aux^.X);y2:=Ytex(aux^.Y);
     writeln(f,'\pgfxyline('+streel(x1)+','+streel(y1)+')('+
                streel(x2)+','+streel(y2)+')');
     aux:=Paffixe(aux^.suivant);
          end;
end;
{================}
function t_implicit.parametres_teg:string;
var chaine:string;
begin
     chaine:=t_element.parametres_teg;
     if ligne_style<>LineStyle then
         begin LineStyle:=ligne_style; chaine:=chaine+',Set(LineStyle,'+Streel(ligne_style)+')';end;
     parametres_teg:=chaine
end;
{========================}
constructor T_Bezier.init(const UnNom, UneCommande:string);
begin
     T_parametree.init(UnNom,UneCommande,5,0);
     cat:=cat_bezier;
end;
{==========================}
procedure T_Bezier.recalculer;
var h:real;
    i:integer;
    a,c,d,b,u,v,w:Paffixe;
    t0:real;
begin
     t_element.recalculer;

     if liste_points^.tete=nil then exit;
     Kill(Pcellule(donnees));

     donnees:=Paffixe(liste_points.tete);
     liste_points^.init;
     a:=donnees; control3:=false;
     u:=nil; v:=nil; w:=nil;
     h:=1/(nb_points-1);
   while a<>nil do
     begin
        b:=Paffixe(a^.suivant);
        if b<>nil then c:=Paffixe(b^.suivant) else c:=nil;
        if (b<>nil) and IsJump(b) then d:=c
                else
        if c<>nil then d:=Paffixe(c^.suivant) else d:=nil;
        if d<>nil then
        begin  {4 pts de controles}
          if a=donnees then Liste_points^.ajouter_fin(new(Paffixe,init(a^.x,a^.y)));
          t0:=h;
          if IsJump(b) then  Liste_points^.ajouter_fin(new(Paffixe,init(d^.x,d^.y)))
           else
           begin
          u:=kFoisC(3, soustraireC(b,a));
          v:=kFoisC(3,ajouterC(c,soustraireC(a,kFoisC(2,b))));
          w:=ajouterC(soustraireC(d,a),kFoisC(3,soustraireC(b,c)));
          if (u<>nil) and (v<>nil) and (w<>nil)
            then
                for i:=2 to nb_points do
                begin
            Liste_points^.ajouter_fin(new(Paffixe,init(a^.x+t0*(u^.x+t0*(v^.x+t0*w^.x)),a^.y+t0*(u^.y+t0*(v^.y+t0*w^.y)))));
            t0:=t0+h;
                end;
           Kill(Pcellule(u));Kill(Pcellule(v)); Kill(Pcellule(w));
            end
        end
         else  {d=nil}
               if a=donnees
               then begin {3pts de controles}
                          if (b=nil) or (c=nil) then begin kill(Pcellule(donnees)); exit end;
                          control3:=true;
                          u:=kFoisC(2, soustraireC(b,a));
                          v:=ajouterC(c,soustraireC(a,kFoisC(2,b)));
                          if (u<>nil) and (v<>nil) then
                          for i:=1 to nb_points do
                                begin
            Liste_points^.ajouter_fin(new(Paffixe,init(a^.x+t0*(u^.x+t0*v^.x),a^.y+t0*(u^.y+t0*v^.y))));
                                t0:=t0+h;
                                end;
                          Kill(Pcellule(u));Kill(Pcellule(v));

                    end
               else begin  {on dtruit les points en trop}
                           a^.suivant:=nil;
                           Kill(Pcellule(b))
                     end;
        a:=d
     end;
     if Liste_points^.tete<>nil then
       begin
        clip;
        if fleche>0 then calcul_fleches;
       end else Kill(Pcellule(donnees));
end;
{===========================}
procedure T_Bezier.enregistrer_pst;
var a,b,c,d:Paffixe;
begin
     if (arbre=nil) or (donnees=nil) then exit;
     if clippee or control3 then begin T_parametree.enregistrer_pst; exit end;
     t_element.enregistrer_pst;
     a:=donnees;
     if fill_style<>0 then writeln(f,'\pscustom{');
     while a<>nil do
     begin
        b:=Paffixe(a^.suivant);
        if b<>nil then c:=Paffixe(b^.suivant) else c:=nil;
        if IsJump(b) then d:=c
                else
        if c<>nil then d:=Paffixe(c^.suivant) else d:=nil;
        if d<>nil then
          begin
                if IsJump(b) then write(f,'\psline') else write(f,'\psbezier');
                if fleche=1 then
                   if d^.suivant=nil then write(f,'{->}') else
                            else
                if fleche=2 then
                   if (a^.precedent=nil)
                        then
                        if  (d^.suivant=nil) then write(f,'{<->}')
                                              else write(f,'{<-}')
                        else
                        if  (d^.suivant=nil) then write(f,'{->}');
                write(f,'('+Streel(Xtex(a^.x))+','+streel(Ytex(a^.y))+')');
                if not IsJump(b) then
                 write(f,'('+Streel(Xtex(b^.x))+','+streel(Ytex(b^.y))+')('+
                           Streel(Xtex(c^.x))+','+streel(Ytex(c^.y))+')');
                 writeln(f,'('+Streel(Xtex(d^.x))+','+streel(Ytex(d^.y))+')');
          end;
        a:=d
     end;
     if fill_style<>0 then writeln(f,'}')
end;
{=================}
procedure T_Bezier.enregistrer_eps;
var aux1,aux2,aux3,aux4:Paffixe;
    FillColor:integer;
begin
     if (arbre=nil) or (donnees=nil) then exit;
     if clippee or control3 then begin T_parametree.enregistrer_eps; exit end;
     if (ligne_style=-1) and (fill_style<>1) then  exit;
     aux1:=Paffixe(donnees);
     if aux1=nil then exit;
     t_ligne.parametres_eps;
     if gestion_couleur then fillColor:=fill_Color
                        else fillColor:=1;
     writeln(f,Streel((XEps(aux1^.x)))+' '+streel((YEps(aux1^.y)))+' m ');
     while aux1<>nil do
        begin
          aux2:=Paffixe(aux1^.suivant);
          if aux2<>nil then aux3:=Paffixe(aux2^.suivant) else aux3:=nil;
          if IsJump(aux2) then aux4:=aux3
                else
          if aux3<>nil then aux4:=Paffixe(aux3^.suivant) else aux4:=nil;
          if aux4<> nil then
               if IsJump(aux2) then
                writeln(f,Streel((XEps(aux4^.x)))+' '+streel((YEps(aux4^.y)))+' lineto')
                else
               writeln(f,Streel((XEps(aux2^.x)))+' '+streel((YEps(aux2^.y)))+' '+
                 Streel((XEps(aux3^.x)))+' '+streel((YEps(aux3^.y)))+' '+
                 Streel((XEps(aux4^.x)))+' '+streel((YEps(aux4^.y)))+' curveto');
          aux1:=aux4;
        end;
        if (ligne_style<>-1)
             then
                 if fill_style=1
                    then writeln(f,'gs ',StrColor(fillColor,eps), 'fill gr s ')
                    else writeln(f, 's ')
             else if fill_style=1
                     then writeln(f, StrColor(fillColor,eps),'fill s ',StrColor(couleur_courante,eps));
        if ligne_style<>-1 then fleches_latex(eps);
end;
{=================}
procedure T_Bezier.enregistrer_pgf;
var aux1,aux2,aux3,aux4:Paffixe;
    fillColor:integer;
begin
     if (arbre=nil) or (donnees=nil) then exit;
     if clippee or control3 then begin T_parametree.enregistrer_pgf; exit end;
     if (ligne_style=-1) and (fill_style<>1) then exit;
     aux1:=Paffixe(donnees);
     if aux1=nil then exit;
     t_ligne.parametres_pgf;
     if gestion_couleur then fillColor:=fill_Color
                        else fillColor:=1;
     writeln(f,'\pgfmoveto{\pgfxy('+Streel(Xtex(aux1^.x))+','+streel(Ytex(aux1^.y))+')}');
     while aux1<>nil do
        begin
          aux2:=Paffixe(aux1^.suivant);
          if aux2<>nil then aux3:=Paffixe(aux2^.suivant) else aux3:=nil;
          if IsJump(aux2) then aux4:=aux3
                else
          if aux3<>nil then aux4:=Paffixe(aux3^.suivant) else aux4:=nil;
          if aux4<> nil then
             if IsJump(aux2) then
              writeln(f,'\pgflineto{\pgfxy('+Streel(Xtex(aux4^.x))+','+streel(Ytex(aux4^.y))+')}')
              else
              writeln(f,'\pgfcurveto{\pgfxy('+
                 Streel(Xtex(aux2^.x))+','+streel(Ytex(aux2^.y))+')}{\pgfxy('+
                 Streel(Xtex(aux3^.x))+','+streel(Ytex(aux3^.y))+')}{\pgfxy('+
                 Streel(Xtex(aux4^.x))+','+streel(Ytex(aux4^.y))+')}');
          aux1:=aux4;
        end;
       if fill_style=1
             then begin
                       if fill_color<>fillcolor_courant then
                          begin
                               fillcolor_courant:=fill_color;
                               write(f,'\pgfsetfillcolor'+StrColor(fill_color,pgf));
                          end;
                       if ligne_style=-1 then writeln(f,'\pgffill') else writeln(f,'\pgffillstroke');
                  end
                  else  writeln(f, '\pgfstroke');
       if ligne_style<>-1 then fleches_latex(pgf);
end;
{=================}
function t_bezier.parametres_teg:string;
begin
        parametres_teg:=t_ligne.parametres_teg
end;
{============================}
function splineCubique(Points,v1,v2:Paffixe):Paffixe;
type Treel=array[1..2] of real;
     Preel=^Treel;
     TlisteComplex=array[1..2] of Paffixe;
var  d1,d2,d3,res1,res2,res3:Paffixe;
     n,k:word;
     a,b,c:Preel;
     d:^TlisteComplex;
     liste:type_liste;
     u:real;

begin
     splineCubique:=nil;
     n:=0;
     d1:=Points;
     while d1<>nil do
           begin
            inc(n);d1:=Paffixe(d1^.suivant)
           end;
     if n<=1 then begin exit;end;
     CalcError:=false;
     liste.init;
     n:=2*n-2;
     getmem(a,(n-1)*Sizeof(real));
     getmem(c,(n-1)*Sizeof(real));
     getmem(b,n*Sizeof(real));
     getmem(d,n*Sizeof(Paffixe));
     b^[1]:=1;if v1=nil then b^[n]:=0 else b^[n]:=1;
     for k:=1 to ((n-2) div 2) do begin b^[2*k]:=3;b^[2*k+1]:=2 end;
     if v2=nil then c^[1]:=3 else c^[1]:=2;
     for k:=1 to ((n-2) div 2) do begin c^[2*k]:=1;c^[2*k+1]:=5 end;
     a^[n-1]:=1;
     for k:=1 to ((n-2) div 2) do begin a^[2*k-1]:=5;a^[2*k]:=1 end;
     d1:=Paffixe(Points);
     d2:=Paffixe(d1^.suivant);
     d3:=Paffixe(d2^.suivant);
     k:=n-1;
     if v1=nil then d^[n]:=new(Paffixe,init(0,0)) else
        begin
             res1:=soustraireC(d2,d1);
             res2:=soustraireC(res1,v1);
             if res2<>nil then d^[n]:=res2 else begin CalcError:=true; d^[n]:=new(Paffixe,init(0,0)) end;
             Kill(Pcellule(res1));
        end;
     while d3<>nil do
     begin
          res1:=soustraireC(d3,d2);
          res2:=soustraireC(d2,d1);
          res3:=soustraireC(res1,res2);
          Kill(Pcellule(res1));Kill(Pcellule(res2));
          if res3<>nil then
          begin
          d^[k]:=res3^.evaluer;
          res3^.x:=multiplier(res3^.x,3);
          res3^.y:=multiplier(res3^.y,3);
          d^[k-1]:=res3;
          end
          else
          begin CalcError:=true;
          d^[k]:=new(Paffixe,init(0,0));
          d^[k-1]:=new(Paffixe,init(0,0));
          end;
          dec(k,2);
          d1:=d2;d2:=d3;d3:=Paffixe(d3^.suivant)
     end;
     if v2=nil then d^[1]:=new(Paffixe,init(0,0)) else
        begin
             res1:=soustraireC(d2,d1);
             res2:=soustraireC(v2,res1);
             if res2<>nil then d^[1]:=res2 else begin CalcError:=true; d^[1]:=new(Paffixe,init(0,0)) end;
             Kill(Pcellule(res1));
        end;
     for k:=1 to n-1 do
         begin
              u:=diviser(a^[k],b^[k]);
              b^[k+1]:=soustraire(b^[k+1],multiplier(u,c^[k]));
              d^[k+1]^.x:=soustraire(d^[k+1]^.x,multiplier(u,d^[k]^.x));
              d^[k+1]^.y:=soustraire(d^[k+1]^.y,multiplier(u,d^[k]^.y));
         end;
     
     d^[n]^.x:=diviser(d^[n]^.x,b^[n]);
     d^[n]^.y:=diviser(d^[n]^.y,b^[n]);
     for k:=(n-1) downto 1 do
      begin
      d^[k]^.x:=diviser(soustraire(d^[k]^.x,multiplier(c^[k],d^[k+1]^.x)),b^[k]);
      d^[k]^.y:=diviser(soustraire(d^[k]^.y,multiplier(c^[k],d^[k+1]^.y)),b^[k]);
      end;
     freemem(a,(n-1)*Sizeof(real));
     freemem(c,(n-1)*Sizeof(real));
     freemem(b,n*Sizeof(real));
     if CalcError then begin for k:=1 to n do Kill(Pcellule(d^[k])) end
               else for k:=n downto 1 do liste.ajouter_fin(d^[k]);
     freemem(d,n*Sizeof(Paffixe));
     SplineCubique:=Paffixe(liste.tete)
end;
{==========================================Type t_spline ==================}
constructor t_spline.init(const UnNom, UneCommande:string);
begin
     t_parametree.init(UnNom,UneCommande,5,0);
     cat:=cat_spline;
end;
{=======================}
procedure t_spline.recalculer;
var h:real;
    i,PointsParSeg:integer;
    r1,v1,v2,res,a,b,A1,A2,u:Paffixe;
    liste:type_liste;
    t0:real;
begin
     if arbre=nil then exit;
     if DefCommande then
        begin
             dispose(arbre,detruire);
             ConstruitArbre(nil);
             if arbre=nil then exit;
        end;
     liste_points^.detruire;
     r1:=arbre^.evaluer;
     if r1=nil then begin exit end;
     if (r1^.suivant=nil) or (r1^.suivant^.suivant=nil) then begin Kill(Pcellule(r1));exit end;
     v1:=r1;i:=0;
     liste.init;
     v2:=Paffixe(v1^.suivant);
     while v2^.suivant<>nil do
           begin
                liste.ajouter_fin(new(Paffixe,init(v2^.x,v2^.y)));inc(i);
                v2:=Paffixe(v2^.suivant);
           end;
     if i<=1 then begin
             Kill(Pcellule(r1));
             liste.detruire;
             exit;
        end;
     PointsParSeg:=2+(nb_points div (i-1));
     if (v1^.x=0) and (v1^.y=0) then v1:=nil;
     if (v2^.x=0) and (v2^.y=0) then v2:=nil;
     res:=SplineCubique(Paffixe(liste.tete),v1,v2);
     if res=nil then
        begin
             Kill(Pcellule(r1));
             liste.detruire;
             exit;
        end;
     a:=res;
     b:=Paffixe(a^.suivant);
     h:=1/(pointsParSeg-1);
     A1:=Paffixe(liste.tete);
     A2:=Paffixe(A1^.suivant);
     while A2<>nil do
     begin
          t0:=0;
          u:=soustraireC(A2,ajouterC(A1,ajouterC(b,a)));
          if u<>nil then
          for i:=1 to PointsParSeg do
           begin
            liste_points^.ajouter_fin(new(Paffixe,init(A1^.x+t0*(u^.x+t0*(b^.x+t0*a^.x)),A1^.y+t0*(u^.y+t0*(b^.y+t0*a^.y)))));
            t0:=t0+h;
            end;
            a:=Paffixe(b^.suivant);
            if a<>nil then begin b:=Paffixe(a^.suivant); end;
            A1:=A2;A2:=Paffixe(A2^.suivant);
            Kill(Pcellule(u));
     end;
     clip;
     if fleche>0 then calcul_fleches;
     Kill(Pcellule(r1));Kill(Pcellule(res));
     liste.detruire;
end;
{==============}
function t_spline.parametres_teg:string;
begin parametres_teg:=t_ligne.parametres_teg
end;
{=========================================T_utilisateur =========}
constructor T_utilisateur.init(const UnNom, UneCommande:string; Acode:integer);
begin
     enfants.init;
     t_parametree.init(UnNom,UneCommande,0,0);
     cat:=cat_utilisateur;
     id:=Acode;
end;
{==================================}
procedure t_utilisateur.fixeAttributs;
begin
     t_parametree.fixeAttributs;
     point_style:=DotStyle;
     style_label:=LabelStyle;
     size_label:=LabelSize;
     angle_label:=LabelAngle;
end;
{===================================}
procedure t_utilisateur.lireAttributs;
begin
      DotStyle:=point_style;
      LabelStyle:=style_label;
      LabelSize:=size_label;
      LabelAngle:=angle_label;
      t_parametree.lireAttributs;
end;
{=========================}
procedure t_utilisateur.ConstruitArbre;
begin
     t_element.ConstruitArbre(UnArbre)
end;
{===================================}
procedure T_utilisateur.recalculer;
var res:Paffixe;
    oldPenMode:longint;
begin
      If arbre=nil then exit;
      if DefCommande then
        begin
             dispose(arbre,detruire);
             ConstruitArbre(nil);
             if arbre=nil then exit;
        end;
      enfants.detruire;
      liste_enfant.init;
      if PPenMode^.affixe<>nil then
      PenMode:=round(PPenMode^.affixe^.x) mod 2 else PenMode:=0;
      oldPenMode:=PenMode;
      PenMode:=byte(pen_mode=PenMode1);
      lireAttributs;
      ContexteUtilisateur:=true;
      res:=arbre^.evaluer;
      lireAttributs;
      PenMode:=oldPenMode;
      PPenMode^.affixe^.x:=PenMode;
      ContexteUtilisateur:=False;
      if res<>nil then Kill(Pcellule(res));
      enfants.tete:=liste_enfant.tete;
      enfants.queue:=liste_enfant.queue;
      liste_enfant.init;
end;
{==============================}
procedure T_utilisateur.dessiner(feuille: Tcanvas);
var aux:type_liste;
begin
     if enfants.tete=nil then exit;
     aux.tete:=liste_element.tete;
     aux.queue:=liste_element.queue;
     liste_element.tete:=enfants.tete;
     liste_element.queue:=enfants.queue;
     draw_elements(feuille);
     liste_element.tete:=aux.tete;
     liste_element.queue:=aux.queue;
end;
{=========================}
procedure T_utilisateur.enregistrer_latex;
var aux:Pelement;
    comment:boolean;
begin
     if enfants.tete=nil then exit;
     t_element.enregistrer_latex;
     aux:=Pelement(enfants.tete);
     comment:=inclure_commentaires;
     inclure_commentaires:=false;
     while aux<>nil do
           begin
                aux^.enregistrer_latex;
                aux:=Pelement(aux^.suivant)
           end;
     inclure_commentaires:=comment;
end;
 {=========================}
function t_utilisateur.parametres_pst;
begin
     parametres_pst:='';
end;
 {=========================}
function t_utilisateur.parametres_teg:string;
var chaine:string;
begin
     chaine:=t_parametree.parametres_teg;
     if point_style<>DotStyle then
         begin DotStyle:=point_style; chaine:=chaine+',Set(DotStyle,'+Streel(point_style)+')';end;
     if style_label<>LabelStyle then
         begin LabelStyle:=style_label; chaine:=chaine+',Set(LabelStyle,'+Streel(style_label)+')';end;
     if size_label<>LabelSize then
         begin LabelSize:=size_label; chaine:=chaine+',Set(LabelSize,'+Streel(size_label)+')';end;
     if angle_label<>LabelAngle then
         begin LabelAngle:=angle_label; chaine:=chaine+',Set(LabelAngle,'+Streel(angle_label)+')';end;
     parametres_teg:=chaine
end;
{=========================}
procedure t_utilisateur.enregistrer_teg;
begin t_parametree.enregistrer_teg;
      if id<>-1 then
              write(f,id,car_special);
end;
{=========================}
procedure T_utilisateur.enregistrer_pst;
var aux:Pelement;
    comment:boolean;
begin
     if enfants.tete=nil then exit;
     t_element.enregistrer_pst;
     aux:=Pelement(enfants.tete);
     comment:=inclure_commentaires;
     inclure_commentaires:=false;
     while aux<>nil do
           begin
                aux^.enregistrer_pst;
                aux:=Pelement(aux^.suivant)
           end;
     inclure_commentaires:=comment;
end;
 {=========================}
procedure T_utilisateur.enregistrer_eps;
var aux:Pelement;
    comment:boolean;
begin
     if enfants.tete=nil then exit;
     t_element.enregistrer_eps;
     aux:=Pelement(enfants.tete);
     comment:=inclure_commentaires;
     inclure_commentaires:=false;
     while aux<>nil do
           begin
                aux^.enregistrer_eps;
                aux:=Pelement(aux^.suivant)
           end;
     inclure_commentaires:=comment;
end;
 {=========================}
procedure T_utilisateur.enregistrer_pgf;
var aux:Pelement;
    comment:boolean;
begin
     if enfants.tete=nil then exit;
     t_element.enregistrer_pgf;
     aux:=Pelement(enfants.tete);
     comment:=inclure_commentaires;
     inclure_commentaires:=false;
     while aux<>nil do
           begin
                aux^.enregistrer_pgf;
                aux:=Pelement(aux^.suivant)
           end;
     inclure_commentaires:=comment;
end;
{=========================}
destructor T_utilisateur.detruire;
begin
     enfants.detruire;
     T_parametree.detruire
end;

{================}
constructor t_cartesienne.init(const UnNom, UneCommande:string;diviser,discont:byte);
begin
        t_parametree.init( UnNom, UneCommande,diviser,discont);
        cat:=cat_cartesienne
end;
{================}
procedure t_cartesienne.ConstruitArbre(Unarbre:Pcorps);
var aux:PConstante;
begin
     if Unarbre<>nil
        then
            begin
             new(arbre,init);
             DefCommande:=false;
             arbre^.VarLoc:=LesVarLoc;
             arbre^.corps:=Unarbre;
        end
        else
            begin
                 new(arbre,init);
                 aux:= new(Pconstante,init('x',nil,true));
                 arbre^.varloc^.ajouter_fin(aux);
                 if not arbre^.definir('x+i*('+LigneCommande+')')
                    then begin dispose(arbre,detruire); arbre:=nil end
                    else aux^.nom:='t';
                 DefCommande:=true;
            end;
end;
{================}
constructor t_polaire.init(const UnNom, UneCommande:string;diviser,discont:byte);
begin
        t_parametree.init( UnNom, UneCommande,diviser,discont);
        cat:=cat_polaire
end;
{================}
procedure t_polaire.ConstruitArbre(Unarbre:Pcorps);
var aux:PConstante;
begin
     if Unarbre<>nil
        then
            begin
             new(arbre,init);
             DefCommande:=false;
             arbre^.VarLoc:=LesVarLoc;
             arbre^.corps:=Unarbre;
        end
        else
            begin
                 new(arbre,init);
                 aux:= new(Pconstante,init('t',nil,true));
                 arbre^.varloc^.ajouter_fin(aux);
                 if not arbre^.definir('('+LigneCommande+')*exp(i*t)')
                    then begin dispose(arbre,detruire); arbre:=nil end;
                 DefCommande:=true;
            end;
end;
{================}


Begin
End.
