{Copyright (C) 2005 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version 
ultrieure choisie par vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
 Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme;
 si ce n'est pas le cas, crivez  la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 }


UNIT listes2; {gestion des listes}

INTERFACE
uses classes;

TYPE
    

  PCellule= ^tcellule;

  tcellule= Object                            {anctre des lments d'une liste }
             suivant, precedent: PCellule;

             Constructor init;
             Destructor detruire;virtual;
             end;

    
        PListe= ^type_liste;
    type_liste= Object
                tete, queue: PCellule;      {un pointeur de debut et un pointeur de fin}

                constructor init;
                procedure ajouter_fin(info: PCellule); virtual;      { on peut ajouter plusieurs cellules chaines}
                procedure supprimer(var p:PCellule);virtual;         { supprime une cellule }
                procedure inserer(info:PCellule;p:PCellule);virtual; { insre une cellule }
                procedure supprimer_element(numero:word);virtual;
                function chercher_element(numero:word):Pcellule;virtual;
                procedure deplacer(source,but:integer);virtual;         {dplace le cellule nsource  la place de la nbut}
                destructor detruire;virtual;
                end;

procedure Kill(var liste:PCellule);  {destruction sans rcursivit }

IMPLEMENTATION


{============= TCellule ==========}

CONSTRUCTOR TCellule.init;
begin suivant:=nil;
      precedent:=nil;
end;


Destructor TCellule.detruire;
begin
end;
{=============== Type_Liste ============}
Constructor type_liste.init;
begin
     tete:=nil;
     queue:=nil;
end;
{=======================}
PROCEDURE type_liste.ajouter_fin;
begin
     if info=nil then exit;
     info^.precedent:=queue;
     if queue<>nil then  queue^.suivant:=info
                   else tete:=info;
     queue:=info;
     while queue^.suivant<>nil do queue:=queue^.suivant;
end;
{=======================}
PROCEDURE type_liste.inserer;
begin
     if p=nil then ajouter_fin(info)
              else
     if p=tete then begin
                         info^.suivant:=tete;
                         info^.precedent:=nil;
                         tete^.precedent:=info;
                         tete:=info
                    end
               else begin
                         info^.suivant:=p;
                         p^.precedent^.suivant:=info;
                         info^.precedent:=p^.precedent;
                         p^.precedent:=info;
                    end;
end;
{=======================}
PROCEDURE type_liste.supprimer;
var aux:PCellule;
begin if p=nil then exit;
      if p=tete then begin
                           tete:=p^.suivant;
                           if tete=nil then queue:=nil
                                       else tete^.precedent:=nil;
                           aux:=tete;
                           end
                      else
      if p=queue then begin
                            queue:=p^.precedent;
                            if queue=nil then tete:=nil
                                         else queue^.suivant:=nil;
                            aux:=nil;
                            end
                       else begin
                            p^.precedent^.suivant:=p^.suivant;
                            p^.suivant^.precedent:=p^.precedent;
                            aux:=p^.suivant
                            end;
      dispose(p,detruire);
      p:=aux
end;

{=======================}
procedure type_liste.supprimer_element(numero:word);
var aux:PCellule;
    compt:word;    
begin
      compt:=1;
      aux:=tete;
      while (aux<>nil) and (compt<>numero) do
            begin inc(compt); aux:=aux^.suivant; end;
      if aux<>nil then begin supprimer(aux); end;
end;

{=======================}
function type_liste.chercher_element(numero:word):Pcellule;
var aux:PCellule;
    compt:word;
begin
      compt:=1;
      aux:=tete;
      while (aux<>nil) and (compt<>numero) do
            begin inc(compt); aux:=aux^.suivant; end;
      chercher_element:=aux;
end;
{=======================}
procedure type_liste.deplacer(source,but:integer);
var aux1,aux2,p:PCellule;
begin
     if (source=but) or (source<=0) or (but<=0) then exit;
      aux1:=chercher_element(source);
      if aux1=nil then exit;
      aux2:= chercher_element(but);
      p:=aux1;
      if p=tete then begin
                           tete:=p^.suivant;
                           if tete=nil then queue:=nil
                                       else tete^.precedent:=nil;
                           end
                      else
      if p=queue then begin
                            queue:=p^.precedent;
                            if queue=nil then tete:=nil
                                         else queue^.suivant:=nil;
                            end
                       else begin
                            p^.precedent^.suivant:=p^.suivant;
                            p^.suivant^.precedent:=p^.precedent;
                            end;
      aux1^.suivant:=nil;
      aux1^.precedent:=nil;
      If but<source then  inserer(aux1,aux2)
                    else  inserer(aux1,aux2^.suivant)
end;
{=======================}
destructor type_liste.detruire;
begin
     if tete<>nil then Kill(tete);
     queue:=nil
end;
{====================================}
procedure Kill(var liste:PCellule);
var aux:Pcellule;
begin
     while liste<>nil do
           begin
                aux:=liste^.suivant;
                dispose(liste,detruire);
                liste:=aux
           end;
end;


BEGIN
END.
